# ###################################################################################
#
#   File: itex.profile.org
#
#
#Licensed Materials - Property of IBM
#
#(c) Copyright IBM Corporation 1993, 2011. All Rights Reserved.
#
#U.S. Government Users Restricted Rights:  
#Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# ##############################################################################
#

case "$hosttype" in
 sunos4|sunos5|hppa)
    if test -z "$itexrelease"
    then
      case "$telelogicitex" in
	"") itexrelease=$telelogic/itex ;;
	/*) itexrelease=$telelogicitex ;;
	*)   itexrelease=$telelogic/$telelogicitex ;;
      esac
      export itexrelease
    fi

    # Check if binary directory is installed for ITEX
    if test ! -x $telelogicbin/iedit2
    then
      echo "(TTCN Suite): Unable to locate binary directory for this architecture."
      echo "(TTCN Suite): Please contact your system administrator."
    else

      # Where to find the access hierarchy.
      if test -z "$TeleLOGIC_USEEXTVAR"
      then
	itexaccessroot="$itexrelease/access/${hosttype}"
	export itexaccessroot
      else
	if test -z "$itexaccessroot"
	then
	  itexaccessroot="$itexrelease/access/${hosttype}"
	  export itexaccessroot
	fi
      fi

      # What is the default compiler called.
      if test -z "$itexaccesscompiler"
      then
	itexaccesscompiler=CC
	export itexaccesscompiler
      fi

      # Where to find the access library and include files.
      if test -z "$TeleLOGIC_USEEXTVAR"
      then
	itexaccess="$itexaccessroot/$itexaccesscompiler"
	export itexaccess
      else
	if test -z "$itexaccess"
	then
	  itexaccess="$itexaccessroot/$itexaccesscompiler"
	  export itexaccess
	fi
      fi

      #x-seanpo ---begin--- BUG=acc_1013308
      # Where to find the gmp library to compile access application.
      if test -z "$TeleLOGIC_USEEXTVAR"
      then
        itexgmplib="$telelogic/lib/${hosttype}lib"
        export itexgmplib
      else
        if [ "$itexgmplib" = "" ] ; then
          itexgmplib="$telelogic/lib/${hosttype}lib"
          export itexgmplib
        fi
      fi
      #x-seanpo ---end---

      # Where to find the code generator files and the Simulator files.
      if test -z "$TeleLOGIC_USEEXTVAR"
      then
	itexlib="$itexrelease/itexlib/${hosttype}"
	export itexlib
      else
	if test -z "$itexlib"
	then
	  itexlib="$itexrelease/itexlib/${hosttype}"
	  export itexlib
	fi
      fi
    fi
    ;;
esac
