// Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:45 PM MET 2011
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 1993, 2011.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  
// Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
/*
 * Name: ITEXAccessVisitor.hh
 *
 * Description:
 * 
 *  One of the ITEX Access API definition files.
 */

#ifndef ITEXAccessVisitor_HH
# define ITEXAccessVisitor_HH

#ifndef ITEXACCESS_DUMMY_NODEINFO
# define ITEXACCESS_DUMMY_NODEINFO

class NodeInfo
{
private:
  void* rfm;
};

#endif

/* This is defined in access.hh for backward compatibility  */
#ifndef ITEXACCESS_DEREF
/* This other declaration prevents operator-> to be defined */
#define ITEXACCESS_DEREF( c ) /* no expansion for c */
#endif


class AccessVisitor
{
 public:
  virtual ~AccessVisitor();
  void Visit( AccessSuite & );
  void Visit( const AccessNode );

  virtual void VisitASuite( const ASuite & );
  virtual void VisitSuiteId( const SuiteId & );
  virtual void VisitSO_SuiteId( const SO_SuiteId & );
  virtual void VisitSuiteOverviewPart( const SuiteOverviewPart & );
  virtual void VisitSuiteStructure( const SuiteStructure & );
  virtual void VisitSO_StandardsRef( const SO_StandardsRef & );
  virtual void VisitSO_PICSRef( const SO_PICSRef & );
  virtual void VisitSO_PIXITRef( const SO_PIXITRef & );
  virtual void VisitSO_TestMethods( const SO_TestMethods & );
  virtual void VisitSO_SelExprId( const SO_SelExprId & );
  virtual void VisitSO_Objective( const SO_Objective & );
  virtual void VisitSO_DefaultRef( const SO_DefaultRef & );
  virtual void VisitSO_DefaultId( const SO_DefaultId & );
  virtual void VisitSO_Description( const SO_Description & );
  virtual void VisitSO_TestStepRef( const SO_TestStepRef & );
  virtual void VisitSO_TestStepId( const SO_TestStepId & );
  virtual void VisitSO_TestCaseId( const SO_TestCaseId & );
  virtual void VisitSO_TestGroupRef( const SO_TestGroupRef & );
  virtual void VisitSO_StructureAndObjectives( const SO_StructureAndObjectives & );
  virtual void VisitSO_StructureAndObjective( const SO_StructureAndObjective & );
  virtual void VisitTestCaseIndex( const TestCaseIndex & );
  virtual void VisitSO_CaseIndexList( const SO_CaseIndexList & );
  virtual void VisitSO_CaseIndex( const SO_CaseIndex & );
  virtual void VisitTestStepIndex( const TestStepIndex & );
  virtual void VisitSO_StepIndexList( const SO_StepIndexList & );
  virtual void VisitSO_StepIndex( const SO_StepIndex & );
  virtual void VisitDefaultIndex( const DefaultIndex & );
  virtual void VisitSO_DefIndexList( const SO_DefIndexList & );
  virtual void VisitSO_DefIndex( const SO_DefIndex & );
  virtual void VisitImportPart( const ImportPart & );
  virtual void VisitImportDeclarations( const ImportDeclarations & );
  virtual void VisitImports( const Imports & );
  virtual void VisitSourceName( const SourceName & );
  virtual void VisitSourceRef( const SourceRef & );
  virtual void VisitImportedObjectList( const ImportedObjectList & );
  virtual void VisitImportedObject( const ImportedObject & );
  virtual void VisitObjectName( const ObjectName & );
  virtual void VisitObjectType( const ObjectType & );
  virtual void VisitDeclarationsPart( const DeclarationsPart & );
  virtual void VisitDefinitions( const Definitions & );
  virtual void VisitTS_TypeDefs( const TS_TypeDefs & );
  virtual void VisitEncodingDefs( const EncodingDefs & );
  virtual void VisitEncodingDefinitions( const EncodingDefinitions & );
  virtual void VisitEncodingDefList( const EncodingDefList & );
  virtual void VisitEncodingDefinition( const EncodingDefinition & );
  virtual void VisitEncodingDefault( const EncodingDefault & );
  virtual void VisitEncodingVariations( const EncodingVariations & );
  virtual void VisitEncodingVariationSet( const EncodingVariationSet & );
  virtual void VisitEncodingVariationList( const EncodingVariationList & );
  virtual void VisitEncodingVariation( const EncodingVariation & );
  virtual void VisitVariationDefault( const VariationDefault & );
  virtual void VisitEncodingVariationId( const EncodingVariationId & );
  virtual void VisitEncVariationIdAndParList( const EncVariationIdAndParList & );
  virtual void VisitInvalidFieldEncodingDefs( const InvalidFieldEncodingDefs & );
  virtual void VisitInvalidFieldEncodingDef( const InvalidFieldEncodingDef & );
  virtual void VisitInvalidFieldEncodingDefinition( const InvalidFieldEncodingDefinition & );
  virtual void VisitInvalidFieldEncodingId( const InvalidFieldEncodingId & );
  virtual void VisitInvalidFieldEncodingIdAndParList( const InvalidFieldEncodingIdAndParList & );
  virtual void VisitSimpleTypeDefs( const SimpleTypeDefs & );
  virtual void VisitSimpleTypeDefList( const SimpleTypeDefList & );
  virtual void VisitSimpleTypeDef( const SimpleTypeDef & );
  virtual void VisitSimpleTypeId( const SimpleTypeId & );
  virtual void VisitSimpleTypeDefinition( const SimpleTypeDefinition & );
  virtual void VisitTypeAndRestriction( const TypeAndRestriction & );
  virtual void VisitTTCN_Type( const TTCN_Type & );
  virtual void VisitTypeOrPDU( const TypeOrPDU & );
  virtual void VisitPredefinedType( const PredefinedType & );
  virtual void VisitReferenceType( const ReferenceType & );
  virtual void VisitCharacterString( const CharacterString & );
  virtual void VisitRestriction( const Restriction & );
  virtual void VisitLengthRestriction( const LengthRestriction & );
  virtual void VisitSingleTypeLength( const SingleTypeLength & );
  virtual void VisitComment( const Comment & );
  virtual void VisitVariationRef( const VariationRef & );
  virtual void VisitVariationReference( const VariationReference & );
  virtual void VisitPDU_FieldEncoding( const PDU_FieldEncoding & );
  virtual void VisitPDU_FieldEncodingCall( const PDU_FieldEncodingCall & );
  virtual void VisitEncVariationId( const EncVariationId & );
  virtual void VisitEncVariationCall( const EncVariationCall & );
  virtual void VisitInvalidFieldEncodingCall( const InvalidFieldEncodingCall & );
  virtual void VisitEncodingRuleId( const EncodingRuleId & );
  virtual void VisitEncRuleId( const EncRuleId & );
  virtual void VisitPDU_EncodingId( const PDU_EncodingId & );
  virtual void VisitEncodingRef( const EncodingRef & );
  virtual void VisitEncodingReference( const EncodingReference & );
  virtual void VisitEncoding_TypeList( const Encoding_TypeList & );
  virtual void VisitDetailedComment( const DetailedComment & );
  virtual void VisitNumber( const Number & );
  virtual void VisitRangeTypeLength( const RangeTypeLength & );
  virtual void VisitLowerTypeBound( const LowerTypeBound & );
  virtual void VisitUpperTypeBound( const UpperTypeBound & );
  virtual void VisitIntegerRange( const IntegerRange & );
  virtual void VisitSimpleValueList( const SimpleValueList & );
  virtual void VisitSimpleValue( const SimpleValue & );
  virtual void VisitStructTypeDefs( const StructTypeDefs & );
  virtual void VisitStructTypeDef( const StructTypeDef & );
  virtual void VisitStructId( const StructId & );
  virtual void VisitStructIdAndFullId( const StructIdAndFullId & );
  virtual void VisitFullIdentifier( const FullIdentifier & );
  virtual void VisitElemDcls( const ElemDcls & );
  virtual void VisitElemDcl( const ElemDcl & );
  virtual void VisitElemId( const ElemId & );
  virtual void VisitElemType( const ElemType & );
  virtual void VisitElemIdAndFullId( const ElemIdAndFullId & );
  virtual void VisitTypeAndAttributes( const TypeAndAttributes & );
  virtual void VisitTypeAndLengthAttribute( const TypeAndLengthAttribute & );
  virtual void VisitLengthAttribute( const LengthAttribute & );
  virtual void VisitSingleLength( const SingleLength & );
  virtual void VisitBound( const Bound & );
  virtual void VisitRangeLength( const RangeLength & );
  virtual void VisitLowerBound( const LowerBound & );
  virtual void VisitUpperBound( const UpperBound & );
  virtual void VisitASN1_TypeDefs( const ASN1_TypeDefs & );
  virtual void VisitASN1_TypeDef( const ASN1_TypeDef & );
  virtual void VisitASN1_TypeId( const ASN1_TypeId & );
  virtual void VisitASN1_TypeDefinition( const ASN1_TypeDefinition & );
  virtual void VisitASN1_TypeRefs( const ASN1_TypeRefs & );
  virtual void VisitASN1_TypeRefList( const ASN1_TypeRefList & );
  virtual void VisitASN1_TypeRef( const ASN1_TypeRef & );
  virtual void VisitASN1_TypeReference( const ASN1_TypeReference & );
  virtual void VisitASN1_ModuleId( const ASN1_ModuleId & );
  virtual void VisitTS_ProcDefs( const TS_ProcDefs & );
  virtual void VisitTS_OpDefs( const TS_OpDefs & );
  virtual void VisitTS_OpDef( const TS_OpDef & );
  virtual void VisitTS_ProcDef( const TS_ProcDef & );
  virtual void VisitTS_OpId( const TS_OpId & );
  virtual void VisitTS_ProcId( const TS_ProcId & );
  virtual void VisitTS_OpIdAndParList( const TS_OpIdAndParList & );
  virtual void VisitTS_ProcIdAndParList( const TS_ProcIdAndParList & );
  virtual void VisitTS_OpResult( const TS_OpResult & );
  virtual void VisitTS_ProcResult( const TS_ProcResult & );
  virtual void VisitTS_OpDescription( const TS_OpDescription & );
  virtual void VisitTS_ProcDescription( const TS_ProcDescription & );
  virtual void VisitParamAndSelection( const ParamAndSelection & );
  virtual void VisitTS_ParDcls( const TS_ParDcls & );
  virtual void VisitTS_ParDclList( const TS_ParDclList & );
  virtual void VisitTS_ParDcl( const TS_ParDcl & );
  virtual void VisitTS_ParId( const TS_ParId & );
  virtual void VisitPICS_PIXITref( const PICS_PIXITref & );
  virtual void VisitTS_ParType( const TS_ParType & );
  virtual void VisitSelectExprDefs( const SelectExprDefs & );
  virtual void VisitSelectExprDefList( const SelectExprDefList & );
  virtual void VisitSelectExprDef( const SelectExprDef & );
  virtual void VisitSelectExprId( const SelectExprId & );
  virtual void VisitSelectExpr( const SelectExpr & );
  virtual void VisitSelectionExpression( const SelectionExpression & );
  virtual void VisitDeclarations( const Declarations & );
  virtual void VisitTS_ConstDcls( const TS_ConstDcls & );
  virtual void VisitTS_ConstRefs( const TS_ConstRefs & );
  virtual void VisitTS_ConstDclList( const TS_ConstDclList & );
  virtual void VisitTS_ConstRefList( const TS_ConstRefList & );
  virtual void VisitTS_ConstDcl( const TS_ConstDcl & );
  virtual void VisitTS_ConstRef( const TS_ConstRef & );
  virtual void VisitASN1_ValueReference( const ASN1_ValueReference & );
  virtual void VisitTS_ConstId( const TS_ConstId & );
  virtual void VisitTS_ConstType( const TS_ConstType & );
  virtual void VisitTS_ConstValue( const TS_ConstValue & );
  virtual void VisitDeclarationValue( const DeclarationValue & );
  virtual void VisitTS_VarDcls( const TS_VarDcls & );
  virtual void VisitTS_VarDclList( const TS_VarDclList & );
  virtual void VisitTS_VarDcl( const TS_VarDcl & );
  virtual void VisitTS_VarId( const TS_VarId & );
  virtual void VisitTS_VarType( const TS_VarType & );
  virtual void VisitTS_VarValue( const TS_VarValue & );
  virtual void VisitTC_VarDcls( const TC_VarDcls & );
  virtual void VisitTC_VarDclList( const TC_VarDclList & );
  virtual void VisitTC_VarDcl( const TC_VarDcl & );
  virtual void VisitTC_VarId( const TC_VarId & );
  virtual void VisitTC_VarType( const TC_VarType & );
  virtual void VisitTC_VarValue( const TC_VarValue & );
  virtual void VisitTCompDcls( const TCompDcls & );
  virtual void VisitTCompDclList( const TCompDclList & );
  virtual void VisitTCompDcl( const TCompDcl & );
  virtual void VisitTCompId( const TCompId & );
  virtual void VisitTC_Role( const TC_Role & );
  virtual void VisitTComp_Role( const TComp_Role & );
  virtual void VisitNumOf_PCOs( const NumOf_PCOs & );
  virtual void VisitNumOf_CPs( const NumOf_CPs & );
  virtual void VisitNum_PCOs( const Num_PCOs & );
  virtual void VisitNum_CPs( const Num_CPs & );
  virtual void VisitTCompConfigDcls( const TCompConfigDcls & );
  virtual void VisitTCompConfigDcl( const TCompConfigDcl & );
  virtual void VisitTCompConfigInfoList( const TCompConfigInfoList & );
  virtual void VisitTCompConfigId( const TCompConfigId & );
  virtual void VisitTCompConfigInfo( const TCompConfigInfo & );
  virtual void VisitTCompUsed( const TCompUsed & );
  virtual void VisitPCOs_Used( const PCOs_Used & );
  virtual void VisitPCO_List( const PCO_List & );
  virtual void VisitCPs_Used( const CPs_Used & );
  virtual void VisitCP_List( const CP_List & );
  virtual void VisitPCO_TypeDcls( const PCO_TypeDcls & );
  virtual void VisitPCO_TypeDclList( const PCO_TypeDclList & );
  virtual void VisitPCO_TypeDcl( const PCO_TypeDcl & );
  virtual void VisitPCO_Dcls( const PCO_Dcls & );
  virtual void VisitPCO_DclList( const PCO_DclList & );
  virtual void VisitPCO_Dcl( const PCO_Dcl & );
  virtual void VisitPCO_Id( const PCO_Id & );
  virtual void VisitPCO_TypeId( const PCO_TypeId & );
  virtual void VisitP_Role( const P_Role & );
  virtual void VisitPCO_Role( const PCO_Role & );
  virtual void VisitCP_Dcls( const CP_Dcls & );
  virtual void VisitCP_DclList( const CP_DclList & );
  virtual void VisitCP_Dcl( const CP_Dcl & );
  virtual void VisitCP_Id( const CP_Id & );
  virtual void VisitTimerDcls( const TimerDcls & );
  virtual void VisitTimerDclList( const TimerDclList & );
  virtual void VisitTimerDcl( const TimerDcl & );
  virtual void VisitTimerId( const TimerId & );
  virtual void VisitDuration( const Duration & );
  virtual void VisitUnit( const Unit & );
  virtual void VisitTimeUnit( const TimeUnit & );
  virtual void VisitComplexDefinitions( const ComplexDefinitions & );
  virtual void VisitASP_TypeDefs( const ASP_TypeDefs & );
  virtual void VisitTTCN_ASP_TypeDefs( const TTCN_ASP_TypeDefs & );
  virtual void VisitTTCN_ASP_TypeDef( const TTCN_ASP_TypeDef & );
  virtual void VisitASP_Id( const ASP_Id & );
  virtual void VisitASP_IdAndFullId( const ASP_IdAndFullId & );
  virtual void VisitPCO_Type( const PCO_Type & );
  virtual void VisitASP_ParDcls( const ASP_ParDcls & );
  virtual void VisitASP_ParDcl( const ASP_ParDcl & );
  virtual void VisitASP_ParId( const ASP_ParId & );
  virtual void VisitASP_ParIdOrMacro( const ASP_ParIdOrMacro & );
  virtual void VisitASP_ParIdAndFullId( const ASP_ParIdAndFullId & );
  virtual void VisitASP_ParType( const ASP_ParType & );
  virtual void VisitASN1_ASP_TypeDefs( const ASN1_ASP_TypeDefs & );
  virtual void VisitASN1_ASP_TypeDef( const ASN1_ASP_TypeDef & );
  virtual void VisitASN1_ASP_TypeDefsByRef( const ASN1_ASP_TypeDefsByRef & );
  virtual void VisitASN1_ASP_TypeDefByRefList( const ASN1_ASP_TypeDefByRefList & );
  virtual void VisitASN1_ASP_TypeDefByRef( const ASN1_ASP_TypeDefByRef & );
  virtual void VisitPDU_TypeDefs( const PDU_TypeDefs & );
  virtual void VisitTTCN_PDU_TypeDefs( const TTCN_PDU_TypeDefs & );
  virtual void VisitTTCN_PDU_TypeDef( const TTCN_PDU_TypeDef & );
  virtual void VisitPDU_Id( const PDU_Id & );
  virtual void VisitPDU_IdAndFullId( const PDU_IdAndFullId & );
  virtual void VisitPDU_FieldDcls( const PDU_FieldDcls & );
  virtual void VisitPDU_FieldDcl( const PDU_FieldDcl & );
  virtual void VisitPDU_FieldId( const PDU_FieldId & );
  virtual void VisitPDU_FieldIdOrMacro( const PDU_FieldIdOrMacro & );
  virtual void VisitPDU_FieldIdAndFullId( const PDU_FieldIdAndFullId & );
  virtual void VisitPDU_FieldType( const PDU_FieldType & );
  virtual void VisitASN1_PDU_TypeDefs( const ASN1_PDU_TypeDefs & );
  virtual void VisitASN1_PDU_TypeDef( const ASN1_PDU_TypeDef & );
  virtual void VisitASN1_PDU_TypeDefsByRef( const ASN1_PDU_TypeDefsByRef & );
  virtual void VisitASN1_PDU_TypeDefByRefList( const ASN1_PDU_TypeDefByRefList & );
  virtual void VisitASN1_PDU_TypeDefByRef( const ASN1_PDU_TypeDefByRef & );
  virtual void VisitCM_TypeDefs( const CM_TypeDefs & );
  virtual void VisitTTCN_CM_TypeDefs( const TTCN_CM_TypeDefs & );
  virtual void VisitTTCN_CM_TypeDef( const TTCN_CM_TypeDef & );
  virtual void VisitCM_Id( const CM_Id & );
  virtual void VisitCM_ParDcls( const CM_ParDcls & );
  virtual void VisitCM_ParDcl( const CM_ParDcl & );
  virtual void VisitCM_ParId( const CM_ParId & );
  virtual void VisitCM_ParIdOrMacro( const CM_ParIdOrMacro & );
  virtual void VisitCM_ParIdAndFullId( const CM_ParIdAndFullId & );
  virtual void VisitCM_ParType( const CM_ParType & );
  virtual void VisitASN1_CM_TypeDefs( const ASN1_CM_TypeDefs & );
  virtual void VisitASN1_CM_TypeDef( const ASN1_CM_TypeDef & );
  virtual void VisitAliasDefs( const AliasDefs & );
  virtual void VisitAliasDefList( const AliasDefList & );
  virtual void VisitAliasDef( const AliasDef & );
  virtual void VisitAliasId( const AliasId & );
  virtual void VisitExpandedId( const ExpandedId & );
  virtual void VisitExpansion( const Expansion & );
  virtual void VisitConstraintsPart( const ConstraintsPart & );
  virtual void VisitTS_TypeConstraints( const TS_TypeConstraints & );
  virtual void VisitASP_Constraints( const ASP_Constraints & );
  virtual void VisitPDU_Constraints( const PDU_Constraints & );
  virtual void VisitCM_Constraints( const CM_Constraints & );
  virtual void VisitStructTypeConstraints( const StructTypeConstraints & );
  virtual void VisitStructTypeConstraintOrGroupList( const StructTypeConstraintOrGroupList & );
  virtual void VisitStructTypeConstraintOrGroup( const StructTypeConstraintOrGroup & );
  virtual void VisitStructTypeConstraintGroup( const StructTypeConstraintGroup & );
  virtual void VisitStructTypeConstraintGroupId( const StructTypeConstraintGroupId & );
  virtual void VisitStructTypeConstraint( const StructTypeConstraint & );
  virtual void VisitStructTypeConstraintGroupRef( const StructTypeConstraintGroupRef & );
  virtual void VisitStructTypeConstraintGroupReference( const StructTypeConstraintGroupReference & );
  virtual void VisitConsId( const ConsId & );
  virtual void VisitConsIdAndParList( const ConsIdAndParList & );
  virtual void VisitDerivPath( const DerivPath & );
  virtual void VisitDerivationPath( const DerivationPath & );
  virtual void VisitElemValues( const ElemValues & );
  virtual void VisitElemValue( const ElemValue & );
  virtual void VisitASN1_TypeConstraints( const ASN1_TypeConstraints & );
  virtual void VisitASN1_TypeConstraintOrGroupList( const ASN1_TypeConstraintOrGroupList & );
  virtual void VisitASN1_TypeConstraintOrGroup( const ASN1_TypeConstraintOrGroup & );
  virtual void VisitASN1_TypeConstraintGroup( const ASN1_TypeConstraintGroup & );
  virtual void VisitASN1_TypeConstraintGroupId( const ASN1_TypeConstraintGroupId & );
  virtual void VisitASN1_TypeConstraint( const ASN1_TypeConstraint & );
  virtual void VisitASN1_TypeConstraintGroupRef( const ASN1_TypeConstraintGroupRef & );
  virtual void VisitASN1_TypeConstraintGroupReference( const ASN1_TypeConstraintGroupReference & );
  virtual void VisitTTCN_ASP_Constraints( const TTCN_ASP_Constraints & );
  virtual void VisitTTCN_ASP_ConstraintOrGroupList( const TTCN_ASP_ConstraintOrGroupList & );
  virtual void VisitTTCN_ASP_ConstraintOrGroup( const TTCN_ASP_ConstraintOrGroup & );
  virtual void VisitTTCN_ASP_ConstraintGroup( const TTCN_ASP_ConstraintGroup & );
  virtual void VisitTTCN_ASP_ConstraintGroupId( const TTCN_ASP_ConstraintGroupId & );
  virtual void VisitTTCN_ASP_Constraint( const TTCN_ASP_Constraint & );
  virtual void VisitASP_ConstraintGroupRef( const ASP_ConstraintGroupRef & );
  virtual void VisitASP_ConstraintGroupReference( const ASP_ConstraintGroupReference & );
  virtual void VisitASP_ParValues( const ASP_ParValues & );
  virtual void VisitASP_ParValue( const ASP_ParValue & );
  virtual void VisitTTCN_PDU_Constraints( const TTCN_PDU_Constraints & );
  virtual void VisitTTCN_PDU_ConstraintOrGroupList( const TTCN_PDU_ConstraintOrGroupList & );
  virtual void VisitTTCN_PDU_ConstraintOrGroup( const TTCN_PDU_ConstraintOrGroup & );
  virtual void VisitTTCN_PDU_ConstraintGroup( const TTCN_PDU_ConstraintGroup & );
  virtual void VisitTTCN_PDU_ConstraintGroupId( const TTCN_PDU_ConstraintGroupId & );
  virtual void VisitTTCN_PDU_Constraint( const TTCN_PDU_Constraint & );
  virtual void VisitPDU_ConstraintGroupRef( const PDU_ConstraintGroupRef & );
  virtual void VisitPDU_ConstraintGroupReference( const PDU_ConstraintGroupReference & );
  virtual void VisitPDU_FieldValues( const PDU_FieldValues & );
  virtual void VisitPDU_FieldValue( const PDU_FieldValue & );
  virtual void VisitConsValue( const ConsValue & );
  virtual void VisitASN1_ASP_Constraints( const ASN1_ASP_Constraints & );
  virtual void VisitASN1_ASP_ConstraintOrGroupList( const ASN1_ASP_ConstraintOrGroupList & );
  virtual void VisitASN1_ASP_ConstraintOrGroup( const ASN1_ASP_ConstraintOrGroup & );
  virtual void VisitASN1_ASP_ConstraintGroup( const ASN1_ASP_ConstraintGroup & );
  virtual void VisitASN1_ASP_ConstraintGroupId( const ASN1_ASP_ConstraintGroupId & );
  virtual void VisitASN1_ASP_Constraint( const ASN1_ASP_Constraint & );
  virtual void VisitASN1_ASP_ConstraintGroupRef( const ASN1_ASP_ConstraintGroupRef & );
  virtual void VisitASN1_ASP_ConstraintGroupReference( const ASN1_ASP_ConstraintGroupReference & );
  virtual void VisitASN1_PDU_Constraints( const ASN1_PDU_Constraints & );
  virtual void VisitASN1_PDU_ConstraintOrGroupList( const ASN1_PDU_ConstraintOrGroupList & );
  virtual void VisitASN1_PDU_ConstraintOrGroup( const ASN1_PDU_ConstraintOrGroup & );
  virtual void VisitASN1_PDU_ConstraintGroup( const ASN1_PDU_ConstraintGroup & );
  virtual void VisitASN1_PDU_ConstraintGroupId( const ASN1_PDU_ConstraintGroupId & );
  virtual void VisitASN1_PDU_Constraint( const ASN1_PDU_Constraint & );
  virtual void VisitASN1_PDU_ConstraintGroupRef( const ASN1_PDU_ConstraintGroupRef & );
  virtual void VisitASN1_PDU_ConstraintGroupReference( const ASN1_PDU_ConstraintGroupReference & );
  virtual void VisitASN1_ConsValue( const ASN1_ConsValue & );
  virtual void VisitConstraintValueAndAttributesOrReplace( const ConstraintValueAndAttributesOrReplace & );
  virtual void VisitReplacementList( const ReplacementList & );
  virtual void VisitReplacement( const Replacement & );
  virtual void VisitReplace( const Replace & );
  virtual void VisitReferenceList( const ReferenceList & );
  virtual void VisitOmitReference( const OmitReference & );
  virtual void VisitArrayRefOrComp( const ArrayRefOrComp & );
  virtual void VisitTTCN_CM_Constraints( const TTCN_CM_Constraints & );
  virtual void VisitTTCN_CM_ConstraintOrGroupList( const TTCN_CM_ConstraintOrGroupList & );
  virtual void VisitTTCN_CM_ConstraintOrGroup( const TTCN_CM_ConstraintOrGroup & );
  virtual void VisitTTCN_CM_ConstraintGroup( const TTCN_CM_ConstraintGroup & );
  virtual void VisitTTCN_CM_ConstraintGroupId( const TTCN_CM_ConstraintGroupId & );
  virtual void VisitTTCN_CM_Constraint( const TTCN_CM_Constraint & );
  virtual void VisitCM_ConstraintGroupRef( const CM_ConstraintGroupRef & );
  virtual void VisitCM_ConstraintGroupReference( const CM_ConstraintGroupReference & );
  virtual void VisitCM_ParValues( const CM_ParValues & );
  virtual void VisitCM_ParValue( const CM_ParValue & );
  virtual void VisitASN1_CM_Constraints( const ASN1_CM_Constraints & );
  virtual void VisitASN1_CM_ConstraintOrGroupList( const ASN1_CM_ConstraintOrGroupList & );
  virtual void VisitASN1_CM_ConstraintOrGroup( const ASN1_CM_ConstraintOrGroup & );
  virtual void VisitASN1_CM_ConstraintGroup( const ASN1_CM_ConstraintGroup & );
  virtual void VisitASN1_CM_ConstraintGroupId( const ASN1_CM_ConstraintGroupId & );
  virtual void VisitASN1_CM_Constraint( const ASN1_CM_Constraint & );
  virtual void VisitASN1_CM_ConstraintGroupRef( const ASN1_CM_ConstraintGroupRef & );
  virtual void VisitASN1_CM_ConstraintGroupReference( const ASN1_CM_ConstraintGroupReference & );
  virtual void VisitDynamicPart( const DynamicPart & );
  virtual void VisitTestCases( const TestCases & );
  virtual void VisitTestGroupOrTestCaseList( const TestGroupOrTestCaseList & );
  virtual void VisitTestGroupOrTestCase( const TestGroupOrTestCase & );
  virtual void VisitTestGroup( const TestGroup & );
  virtual void VisitCompactTestGroup( const CompactTestGroup & );
  virtual void VisitCompactTestCaseList( const CompactTestCaseList & );
  virtual void VisitCompactTestCase( const CompactTestCase & );
  virtual void VisitTestStepAttachment( const TestStepAttachment & );
  virtual void VisitTestCase( const TestCase & );
  virtual void VisitTestCaseId( const TestCaseId & );
  virtual void VisitTestGroupRef( const TestGroupRef & );
  virtual void VisitTestPurpose( const TestPurpose & );
  virtual void VisitObjective( const Objective & );
  virtual void VisitDescription( const Description & );
  virtual void VisitConfiguration( const Configuration & );
  virtual void VisitSelExprId( const SelExprId & );
  virtual void VisitDefaultsRef( const DefaultsRef & );
  virtual void VisitDefaultRefList( const DefaultRefList & );
  virtual void VisitDefaultReference( const DefaultReference & );
  virtual void VisitBehaviourDescription( const BehaviourDescription & );
  virtual void VisitRootTree( const RootTree & );
  virtual void VisitBehaviourLineList( const BehaviourLineList & );
  virtual void VisitChildren( const Children & );
  virtual void VisitBehaviourLine( const BehaviourLine & );
  virtual void VisitLineNumber( const LineNumber & );
  virtual void VisitLabelId( const LabelId & );
  virtual void VisitLabel( const Label & );
  virtual void VisitLine( const Line & );
  virtual void VisitIndentation( const Indentation & );
  virtual void VisitVerdictId( const VerdictId & );
  virtual void VisitVerdict( const Verdict & );
  virtual void VisitPass( const Pass & );
  virtual void VisitFail( const Fail & );
  virtual void VisitInconclusive( const Inconclusive & );
  virtual void VisitResult( const Result & );
  virtual void VisitStatementLine( const StatementLine & );
  virtual void VisitEventStatement( const EventStatement & );
  virtual void VisitEvent( const Event & );
  virtual void VisitSend( const Send & );
  virtual void VisitImplicitSend( const ImplicitSend & );
  virtual void VisitReceive( const Receive & );
  virtual void VisitOtherwise( const Otherwise & );
  virtual void VisitTimeout( const Timeout & );
  virtual void VisitDone( const Done & );
  virtual void VisitTCompIdList( const TCompIdList & );
  virtual void VisitAssignmentList( const AssignmentList & );
  virtual void VisitAssignment( const Assignment & );
  virtual void VisitQualifier( const Qualifier & );
  virtual void VisitTimerOps( const TimerOps & );
  virtual void VisitTimerOp( const TimerOp & );
  virtual void VisitStartTimer( const StartTimer & );
  virtual void VisitCancelTimer( const CancelTimer & );
  virtual void VisitReadTimer( const ReadTimer & );
  virtual void VisitTimerValue( const TimerValue & );
  virtual void VisitConstruct( const Construct & );
  virtual void VisitGoTo( const GoTo & );
  virtual void VisitAttach( const Attach & );
  virtual void VisitTreeReference( const TreeReference & );
  virtual void VisitRepeat( const Repeat & );
  virtual void VisitActivate( const Activate & );
  virtual void VisitCreate( const Create & );
  virtual void VisitCreateList( const CreateList & );
  virtual void VisitCreateTComp( const CreateTComp & );
  virtual void VisitCreateAttach( const CreateAttach & );
  virtual void VisitCref( const Cref & );
  virtual void VisitConstraintReference( const ConstraintReference & );
  virtual void VisitConsRef( const ConsRef & );
  virtual void VisitActualCrefParList( const ActualCrefParList & );
  virtual void VisitLocalTreeList( const LocalTreeList & );
  virtual void VisitLocalTree( const LocalTree & );
  virtual void VisitHeader( const Header & );
  virtual void VisitTreeHeader( const TreeHeader & );
  virtual void VisitTestStepLibrary( const TestStepLibrary & );
  virtual void VisitTestStepGroupOrTestStepList( const TestStepGroupOrTestStepList & );
  virtual void VisitTestStepGroupOrTestStep( const TestStepGroupOrTestStep & );
  virtual void VisitTestStepGroup( const TestStepGroup & );
  virtual void VisitTestGroupId( const TestGroupId & );
  virtual void VisitTestStepGroupId( const TestStepGroupId & );
  virtual void VisitTestStep( const TestStep & );
  virtual void VisitTestStepId( const TestStepId & );
  virtual void VisitTestStepIdAndParList( const TestStepIdAndParList & );
  virtual void VisitTestStepRef( const TestStepRef & );
  virtual void VisitDefaultsLibrary( const DefaultsLibrary & );
  virtual void VisitDefaultGroupOrDefaultList( const DefaultGroupOrDefaultList & );
  virtual void VisitDefaultGroupOrDefault( const DefaultGroupOrDefault & );
  virtual void VisitDefaultGroup( const DefaultGroup & );
  virtual void VisitDefaultCase( const DefaultCase & );
  virtual void VisitDefaultGroupId( const DefaultGroupId & );
  virtual void VisitDefaultId( const DefaultId & );
  virtual void VisitDefaultIdAndParList( const DefaultIdAndParList & );
  virtual void VisitDefaultRef( const DefaultRef & );
  virtual void VisitConstraintValueAndAttributes( const ConstraintValueAndAttributes & );
  virtual void VisitConstraintValue( const ConstraintValue & );
  virtual void VisitConstraintExpression( const ConstraintExpression & );
  virtual void VisitDefaultExpression( const DefaultExpression & );
  virtual void VisitMatchingSymbol( const MatchingSymbol & );
  virtual void VisitComplement( const Complement & );
  virtual void VisitOmit( const Omit & );
  virtual void VisitValueList( const ValueList & );
  virtual void VisitValRange( const ValRange & );
  virtual void VisitLowerRangeBound( const LowerRangeBound & );
  virtual void VisitUpperRangeBound( const UpperRangeBound & );
  virtual void VisitSuperSet( const SuperSet & );
  virtual void VisitSubSet( const SubSet & );
  virtual void VisitPermutation( const Permutation & );
  virtual void VisitValueAttributes( const ValueAttributes & );
  virtual void VisitValueLength( const ValueLength & );
  virtual void VisitSingleValueLength( const SingleValueLength & );
  virtual void VisitValueBound( const ValueBound & );
  virtual void VisitRangeValueLength( const RangeValueLength & );
  virtual void VisitLowerValueBound( const LowerValueBound & );
  virtual void VisitUpperValueBound( const UpperValueBound & );
  virtual void VisitExpression( const Expression & );
  virtual void VisitSimpleExpression( const SimpleExpression & );
  virtual void VisitTerm( const Term & );
  virtual void VisitFactor( const Factor & );
  virtual void VisitPrimary( const Primary & );
  virtual void VisitParenExpression( const ParenExpression & );
  virtual void VisitRelExpression( const RelExpression & );
  virtual void VisitAddExpression( const AddExpression & );
  virtual void VisitMultExpression( const MultExpression & );
  virtual void VisitUnaryExpression( const UnaryExpression & );
  virtual void VisitRelOp( const RelOp & );
  virtual void VisitAddOp( const AddOp & );
  virtual void VisitMultOp( const MultOp & );
  virtual void VisitUnaryOp( const UnaryOp & );
  virtual void VisitDataObjectReference( const DataObjectReference & );
  virtual void VisitComponentReferenceList( const ComponentReferenceList & );
  virtual void VisitComponentReference( const ComponentReference & );
  virtual void VisitRecordRef( const RecordRef & );
  virtual void VisitComponentIdentifier( const ComponentIdentifier & );
  virtual void VisitComponentPosition( const ComponentPosition & );
  virtual void VisitArrayRef( const ArrayRef & );
  virtual void VisitComponentNumber( const ComponentNumber & );
  virtual void VisitBitRef( const BitRef & );
  virtual void VisitBitIdentifier( const BitIdentifier & );
  virtual void VisitBitNumber( const BitNumber & );
  virtual void VisitOpCall( const OpCall & );
  virtual void VisitActualParList( const ActualParList & );
  virtual void VisitValue( const Value & );
  virtual void VisitLiteralValue( const LiteralValue & );
  virtual void VisitBooleanValue( const BooleanValue & );
  virtual void VisitR_Value( const R_Value & );
  virtual void VisitASN1_TypeAndLocalTypes( const ASN1_TypeAndLocalTypes & );
  virtual void VisitASN1_Type( const ASN1_Type & );
  virtual void VisitTypeReference( const TypeReference & );
  virtual void VisitDefinedType( const DefinedType & );
  virtual void VisitBuiltinType( const BuiltinType & );
  virtual void VisitNamedNumberList( const NamedNumberList & );
  virtual void VisitNamedNumber( const NamedNumber & );
  virtual void VisitIdOrNum( const IdOrNum & );
  virtual void VisitAlternativeTypeList( const AlternativeTypeList & );
  virtual void VisitElementTypeList( const ElementTypeList & );
  virtual void VisitElementType( const ElementType & );
  virtual void VisitComponentsOf( const ComponentsOf & );
  virtual void VisitNamedTypeAndAttributes( const NamedTypeAndAttributes & );
  virtual void VisitNamedTypeAttribute( const NamedTypeAttribute & );
  virtual void VisitNamedTypeOrSelection( const NamedTypeOrSelection & );
  virtual void VisitNamedType( const NamedType & );
  virtual void VisitIntegerType( const IntegerType & );
  virtual void VisitBitStringType( const BitStringType & );
  virtual void VisitSequenceType( const SequenceType & );
  virtual void VisitSequenceOfType( const SequenceOfType & );
  virtual void VisitSetType( const SetType & );
  virtual void VisitSetOfType( const SetOfType & );
  virtual void VisitChoiceType( const ChoiceType & );
  virtual void VisitSelectionType( const SelectionType & );
  virtual void VisitTaggedType( const TaggedType & );
  virtual void VisitTagAttributes( const TagAttributes & );
  virtual void VisitAnyType( const AnyType & );
  virtual void VisitAnyDefinedBy( const AnyDefinedBy & );
  virtual void VisitUsefulType( const UsefulType & );
  virtual void VisitEnumeratedType( const EnumeratedType & );
  virtual void VisitEnumeration( const Enumeration & );
  virtual void VisitNamedBitList( const NamedBitList & );
  virtual void VisitTag( const Tag & );
  virtual void VisitClassType( const ClassType & );
  virtual void VisitClassNumber( const ClassNumber & );
  virtual void VisitSubType( const SubType & );
  virtual void VisitPermittedAlphabet( const PermittedAlphabet & );
  virtual void VisitSizeConstraint( const SizeConstraint & );
  virtual void VisitContainedSubType( const ContainedSubType & );
  virtual void VisitSingleValue( const SingleValue & );
  virtual void VisitSubTypeSpec( const SubTypeSpec & );
  virtual void VisitParentSubType( const ParentSubType & );
  virtual void VisitParentType( const ParentType & );
  virtual void VisitSetSubType( const SetSubType & );
  virtual void VisitSequenceSubType( const SequenceSubType & );
  virtual void VisitSubtypeValueSet( const SubtypeValueSet & );
  virtual void VisitValueRange( const ValueRange & );
  virtual void VisitLowerEndpoint( const LowerEndpoint & );
  virtual void VisitUpperEndpoint( const UpperEndpoint & );
  virtual void VisitUpperEndValue( const UpperEndValue & );
  virtual void VisitLowerEndValue( const LowerEndValue & );
  virtual void VisitInnerTypeConstraints( const InnerTypeConstraints & );
  virtual void VisitWithComponent( const WithComponent & );
  virtual void VisitWithComponents( const WithComponents & );
  virtual void VisitFullSpecification( const FullSpecification & );
  virtual void VisitPartialSpecification( const PartialSpecification & );
  virtual void VisitSingleTypeConstraint( const SingleTypeConstraint & );
  virtual void VisitMultipleTypeConstraints( const MultipleTypeConstraints & );
  virtual void VisitTypeConstraints( const TypeConstraints & );
  virtual void VisitNamedConstraintList( const NamedConstraintList & );
  virtual void VisitNamedConstraint( const NamedConstraint & );
  virtual void VisitValueConstraint( const ValueConstraint & );
  virtual void VisitPresenceConstraint( const PresenceConstraint & );
  virtual void VisitConstraint( const Constraint & );
  virtual void VisitASN1_LocalTypes( const ASN1_LocalTypes & );
  virtual void VisitTypeAssignmentList( const TypeAssignmentList & );
  virtual void VisitTypeAssignment( const TypeAssignment & );
  virtual void VisitASN1_Value( const ASN1_Value & );
  virtual void VisitBitStringValue( const BitStringValue & );
  virtual void VisitIdentifierList( const IdentifierList & );
  virtual void VisitSequenceValue( const SequenceValue & );
  virtual void VisitElementValueList( const ElementValueList & );
  virtual void VisitSequenceOfValue( const SequenceOfValue & );
  virtual void VisitASN1_ValueList( const ASN1_ValueList & );
  virtual void VisitSetValue( const SetValue & );
  virtual void VisitSetOfValue( const SetOfValue & );
  virtual void VisitChoiceValue( const ChoiceValue & );
  virtual void VisitSelectionValue( const SelectionValue & );
  virtual void VisitAnyValue( const AnyValue & );
  virtual void VisitNamedValue( const NamedValue & );
  virtual void VisitObjectIdentifierValue( const ObjectIdentifierValue & );
  virtual void VisitObjIdComponentList( const ObjIdComponentList & );
  virtual void VisitObjIdComponent( const ObjIdComponent & );
  virtual void VisitNameForm( const NameForm & );
  virtual void VisitNumberForm( const NumberForm & );
  virtual void VisitNameAndNumberForm( const NameAndNumberForm & );
  virtual void VisitRealValue( const RealValue & );
  virtual void VisitNumericRealValue( const NumericRealValue & );
  virtual void VisitMantissa( const Mantissa & );
  virtual void VisitBase( const Base & );
  virtual void VisitExponent( const Exponent & );
  virtual void VisitSpecialRealValue( const SpecialRealValue & );
  virtual void VisitDefinedValue( const DefinedValue & );
  virtual void VisitSignedNumber( const SignedNumber & );
  virtual void VisitDefaultValue( const DefaultValue & );
  virtual void VisitIdentifier( const Identifier & );
  virtual void VisitFormalParList( const FormalParList & );
  virtual void VisitFormalParAndType( const FormalParAndType & );
  virtual void VisitFormalParIdList( const FormalParIdList & );
  virtual void VisitFormalParType( const FormalParType & );
  virtual void VisitTestGroupReference( const TestGroupReference & );
  virtual void VisitTestStepGroupReference( const TestStepGroupReference & );
  virtual void VisitDefaultGroupReference( const DefaultGroupReference & );
  virtual void VisitOstring( const Ostring & );
  virtual void VisitCstring( const Cstring & );
  virtual void VisitBstring( const Bstring & );
  virtual void VisitHstring( const Hstring & );
  virtual void VisitINTEGER( const INTEGER & );
  virtual void VisitBOOLEAN_TYPE( const BOOLEAN_TYPE & );
  virtual void VisitBITSTRING( const BITSTRING & );
  virtual void VisitHEXSTRING( const HEXSTRING & );
  virtual void VisitOCTETSTRING( const OCTETSTRING & );
  virtual void VisitBooleanType( const BooleanType & );
  virtual void VisitOctetStringType( const OctetStringType & );
  virtual void VisitObjectIdentifierType( const ObjectIdentifierType & );
  virtual void VisitNumericString( const NumericString & );
  virtual void VisitPrintableString( const PrintableString & );
  virtual void VisitTeletexString( const TeletexString & );
  virtual void VisitVideotexString( const VideotexString & );
  virtual void VisitVisibleString( const VisibleString & );
  virtual void VisitIA5String( const IA5String & );
  virtual void VisitGraphicString( const GraphicString & );
  virtual void VisitGeneralString( const GeneralString & );
  virtual void VisitT61String( const T61String & );
  virtual void VisitISO646String( const ISO646String & );
  virtual void VisitGeneralizedTime( const GeneralizedTime & );
  virtual void VisitUTCTime( const UTCTime & );
  virtual void VisitEXTERNAL( const EXTERNAL & );
  virtual void VisitObjectDescriptor( const ObjectDescriptor & );
  virtual void VisitRealType( const RealType & );
  virtual void VisitUNIVERSAL( const UNIVERSAL & );
  virtual void VisitAPPLICATION( const APPLICATION & );
  virtual void VisitPRIVATE_( const PRIVATE_ & );
  virtual void VisitANY( const ANY & );
  virtual void VisitMax( const Max & );
  virtual void VisitMin( const Min & );
  virtual void VisitINCLUSIVE( const INCLUSIVE & );
  virtual void VisitPRESENT( const PRESENT & );
  virtual void VisitIF_PRESENT( const IF_PRESENT & );
  virtual void VisitABSENT( const ABSENT & );
  virtual void VisitOPTIONAL( const OPTIONAL & );
  virtual void VisitNullType( const NullType & );
  virtual void VisitNullValue( const NullValue & );
  virtual void VisitPlus_INFINITY( const Plus_INFINITY & );
  virtual void VisitMinusINFINITY( const MinusINFINITY & );
  virtual void VisitMinus_INFINITY( const Minus_INFINITY & );
  virtual void VisitINFINITY( const INFINITY & );
  virtual void VisitPDU( const PDU & );
  virtual void VisitCP( const CP & );
  virtual void VisitTIMER( const TIMER & );
  virtual void VisitUT( const UT & );
  virtual void VisitLT( const LT & );
  virtual void VisitMTC( const MTC & );
  virtual void VisitPTC( const PTC & );
  virtual void VisitPicoSeconds( const PicoSeconds & );
  virtual void VisitNanoSeconds( const NanoSeconds & );
  virtual void VisitMicroSeconds( const MicroSeconds & );
  virtual void VisitMilliSeconds( const MilliSeconds & );
  virtual void VisitSeconds( const Seconds & );
  virtual void VisitMinutes( const Minutes & );
  virtual void VisitAIMPLICIT( const AIMPLICIT & );
  virtual void VisitAEXPLICIT( const AEXPLICIT & );
  virtual void VisitRETURN_( const RETURN_ & );
  virtual void VisitPASS( const PASS & );
  virtual void VisitPreliminaryPASS( const PreliminaryPASS & );
  virtual void VisitFAIL( const FAIL & );
  virtual void VisitPreliminaryFAIL( const PreliminaryFAIL & );
  virtual void VisitINCONC( const INCONC & );
  virtual void VisitPreliminaryINCONC( const PreliminaryINCONC & );
  virtual void VisitR( const R & );
  virtual void VisitNONE( const NONE & );
  virtual void VisitR_TYPE( const R_TYPE & );
  virtual void VisitOMIT( const OMIT & );
  virtual void VisitANYValue( const ANYValue & );
  virtual void VisitAnyOrOmit( const AnyOrOmit & );
  virtual void VisitEqual( const Equal & );
  virtual void VisitLess( const Less & );
  virtual void VisitGreater( const Greater & );
  virtual void VisitNotEqual( const NotEqual & );
  virtual void VisitGreaterOrEqual( const GreaterOrEqual & );
  virtual void VisitLessOrEqual( const LessOrEqual & );
  virtual void VisitTwo( const Two & );
  virtual void VisitTen( const Ten & );
  virtual void VisitMult( const Mult & );
  virtual void VisitDiv( const Div & );
  virtual void VisitMod( const Mod & );
  virtual void VisitAnd( const And & );
  virtual void VisitOr( const Or & );
  virtual void VisitMinus( const Minus & );
  virtual void VisitNot( const Not & );
  virtual void VisitPlus( const Plus & );
  virtual void VisitATrue( const ATrue & );
  virtual void VisitAFalse( const AFalse & );
  virtual void VisitMacroSymbol( const MacroSymbol & );
  virtual void VisitCharacterStringList( const CharacterStringList & );
  virtual void VisitCharsDefn( const CharsDefn & );
  virtual void VisitTuple( const Tuple & );
  virtual void VisitTableColumn( const TableColumn & );
  virtual void VisitTableRow( const TableRow & );
};


#endif
