/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:44 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1993, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
 /*
 * Description:
 *  This header file is a template file generated by the ITEX C Code
 *  Generator to provide the user with a quick way to get started with
 *  the adaptation process.
 */

#ifndef ADAPTOR_H
#define ADAPTOR_H

#include <stdio.h>

/*-------------------------------------------------------------------------
 * These are the functions of the GCI operational interface. The adaptation
 * process is the process of implementing these functions to allow the
 * generated code to communicate with the system to be tested. Here is a 
 * short description of what the functions must do:
 *
 * GciSend          - Send something to the IUT through a PCO
 * GciImplicitSend  - Send something to the IUT, not through a PCO (but for
 *                    example to the test operator) to affect the current
 *                    status of the IUT
 * GciStartTimer    - Start a given timer
 * GciCancelTimer   - Cancel a given timer
 * GciReadTimer     - Read the value of a given timer
 * GciSnapshot      - Check the status of the receive channels, timers and
 *                    possibly test components (concurrent TTCN)
 * GciLog           - Function used for logging
 * GciConfig        - Create configuration (concurrent TTCN)
 * GciCreate        - Create test component (concurrent TTCN)
 */

GciStatus GciSend( int pco, GciValue* object );
GciStatus GciImplicitSend( GciValue* object );
GciStatus GciStartTimer( GciTimerID timer, long value, int unit );
GciStatus GciCancelTimer( GciTimerID timer );
long GciReadTimer( GciTimerID timer );
GciStatus GciSnapshot( );
GciSnapshotStatus GciPollingSnapshot( );
GciStatus GciConfig( GciConf conf );
GciStatus GciCreate( int comp, char* tree, GciValue* args );
GciStatus GciLog( int logId, const char* logString );
void GciLogPrint( const char* string, const char* logString, int isRow );

extern GciValue* GciReadTSPar( char* par, char* pRef );

/*------------------------------------------------------------------------
 * Global definition of the Log Stream used by the GciLog function, might
 * be used by other user written code in order to have a conformant logging.
 */

extern FILE * logStream;

#endif /* ADAPTOR_H */
