/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:44 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1993, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "types_gen.h"
#include "gci.h"
#include "static.h"
#include "mscgen.h"



#ifdef GENMSC
  const Bool global_variable_genmsc = GcTRUE;
#else
  const Bool global_variable_genmsc = GcFALSE;
#endif

/*--------------------------------------------------------------------
 *
 * Note: There are some comments in the accompanying mscgen.h file,
 * and also in the TTCN Suite user manual. This file is
 * subject to change between releases and user changes may not be
 * supported.
 *
 *------------------------------------------------------------------*/


/*--------------------------------------------------------------------
 * Definition Name: MSC_DEFAULT_SYSTEM_NAME
 * Description:
 *
 *  In the composed MSC generation mode, this is used as a default 
 *  name for the IUT. The function MscSetSystemName overrides this
 *  value.
 */

#define MSC_DEFAULT_SYSTEM_NAME "IUT"

/*--------------------------------------------------------------------
 * Definition Name: MSC_DEFAULT_FILE_PREFIX
 * Description:
 *
 *  Used as file name prefix if MscFilePrefix is NULL
 */

#define MSC_DEFAULT_FILE_PREFIX "log_"

/*--------------------------------------------------------------------
 * Definition Name: MSC_MAX_VALUE_LEN
 * Description:
 *
 *  Determines the buffer size for textual encodings of any data
 *  parameters for messages.
 */

/*--------------------------------------------------------------------
 * Definition Name: MSC_MSCE_MODE, MSC_FILE_MODE
 * Description:
 *
 *  If the MSC_MSCE_MODE flag is set, the tool will attempt to
 *  communicate with the SDT postmaster using the mscpm interface. 
 *  If else, it will attempt to generate new files for each test case.
 *
 *  Note that the two modes are not mutually exclusive.
 */

#ifndef MSC_MSCE_MODE
# undef  MSC_FILE_MODE
# define MSC_FILE_MODE
#endif

/*--------------------------------------------------------------------
 * Definition Name: MscFilePrefix
 * Description:
 *
 *  Static variable possibly holding a prefix for file names with 
 *  possible path that will be pre-pended to any generated files.
 */

#ifdef MSC_FILE_MODE
static char * MscFilePrefix = (char*) 0;
#endif

/*--------------------------------------------------------------------
 * Other inclusions, depending on postmaster library mode
 */

#ifdef MSC_MSCE_MODE
# include <post.h>
# include <sdt.h>
# include "mscpm.h"
#endif

/*--------------------------------------------------------------------
 * Type Name:   MscMessageEvent
 * Description: Represents an MSC Event
 */

typedef struct _MscMessageEvent {
  struct _MscMessageEvent * next;/* Next in list */
  unsigned int id;		/* Unsigned int identifier */
  MscString from;		/* From instance name */
  MscString to;			/* To instance name */
  MscString type;		/* Message type name */
  MscString value;/* Encoded representation of value */
} MscMessageEvent;


/*--------------------------------------------------------------------
 * Type Name:   MscDisplayNameEntry
 * Description: Keeping track of instance names to make them unique.
 */

typedef struct _MscDisplayNameEntry 
{
  char name[256];
  int nr;
  char dispname[256];
  struct _MscDisplayNameEntry* next;
} MscDisplayNameEntry;

/*--------------------------------------------------------------------
 * Object Name: dispnamelist
 * Description: List of instance names.
 */
static MscDisplayNameEntry *dispnamelist = NULL;

/*--------------------------------------------------------------------
 * Object Name: MscMessageEventList
 * Description: List of messages sent but still not consumed
 */

static MscMessageEvent * MscMessageEventList = (MscMessageEvent*) 0;

/*--------------------------------------------------------------------
 * Function Names: MscMessageEvent*()
 * Description: Forward definitions of functions manipulating the
 * MscMessageEventList
 */

static const MscMessageEvent *
MscMessageEventEnqueue( const char * from, 
			const char * to, 
			const char * type, 
			MscString value );

static MscMessageEvent *
MscMessageEventFindFirst( const char * from,
			  const char * to );

static void
MscMessageEventRemove( MscMessageEvent * event );

/*--------------------------------------------------------------------
 * Type Name:   MscTimerEvent
 * Description: Used to keep track of running timers
 */

typedef struct _MscTimerEvent{
  struct _MscTimerEvent * next;	/* Next in list */
  unsigned int id;		/* Unsigned int identifier */
  MscString ptc;		/* Name of test component */
  MscString name;		/* Timer name */
}  MscTimerEvent;

/*--------------------------------------------------------------------
 * Object Name: MscTimerEventList
 * Description: List of timers that are currently running
 */

static MscTimerEvent * MscTimerEventList = NULL;

/*--------------------------------------------------------------------
 * Function Names: MscTimerEvent*()
 * Description: Forward definitions of functions manipulating the
 * MscMessageEventList
 */

static const MscTimerEvent *
MscTimerEventInsert( const char * ptc, const char * timer );

static MscTimerEvent * 
MscTimerEventFind( const char * ptc, const char * timer );

static void 
MscTimerEventRemove( MscTimerEvent * event );

/*--------------------------------------------------------------------
 * Object Name: mscLogMode
 * Description:
 *  
 *  The mode of logging that will be used. If the mode is 
 *  MscComposedMode a form will be used where the internal behaviour 
 *  of the tester is hidden. If else, it will show internal details, 
 *  such as CP communication and timer activity.
 */

static char * MscSystemName = MSC_DEFAULT_SYSTEM_NAME;

/*--------------------------------------------------------------------
 * Object Name: mscLogMode
 * Description:
 *  
 *  The mode of logging that will be used. If the mode is 
 *  MscComposedMode a form will be used where the internal behaviour 
 *  of the tester is hidden. If else, it will show internal details, 
 *  such as CP communication and timer activity.
 */

static MscLogMode MscCurrentMode = MscDecomposedMode;

/*--------------------------------------------------------------------
 * Object Name: MscEventId;
 * Description:
 *  
 *  Flag determining if a test is in progress. This is reset by the
 *  functions MscInit, MscExit and MscStopTestCase. It is set by the
 *  function MscStartTestCase. It is also used as a counter of event
 *  identifiers, which is used to determine which event belong to a
 *  given action.  
 */

static int MscEventId = 0;

/*--------------------------------------------------------------------
 * Object Name: mscOutputFile;
 * Description:
 *  
 *  Defined if MSC_FILE_MODE is defined at compile time. The current
 *  open output file.
 */

#ifdef MSC_FILE_MODE
static FILE * MscOutputFile = NULL;
#endif

/*--------------------------------------------------------------------
 * Function Name: MscGenerateFileName
 * Description:
 *  
 *  Defined if MSC_FILE_MODE is defined at compile time. Determines a
 *  name of a non-existing log file.
 */

#ifdef MSC_FILE_MODE
static void MscGenerateFileName( const char * testname, MscString buffer );
#endif

/*--------------------------------------------------------------------
 * Object Name: mscOutputFile;
 * Description:
 *  
 *  Buffer id of a MSC Editor buffer;
 */

#ifdef MSC_MSCE_MODE
# include "mscpm.h"
#endif

/*--------------------------------------------------------------------
 * Variable Name: MscBufId
 * Description:
 *
 *  Keeps track of the current buffer id of the generated msc in msc 
 *  editor.
 */

#ifdef MSC_MSCE_MODE
static int  MscBufId = 0;
#endif

/*--------------------------------------------------------------------
 * Function Name: MscAppendPREvent;
 * Description:
 *  
 *  Append a PR event to the MSC log(s).
 */

static void MscAppendPREvent( const char * event );

static const char* MscMapDisplayName(const char *name);
static const char* MscGetDisplayName(const char *name);
static MscDisplayNameEntry *MscGetDisplayNameEntry(const char* name);
static MscDisplayNameEntry *MscNewDisplayNameEntry(const char* name, int nr );
static void MscDeleteDisplayNameEntries();

/*--------------------------------------------------------------------
 * Function Name: MscInit
 * Description:
 *
 *   Connect to postmaster if managing a PM connection. Initialize the
 *   static variables.  
 */

void MscInit( )
{
#ifdef GENMSC

  /* Initialize variables */
  MscEventId = 0;		/* Indicates that no test is in progress */
  MscMessageEventList = (MscMessageEvent*) 0;
  MscTimerEventList   = (MscTimerEvent*) 0;

#ifdef MSC_FILE_MODE
  MscOutputFile = NULL;
#endif

#ifdef MSC_MSCE_MODE
  MscBufId = 0;

  /* Initialize postmaster connection if we are to create our own */
  MscPmInit();
#endif

  return;
#endif
}

/*--------------------------------------------------------------------
 * Function Name: MscExit
 * Description:
 *
 *   Close files and connections, reset static variables if necessary 
 */

void MscExit( void )
{
#ifdef GENMSC
  MscEventId = 0;
  MscMessageEventList = (MscMessageEvent*) 0;
  MscTimerEventList   = (MscTimerEvent*) 0;

#ifdef MSC_FILE_MODE
  if ( MscOutputFile != NULL ) {
    fclose( MscOutputFile );
    MscOutputFile = NULL;
  }
  MscSetFilePrefix( (const char*) 0 ); /* This is to free memory */
#endif

#ifdef MSC_MSCE_MODE
  MscPmExit( );
#endif
  
  return;
#endif
}

/*--------------------------------------------------------------------
 * Function Name: MscSetLogMode
 * Description:
 *
 *  If no test case is in progress, set the current log mode to the
 *  provided new mode.
 */

void MscSetLogMode( MscLogMode logmode )
{
#ifdef GENMSC
  if ( MscEventId == 0 )
    MscCurrentMode = logmode;
  else
    GciLog( GciLogMessage, 
	    "Cannot change log mode while test is running" );
  return;
#else
  VC_NOT_USED(logmode)
#endif
}

/*--------------------------------------------------------------------
 * Function Name: MscSetSystemName
 * Description:
 *
 *  If no test case is in progress, set the name of the IUT used by
 *  the composed msc generation mode.
 */

void MscSetSystemName( const char * iut_name )
{
#ifdef GENMSC
  if ( MscEventId == 0 ) {
    /* This will be a memory leak if done over and over: */
    MscSystemName = (char*) VCMALLOC( strlen( iut_name ) + 1 , GcFALSE);
    strcpy( MscSystemName, iut_name );
  }
  else
    GciLog( GciLogMessage, 
	    "Cannot change iut name while test is running" );
  return;
#else
  VC_NOT_USED(iut_name)
#endif
}

/*--------------------------------------------------------------------
 * Function Name: MscSetFilePrefix
 * Description:
 *
 *  This function sets a prefix to the file name for generated files.
 *  It has no effect if the current generation mode is MSC_MSCE_MODE.
 *  The function will create a static copy of the filename.
 *
 *  A parameter value of 0 will make the code use the 
 *  MSC_DEFAULT_FILE_PREFIX file prefix as prefix.
 */

void 
MscSetFilePrefix( const char * prefix )
{
#ifdef GENMSC

#ifdef MSC_FILE_MODE 
  if ( MscFilePrefix )
    VCFREE( MscFilePrefix ); 
  if ( prefix ) {
    MscFilePrefix = (char*) VCMALLOC( strlen( prefix ) + 1, GcFALSE );
    strcpy( MscFilePrefix, prefix );
  }
  else
    MscFilePrefix = 0;
#else
  (void) &prefix;		/* Avoid compiler warning */
#endif  
  return;
#else 
  VC_NOT_USED(prefix);
#endif
}


/*--------------------------------------------------------------------
 * Function Name: MscStartTestCase
 * Description:
 *
 *  Create a new MSC for the test case.
 */

void MscStartTestCase( const char * ptc, const char * name )
{
#ifdef GENMSC
  if ( MscEventId != 0 ) {
    GciLog ( GciLogMessage, "MscStartTestCase: Discarding old trace\n" );
    MscStopTestCase( ptc );
  }

  if ( MscCurrentMode == MscNologMode )
    return;

  MscEventId = 1;		/* Will reset event numbering and
				   non-zero value also 
				   indicates that a test is 
				   in progress */

#ifdef MSC_FILE_MODE
  {
    MscString buffer=MscStringCreate();
    MscGenerateFileName( name, buffer );
    GciLog( GciLogMessage, "Attempting to create MSC PR trace file," );
    GciLog( GciLogMessage, MscStringBegin(buffer) );

    MscOutputFile = fopen( MscStringBegin(buffer), "w" );
	MscStringDelete(buffer);
    if ( MscOutputFile == 0 ) {
      GciLog( GciLogMessage, "Failed to create MSC PR log file" );
    }
  }
#endif

#ifdef MSC_MSCE_MODE
  {
    MscString buffer=MscStringCreate();
    int status = 0;
    
	MscStringAddInteger(buffer,SET_MSCE);
    MscPmDoRPC( SET_ORGANIZER, SESTART, MscStringBegin(buffer) );
    
	MscStringClear(buffer);
	MscStringAddInteger(buffer,16);
	MscStringAddText(buffer," \"");
	MscStringAddText(buffer,name);
	MscStringAddText(buffer," \" \"\"");
    MscPmDoRPC( SET_MSCE, SEMSCECREATEDIAGRAM, MscStringBegin(buffer) );
    sscanf( MscStringBegin(buffer), "%d %d", &status, &MscBufId );
	MscStringDelete(buffer);
  }
#endif  

  {
    MscString buffer=MscStringCreate();
    int pcoindex;

#ifndef MSC_MSCE_MODE
/*	MscStringAddText(buffer,"mscdocument ");
	MscStringAddText(buffer,name );
	MscStringAddText(buffer,";");*/
	MscStringAddText(buffer,"msc ");
	MscStringAddText(buffer,name );
	MscStringAddText(buffer,";");
    MscAppendPREvent( MscStringBegin(buffer) );
#endif

    for ( pcoindex = 0; pcoindex < GciGetNoOfPCOs(); ++pcoindex ) {
	    int id = GciGetPCO( pcoindex );
	    if (IcIsCP( VcContextGetValueByID( id, IcGetActiveContext() ) ) == GcFALSE) {
			MscStringClear(buffer);
			MscStringAddText(buffer,GciGetPCOName( id ));
			MscStringAddText(buffer," : instance;");
            MscAppendPREvent(MscStringBegin(buffer));
	    }
    }

    if ( MscCurrentMode == MscDecomposedMode ) {
	  MscStringClear(buffer);
	  MscStringAddText(buffer, ptc);
	  MscStringAddText(buffer," : instance;");
      MscAppendPREvent( MscStringBegin(buffer) );
    } 

    if ( MscCurrentMode == MscComposedMode ) {
	  MscStringClear(buffer);
	  MscStringAddText(buffer, MscSystemName);
	  MscStringAddText(buffer," : instance;");
      MscAppendPREvent( MscStringBegin(buffer) );
    }
	MscStringDelete(buffer);
    
  }

  return;
#else
  VC_NOT_USED(name);
  VC_NOT_USED(ptc);
#endif
}

/*--------------------------------------------------------------------
 * Function Name: MscStopTestCase
 * Description:	  
 * 
 *   Terminate a MSC test case log. Includes generation of some
 *   cleanup code for running timers and the MTC. Also generate the
 *   final verdict as a text box in the MSC.
 */

void MscStopTestCase( const char * ptc )
{
#ifdef GENMSC
  MscString buffer=MscStringCreate();

  if ( MscCurrentMode == MscNologMode )
  {
	MscStringDelete(buffer);
    return;
  }

  /* Generate implicit consumptions of any pending timers or messages
     - the timer list should be empty unless it is a decomposed
     mode. Therefore there is no check. */
  
  while ( MscTimerEventList ) {
  
	MscStringClear(buffer);
	MscStringAddText(buffer,MscStringBegin(MscTimerEventList->ptc));
	MscStringAddText(buffer," : reset ");
	MscStringAddText(buffer,MscStringBegin(MscTimerEventList->name));
	MscStringAddText(buffer,",");
	MscStringAddInteger(buffer,MscTimerEventList->id);
	MscStringAddText(buffer," comment 'Implicit';");
    MscAppendPREvent( MscStringBegin(buffer));
    MscTimerEventRemove( MscTimerEventList );
  }

  while ( MscMessageEventList ) {

	MscStringClear(buffer);
	MscStringAddText(buffer,MscStringBegin(MscMessageEventList->to));
	MscStringAddText(buffer," : in ");
	MscStringAddText(buffer,MscStringBegin(MscMessageEventList->type));
	MscStringAddText(buffer,",");
	MscStringAddInteger(buffer,MscMessageEventList->id);
	MscStringAddText(buffer,"(");
	MscStringAddText(buffer,MscStringBegin(MscMessageEventList->value));
	MscStringAddText(buffer,") from ");
	MscStringAddText(buffer,MscStringBegin(MscMessageEventList->from));
	MscStringAddText(buffer," comment 'Discarded';");
    MscAppendPREvent( MscStringBegin(buffer) );
    MscMessageEventRemove( MscMessageEventList );
  }

  /* Terminate the msc log */
  if ( MscCurrentMode == MscDecomposedMode ) {
	MscStringClear(buffer);
	MscStringAddText(buffer,ptc);
	MscStringAddText(buffer," : stop;");
    MscAppendPREvent( MscStringBegin(buffer));
  } 

#ifndef MSC_MSCE_MODE
  MscAppendPREvent( "endmsc;" );
#endif

#ifdef MSC_FILE_MODE
  if ( MscOutputFile )
    fclose ( MscOutputFile );
  MscOutputFile = NULL;
#endif

  MscDeleteDisplayNameEntries();

  MscEventId = 0;	/* Indicate that the test has stopped */
  MscStringDelete(buffer);
  return;
#else
  VC_NOT_USED(ptc);
#endif
}

/*--------------------------------------------------------------------
 * Function Name: MscOut
 * Description:   
 *
 *   Produce an Out event in the MSC log. This corresponds
 *   to an instance sending something. Also store this in
 *   the MessageList for later use with a MscIn event.
 */

void MscOut( MscMessageDirection direction,
	     const char * from, 
	     const char * to, 
	     GciValue * value,
	     const char * comment )
{
#ifdef GENMSC

  MscString buffer=MscStringCreate();
  const MscMessageEvent * event;

  if ( MscCurrentMode == MscNologMode ) 
    return;

  if ( MscCurrentMode == MscComposedMode && direction == MscInternalMessage )
    return;

  MscEncodeValue( value, buffer);

  /* Possibly adjust the instance names to fit with composed mode */
  if ( MscCurrentMode == MscComposedMode )
    if ( direction == MscSendMessage )
      from = to, to = MscSystemName;
    else
      to = from, from = MscSystemName;

  event = 
    MscMessageEventEnqueue( from, 
			    to, 
			    GciGetTypeNameString( GciGetType( value ) ), 
			    buffer );
  
  if ( event ) {
    
	MscStringClear(buffer);
	MscStringAddText(buffer,MscMapDisplayName(MscStringBegin(event->from)));
	MscStringAddText(buffer," : out ");
	MscStringAddText(buffer,MscStringBegin(event->type));
	MscStringAddText(buffer,",");
	MscStringAddInteger(buffer,event->id);
	MscStringAddText(buffer,MscStringBegin(event->value));
	MscStringAddText(buffer," to ");
	MscStringAddText(buffer,MscMapDisplayName(MscStringBegin(event->to)));

    
    if ( comment && strcmp( comment, "") ) {
	  MscStringAddText(buffer," comment '");
	  MscStringAddText(buffer,comment);
	  MscStringAddText(buffer,"';");
    }
    else
	  MscStringAddText(buffer,";");
    MscAppendPREvent( MscStringBegin(buffer) );
  }
  else
    GciLog( GciLogMessage, "MscOut: Failed to insert msc event" );

  MscStringDelete(buffer);

#else
  VC_NOT_USED(direction);
  VC_NOT_USED(from);
  VC_NOT_USED(to);
  VC_NOT_USED(value);
  VC_NOT_USED(comment);
#endif

}

/*--------------------------------------------------------------------
 * Function Name: MscIn
 * Description:   
 *
 *   Produce an In event in the MSC log. This corresponds to an
 *   instance consuming something. The event is to be found in the
 *   MessageList where it was stored by a corresponding MscOut action.
 */

void MscIn( MscMessageDirection direction,
	    const char * from, 
	    const char * to, 
	    const char * comment )
{
#ifdef GENMSC
  MscMessageEvent * event;

  if ( MscCurrentMode == MscNologMode ) 
    return;

  if ( MscCurrentMode == MscComposedMode && direction == MscInternalMessage )
    return;

  /* Possibly adjust the instance names to fit with composed mode */
  if ( MscCurrentMode == MscComposedMode )
    if ( direction == MscSendMessage )
      from = to, to = MscSystemName;
    else
      to = from, from = MscSystemName;

  event = MscMessageEventFindFirst( from, to );
  if ( event ) {
    MscString buffer=MscStringCreate();

	MscStringAddText(buffer,MscMapDisplayName(MscStringBegin(event->to)));
	MscStringAddText(buffer," : in ");
	MscStringAddText(buffer,MscStringBegin(event->type));
	MscStringAddText(buffer,",");
	MscStringAddInteger(buffer,event->id);
	MscStringAddText(buffer,MscStringBegin(event->value));
	MscStringAddText(buffer," from ");
	MscStringAddText(buffer,MscMapDisplayName(MscStringBegin(event->from)));

    if ( comment && strcmp( comment, "") ) {
	  MscStringAddText(buffer," comment '");
	  MscStringAddText(buffer,comment);
	  MscStringAddText(buffer,"';");
    }
    else
	  MscStringAddText(buffer,";");

    MscAppendPREvent( MscStringBegin(buffer));
    MscMessageEventRemove( event );
    MscStringDelete(buffer);
  }
  else {
    GciLog( GciLogMessage, "MscIn: Failed to find message" );
  }
#else
  VC_NOT_USED(direction);
  VC_NOT_USED(from);
  VC_NOT_USED(to);
  VC_NOT_USED(comment);
#endif
}

/*--------------------------------------------------------------------
 * Function Name: MscImplicitSend
 * Description:
 *
 *  If mode is Decomposed, log the implicit send as a send event
 *  with a comment.
 */

void MscImplicitSend( const char * ptc, GciValue * value )
{
#ifdef GENMSC
  if ( MscCurrentMode == MscDecomposedMode ) {    
    MscString buffer=MscStringCreate();
    MscString encoded=MscStringCreate();

    MscEncodeValue( value, encoded);

	MscStringAddText(buffer,MscMapDisplayName(ptc));
	MscStringAddText(buffer," : out ");
	MscStringAddText(buffer,GciGetTypeNameString( GciGetType( value )));
	MscStringAddInteger(buffer,MscEventId++);
	MscStringAddText(buffer,MscStringBegin(encoded));
	MscStringAddText(buffer," to lost comment 'Implicit Send';");
    MscAppendPREvent( MscStringBegin(buffer) );
	MscStringDelete(buffer);
	MscStringDelete(encoded);
  }
  return;
#else
  VC_NOT_USED(ptc);
  VC_NOT_USED(value);
#endif

}

/*--------------------------------------------------------------------
 * Function Name: MscStartTimer
 * Description:
 *
 *  If mode is Decomposed, log the starting of the timer in the MSC.
 *  The MscTimerEventInsert function may also produce a cancel event.
 */

void MscStartTimer( const char * ptc, const char * timer, long dur )
{
#ifdef GENMSC
  if ( MscCurrentMode == MscDecomposedMode ) {
    const MscTimerEvent * event = MscTimerEventInsert( ptc, timer );
    char * buffer = (char*) VCMALLOC( strlen(ptc) + strlen(timer) + 100,GcFALSE );
    sprintf( buffer, "%s : set %s,%ld/* #SDTMSCPAR(%d) */;", 
	     MscMapDisplayName(MscStringBegin(event->ptc)), MscStringBegin(event->name), event->id, dur );
    MscAppendPREvent( buffer );
    VCFREE( buffer );
  }
  return;
#else
  VC_NOT_USED(ptc);
  VC_NOT_USED(timer);
  VC_NOT_USED(dur);
#endif

}

/*--------------------------------------------------------------------
 * Function Name: MscCancelTimer
 * Description:
 *
 *  Find the event matching the cancel event, and generate a reset
 */

void MscCancelTimer( const char * ptc, const char * timer )
{
#ifdef GENMSC
  if ( MscCurrentMode == MscDecomposedMode ) {
    MscTimerEvent * event = MscTimerEventFind( ptc, timer );
    if ( event ) {
      char * buffer = (char*) VCMALLOC( strlen(ptc)+strlen(timer) + 100, GcFALSE );
      sprintf( buffer, "%s : reset %s,%d;", 
	       MscMapDisplayName(MscStringBegin(event->ptc)), MscStringBegin(event->name), event->id );
      MscAppendPREvent( buffer );
      VCFREE(buffer );
      MscTimerEventRemove( event );
    }
    else
      GciLog( GciLogMessage, "MscCancelTimer: Timer not running" );
  }
  return;
#else
  VC_NOT_USED(ptc);
  VC_NOT_USED(timer);
#endif
}

/*--------------------------------------------------------------------
 * Function Name: MscTimeoutTimer
 * Description:
 *
 *  Log the named timer as expired
 */

void MscTimeoutTimer( const char * ptc, const char * timer )
{
#ifdef GENMSC
  if ( MscCurrentMode == MscDecomposedMode ) {
    MscTimerEvent * event = MscTimerEventFind( ptc, timer );
    if ( event ) {
      char * buffer = (char*) VCMALLOC( strlen(ptc)+strlen(timer) + 100, GcFALSE );
      sprintf( buffer, "%s : timeout %s,%d;", 
	       MscMapDisplayName(MscStringBegin(event->ptc)), MscStringBegin(event->name), event->id );
      MscAppendPREvent( buffer );
      VCFREE ( buffer );
      MscTimerEventRemove( event );
    }
    else
      GciLog( GciLogMessage, "MscTimeoutTimer: Timer not running" );
  }
  return;
#else
  VC_NOT_USED(ptc);
  VC_NOT_USED(timer);
#endif
}

/*--------------------------------------------------------------------
 * Function Name: MscCreateComponent
 * Description:
 *  Create the instance axis corresponding to the named component.
 */

void MscCreateComponent( const char * parent, const char * child )
{
#ifdef GENMSC
  if ( MscCurrentMode == MscDecomposedMode ) {
    char * buffer = (char*)VCMALLOC( strlen ( parent ) + strlen( child ) + 100, GcFALSE );
    const char* dchild = MscGetDisplayName(child);
    sprintf( buffer, "%s : instance %s;", (dchild != NULL) ? dchild : child, child );
    MscAppendPREvent( buffer );

    sprintf( buffer, "%s : create %s;", parent, (dchild != NULL) ? dchild : child);
    MscAppendPREvent( buffer );
    VCFREE( buffer );
  }
  return;
#else
  VC_NOT_USED(parent);
  VC_NOT_USED(child);
#endif
}

/*--------------------------------------------------------------------
 * Function Name: MscDoneComponent
 * Description:
 *
 *  Generate a stop msc event to indicate that the particular component
 *  Has terminated. Only applicable in the Decomposed mode.
 */

void MscDoneComponent( const char * ptc )
{
#ifdef GENMSC
  if ( MscCurrentMode == MscDecomposedMode ) {
    char * buffer = (char*)VCMALLOC( strlen ( ptc ) + 100, GcFALSE );
    sprintf( buffer, "%s : stop;", MscMapDisplayName(ptc) );
    MscAppendPREvent( buffer );
    VCFREE( buffer );
  }
  return;
#else
  VC_NOT_USED(ptc);
#endif
}

/*--------------------------------------------------------------------
 * Function Name: MscPreliminaryVerdict
 * Description:
 *  Generate a verdict notification if in DecomposedMode 
 */

void MscPreliminaryVerdict( const char * ptc, const char * verdict )
{
#ifdef GENMSC
  if ( MscCurrentMode == MscDecomposedMode ) {
    /* Set as condition on the current PTC axis */
    char * buffer = (char*) VCMALLOC( strlen(ptc) + 100, GcFALSE );
    sprintf( buffer, "%s : condition %s;", 
	     MscMapDisplayName(ptc), verdict );
    MscAppendPREvent( buffer );
    VCFREE( buffer );
  }

  return;
#else
  VC_NOT_USED(ptc);
  VC_NOT_USED(verdict);
#endif
}

/*--------------------------------------------------------------------
 * Function Name: MscFinalVerdict
 * Description:
 *   Generate a final verdict notification as a comment in the MSC
 */

void MscFinalVerdict( const char * ptc, const char * verdict )
{
#ifdef GENMSC
  if ( MscCurrentMode != MscNologMode ) {
    char * buffer = (char*) VCMALLOC( strlen( MscMapDisplayName(ptc) ) + 100, GcFALSE );
    sprintf( buffer, "text 'Result: %s';", verdict );
    MscAppendPREvent( buffer );
    
    VCFREE( buffer );  
  }
  return;
#else
  VC_NOT_USED(ptc);
  VC_NOT_USED(verdict);
#endif
}


/*--------------------------------------------------------------------
 * Function Name: MscGenerateFileName
 * Description:
 *  Generate a file name for an MSC PR file that does not already 
 *  exist. An improvement may be to add a directory path in front
 *  of the name...
 */

#ifdef MSC_FILE_MODE
static void MscGenerateFileName( const char * testname, MscString buffer )
{
  FILE * file = NULL;
  int try_num = 1;
  while ( try_num <= 9999 /* sanity check */ ) {
    const char * prefix = MSC_DEFAULT_FILE_PREFIX;
	char buf4[10];
    if ( MscFilePrefix )
      prefix = MscFilePrefix;
	MscStringClear(buffer);
	MscStringAddText(buffer,prefix);
	MscStringAddText(buffer,testname);
	MscStringAddText(buffer,"_");
    sprintf( buf4, "%04d", try_num++ );
	MscStringAddText(buffer,buf4);
	MscStringAddText(buffer,".mpr");
    file = fopen( MscStringBegin(buffer), "r" );
    if ( file == NULL )
      break;
    fclose( file );
  } 
  return;
}
#endif



static void MscAppendPREvent( const char * event )
{
#ifdef MSC_FILE_MODE
  if ( MscOutputFile != 0 ) {
    fprintf( MscOutputFile, "%s\n", event );
    fflush( MscOutputFile );
  }
#endif

#ifdef MSC_MSCE_MODE
  {
    MscString msg=MscStringCreate();
    int status, objectId = 0;
	MscStringAddInteger(msg,MscBufId);
	MscStringAddText(msg," 0 \"");
	MscStringAddTextWithQuote(msg, event);
	MscStringAddText(msg,"\"");
    MscPmDoRPC( SET_MSCE, SEINSERTOBJECT, MscStringBegin(msg) );
    sscanf( MscStringBegin(msg), "%d %d", &status, &objectId );
	MscStringClear(msg);
	MscStringAddInteger(msg,MscBufId);
	MscStringAddText(msg," ");
	MscStringAddInteger(msg,objectId);
    MscPmDoRPC( SET_MSCE, SESHOWOBJECT, MscStringBegin(msg) );
	MscStringDelete(msg);
    /* ignore reply */
  }
#endif
}

/*--------------------------------------------------------------------
 * Function Name: MscMessageEventEnqueue()
 * Description: Allocate and put a message event at the front of the 
 * list of currently pending messages.
 */

static const MscMessageEvent *
MscMessageEventEnqueue( const char * from, 
			const char * to, 
			const char * type, 
			MscString value )
{
  MscMessageEvent * event = 
    (MscMessageEvent*) VCMALLOC(sizeof( MscMessageEvent ) , GcFALSE);

  /* Assign the various fields of the structure, truncate any
     fields that are to long for the structures field sizes */
  
  event->id = (unsigned int)MscEventId++;
  
  event->from=MscStringCreate();
  MscStringAddText(event->from, from);
  
  event->to=MscStringCreate();
  MscStringAddText(event->to, to);
  
  event->type=MscStringCreate();
  MscStringAddText(event->type, type);

  event->value=MscStringCreate();
  MscStringAddText(event->value, MscStringBegin(value));
  
  event->next = (MscMessageEvent*) MscMessageEventList;
  MscMessageEventList = event;
  
  return event;
}

/*--------------------------------------------------------------------
 * Function Name: MscMessageEventFindFirst()
 * Description: 
 * 
 *  Search for the least recently inserted event that matches the from
 *  and to criteria. Relies on that new events are inserted first in
 *  the list.
 */

static MscMessageEvent *
MscMessageEventFindFirst( const char * from,
			  const char * to )
{
#ifdef GENMSC
  MscMessageEvent * last = (MscMessageEvent*) 0;
  MscMessageEvent * event;
  for ( event = (MscMessageEvent*) MscMessageEventList; 
	event; event = (MscMessageEvent*) event->next )
    if ( !strcmp( from, MscStringBegin(event->from) ) && !strcmp( to, MscStringBegin(event->to )) )
      last = event;

  if ( !last )
    GciLog( GciLogMessage, "MscMessageEventFindFirst: Failed to find event" );
  
  return last;
#else
  VC_NOT_USED(from);
  VC_NOT_USED(to);
  return NULL;
#endif
}

/*--------------------------------------------------------------------
 * Function Name: MscMessageEventRemove()
 * Description: 
 * 
 *  Remove the event pointed to by the event pointer from the
 *  list. Free memory associated with it.
 */

static void
MscMessageEventRemove( MscMessageEvent * event )
{
#ifdef GENMSC
  MscMessageEvent * prev = (MscMessageEvent*) event;
  int found_in_list = 0;
  if ( event ) {
    if ( MscMessageEventList == event ) {
      MscMessageEventList = (void*) event->next;
      found_in_list = 1;
    }
    else for ( prev = (void*) MscMessageEventList; 
	       prev; prev = (void*) prev->next )
      if ( prev->next == (void*) event ) {
	prev->next= ((MscMessageEvent*)prev->next)->next;
	found_in_list = 1;
	break;
      }    

    if ( !found_in_list )
      GciLog (GciLogMessage, "MscMessageEventRemove: Removing event not in event list" );
    
	MscStringDelete(event->from);
	MscStringDelete(event->to);
	MscStringDelete(event->type);
	MscStringDelete(event->value);
    /* Always free the memory of the event object */
    VCFREE( event );	  
  } 
  else
    GciLog(GciLogMessage, "MscMessageEventRemove: Attempting to remove NULL event" );
#else
  VC_NOT_USED(event);
#endif
}


/*--------------------------------------------------------------------
 * Function Name: MscTimerEventInsert()
 * Description: 
 * 
 *  If the timer event does not exist in the list, allocate it and 
 *  insert it in the list. If it does exist, generate an implicit reset
 *  and then update the event id (to save a free/malloc). 
 */

static const MscTimerEvent *
MscTimerEventInsert( const char * ptc, const char * timer )
{
  MscTimerEvent * event = (MscTimerEvent*) MscTimerEventFind( ptc, timer );
  if ( event ) {
    /* Implicit reset could be generated */
    /* 
       char * buffer = 
       (char*) malloc( strlen(event->ptc) + strlen(event->name) + 100 );
       sprintf( buffer, 
                "%s : reset %s,%d comment 'Restarting';",
                event->ptc, event->name, event->id );
       MscAppendPREvent( buffer );
       free ((void*) buffer );
    */
  }
  else {
    event = (MscTimerEvent* ) VCMALLOC( sizeof (MscTimerEvent), GcFALSE );
	event->ptc=MscStringCreate();
	MscStringAddText(event->ptc, ptc);
  
	event->name=MscStringCreate();
	MscStringAddText(event->name, timer);

    event->next = (MscTimerEvent*) MscTimerEventList;
    MscTimerEventList = event;
  }
  
  event->id = (unsigned int)MscEventId++;
  
  return event;
}

/*--------------------------------------------------------------------
 * Function Name: MscMessageEventFind()
 * Description: 
 * 
 *  Find a timer event associated with the ptc and the timer
 */

static MscTimerEvent * 
MscTimerEventFind( const char * ptc, const char * timer )
{
  MscTimerEvent * event;
  for ( event = (MscTimerEvent*) MscTimerEventList; 
	event; event = (MscTimerEvent*) event->next )
    if ( !strcmp( ptc, MscStringBegin(event->ptc) ) && !strcmp( timer, MscStringBegin(event->name) ) )
      return event;
      
  return event;
}

/*--------------------------------------------------------------------
 * Function Name: MscTimerEventRemove()
 * Description: 
 * 
 *  Remove the event pointed to by the event pointer from the
 *  list. Free memory associated with it.
 */

static void 
MscTimerEventRemove( MscTimerEvent * event )
{
#ifdef GENMSC
  MscTimerEvent * prev = (MscTimerEvent*) event;
  int found_in_list = 0;
  if ( event ) {
    if ( MscTimerEventList == (void*) event ) {
      MscTimerEventList = (MscTimerEvent*) event->next;
      found_in_list = 1;
    }
    else for ( prev = (MscTimerEvent*) MscTimerEventList; 
	       prev; prev = (MscTimerEvent*) prev->next )
      if ( prev->next == (void*) event ) {
	prev->next= ((MscTimerEvent*)prev->next)->next;
	found_in_list = 1;
	break;
      }    

    if ( !found_in_list )
      GciLog (GciLogMessage, "MscTimerEventRemove: Removing event not in event list" );
    
	MscStringDelete(event->name);
	MscStringDelete(event->ptc);
    /* Always free the memory of the event object */
    VCFREE( event );	  
  } 
  else
    GciLog(GciLogMessage, "MscTimerEventRemove: Attempting to remove NULL event" );
#else
  VC_NOT_USED(event);
#endif
}

/*--------------------------------------------------------------------
 * Function Name: MscEncodeValue
 * Description: 
 * 
 *  Store a textual representation of the value in memory at pos,
 *  provided that there are enough bytes left. The representation is
 *  similar to the simulator representation with some exceptions for
 *  the SET, CHOICE, HEXSTRING and ENUMERATED types that are simpler
 *  or not supported.
 *
 *  Note that the recursive call in composite types reserves some
 *  characters such that it should be able to at least complete the
 *  current call.
 */

void MscEncodeValue ( GciValue * value, MscString str)
{
#ifdef GENMSC
  int i = 0;

  /* Can be defined to disable value logs and get a more high-level
     format: */
  unsigned int index = 0;
  
#ifndef MSC_NO_VALUE_LOGGING
  
  if (value == NULL) {
	MscStringAddText(str,"-");
  } 
#ifdef MSC_NO_OMIT_LOGGING
  else if (GciGetOMIT(value) == GcTRUE) {
    MscStringAddText(str,"");
  } 
#endif
  else {
    switch ( GciGetBaseType( value ) ) {
      /* Handling of composite types */
    case GcSEQUENCED:
    case GcSETD:
    case GcSEQUENCEOFD:
    case GcSETOFD:
	  MscStringAddText(str,"( ");
      for ( index = 0 ; index < (unsigned int)GciSeqSize( value ); ++index ) {
		GciValue* svalue = NULL;
		svalue = GciGetField( value, index + 1 );
		if (GciGetOMIT(svalue))
		  continue;
		MscEncodeValue( svalue, str);

		if (index + 1 < (unsigned int)GciSeqSize( value ) )
		  MscStringAddText(str,", ");
      }
	  MscStringAddText(str,")");
      break;
      
      /* Handling of simple types */
    case GcBOOLEAND:
	  MscStringAddText(str,GciGetBOOLEAN( value ) ? "true" : "false");
      break;
      
    case GcENUMERATEDD:
	  MscStringAddText(str,EGciGetENUMERATEDName( value ) );
      break;

    case GcINTEGERD:
	  {
		char buffer[VC_MAX_INTEGER_LEN + 1];
		GciGetBigINTEGER(value, buffer);
		MscStringAddText(str,buffer);
	  }
      break;
      
    case GcBITSTRINGD:
	  MscStringAddText(str,"'");
	  MscStringAddText(str,GciGetBIT_STRING( value ));
	  MscStringAddText(str,"'B");
      break;
      
    case GcOCTETSTRINGD:
	  MscStringAddText(str,"'");
	  MscStringAddText(str,GciGetOCTET_STRING( value ));
	  MscStringAddText(str,"'H");
      break;
      
    case GcHEXSTRINGD:
	  MscStringAddText(str,"'");
	  MscStringAddText(str,GciGetHEXSTRING( value ));
	  MscStringAddText(str,"'H");
      break;
      
    case GcVIDEOTEXSTRINGD:
    case GcGENERALSTRINGD:
    case GcGRAPHICSTRINGD:
    case GcISO646STRINGD:
    case GcT61STRINGD:
    case GcTELETEXSTRINGD:
    case GcNUMERICSTRINGD:
    case GcPRINTABLESTRINGD:
    case GcVISIBLESTRINGD:
    case GcIA5STRINGD:
	  MscStringAddText(str,"'");
	  MscStringAddText(str,GciGetIA5String( value ));
	  MscStringAddText(str,"'");
    break;
    case GcNULLD:
	  MscStringAddText(str,"'NULL'");
      break;
    
    case GcCHOICED:
      MscEncodeValue(GciGetCHOICE(value), str);
      break;
   
      
    case GcOBJECTIDENTIFIERD:
      for (i = 0; i < GciOBJECT_IDENTIFIERSize(value); i++) {
		MscStringAddText(str,"'");
		MscStringAddInteger(str,GciGetOBJECT_IDENTIFIERComponent(value, i));
		MscStringAddText(str,"'");
      }
      break;

    default:
      GciLog( GciLogMessage, "MscEncodeValue: type not implemented:" );
      GciLog( GciLogMessage, GciGetTypeNameString( GciGetType( value ) )); 
    }
  } 
  
#endif /* MSC_NO_VALUE_LOGGING */
  return;
#else
  VC_NOT_USED(str);
  VC_NOT_USED(value);
#endif
}


static const char* 
MscMapDisplayName(const char *name)
{
  MscDisplayNameEntry *ptr = MscGetDisplayNameEntry(name);

  if (ptr == NULL)
    return (const char*)name;
  else
    return (const char*)ptr->dispname;
}

static const char* 
MscGetDisplayName(const char *name)
{
  MscDisplayNameEntry *ptr = MscGetDisplayNameEntry(name);

  if (ptr == NULL) {
    /* Allocate new entry */
    MscDisplayNameEntry *elem = MscNewDisplayNameEntry(name, 0);

    if (elem == NULL)
      return name;
    
    elem->next = dispnamelist;
    dispnamelist = elem;

    return (const char*)elem->dispname;
  } else {
    (ptr->nr)++;
    sprintf(ptr->dispname, "%s_%d", name, ptr->nr);
    
    return (const char *)ptr->dispname;
  }
}

static MscDisplayNameEntry *
MscGetDisplayNameEntry(const char* name)
{
  MscDisplayNameEntry *ptr = dispnamelist;

  while (ptr != NULL) {
    if (strcmp(name, ptr->name) == 0)
      return ptr;
    ptr = ptr->next;
  }

  return NULL;
}

static MscDisplayNameEntry *
MscNewDisplayNameEntry(const char* name, int nr )
{
  MscDisplayNameEntry *elem = (MscDisplayNameEntry *)malloc(sizeof(MscDisplayNameEntry));
  if (elem == NULL)
    return NULL;

  elem->nr = nr;
  strcpy(elem->name, name);

  if (nr == 0)
    strcpy(elem->dispname, elem->name);
  else
    sprintf(elem->dispname, "%s_%d", elem->name, nr);

  elem->next = NULL;

  return elem;
}


static void 
MscDeleteDisplayNameEntries()
{
  MscDisplayNameEntry *ptr = dispnamelist;

  while (ptr != NULL) {
    dispnamelist = ptr->next;
  
    free(ptr);
    ptr = dispnamelist;
  }
}
