/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:44 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1993, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef MSCGEN_H
#define MSCGEN_H

#include "static.h"

/*--------------------------------------------------------------------
 *
 * About this file: 
 * 
 * This file defines an interface internal to the ITEX c code generator
 * runtime environment. It is not supposed to be accessed by user-defined
 * code.
 *
 * There are more comments in the accompanying mscgen.c file,
 * and also in the TTCN Suite user manual. This file is
 * subject to change between releases and user changes may not be
 * supported. 
 */

/*-------------------------------------------------------------------- 
 *  Definition Name: MscLogMode
 *  Description:     Identifies the msc generation modes.
 */

typedef enum { 
  MscNologMode,			/* No MSC logging at all */
  MscComposedMode,		/* Composed tester - only external events */
  MscDecomposedMode		/* Almost all internal events and PTCs */
} MscLogMode;

/*-------------------------------------------------------------------- 
 *  Definition Name: MscMessageDirection
 *  Description:     Used to determine the direction of events relative
 *		     to the ETS.
 */

typedef enum {
  MscSendMessage,		/* Message from ETS to IUT */
  MscReceiveMessage,		/* Message from IUT to ETS */
  MscInternalMessage		/* Message from PTC to PTC */
} MscMessageDirection;

/*-------------------------------------------------------------------- 
 *  Function prototypes for MSC generation management.
 */

extern void MscInit( void );	/* Call only once from GciInit  */
extern void MscExit( void );	/* Call only once from GciExit  */

extern void MscSetLogMode( MscLogMode logmode );
extern void MscSetSystemName( const char * iut );
extern void MscSetFilePrefix( const char * prefix );

/*-------------------------------------------------------------------- 
 *  Function prototypes TTCN operation logging. They internally do the
 *  filtering determined by the MSC generation mode.
 */

extern void MscStartTestCase( const char * ptc, const char * name );
extern void MscStopTestCase( const char * ptc );
extern void MscOut( MscMessageDirection direction, 
		    const char * from, const char * to, 
		    GciValue * value, const char * comment );
extern void MscIn( MscMessageDirection direction,
		   const char * from, const char * to, 
		   const char * comment );
extern void MscImplicitSend( const char * ptc, GciValue * value );
extern void MscStartTimer( const char* ptc, const char * timer, long dur );
extern void MscCancelTimer( const char* ptc, const char * timer );
extern void MscTimeoutTimer( const char* ptc, const char * timer );
extern void MscCreateComponent( const char* parent, const char *child );
extern void MscDoneComponent( const char* ptc );
extern void MscPreliminaryVerdict( const char* ptc, const char * verdict );
extern void MscFinalVerdict( const char* ptc, const char * verdict );

/*--------------------------------------------------------------------
 * Utility function that may be useful for other code as well, for a
 * decoder may use this to log what value was decoded, though that is
 * also done by the MSCs ... if enabled. Note that there are some
 * limitations to the supported types.  
 */

extern void MscEncodeValue( GciValue * value, MscString str);

#endif /* MSCGEN_H */

