/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:43 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#include <sys/types.h>
#include <stdio.h>

#define SDL_NEWGAME "Newgame"
#define SDL_PROBE   "Probe"
#define SDL_RESULT  "Result"
#define SDL_ENDGAME "Endgame"

#ifndef NULL
#define NULL 0
#endif

int post_fd;
int keyboard_fd = 1; /* Keyboard input is set to descriptor 1 by default */

/*---------------------------------------------------------------------------*/

#ifndef XNOPROTO
Appl_Receive (void)
#else
Appl_Receive ()
#endif
{
  return Receive();
}


#ifndef XNOPROTO
Init_UI (int port)
#else
Init_UI (port)
  int port;
#endif
{
 post_fd = port;

 setbuf(stdout, (char *)0); /* Set output to terminal unbuffered */ 
}


#ifndef XNOPROTO
Exit_UI (void)
#else
Exit_UI ()
#endif
{
  Exit_PM();
  exit(1);
}


#ifndef XNOPROTO
Send_To_UI (char * event, char * param)
#else
Send_To_UI (event, param)
  char * event;
  char * param;
#endif
{
  if ( param != NULL )
    printf("\n%s%s%s%s\n", "Receiving signal: ", event, " ", param);
  else
    printf("\n%s%s\n", "Receiving signal: ", event);
}

/*---------------------------------------------------------------------------*/


#ifndef XNOPROTO
int GetInput (char *str)
#else
int GetInput (str)
  char *str;
#endif
{
  int c;
  int i=0;

  while( ( c = getchar()) != '\n' )
  {
    str[i] = c;
    i++;
  }
  str[i] = '\0';

  if ( strcasecmp(str, SDL_NEWGAME) == 0 )
  {
    printf("New game started\n");
    printf("Signal: ");
    return(1);
  }
  if ( strcasecmp(str, SDL_PROBE) == 0 )
    return(1);
  if ( strcasecmp(str, SDL_RESULT) == 0 )
    return(1);
  if ( strcasecmp(str, SDL_ENDGAME) == 0 )
  {
    printf("Game stopped\n");
    printf("Signal: ");
    return(1);
  }
  if ( strcasecmp(str, "exit") == 0 )
    Exit_UI();

  printf("Not a valid command. Type any of the following signals:\n");
  printf("NewGame, Probe, Result, EndGame or Exit.\n");
  printf("Signal: ");
  return(0);
}

#ifndef XNOPROTO
main(int argc, char *argv[] )
#else
main(argc, argv)
int argc;
char *argv[];
#endif

{
  int    nfds;
  fd_set readfds;
  struct timeval * tp;
  char   sig[20];
  int    dtablesize;

  tp = NULL;  /* wait forever */

#if defined hpux 
  /*
   *  The getdtablesize() function does not exist in HP-UX
   */
  dtablesize = 100;
#else
  dtablesize = getdtablesize();
#endif

  Init(argv[0]);

  printf("Welcome to Demongame\n");
  printf("Signal: ");

  for(;;)
  {
    FD_ZERO(&readfds);
    FD_SET(post_fd, &readfds);
    FD_SET(keyboard_fd, &readfds);

    nfds = select(dtablesize, &readfds, NULL, NULL, tp);

    if ( FD_ISSET(keyboard_fd, &readfds) != 0 )
    {
      if ( GetInput(sig) )
        Send_To_PM(sig);
    }
    else if ( FD_ISSET(post_fd, &readfds) != 0 )
    {
      if ( Appl_Receive() )
        printf("Signal: ");
    }
  }
}
