@SDL@KERNEL_HEADING_PACKAGE@Kernel Heading
$GRAMMAR
Z100: 2.4.1.2

<PackageKernelHeading> ::=
   'PACKAGE' <Name>
@SDL@ADDITIONAL_HEADING_PACKAGE@Additional Heading
$GRAMMAR
Z100: 2.4.1.2

<PackageAdditionalHeading> ::=
   <Interface> ';' / $
<Interface> ::=
   <DefinitionSelection>\','
<DefinitionSelection> ::=
   ( <EntityKind> / $ ) <Name>
<EntityKind> :=
   'SYSTEM' 'TYPE'   / 'BLOCK' 'TYPE'   /
   'PROCESS' 'TYPE'  / 'PROCEDURE'      /
   'REMOTE'          / 'SERVICE' 'TYPE' /
   'SIGNAL'          / 'NEWTYPE'        /
   'SIGNALLIST'      / 'GENERATOR'      /
   'SYNONYM'
@SDL@PACKAGE_REF@Package references
$GRAMMAR
Z100: 2.4.1.2  Reference in Package
Z100: 2.4.2    Reference in System

<PackageReferences> ::= <PackageRefClause>*
<PackageRefClause> ::=
   'USE' <Name>
   ( '/' (<DefinitionSelection>)\',' / $)
   ';'
<DefinitionSelection> ::=
   ( <EntityKind> / $ ) <Name>
<EntityKind> :=
   'SYSTEM' 'TYPE'   / 'BLOCK' 'TYPE'   /
   'PROCESS' 'TYPE'  / 'PROCEDURE'      /
   'REMOTE'          / 'SERVICE' 'TYPE' /
   'SIGNAL'          / 'NEWTYPE'        /
   'SIGNALLIST'      / 'GENERATOR'      /
   'SYNONYM'
$Use1
USE PackageName;

$Use2
USE PackageName1;
USE PackageName2;

$Use1_Select
USE PackageName /
  BLOCK TYPE Name,
  SIGNAL Name;

@SDL@KERNEL_HEADING_SYSTEM@Kernel Heading
$GRAMMAR
Z100: 2.4.2    System definition
z100: 6.1.3.1  System definition based on system type

<SystemKernelHeading> ::=
   'SYSTEM' <Name> 
   ( ':' <SystemTypeName> / $)
$System_Def
SYSTEM SystemName
$Type_Based_System
SYSTEM SystemName : SystemTypeName
@SDL@ADDITIONAL_HEADING_SYSTEM@Additional Heading
$GRAMMAR
<SystemAdditionalHeading> ::= $
@SDL@SYSTEM_TYPE_REF@System type symbol
$GRAMMAR
Z100: 6.1.1.1

<SystemTypeSymbolContents> ::=
   'system' <SystemName>
@SDL@KERNEL_HEADING_SYSTEM_TYPE@Kernel Heading
$GRAMMAR
Z100: 6.1.1.1  System type heading

<SystemTypeKernelHeading> ::=
   'SYSTEM' 'TYPE' <Name>
@SDL@ADDITIONAL_HEADING_SYSTEM_TYPE@Additional Heading
$GRAMMAR
Z100: 6.1.1.1  System type heading
Z100: 6.3      Specialization
Z100: 6.3.1    Inherits
Z100: 6.2      Actual context parameters
Z100: 6.2      Formal context parameters
Z100: 6.2.1 - 6.2.9  Formal context parameters

<SystemTypeAdditionalHeading> ::=
   (<SystemTypeAdditionalHeadingContents> / $)
<SystemTypeAdditionalHeadingContents> ::=
   (<FormalContextPars> / $)
   (<Specialization> / $)
   ';'
<Specialization> ::= 
   'INHERITS' <Name> 
   (<ActualContextPars> / $) 
   ('ADDING' / $)
<ActualContextPars> ::=
   '<' (<Name> / $)\','  '>'
<FormalContextPars> ::= 
   '<' <FormalContextPar>\';' '>'
<FormalContextPar> ::= 
   ( 'PROCESS' <Name> 
     ( ('ATLEAST'/$) <Name> / <ProcessSignature> / $ )
   / 'PROCEDURE' <Name>
     ( 'ATLEAST' <Name> / <ProcedureSignature> )
   / 'REMOTE' 'PROCEDURE' <Name> <ProcedureSignature>
   / 'SIGNAL'
     ( <Name> ('ATLEAST' <Name> / <SignalSignature>) )\','
   / 'DCL' ( <Name>\',' <SortName> )\','
   / 'REMOTE' ( <Name>\',' <SortName> )\','
   / 'TIMER' ( <Name> ( '(' <>\',' ')' / $) )\','
   / 'SYNONYM' ( <Name> <SortName> )\','
   / 'NEWTYPE' <Name>
     ( 'ATLEAST' <SortName> / <SortSignature> / $ )
   )
<ProcessSignature> ::= 
   (';'/$) 'FPAR' <SortName>\','
<ProcedureSignature> = 
   ( (';'/$) 
     ( 'FPAR' ( ('IN' / 'IN/OUT' / $) <SortName>)\','
       ( ';' 'RETURNS' <SortName> / $)
     / 'RETURNS' <SortName>
     / $
     )
   )
<SignalSignature> ::=
   ( '(' <SortName>\',' ')' / $)
   ( <SignalRefinement> / $)
<SortSignature> ::= <Operators> 'ENDNEWTYPE' (<Name>/$)
<Operators> ::=
   ( <LiteralList> / $ )
   ( 'OPERATORS'
     ( ( <OperatorSignature> / 'ORDERING' ) ';'
     )+
   / $
   )
<LiteralList> ::=
   'LITERALS'
   ( <CharStringLiteral> / <LiteralName> /
     <NameClassLiteral> )
   )\','
   (';' / $)
<OperatorSignature> ::=
   <OperatorName> ':' <SortName>\',' '->' <SortName>
$Inherits
INHERITS SystemTypeName;
@SDL@BLOCK_REF@Block symbol
$GRAMMAR
Z100: 2.4.2    Block definition
Z100: 6.1.3.2  Block def based on block type
Z100: 6.1.2    Type expression
Z100: 6.2      Actual context parameters

<BlockSymbolContents> ::=
   <BlockName> / <TypeBasedBlockHeading>
<TypeBasedBlockHeading> ::=
   <BlockName>
   ( <NumberOfBlockInst> / $ )
   ':' <BlockTypeExpression>
<NumberOfBlockInst> ::=
   '(' <SimpleExpression> ')'
<BlockTypeExpression> ::=
   <BaseBlockType>
   (<ActualContextPar> / $)
<ActualContextPars> ::=
   '<' (<Name> / $)\','  '>'
$BlockInst
BlockName : BlockType
$BlockInstSet
BlockName(NoOfInst) : BlockType
@SDL@KERNEL_HEADING_BLOCK@Kernel Heading
$GRAMMAR
Z100: 2.4.3    Block definition

<BlockKernelHeading> ::=
   'BLOCK' <Name> 
$Block_Def
BLOCK BlockName
@SDL@ADDITIONAL_HEADING_BLOCK@Additional Heading
$GRAMMAR
<BlockAdditionalHeading> ::= $
@SDL@BLOCK_TYPE_REF@Block type symbol
$GRAMMAR
Z100: 6.1.1.2

<BlockTypeSymbolContents> ::=
   ('VIRTUAL' / 'REDEFINED' / 'FINALIZED' / $)
   <BlockName>
@SDL@KERNEL_HEADING_BLOCK_TYPE@Kernel Heading
$GRAMMAR
Z100: 6.1.1.2  Block type heading

<BlockTypeKernelHeading> ::=
   ('VIRTUAL' / 'REDEFINED' / 'FINALIZED' / $)
   'BLOCK' 'TYPE' <Name>
$TypeDef
BLOCK TYPE BlockTypeName
$VirtualType
VIRTUAL BLOCK TYPE BlockTypeName
$RedefinedType
REDEFINED BLOCK TYPE BlockTypeName
$FinalizedType
FINALIZED BLOCK TYPE BlockTypeName
@SDL@ADDITIONAL_HEADING_BLOCK_TYPE@Additional Heading
$GRAMMAR
Z100: 6.1.1.2  Block type heading
Z100: 6.3      Specialization
Z100: 6.3.1    Inherits
Z100: 6.3.2    Virtual, Redefined, Finalized
Z100: 6.3.2    Virtuality constraint (atleast)
Z100: 6.2      Actual context parameters
Z100: 6.2      Formal context parameters
Z100: 6.2.1 - 6.2.9  Formal context parameters

<BlockTypeAdditionalHeading> ::=
   (<BlockTypeAdditionalHeadingContents> / $)
<BlockTypeAdditionalHeadingContents> ::=
   (<FormalContextPars> / $)
   (<VirtualityConstraint> / $)
   (<Specialization> / $)
   ';'
<VirtualityConstraint> ::=
   'ATLEAST' <Name>
<Specialization> ::= 
   'INHERITS' <Name> 
   (<ActualContextPars> / $) 
   ('ADDING' / $)
<ActualContextPars> ::=
   '<' (<Name> / $)\','  '>'
<FormalContextPars> ::= 
   '<' <FormalContextPar>\';' '>'
<FormalContextPar> ::= 
   ( 'PROCESS' <Name> 
     ( ('ATLEAST'/$) <Name> / <ProcessSignature> / $ )
   / 'PROCEDURE' <Name>
     ( 'ATLEAST' <Name> / <ProcedureSignature> )
   / 'REMOTE' 'PROCEDURE' <Name> <ProcedureSignature>
   / 'SIGNAL'
     ( <Name> ('ATLEAST' <Name> / <SignalSignature>) )\','
   / 'DCL' ( <Name>\',' <SortName> )\','
   / 'REMOTE' ( <Name>\',' <SortName> )\','
   / 'TIMER' ( <Name> ( '(' <>\',' ')' / $) )\','
   / 'SYNONYM' ( <Name> <SortName> )\','
   / 'NEWTYPE' <Name>
     ( 'ATLEAST' <SortName> / <SortSignature> / $ )
   )
<ProcessSignature> ::= 
   (';'/$) 'FPAR' <SortName>\','
<ProcedureSignature> = 
   ( (';'/$) 
     ( 'FPAR' ( ('IN' / 'IN/OUT' / $) <SortName>)\','
       ( ';' 'RETURNS' <SortName> / $)
     / 'RETURNS' <SortName>
     / $
     )
   )
<SignalSignature> ::=
   ( '(' <SortName>\',' ')' / $)
   ( <SignalRefinement> / $)
<SortSignature> ::= <Operators> 'ENDNEWTYPE' (<Name>/$)
<Operators> ::=
   ( <LiteralList> / $ )
   ( 'OPERATORS'
     ( ( <OperatorSignature> / 'ORDERING' ) ';'
     )+
   / $
   )
<LiteralList> ::=
   'LITERALS'
   ( <CharStringLiteral> / <LiteralName> /
     <NameClassLiteral> )
   )\','
   (';' / $)
<OperatorSignature> ::=
   <OperatorName> ':' <SortName>\',' '->' <SortName>
$Inherits
INHERITS BlockTypeName;
$AtleastInherits
ATLEAST BlockTypeName INHERITS BlockTypeName;
@SDL@BLOCKSUBSTRUCTURE@Block substructure symbol
$GRAMMAR
Z100: 3.2.2

<BlockSubstructureSymbolContents> ::=
   <SubstructureName> / $
@SDL@CHANNELSUBSTRUCTURE@Channel substructure symbol
$GRAMMAR
Z100: 3.2.3

<ChannelSubstructureSymbolContents> ::=
   <SubstructureName> / $
@SDL@KERNEL_HEADING_SUBSTRUCTURE@Kernel Heading
$GRAMMAR
Z100: 3.2.2

<SubstructureKernelHeading> ::=
   'SUBSTRUCTURE' <Name>
@SDL@ADDITIONAL_HEADING_SUBSTRUCTURE@Additional Heading
$GRAMMAR
Z100: 3.2.2

<SubstructureAdditionalHeading> ::= $
@SDL@PROCESS_REF@Process symbol
$GRAMMAR
Z100: 2.4.3    Process definition
Z100: 2.4.4    Number of instances
Z100: 6.1.3.3  Process def based on process type
Z100: 6.1.2    Type expression
Z100: 6.2      Actual context parameters

<ProcessSymbolContents> ::=
  <ProcessName> (<NumberOfInstances> / $) /
  <TypeBasedProcessHeading>
<NumberOfInstances> ::=
   '(' (<InitialNumber> / $)
       (',' (<MaximumNumber> / $) / $)
   ')'
<TypeBasedProcessHeading> ::=
   <ProcessName> (<NumberOfInstances> / $)
   ':' <ProcessTypeName>
$ProcessInst
ProcessName : ProcessType
$NumberOfInstances
(NoOfStatic, MaxDynamic)
$(1,1)
(1,1)
$(0,infinity)
(0, )
@SDL@KERNEL_HEADING_PROCESS@Kernel Heading
$GRAMMAR
Z100: 2.4.4    Process definition

<ProcessKernelHeading> ::=
   'PROCESS' <Name>
   ( <NumberOfInstances> / $ )
<NumberOfInstances> ::=
   '(' (<InitialNumber> / $)
       (',' (<MaximumNumber> / $) / $)
   ')'
$ProcessKernelHeading
PROCESS ProcessName(1,1)
$NumberOfInstances
(NoOfStatic, MaxDynamic)
$(1,1)
(1,1)
$(0,infinity)
(0, )
@SDL@ADDITIONAL_HEADING_PROCESS@Additional heading
$GRAMMAR
Z100: 2.4.4    Process definition

<ProcessAdditionalHeading> ::=
   (<ProcessAdditionalHeadingContents> / $)
<ProcessAdditionalHeadingContents> ::=
   ';'
   ( <PrioDirective> / $ )
   ( <FormalPar> / $ )
   ( <ValidInputSignalSet> / $ )
<FormalPar> ::=
   'FPAR' ( <FormalParName>\',' <SortName> )\',' ';'
<ValidInputSignalSet> ::=
   'SIGNALSET' ( <SignalList> / $ ) ';'
<SignalList> ::=
   ( <SignalName> /
     <RemoteProcedureName> /
     '(' <SignalListName> ')'
   )\','
<PrioDirective> ::= '/*#PRIO' <Value> '*/'


Definition of grammar see META_GRAMMAR
in a macro call symbol.
$Add_Heading
;
FPAR
  FparName SortName,
  FparName SortName;
SIGNALSET
  SignalName, SignalName;
$Add_Heading_PRIO
;
/*#PRIO Value */
FPAR
  FparName SortName,
  FparName SortName;
SIGNALSET
  SignalName, SignalName;
$Fpar
FPAR
  FparName SortName,
  FparName SortName;

$Signalset
SIGNALSET
  SignalName, SignalName;

$EmptySignalset
SIGNALSET ;

$Fpar_Only
;
FPAR
  FparName SortName,
  FparName SortName;

$Signalset_Only
;
SIGNALSET
  SignalName, SignalName;

$EmptySignalset_Only
;
SIGNALSET ;

$PRIO_Directive
/*#PRIO Value */

@SDL@ADDITIONAL_HEADING_P_AS_SERVICE@Additional heading
$GRAMMAR
Z100: 2.4.4    Process definition

<ProcessAdditionalHeading> ::=
   (<ProcessAdditionalHeadingContents> / $)
<ProcessAdditionalHeadingContents> ::=
   ';'
   (<FormalPar> / $) (<ValidInputSignalSet> / $)
<FormalPar> ::=
   'FPAR' ( <FormalParName>\',' <SortName> )\',' ';'
<ValidInputSignalSet> ::=
   'SIGNALSET' ( <SignalList> / $ ) ';'
<SignalList> ::=
   ( <SignalName> /
     <RemoteProcedureName> /
     '(' <SignalListName> ')'
   )\','


Definition of grammar see META_GRAMMAR
in a macro call symbol.
$Add_Heading
;
FPAR
  FparName SortName,
  FparName SortName;
SIGNALSET
  SignalName, SignalName;
$Fpar
FPAR
  FparName SortName,
  FparName SortName;
$Signalset
SIGNALSET
  SignalName, SignalName;
$EmptySignalset
SIGNALSET ;
$Fpar_Only
;
FPAR
  FparName SortName,
  FparName SortName;
$Signalset_Only
;
SIGNALSET
  SignalName, SignalName;
$EmptySignalset_Only
;
SIGNALSET ;
@SDL@PROCESS_TYPE_REF@Process type symbol
$GRAMMAR
Z100: 6.1.1.3

<ProcessTypeSymbolContents> ::=
   ('VIRTUAL' / 'REDEFINED' / 'FINALIZED' / $)
   <ProcessTypeName>
@SDL@KERNEL_HEADING_PROCESS_TYPE@Kernel Heading
$GRAMMAR
Z100: 6.1.1.3  Process type heading

<ProcessTypeKernelHeading> ::=
   ('VIRTUAL' / 'REDEFINED' / 'FINALIZED' / $)
   'PROCESS' 'TYPE' <Name>
$TypeDef
PROCESS TYPE ProcessTypeName
$VirtualType
VIRTUAL PROCESS TYPE ProcessTypeName
$RedefinedType
REDEFINED PROCESS TYPE ProcessTypeName
$FinalizedType
FINALIZED PROCESS TYPE ProcessTypeName
@SDL@ADDITIONAL_HEADING_PROCESS_TYPE@Additional heading
$GRAMMAR
Z100: 6.1.1.3  Process type heading
Z100: 2.4.4    Formal parameters, Signalset
Z100: 6.3      Specialization
Z100: 6.3.1    Inherits
Z100: 6.3.2    Virtual, Redefined, Finalized
Z100: 6.3.2    Virtuality constraint (atleast)
Z100: 6.2      Actual context parameters
Z100: 6.2      Formal context parameters
Z100: 6.2.1 - 6.2.9  Formal context parameters

<ProcessTypeAdditionalHeading> ::=
   (<ProcessTypeAdditionalHeadingContents> / $)
<ProcessTypeAdditionalHeadingContents> ::=
   (<FormalContextPars> / $)
   (<VirtualityConstraint> / $)
   (<Specialization> / $)
   ';'
   ( <FormalPar> / $ )
   ( <ValidInputSignalSet> / $ )
<VirtualityConstraint> ::=
   'ATLEAST' <Name>
<Specialization> ::= 
   'INHERITS' <Name> 
   (<ActualContextPars> / $) 
   ('ADDING' / $)
<ActualContextPars> ::=
   '<' (<Name> / $)\','  '>'
<FormalPar> ::=
   'FPAR' ( <FormalParName>\',' <SortName> )\',' ';'
<ValidInputSignalSet> ::=
   'SIGNALSET' ( <SignalList> / $ ) ';'
<SignalList> ::=
   ( <SignalName> /
     <RemoteProcedureName> /
     '(' <SignalListName> ')'
   )\','
<FormalContextPars> ::= 
   '<' <FormalContextPar>\';' '>'
<FormalContextPar> ::= 
   ( 'PROCESS' <Name> 
     ( ('ATLEAST'/$) <Name> / <ProcessSignature> / $ )
   / 'PROCEDURE' <Name>
     ( 'ATLEAST' <Name> / <ProcedureSignature> )
   / 'REMOTE' 'PROCEDURE' <Name> <ProcedureSignature>
   / 'SIGNAL'
     ( <Name> ('ATLEAST' <Name> / <SignalSignature>) )\','
   / 'DCL' ( <Name>\',' <SortName> )\','
   / 'REMOTE' ( <Name>\',' <SortName> )\','
   / 'TIMER' ( <Name> ( '(' <>\',' ')' / $) )\','
   / 'SYNONYM' ( <Name> <SortName> )\','
   / 'NEWTYPE' <Name>
     ( 'ATLEAST' <SortName> / <SortSignature> / $ )
   )
<ProcessSignature> ::= 
   (';'/$) 'FPAR' <SortName>\','
<ProcedureSignature> = 
   ( (';'/$) 
     ( 'FPAR' ( ('IN' / 'IN/OUT' / $) <SortName>)\','
       ( ';' 'RETURNS' <SortName> / $)
     / 'RETURNS' <SortName>
     / $
     )
   )
<SignalSignature> ::=
   ( '(' <SortName>\',' ')' / $)
   ( <SignalRefinement> / $)
<SortSignature> ::= <Operators> 'ENDNEWTYPE' (<Name>/$)
<Operators> ::=
   ( <LiteralList> / $ )
   ( 'OPERATORS'
     ( ( <OperatorSignature> / 'ORDERING' ) ';'
     )+
   / $
   )
<LiteralList> ::=
   'LITERALS'
   ( <CharStringLiteral> / <LiteralName> /
     <NameClassLiteral> )
   )\','
   (';' / $)
<OperatorSignature> ::=
   <OperatorName> ':' <SortName>\',' '->' <SortName>
$Add_Heading
ATLEAST ProcessTypeName INHERITS ProcessTypeName;
FPAR
  FparName SortName,
  FparName SortName;
SIGNALSET
  SignalName, SignalName;
$Inherits
INHERITS ProcessTypeName;
$AtleastInherits
ATLEAST ProcessTypeName INHERITS ProcessTypeName;
$Fpar
FPAR
  FparName SortName,
  FparName SortName;

$Fpar_Only
;
FPAR
  FparName SortName,
  FparName SortName;

$Signalset
SIGNALSET
  SignalName, SignalName;

$EmptySignalset
SIGNALSET ;

$Signalset_Only
;
SIGNALSET
  SignalName, SignalName;

$EmptySignalset_Only
;
SIGNALSET ;

@SDL@PROCEDURE_REF@Procedure symbol
$GRAMMAR
Z100: 2.4.6    Procedure definition

<ProcedureSymbolContents> ::=
   (<ProcedurePreamble> / $)
   <ProcedureName>
<ProcedurePreamble> ::=
   ('VIRTUAL' / 'REDEFINED' / 'FINALIZED' / $)
   ('EXPORTED' ('AS' <RemoteProcedureName> / $) / $)
$Virtual
VIRTUAL ProcedureName
$Redefined
REDEFINED ProcedureName
$Finalized
FINALIZED ProcedureName
$Exported
EXPORTED ProcedureName
$ExportedAs
EXPORTED AS Name
ProcedureName
@SDL@KERNEL_HEADING_PROCEDURE@Kernel Heading
$GRAMMAR
Z100: 2.4.6    Procedure definition

<ProcedureKernelHeading> ::=
   ('VIRTUAL' / 'REDEFINED' / 'FINALIZED' / $)
   ('EXPORTED' ('AS' <Name> / $) / $)
   'PROCEDURE' <Name>
$PrdDef
PROCEDURE ProcedureName
$VirtualPrd
VIRTUAL PROCEDURE ProcedureName
$RedefinedPrd
REDEFINED PROCEDURE ProcedureName
$FinalizedPrd
FINALIZED PROCEDURE ProcedureName
$ExportedPrd
EXPORTED PROCEDURE ProcedureName
@SDL@ADDITIONAL_HEADING_PROCEDURE@Additional heading
$GRAMMAR
Z100: 2.4.6    Procedure definition
Z100: 6.3      Specialization
Z100: 6.3.1    Inherits
Z100: 6.3.2    Virtual, Redefined, Finalized
Z100: 6.3.2    Virtuality constraint (atleast)
Z100: 6.2      Actual context parameters
Z100: 6.2      Formal context parameters
Z100: 6.2.1 - 6.2.9  Formal context parameters

<ProcedureAdditionalHeading> ::=
   (<ProcedureAdditionalHeadingContents> / $)
<ProcedureAdditionalHeadingContents> ::=
   (<FormalContextPars> / $)
   (<VirtualityConstraint> / $)
   (<Specialization> / $)
   ';'
   ( <ProcedureFormalPar> / $ )
   ( <ProcedureResult> / $ )
<VirtualityConstraint> ::=
   'ATLEAST' <Name>
<Specialization> ::= 
   'INHERITS' <Name> 
   (<ActualContextPars> / $) 
   ('ADDING' / $)
<ActualContextPars> ::=
   '<' (<Name> / $)\','  '>'
<ProcedureFormalPar> ::=
   'FPAR'
   ( ('IN' / 'IN/OUT' / $)
     <ParameterName>\',' <SortName>
   )\','
   ';'
<ProcedureResult> ::=
   'RETURNS' (<VariableName>/$) <SortName>
<FormalContextPars> ::= 
   '<' <FormalContextPar>\';' '>'
<FormalContextPar> ::= 
   ( 'PROCESS' <Name> 
     ( ('ATLEAST'/$) <Name> / <ProcessSignature> / $ )
   / 'PROCEDURE' <Name>
     ( 'ATLEAST' <Name> / <ProcedureSignature> )
   / 'REMOTE' 'PROCEDURE' <Name> <ProcedureSignature>
   / 'SIGNAL'
     ( <Name> ('ATLEAST' <Name> / <SignalSignature>) )\','
   / 'DCL' ( <Name>\',' <SortName> )\','
   / 'REMOTE' ( <Name>\',' <SortName> )\','
   / 'TIMER' ( <Name> ( '(' <>\',' ')' / $) )\','
   / 'SYNONYM' ( <Name> <SortName> )\','
   / 'NEWTYPE' <Name>
     ( 'ATLEAST' <SortName> / <SortSignature> / $ )
   )
<ProcessSignature> ::= 
   (';'/$) 'FPAR' <SortName>\','
<ProcedureSignature> = 
   ( (';'/$) 
     ( 'FPAR' ( ('IN' / 'IN/OUT' / $) <SortName>)\','
       ( ';' 'RETURNS' <SortName> / $)
     / 'RETURNS' <SortName>
     / $
     )
   )
<SignalSignature> ::=
   ( '(' <SortName>\',' ')' / $)
   ( <SignalRefinement> / $)
<SortSignature> ::= <Operators> 'ENDNEWTYPE' (<Name>/$)
<Operators> ::=
   ( <LiteralList> / $ )
   ( 'OPERATORS'
     ( ( <OperatorSignature> / 'ORDERING' ) ';'
     )+
   / $
   )
<LiteralList> ::=
   'LITERALS'
   ( <CharStringLiteral> / <LiteralName> /
     <NameClassLiteral> )
   )\','
   (';' / $)
<OperatorSignature> ::=
   <OperatorName> ':' <SortName>\',' '->' <SortName>


Definition of grammar see META_GRAMMAR
in a macro call symbol.
$Add_Heading
ATLEAST ProcedureName INHERITS ProcedureName;
FPAR
  IN     FparName SortName,
  IN/OUT FparName SortName;
$Inherits
INHERITS ProcedureName;
$AtleastInherits
ATLEAST ProcedureName INHERITS ProcedureName;
$Fpar
FPAR
  IN     FparName SortName,
  IN/OUT FparName SortName;
$In_fpar
  IN     FparName SortName,

$InOut_fpar
  IN/OUT FparName SortName,

$Fpar_Only
;
FPAR
  IN     FparName SortName,
  IN/OUT FparName SortName;

@SDL@SERVICE_REF@Service symbol
$GRAMMAR
Z100: 2.4.4

<ServiceSymbolContents> ::=
   <ServiceName>

@SDL@KERNEL_HEADING_SERVICE@Kernel Heading
$GRAMMAR
Z100: 2.4.5    Service definition

<ServiceKernelHeading> ::=
   'SERVICE' <Name> 
$Service_Def
SERVICE ServiceName
@SDL@ADDITIONAL_HEADING_SERVICE@Additional heading
$GRAMMAR
Z100: 2.4.5    Service definition
Z100: 2.4.4    Signalset (as for processes)

<AdditionalHeading> ::=
   (<ValidInputSignalSet> / $)
<ValidInputSignalSet> ::=
   ';' 'SIGNALSET' ( <SignalList> / $ ) ';'
<SignalList> ::=
   ( <SignalName> /
     <RemoteProcedureName> /
     '(' <SignalListName> ')'
   )\','


Definition of grammar see META_GRAMMAR
in a macro call symbol.
$Signalset
;
SIGNALSET
  SignalName, SignalName;
$EmptySignalset
;
SIGNALSET ;
@SDL@SERVICE_TYPE_REF@Service type symbol
$GRAMMAR
Z100: 6.1.1.4

<ServiceTypeSymbolContents> ::=
   ('VIRTUAL' / 'REDEFINED' / 'FINALIZED' / $)   
   <ServiceTypeName>
@SDL@KERNEL_HEADING_SERVICE_TYPE@Kernel Heading
$GRAMMAR
Z100: 6.1.1.4  Service type heading

<ServiceTypeKernelHeading> ::=
   ('VIRTUAL' / 'REDEFINED' / 'FINALIZED' / $)
   'SERVICE' 'TYPE' <Name>
$TypeDef
SERVICE TYPE ServiceTypeName
$VirtualType
VIRTUAL SERVICE TYPE ServiceTypeName
$RedefinedType
REDEFINED SERVICE TYPE ServiceTypeName
$FinalizedType
FINALIZED SERVICE TYPE ServiceTypeName
@SDL@ADDITIONAL_HEADING_SERVICE_TYPE@Additional heading
$GRAMMAR
Z100: 6.1.1.4  Service type heading
Z100: 6.3      Specialization
Z100: 6.3.1    Inherits
Z100: 6.3.2    Virtual, Redefined, Finalized
Z100: 6.3.2    Virtuality constraint (atleast)
Z100: 6.2      Actual context parameters
Z100: 6.2      Formal context parameters
Z100: 6.2.1 - 6.2.9  Formal context parameters

<ServiceTypeAdditionalHeading> ::=
   (<ServiceTypeAdditionalHeadingContents> / $)
<ServiceTypeAdditionalHeadingContents> ::=
   (<FormalContextPars> / $)
   (<VirtualityConstraint> / $)
   (<Specialization> / $)
   ';'
   (<ValidInputSignalSet> / $)
<VirtualityConstraint> ::=
   'ATLEAST' <Name>
<Specialization> ::= 
   'INHERITS' <Name> 
   (<ActualContextPars> / $) 
   ('ADDING' / $)
<ActualContextPars> ::=
   '<' (<Name> / $)\','  '>'
<ValidInputSignalSet> ::=
   'SIGNALSET' ( <SignalList> / $ ) ';'
<SignalList> ::=
   ( <SignalName> /
     <RemoteProcedureName> /
     '(' <SignalListName> ')'
   )\','
<FormalContextPars> ::= 
   '<' <FormalContextPar>\';' '>'
<FormalContextPar> ::= 
   ( 'PROCESS' <Name> 
     ( ('ATLEAST'/$) <Name> / <ProcessSignature> / $ )
   / 'PROCEDURE' <Name>
     ( 'ATLEAST' <Name> / <ProcedureSignature> )
   / 'REMOTE' 'PROCEDURE' <Name> <ProcedureSignature>
   / 'SIGNAL'
     ( <Name> ('ATLEAST' <Name> / <SignalSignature>) )\','
   / 'DCL' ( <Name>\',' <SortName> )\','
   / 'REMOTE' ( <Name>\',' <SortName> )\','
   / 'TIMER' ( <Name> ( '(' <>\',' ')' / $) )\','
   / 'SYNONYM' ( <Name> <SortName> )\','
   / 'NEWTYPE' <Name>
     ( 'ATLEAST' <SortName> / <SortSignature> / $ )
   )
<ProcessSignature> ::= 
   (';'/$) 'FPAR' <SortName>\','
<ProcedureSignature> = 
   ( (';'/$) 
     ( 'FPAR' ( ('IN' / 'IN/OUT' / $) <SortName>)\','
       ( ';' 'RETURNS' <SortName> / $)
     / 'RETURNS' <SortName>
     / $
     )
   )
<SignalSignature> ::=
   ( '(' <SortName>\',' ')' / $)
   ( <SignalRefinement> / $)
<SortSignature> ::= <Operators> 'ENDNEWTYPE' (<Name>/$)
<Operators> ::=
   ( <LiteralList> / $ )
   ( 'OPERATORS'
     ( ( <OperatorSignature> / 'ORDERING' ) ';'
     )+
   / $
   )
<LiteralList> ::=
   'LITERALS'
   ( <CharStringLiteral> / <LiteralName> /
     <NameClassLiteral> )
   )\','
   (';' / $)
<OperatorSignature> ::=
   <OperatorName> ':' <SortName>\',' '->' <SortName>
$Add_Heading
ATLEAST ServiceTypeName INHERITS ServiceTypeName;
SIGNALSET
  SignalName, SignalName;
$Inherits
INHERITS ProcessTypeName;
$AtleastInherits
ATLEAST ServiceTypeName INHERITS ServiceTypeName;
$Signalset_Only
;
SIGNALSET
  SignalName, SignalName;
$EmptySignalset_Only
;
SIGNALSET ;
<ServiceName> ::= <Name>
@SDL@CHANNEL@Channel symbol
$GRAMMAR
Z100: 2.5.1  Channel
Z100: 2.5.5  Signal list
SDL-96       Remote procedure name in signal list

<ChannelName> ::= <Name>
<SignalList> ::=
   ( <SignalName> /
     <RemoteProcedureName> /
     '(' <SignalListName> ')'
   )\','
$SignalList
SignalName, SignalName
$SignalList2
SignalName, SignalName, (SignalListName)
$SignalList3
SignalName, SignalName, PROCEDURE RemotePrdname
@SDL@SIGNALROUTE@Signal route symbol
$GRAMMAR
Z100: 2.5.2  Signal route
Z100: 2.5.5  Signal list
SDL-96       Remote procedure name in signal list

<SignalRouteName> ::= <Name>
<SignalList> ::=
   ( <SignalName> /
     <RemoteProcedureName> /
     '(' <SignalListName> ')'
   )\','
$SignalList
SignalName, SignalName
$SignalList2
SignalName, SignalName, (SignalListName)
$SignalList3
SignalName, SignalName, PROCEDURE RemotePrdname
@SDL@GATE@Gate symbol
$GRAMMAR
Z100: 6.1.4  Gate
Z100: 6.1.4  Textual endpoint constraint
Z100: 2.5.5  Signal list

<GateName> ::= <Name>
<TextualEndpointConstraint> ::=
   ('ATLEAST'/$) <Name>
<SignalList> ::=
   ( <SignalName> /
     <RemoteProcedureName> /
     '(' <SignalListName> ')'
   )\','
$Constraint
ATLEAST Name
$SignalList
SignalName, SignalName
$SignalList2
SignalName, SignalName, (SignalListName)
$SignalList3
SignalName, SignalName, PROCEDURE RemotePrdname
@SDL@CONNECTION_POINT@Connection point symbol
$GRAMMAR
Z100: 2.5.3  Connection

<ConnectionPointSymbol> ::=
   <ChannelOrSignalrouteName>\','
$Connection1
ChannelName
$Connection2
ChannelName1, ChannelName2
@SDL@START@Start symbol
$GRAMMAR
Z100: 2.6.2  Start
Z100: 6.3.3  Virtual transition

<StartArea> ::=
   ('VIRTUAL' / 'REDEFINED' / 'FINALIZED' / $)
$Virtual
VIRTUAL
$Redefined
REDEFINED
$Finalized
FINALIZED
@SDL@STATE@State symbol, Nextstate symbol
$GRAMMAR
Z100: 2.6.3     State
Z100: 4.4       Asterisk state
Z100: 4.5       Multiple appearence of state
Z100: 2.6.8.2.1 Nextstate
Z100: 4.9       Dash nextstate

<StateArea> ::=
   <StateName>\',' /
   '*' ( '(' <StateName>\',' ')' / $)
<NextstateSymbol> ::=
   <StateName> / '-'


Definition of grammar see META_GRAMMAR
in a macro call symbol.
$StateList
StateName, StateName
$All_States
*
$All_States_Except
* (StateName, StateName)
@SDL@INPUT@Input symbol
$GRAMMAR
Z100: 2.6.4    Input
Z100: 4.6      Asterisk input
Z100: 4.14     Remote procedure input
Z100: 6.3.3    Virtual transition
z100: 5.4.3    Variable
z100: 5.4.3.1  Indexed Variable
z100: 5.4.3.2  Field Variable
SDL-96         Signal and remote procedure in same input

<InputArea> ::=
   ( 'VIRTUAL' / 'REDEFINED' / 'FINALIZED' / $ )
   ( <Stimulus>\',' / '*' )
<Stimulus> ::=
   ( <SignalName> 
     ( '(' (<Variable> / $)\',' ')' / $ )
   / ('PROCEDURE'/$) <RemoteProcedureName>
   )
<Variable> ::=
   <VariableName>
   ( '(' <Expr>\',' ')' /
     '!' <FieldName>\'!'
   )*


Definition of grammar see META_GRAMMAR
in a macro call symbol.
$Input
SignalName
$Input_With_Param
SignalName
(Variable,
Variable)
$Input_Several
SignalName,
SignalName
$Input_All
*
$VirtualInput
VIRTUAL SignalName
$RedefinedInput
REDEFINED SignalName
$FinalizedInput
FINALIZED SignalName
$RPC_Input
PROCEDURE Name
@SDL@PRIORITY_INPUT@Priority input symbol
$GRAMMAR
Z100: 4.10     Priority input
Z100: 2.6.4    Stimulus
Z100: 6.3.3    Virtual transition
z100: 5.4.3    Variable
z100: 5.4.3.1  Indexed Variable
z100: 5.4.3.2  Field Variable

<PriorityInputArea> ::=
   ( 'VIRTUAL' / 'REDEFINED' / 'FINALIZED' / $ )
   <Stimulus>\','
<Stimulus> ::=
   <SignalName> 
   ( '(' (<Variable> / $)\',' ')' / $ )
<Variable> ::=
   <VariableName>
   ( '(' <Expr>\',' ')' /
     '!' <FieldName>\'!'
   )*
<InputSignal> ::=
   <SignalName>
   ( '(' (<VariableName> / $)\',' ')' / $ )
@SDL@SAVE@Save symbol
$GRAMMAR
Z100: 2.6.5   Save
Z100: 4.7     Asterisk save
Z100: 6.3.3   Virtual save
SDL-96        Signal and remote procedure in same save


<SaveArea> ::=
   ( 'VIRTUAL' / 'REDEFINED' / 'FINALIZED' / $ )
   ( <SignalList> / '*' )
<SignalList> ::=
   ( <SignalName> /
     <RemoteProcedureName> /
     '(' <SignalListName> ')'
   )\','

$Save
SignalName
$Save_Several
SignalName,
SignalName
$Save_RemotePrd_Several
SignalName,
PROCEDURE RemotePrdName,
SignalName
$Save_All
*
$VirtualSave
VIRTUAL SignalName
$RedefinedSave
REDEFINED SignalName
$FinalizedSave
FINALIZED SignalName
@SDL@OUTPUT@Output symbol
$GRAMMAR
Z100: 2.7.4

<OutputArea> ::=
   ( <SignalName> ( <ActualParameters> / $ ) )\','
   ( 'TO' <Destination> / $ )
   ( 'VIA' ('ALL'/$) <PathElement>\',' / $ )
   ( <PrioDirective> / $ )
   ( <ExtSigDirective> / $ )
   ( <AltDirective> / $ )
   ( <TransferDirective> / $ )
<ActualParameters> ::=
   '(' ( <Expr> / $ )\',' ')'
<Destination> ::=
   <PIdExpr> / <ProcessName> / 'THIS'
<PathElement> ::=
   <ChannelName> / <SignalrouteName> / <GateName>
<PrioDirective> ::=     '/*#PRIO' <Value> '*/'
<ExtSigDirective> ::=   '/*#EXTSIG*/'
<AltDirective> ::=      '/*#ALT*/'
<TransferDirective> ::= '/*#TRANSFER*/'


Definition of grammar see META_GRAMMAR
in a macro call symbol.
$Output
SignalName
$Output_With_Param
SignalName
(Expr, Expr)
$Output_To
SignalName
TO PIdExpr
$Output_To_This
SignalName
TO THIS
$Output_To_Param
SignalName
(Expr, Expr)
TO PIdExpr
$Output_Via
SignalName
VIA PathName
$Output_Via_All
SignalName
VIA ALL
PathName, PathName
$Output_To_Via
SignalName
TO PId_Expr
VIA PathName
$Sender
SENDER
$Offspring
OFFSPRING
$Parent
PARENT
$PRIO_Directive
/*#PRIO Value */
$ALT_Directive
/*#ALT*/
$TRANSFER_Directive
/*#TRANSFER*/
$EXTSIG_Directive
/*#EXTSIG*/
@SDL@DECISION@Decision symbol
$GRAMMAR
Z100: 2.7.5      Decision
Z100: 5.3.1.9.1  Range condition
Z100: 2.2.3      Informal text

<Question> ::= <Expr> / 'ANY' / <InformalText>
<AnswerIfANY> ::= $
<AnswerIfInformal> ::= <InformalText> / 'ELSE'
<Answer> ::= <RangeCondition>\',' / 'ELSE'
<RangeCondition> ::=
   ( ('=' / '/=' / '<' / '>' / '<=' / '>=') <Expr> /
     <Expr> ( ':' <Expr> / $ )
   )
<InformalText> ::= <CharstringLiteral>


Definition of grammar see META_GRAMMAR
in a macro call symbol.
@SDL@CONNECTOR@In-connector or out-connector symbol
$GRAMMAR
Z100: 2.6.7       In-connector
Z100: 2.6.8.2.2   Out-connector

<ConnectorArea> ::= <Name>
@SDL@TASK@Task, Set, Reset, or Export symbol
$GRAMMAR
Z100: 2.7.1   Task
Z100: 5.4.3   Assignment
Z100: 2.8     Set, Reset
Z100: 4.13    Export
Textual Algorithms

<TaskArea> ::=
   <Task> / <Set> / <Reset> / <Export>
<Task> ::=
   ( (<CodeDirective> / $)
     <AssignmentStatement>
     (<CodeDirective> / $)
   ) \','
   /
   ( (<CodeDirective> / $)
     <InformalText>
     (<CodeDirective> / $)
   ) \','
   /
   (
     (<CodeDirective> / $)
     <StatementList>
     (<CodeDirective> / $)
   )
<AssignmentStatement> ::=
   <Variable> ':=' <Expr>
<Variable> ::=
   <VariableName>
   ( '(' <Expr>\',' ')' /
     '!' <FieldName>\'!'
   )*
<InformalText> ::= <CharstringLiteral>
<StatementList> ::= 
   ( <VariableDefinitionStatement> )*
   ( <Statement> )*
<VariableDefinitionStatement> ::= 
   'DCL' <LocalVariablesOfSort>\',' ';'
<LocalVariablesOfSort> ::= 
   <VariableName>\',' <SortName> 
   ( '::=' <Expr> / $ )
<Statement> ::=
   <CompoundStatement> /
   <Assignment> /
   <ExtendedActionStatement> /
   <ReturnStatement> /
   <CallStatement> /
   <ExpressionStatement> /
   <IfStatement> /
   <DecisionStatement> /
   <LoopStatement> /
   <LabelledStatement> /
   <JumpStatement> /
   <EmptyStatement> 
<CompoundStatement> ::= 
   '{' <StatementList> '}'
<Assignment> ::=
   <AssignmentStatement> ';'
<ExtendedActionStatement> ::= 
   <Output> ';' /
   <CreateRequest> ';' /
   <Set> ';' /
   <Reset> ';' /
   <Export> ';'
<ReturnStatement> ::= 
   'RETURN' ( <Expression> / $ ) ';'
<CallStatement> ::= 
   ( 'CALL' / $ )
   ( 'THIS' / $ )
   <Identifier> ( <ActualParameters> / $ )
   ( <RemoteCallExtra> / $ ) ';'
<ActualParameters> ::=
   '(' (<Expression> / $)\',' ')'
<RemoteCallExtra> ::=
   ( 'TO' <Destination> / $ )
   ( 'VIA' <PathElement>\',' / $ )
<Destination> ::=
   <PIdExpr> / <ProcessName> / 'THIS'
<PathElement> ::=
   <ChannelName> / <SignalrouteName> / <GateName>
<ExpressionStatement> ::= 
   <OperatorIdentifier> '(' <ActiveExpressionList> ')'
<IfStatement> ::= 
   'IF' '(' <Expression> ')' <Statement> 
     ( 'ELSE' <Statement> / $ )
<DecisionStatement> ::= 
   'DECISION' '(' <Expression> ')' 
     '{' ( '(' <RangeCondition> ')' ':' <Statement> )+ 
     ( 'ELSE' ':' <Statement> / $ ) '}'
<LoopStatement> ::= 
   'FOR' '(' ( <LoopClause>\';' / $ ) ')' 
     <Statement> ( 'THEN' <Statement> / $ )
<LoopClause> ::= 
   ( <LoopVariableIndication> / $ ) 
   ( ',' ( <LimitExpression> / $ ) 
         ( ',' ( <StepExpression> / 
                 <StepProcedureCall> / 
                 <StepProcedureCallBody> / 
                 $ ) /
           $ ) /
     $ )
<LoopVariableIndication> ::= 
   'DCL' <Name> <SortName> ':=' <Expr> /
   <Identifier> ':=' <Expr> /
   <Identifier>
<LabelledStatement> ::= <Name> ':' <Statement>
<JumpStatement> ::= 
   'BREAK' ( <Name> / $ ) ';' /
   'CONTINUE' ';'
<EmptyStatement> ::= ';'
<CodeDirective> ::=
   '/*#CODE' <CR> <Any_C_Code> '*/'
<Setx> ::=
   'SET'
   ( '('
     ( <TimeExpr> ',' / $ )
     <TimerName>
     ( '(' <Expr>\',' ')' / $ )
     ')'
   )\','
<Resetx> ::=
   'RESET' '('
   ( <TimerName> ( '(' <Expr>\',' ')' / $) )\','
   ')'
<Export> ::=
   'EXPORT' '(' <ExportedVariableName>\',' ')'


Definition of grammar see META_GRAMMAR
in a macro call symbol.
$Assignment
Variable := Expr
$Assignment2
Variable := Expr,
Variable := Expr
$CODE_Directive
/*#CODE
C_code
*/
$Task_with_CODE_Dir
'' /*#CODE
C_code
*/
$Set
SET(Now+Expr,
TimerName)
$Set_No_Time
SET(TimerName)
$Reset
RESET(TimerName)
$Export
EXPORT(VariableName)
$Assignment3
Variable := Expression;
$VariableDefinitionStatement
DCL VariableName SortName;
$VariableDefinitionStatement2
DCL VariableName SortName ::= Expression;
$CompoundStatement
{ statement statement }
$ExtendedActionOutput
OUTPUT SignalName(Parameters) 
TO pid 
VIA RouteName;
$ExtendedActionCreate
CREATE ProcessName;
$ReturnStatement
RETURN Expression;
$CallStatement
ProcedureName(Parameters);
$IfStatement
IF ( Expression ) Statement 
ELSE Statement
$DecisionStatement
DECISION ( Expression )
{ ( RangeCondition ): Statement
  ELSE: Statement }
$LoopStatementSimple
FOR ( ) Statement
$LoopStatementWithLoopVariable
FOR (LoopVariable := Expression, 
     LimitExpression, 
     StepExpression) Statement
$LoopStatementWithLoopVariable2
FOR (DCL LoopVariable Sort := Expression,
     LimitExpression, 
     StepExpression) Statement
$LoopStatementWithFinal
FOR ( ) Statement THEN Statement
$LabelledStatement
LabelName: Statement
$JumpStatementBreak
BREAK LabelName;
$JumpStatementContinue
CONTINUE;
@SDL@CALL@Procedure call symbol
$GRAMMAR
Z100: 2.7.3   Call
Z100: 2.7.2   Actual parameters
Z100: 4.14    Remote procedure call
SDL-96        VIA in remote procedure call

<CallArea> ::=
   <ProcedureCallArea> / <RemoteProcedureCallArea>
<ProcedureCallArea> ::=
   ( 'THIS' / $ ) <ProcedureName>
   ( <ActualParameters> / $ )
<ActualParameters> ::=
   '(' (<Expr> / $)\',' ')'
<RemoteProcedureCallArea> ::=
   <ProcedureName>
   ( <ActualParameters> / $ )
   ( 'TO' <Destination> / $ )
   ( 'VIA' <PathElement>\',' / $ )
<Destination> ::=
   <PIdExpr> / <ProcessName> / 'THIS'
<PathElement> ::=
   <ChannelName> / <SignalrouteName> / <GateName>
$Call
ProcedureName
$Call_with_Param
ProcedureName
(Expr, Expr)
$RPC_TO
ProcedureName
(Expr, Expr)
TO Destination
$RPC_VIA
ProcedureName
(Expr, Expr)
VIA PathName
@SDL@CREATE@Create request symbol
$GRAMMAR
Z100: 2.7.2 

<CreateRequestArea> ::=
   ( <ProcessName> / 'THIS' ) 
   ( <ActualParameters> / $ )
<ActualParameters> ::=
   '(' (<Expr> / $)\',' ')'


Definition of grammar see META_GRAMMAR
in a macro call symbol.
@SDL@TRANSITION_OPTION@Transition option symbol
$GRAMMAR
Z100: 4.3.4      Transition option
Z100: 5.3.1.9.1  Range condition

<Question> ::= <StaticExpr>
<Answer> ::= <RangeCondition>\',' / 'ELSE'
<RangeCondition> ::=
   ( ('=' / '/=' / '<' / '>' / '<=' / '>=') <StaticExpr> /
     <StaticExpr> ( ':' <StaticExpr> / $ )
   )
@SDL@ENABLING_CONDITION@Enabling condition symbol
$GRAMMAR
Z100: 4.12

<EnablingConditionArea> ::=
   <BooleanExpr>
@SDL@CONTINUOUS_SIGNAL@Continuous signal symbol
$GRAMMAR
Z100: 4.11

<ContinuousSignalArea> ::=
   ( 'VIRTUAL' / 'REDEFINED' / 'FINALIZED' / $ )
   <BooleanExpr> ( ';' 'PRIORITY' <Value> / $ )
$ContSig_with_Prio
BooleanExpr;
PRIORITY Value
@SDL@STOP@Stop symbol
$GRAMMAR
Z100: 2.6.8.2.3

<StopArea> ::= $


Definition of grammar see META_GRAMMAR
in a macro call symbol.
@SDL@PROCEDURE_START@Procedure start symbol
$GRAMMAR
Z100: 2.4.6

<ProcedureStartArea> ::= 
   ( 'VIRTUAL' / 'REDEFINED' / 'FINALIZED' / $ )


Definition of grammar see META_GRAMMAR
in a macro call symbol.
@SDL@RETURN@Return symbol
$GRAMMAR
Z100: 2.6.8.2.4

<ReturnArea> ::= 
   ( <Expression> / $ )


Definition of grammar see META_GRAMMAR
in a macro call symbol.
@SDL@PRIORITY_OUTPUT@Priority output symbol
$GRAMMAR
Z100: NOT part of SDL-92

@SDL@TEXTSYMBOL_SYSTEM_PACKAGE_SUBSTR_BLOCK@Text symbol
$GRAMMAR
Z100: 2.5.4      Signal
Z100: 2.5.5      Signal list
Z100: 5.2.1      Newtype
Z100: 5.3.1.9    Syntype
Z100: 5.3.1.13   Synonym
Z100: 5.3.1.12.1 Generator
Z100: 4.13       Remote variable
Z100: 4.14       Remote procedure
SDL-96           External procedure
Textual Algorithms Textual procedure

<TextSymbol> ::=
   ( <MainDirective> / $ )
   ( <CodeDirective> / $ )
   ( ( <SignalDef>  / <SignalListDef> /
       <NewTypeDef> / <SynTypeDef>    /
       <SynonymDef> / <GeneratorDef>  /
       <RemoteVariableDef> /
       <RemoteProcedureDef> /
       <ExternalProcedureDef> /
       <TextualProcedureDef> )
     ( <CodeDirective> / $ )
   )*
<MainDirective> ::=
   '/*#MAIN' <CR> <Any_C_Code> '*/'
<CodeDirective> ::=
   '/*#CODE' <CR> <Any_C_Code> '*/'


Definition of grammar see META_GRAMMAR
in a macro call symbol.
$GRAMMAR_SIGNALDEF
Z100: 2.5.4    Signal
Z100: 6.3      Specialization
Z100: 6.3.1    Inherits
Z100: 6.2      Actual context parameters
Z100: 6.2      Formal context parameters
Z100: 6.2.9    Sort context parameter

<SignalDef> ::=
   'SIGNAL'
     ( <SignalName>
       ( <FormalContextPars> / $ )
       ( <Specialization> / $ )
       ( '(' <SortName>\',' ')' / $)
       ( <SignalRefinement> / $)
       ( <PrioDirective> / $ )
     )\','
   ';'
<SignalRefinement> ::=
   'REFINEMENT'
   ( ('REVERSE' / $) <SignalDef> )+
   'ENDREFINEMENT'
<PrioDirective> ::=
   '/*#PRIO' <Value> '*/'
<Specialization> ::= 
   'INHERITS' <Name> 
   (<ActualContextPars> / $) 
   ('ADDING' / $)
<ActualContextPars> ::=
   '<' (<Name> / $)\','  '>'
<FormalContextPars> ::= 
   '<' <FormalContextPar>\';' '>'
<FormalContextPar> ::= 
   'NEWTYPE' <Name>
   ( 'ATLEAST' <SortName> / <SortSignature> / $ )
<SortSignature> ::= <Operators> 'ENDNEWTYPE' (<Name>/$)
<Operators> ::=
   ( <LiteralList> / $ )
   ( 'OPERATORS'
     ( ( <OperatorSignature> / 'ORDERING' ) ';'
     )+
   / $
   )
<LiteralList> ::=
   'LITERALS'
   ( <CharStringLiteral> / <LiteralName> /
     <NameClassLiteral> )
   )\','
   (';' / $)
<OperatorSignature> ::=
   <OperatorName> ':' <SortName>\',' '->' <SortName>
$GRAMMAR_SIGNALLIST
Z100: 2.5.5

<SignalListDef> ::=
   'SIGNALLIST' <SignalListName> '='
   <SignalList> ';'
<SignalList> ::=
   ( <SignalName> /
     <RemoteProcedureName> /
     '(' <SignalListName> ')'
   )\','
$GRAMMAR_NEWTYPE
Z100: 5.2.1      Newtype
Z100: 5.3.1.10   Structure
Z100: 5.3.1.12.2 Generator
Z100: 5.3.1.11   Inheritance
Z100: 5.2.2      Literals
Z100: 5.2.2      Operators
Z100: 5.3.1.9.1  Range condition
Z100: 5.3.2      Operator definitions
Z100: 5.4.3.3    Default assignment
Z100: 5.4.6      External properties
IBM Rational     Bit field, Initializer, Optional
IBM Rational     Choice

<NewTypeDef> ::=
   'NEWTYPE' <SortName>
   ( <FormalContextPars> / $ )
   ( <ExtendedProperties> / $ )
   <PropertiesExpr>
   ( <Constants> / $ )
   ( <ADTDirective> / $ )
   'ENDNEWTYPE' ( <SortName> / $ ) ';'
<ExtendedProperties> ::=
   <StructureDef> / <GeneratorInsts> /
   <InheritanceRule> / <ChoiceDef>
<StructureDef> ::=
   'STRUCT'
   ( <BitField> /
     ( <ComponentName>\',' <SortName>
       ( 'OPTIONAL' / <Initializer> / <BitField> / $ )
       ';'
     )
   )+
   ('ADDING' / $)
<BitField> ::=
   ':' <Expr>
<Initializer> ::= 
   ':=' <Expr>
<ChoiceDef> ::= 
   'CHOICE'
   ( <ComponentName>\',' <SortName> (<BitField> / $) ';')+
   ('ADDING' / $)
<GeneratorInsts> ::=
   ( <GeneratorInst> (';' / $) ('ADDING' / $) )+
<GeneratorInst> ::=
   <GeneratorName> '('
   ( <NameClassLiteral> / <OperatorName> /
     <SortName> / <CharStringLiteral> / <Expr>
   )\','
   ')'
<InheritanceRule> ::=
   'INHERITS' <SortName>
   ( <LiteralRenaming> / $)
   ( ('OPERATORS' / $)
     ('ALL' / '(' <InheritanceList>\',' ')' )
     (';' / $)
   / $
   )
   ('ADDING' / $)
<InheritanceList> ::=
   <InheritedOperator>\',' ( 'NOEQUALITY' / $ )
<InheritedOperator> ::=
   <OperatorName> ( '=' <OperatorName> / $)
<LiteralRenaming> ::=
   'LITERALS'
   ( (<Name> / <CharStringLiteral>) '='
     (<Name> / <CharStringLiteral>)
   )\',' ';'
<PropertiesExpr> ::=
   <Operators>
   ( <InternalProperties> / <ExternalProperties> )
   ( <DefaultAssignment> / $)
<Operators> ::=
   ( <LiteralList> / $ )
   ( 'OPERATORS'
     ( ( <OperatorSignature> /
         'ORDERING' / 'NOEQUALITY' ) ';'
       ( <OPDirective> / $ )
     )+
   / $
   )
<LiteralList> ::=
   'LITERALS'
   ( ( <CharStringLiteral> / <LiteralName> /
       <NameClassLiteral> )
     ( <OPDirective> / $ )
   )\','
   (';' / $)
<OperatorSignature> ::=
   <OperatorName> ':' <SortName>\',' '->' <SortName>
<InternalProperties> ::=
   ( <OperatorDefinitions> / $ )
   ( 'AXIOMS' <Axioms> / $)
   ( <LiteralMapping> / $)
<OperatorDefinitions> ::=
   ( <OperatorDefinition> / <TextualOperatorReference> )+
<TextualOperatorReference> ::=
   'OPERATOR' <OperatorName> 'REFERENCED' ';'
<DefaultAssignment> ::=
   'DEFAULT' <Expr> (';' / $)
<Constants> ::=
   'CONSTANTS' <RangeCondition>\','
<RangeCondition> ::=
   ( ('=' / '/=' / '<' / '>' / '<=' / '>=') <Expr> /
     <Expr> ( ':' <Expr> / $ )
   )
<FormalContextPars> ::= 
   '<' <FormalContextPar>\';' '>'
<FormalContextPar> ::= 
   ( 'SYNONYM' ( <Name> <SortName> )\','
   / 'NEWTYPE' <Name>
     ( 'ATLEAST' <SortName> / <SortSignature> / $ )
   )
<SortSignature> ::= <Operators> 'ENDNEWTYPE' (<Name>/$)
<ExternalProperties> ::=
   'ALTERNATIVE' <Name> (<Word>/$) ';'
   <ExternalDataDescription>
   ( 'ENDALTERNATIVE' / $ ) ';'
<ADTDirective> ::=
   '/*#ADT' '(' <ADTDefs> ')' <CR>
   ( '#TYPE' <CR> <Any_C_Code> / $ )
   ( '#HEADING' <CR> <Any_C_Code> / $ )
   ( '#BODY' <CR> <Any_C_Code> / $ )
   '*/'
<OPDirective> ::=
   '/*#OP' '(' <OPDefs> ')' '*/'
$GRAMMAR_SYNTYPE
Z100: 5.3.1.9    Syntype
Z100: 5.3.1.9.1  Range condition
Z100: 5.4.3.3    Default assignment

<SynTypeDef> ::=
   'SYNTYPE' <SortName> '=' <SortName>
   (<DefaultAssignment> / $) (<Constants> / $)
   'ENDSYNTYPE' (<SortName> / $) ';'
<DefaultAssignment> =
   'DEFAULT' <Expr> (';' / $)
<Constants> ::=
   'CONSTANTS' <RangeCondition>\','
<RangeCondition> ::=
   ( ('=' / '/=' / '<' / '>' / '<=' / '>=') <Expr> /
     <Expr> ( ':' <Expr> / $ )
   )
$GRAMMAR_SYNONYM
Z100: 5.3.1.13  Synonym
Z100: 4.3.1     External synonym

<SynonymDef> ::=
   'SYNONYM'
   ( <SynonymName> (<SortName> / $) '='
     ( <Expr> / 'EXTERNAL' )
   )\','
   ';'
$GRAMMAR_GENERATOR
Z100: 5.3.1.12.1

<GeneratorDef> ::=
   'GENERATOR' <GeneratorName>
   <GeneratorParameters>
   (<GeneratorInsts> / $)
   <PropertiesExpr>
   'ENDGENERATOR' (<GeneratorName> / $) ';'
<GeneratorParameters> ::=
   '('
   ( ('TYPE' / 'LITERAL' / 'OPERATOR' / 'CONSTANT')
     <Name>\','
   )\','
   ')'
<GeneratorInsts>  see GRAMMAR_NEWTYPE
<PropertiesExpr>  see GRAMMAR_NEWTYPE
$GRAMMAR_REMOTE
<RemoteVariableDef> ::=
   'REMOTE'
   ( <RemoteVariableName>\',' <SortName>
     ( 'NODELAY' / $ )
   )\','
   ';'
<RemoteProcedureDef> ::=
   'REMOTE' 'PROCEDURE' <RemoteProcedureName>
   ( 'NODELAY' / $ ) ';'
   ( <ProcedureSignature> ';' / $ )
<ProcedureSignature> ::=
   ( 'FPAR' ( ('IN' / 'IN/OUT' / $) <SortName>)\','
     ( ';' 'RETURNS' <SortName> / $)
   / 'RETURNS' <SortName>
   / $
   )
$GRAMMAR_PROCEDURE
<ExternalProcedureDef> ::=
   'PROCEDURE' <ExternalProcedureName> 
   ( <ProcedureFormalPar> ';' / $ )
   ( <ProcedureResult> ';' / $ )
   'EXTERNAL' ';'
<ProcedureFormalPar> ::=
   'FPAR'
   ( ('IN' / 'IN/OUT' / $)
     <ParameterName>\',' <SortName>
   )\','
   ';'
<ProcedureResult> ::=
   'RETURNS' (<VariableName>/$) <SortName>
$GRAMMAR_TEXTUAL_PROCEDURE
<TextualProcedureDef> ::=
   <ProcedurePreamble>
   'PROCEDURE' <ProcedureIdentifier> 
   ( <FormalContextParameters> / $ )
   ( <VirtualityConstraint> / $ )
   ( <Specialization> / $ )
   ( <ProcedureFormalParameters> / $ )
   ( <ProcedureResult> / $ )
   ( <CompoundStatement> /
     <ProcedureBody> 'ENDPROCEDURE' ( <ProcedureIdentifier> / $ ) ';' 
     )
$MAIN_Directive
/*#MAIN
C_code
*/

$CODE_Directive
/*#CODE
#TYPE
C_code
#HEADING
C_code
#BODY
C_code
*/

$SignalDef
SIGNAL
  SignalName,
  SignalName(SortName),
  SignalName(SortName, SortName);

$PRIO_Directive
/*#PRIO Value */
$Signallist
SIGNALLIST SignalListName =
  SignalName, SignalName, (SignalListName);

$SignallistRemotePrd
SIGNALLIST SignalListName =
  SignalName, SignalName, PROCEDURE RemotePrdName;

$Newtype_Struct
NEWTYPE SortName STRUCT
  ConponentName, ComponentName SortName;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Struct_Optional
NEWTYPE SortName STRUCT
  ConponentName SortName OPTIONAL;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Struct_Initializer
NEWTYPE SortName STRUCT
  ConponentName SortName := Value;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Struct_Bitfield
NEWTYPE SortName STRUCT
  ConponentName Integer : 4;
  ComponentName UnsignedInt : 1;
                : 0;
  ComponentName UnsignedInt : 1;
ENDNEWTYPE;

$Newtype_Choice
NEWTYPE SortName CHOICE
  ConponentName, ComponentName SortName;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Array
NEWTYPE SortName
  ARRAY(IndexSortName, ComponentSortName)
ENDNEWTYPE;

$Newtype_Bag
NEWTYPE SortName
  BAG(ComponentSortName)
ENDNEWTYPE;

$Newtype_CArray
NEWTYPE SortName
  CARRAY(Length, ComponentSortName)
ENDNEWTYPE;

$Newtype_Powerset
NEWTYPE SortName
  POWERSET(ComponentSortName)
ENDNEWTYPE;

$Newtype_Ref
NEWTYPE SortName
  REF(ComponentSortName)
ENDNEWTYPE;

$Newtype_String
NEWTYPE SortName
  STRING(ComponentSortName, EmptystringLiteralName)
ENDNEWTYPE;

$Newtype_enum
NEWTYPE SortName
  LITERALS LiteralName, LiteralName;
ENDNEWTYPE;

$Newtype_Struct_add
NEWTYPE SortName STRUCT
  ConponentName, ComponentName SortName;
  ComponentName SortName;
ADDING
  LITERALS
    LiteralName,
    LiteralName;
  OPERATORS
    OperatorName : SortName, SortName -> SortName;
  DEFAULT (. Value, Value, Value .)
ENDNEWTYPE;

$Newtype_Array_add
NEWTYPE SortName
  ARRAY(IndexSortName, ComponentSortName)
ADDING
  LITERALS
    LiteralName,
    LiteralName;
  OPERATORS
    OperatorName : SortName, SortName -> SortName;
  DEFAULT (. Value .)
ENDNEWTYPE;

$Newtype_Operator
NEWTYPE SortName
  OPERATORS
    OperatorName : SortName, SortName -> SortName;
  OPERATOR OperatorName REFERENCED;
ENDNEWTYPE;

$Newtype_Operator2
NEWTYPE SortName
  OPERATORS Add: int, int -> int;
  OPERATOR Add FPAR a,b int returns int
    { return a+b; }
ENDNEWTYPE;

$OperatorSign1
    OperatorName : SortName -> SortName;

$OperatorSign2
    OperatorName : SortName, SortName -> SortName;

$OperatorSign3
    OperatorName : SortName, SortName, SortName -> SortName;

$OperatorSign1_NAME
    OperatorName /*#NAME 'NameInC'*/
      : SortName -> SortName;

$OperatorSign2_NAME
    OperatorName /*#NAME 'NameInC'*/
      : SortName, SortName -> SortName;

$OperatorSign3_NAME
    OperatorName /*#NAME 'NameInC'*/
      : SortName, SortName, SortName -> SortName;

$NAME_Directive
/*#NAME 'NameInC'*/
$OP_Directive
/*#OP(BP)*/
$ADT_Directive
/*#ADT(BP)
#TYPE
C_code
#HEADING
C_code
#BODY
C_code
*/

$Simple_Syntype
SYNTYPE SortName = SortName
ENDSYNTYPE;

$Syntype
SYNTYPE SortName = SortName
  DEFAULT Value
  CONSTANTS Value:Value
ENDSYNTYPE;

$Integer_Syntype
SYNTYPE SortName = Integer
  CONSTANTS Value:Value
ENDSYNTYPE;

$Synonym
SYNONYM SynonymName SortName = Value;

$ExternalSynonym
SYNONYM SynonymName SortName = EXTERNAL;

$ExternalProcedure
PROCEDURE ProcedureName;
FPAR IN FparName SortName, IN/OUT FparName SortName;
EXTERNAL;

$ExternalProcedure
PROCEDURE ProcedureName;
FPAR IN FparName SortName;
RETURNS SortName;
EXTERNAL;

$TextualProcedure
PROCEDURE ProcedureName
FPAR IN FparName SortName
RETURNS SortName
{ OUTPUT SignalName; 
  RETURN Expression; }

$TextualProcedure
PROCEDURE ProcedureName;
FPAR IN FparName SortName;
START; 
RETURN;
ENDPROCEDURE;

@SDL@TEXTSYMBOL_PROCESS@Text symbol
$GRAMMAR
Z100: 2.5.4      Signal
Z100: 2.5.5      Signal list
Z100: 5.2.1      Newtype
Z100: 5.3.1.9    Syntype
Z100: 5.3.1.13   Synonym
Z100: 5.3.1.12.1 Generator
Z100: 2.6.1.1    Variable
Z100: 2.6.1.2    View
Z100: 2.8        Timer
Z100: 4.13       Remote variable
Z100: 4.13       Imported variable
Z100: 4.14       Remote procedure
Z100: 4.14       Imported procedure
SDL-96           External procedure
Textual Algorithms Textual procedure

<TextSymbol> ::=
   ( <CodeDirective> / $ )
   ( ( <SignalDef>    / <SignalListDef> /
       <NewTypeDef>   / <SynTypeDef>    /
       <SynonymDef>   / <GeneratorDef>  /
       <VariableDef>  / <ViewDef>       /
       <TimerDef>     / <RemoteVariableDef> /
       <ImportedVariableDef>  /
       <RemoteProcedureDef>   /
       <ImportedProcedureDef> /
       <ExternalProcedureDef> /
       <TextualProcedureDef> )
     )
     ( <CodeDirective> / $ )
   )*
<CodeDirective> ::=
   '/*#CODE' <CR> <Any_C_Code> '*/'


Definition of grammar see META_GRAMMAR
in a macro call symbol.
$GRAMMAR_SIGNALDEF
Z100: 2.5.4    Signal
Z100: 6.3      Specialization
Z100: 6.3.1    Inherits
Z100: 6.2      Actual context parameters
Z100: 6.2      Formal context parameters
Z100: 6.2.9    Sort context parameter

<SignalDef> ::=
   'SIGNAL'
     ( <SignalName>
       ( <FormalContextPars> / $ )
       ( <Specialization> / $ )
       ( '(' <SortName>\',' ')' / $)
       ( <SignalRefinement> / $)
       ( <PrioDirective> / $ )
     )\','
   ';'
<SignalRefinement> ::=
   'REFINEMENT'
   ( ('REVERSE' / $) <SignalDef> )+
   'ENDREFINEMENT'
<PrioDirective> ::=
   '/*#PRIO' <Value> '*/'
<Specialization> ::= 
   'INHERITS' <Name> 
   (<ActualContextPars> / $) 
   ('ADDING' / $)
<ActualContextPars> ::=
   '<' (<Name> / $)\','  '>'
<FormalContextPars> ::= 
   '<' <FormalContextPar>\';' '>'
<FormalContextPar> ::= 
   'NEWTYPE' <Name>
   ( 'ATLEAST' <SortName> / <SortSignature> / $ )
<SortSignature> ::= <Operators> 'ENDNEWTYPE' (<Name>/$)
<Operators> ::=
   ( <LiteralList> / $ )
   ( 'OPERATORS'
     ( ( <OperatorSignature> / 'ORDERING' ) ';'
     )+
   / $
   )
<LiteralList> ::=
   'LITERALS'
   ( <CharStringLiteral> / <LiteralName> /
     <NameClassLiteral> )
   )\','
   (';' / $)
<OperatorSignature> ::=
   <OperatorName> ':' <SortName>\',' '->' <SortName>
$GRAMMAR_SIGNALLIST
Z100: 2.5.5

<SignalListDef> ::=
   'SIGNALLIST' <SignalListName> '='
   <SignalList> ';'
<SignalList> ::=
   ( <SignalName> /
     <RemoteProcedureName> /
     '(' <SignalListName> ')'
   )\','
$GRAMMAR_NEWTYPE
Z100: 5.2.1      Newtype
Z100: 5.3.1.10   Structure
Z100: 5.3.1.12.2 Generator
Z100: 5.3.1.11   Inheritance
Z100: 5.2.2      Literals
Z100: 5.2.2      Operators
Z100: 5.3.1.9.1  Range condition
Z100: 5.3.2      Operator definitions
Z100: 5.4.3.3    Default assignment
Z100: 5.4.6      External properties
IBM Rational     Bit field, Initializer, Optional
IBM Rational     Choice

<NewTypeDef> ::=
   'NEWTYPE' <SortName>
   ( <FormalContextPars> / $ )
   ( <ExtendedProperties> / $ )
   <PropertiesExpr>
   ( <Constants> / $ )
   ( <ADTDirective> / $ )
   'ENDNEWTYPE' ( <SortName> / $ ) ';'
<ExtendedProperties> ::=
   <StructureDef> / <GeneratorInsts> /
   <InheritanceRule> / <ChoiceDef>
<StructureDef> ::=
   'STRUCT'
   ( <BitField> /
     ( <ComponentName>\',' <SortName>
       ( 'OPTIONAL' / <Initializer> / <BitField> / $ )
       ';'
     )
   )+
   ('ADDING' / $)
<BitField> ::=
   ':' <Expr>
<Initializer> ::= 
   ':=' <Expr>
<ChoiceDef> ::= 
   'CHOICE'
   ( <ComponentName>\',' <SortName> (<BitField> / $) ';')+
   ('ADDING' / $)
<GeneratorInsts> ::=
   ( <GeneratorInst> (';' / $) ('ADDING' / $) )+
<GeneratorInst> ::=
   <GeneratorName> '('
   ( <NameClassLiteral> / <OperatorName> /
     <SortName> / <CharStringLiteral> / <Expr>
   )\','
   ')'
<InheritanceRule> ::=
   'INHERITS' <SortName>
   ( <LiteralRenaming> / $)
   ( ('OPERATORS' / $)
     ('ALL' / '(' <InheritanceList>\',' ')' )
     (';' / $)
   / $
   )
   ('ADDING' / $)
<InheritanceList> ::=
   <InheritedOperator>\',' ( 'NOEQUALITY' / $ )
<InheritedOperator> ::=
   <OperatorName> ( '=' <OperatorName> / $)
<LiteralRenaming> ::=
   'LITERALS'
   ( (<Name> / <CharStringLiteral>) '='
     (<Name> / <CharStringLiteral>)
   )\',' ';'
<PropertiesExpr> ::=
   <Operators>
   ( <InternalProperties> / <ExternalProperties> )
   ( <DefaultAssignment> / $)
<Operators> ::=
   ( <LiteralList> / $ )
   ( 'OPERATORS'
     ( ( <OperatorSignature> /
         'ORDERING' / 'NOEQUALITY' ) ';'
       ( <OPDirective> / $ )
     )+
   / $
   )
<LiteralList> ::=
   'LITERALS'
   ( ( <CharStringLiteral> / <LiteralName> /
       <NameClassLiteral> )
     ( <OPDirective> / $ )
   )\','
   (';' / $)
<OperatorSignature> ::=
   <OperatorName> ':' <SortName>\',' '->' <SortName>
<InternalProperties> ::=
   ( <OperatorDefinitions> / $ )
   ( 'AXIOMS' <Axioms> / $)
   ( <LiteralMapping> / $)
<OperatorDefinitions> ::=
   ( <OperatorDefinition> / <TextualOperatorReference> )+
<TextualOperatorReference> ::=
   'OPERATOR' <OperatorName> 'REFERENCED' ';'
<DefaultAssignment> ::=
   'DEFAULT' <Expr> (';' / $)
<Constants> ::=
   'CONSTANTS' <RangeCondition>\','
<RangeCondition> ::=
   ( ('=' / '/=' / '<' / '>' / '<=' / '>=') <Expr> /
     <Expr> ( ':' <Expr> / $ )
   )
<FormalContextPars> ::= 
   '<' <FormalContextPar>\';' '>'
<FormalContextPar> ::= 
   ( 'SYNONYM' ( <Name> <SortName> )\','
   / 'NEWTYPE' <Name>
     ( 'ATLEAST' <SortName> / <SortSignature> / $ )
   )
<SortSignature> ::= <Operators> 'ENDNEWTYPE' (<Name>/$)
<ExternalProperties> ::=
   'ALTERNATIVE' <Name> (<Word>/$) ';'
   <ExternalDataDescription>
   ( 'ENDALTERNATIVE' / $ ) ';'
<ADTDirective> ::=
   '/*#ADT' '(' <ADTDefs> ')' <CR>
   ( '#TYPE' <CR> <Any_C_Code> / $ )
   ( '#HEADING' <CR> <Any_C_Code> / $ )
   ( '#BODY' <CR> <Any_C_Code> / $ )
   '*/'
<OPDirective> ::=
   '/*#OP' '(' <OPDefs> ')' '*/'
$GRAMMAR_SYNTYPE
Z100: 5.3.1.9    Syntype
Z100: 5.3.1.9.1  Range condition
Z100: 5.4.3.3    Default assignment

<SynTypeDef> ::=
   'SYNTYPE' <SortName> '=' <SortName>
   (<DefaultAssignment> / $) (<Constants> / $)
   'ENDSYNTYPE' (<SortName> / $) ';'
<DefaultAssignment> =
   'DEFAULT' <Expr> (';' / $)
<Constants> ::=
   'CONSTANTS' <RangeCondition>\','
<RangeCondition> ::=
   ( ('=' / '/=' / '<' / '>' / '<=' / '>=') <Expr> /
     <Expr> ( ':' <Expr> / $ )
   )
$GRAMMAR_SYNONYM
Z100: 5.3.1.13  Synonym
Z100: 4.3.1     External synonym

<SynonymDef> ::=
   'SYNONYM'
   ( <SynonymName> (<SortName> / $) '='
     ( <Expr> / 'EXTERNAL' )
   )\','
   ';'
$GRAMMAR_GENERATOR
Z100: 5.3.1.12.1

<GeneratorDef> ::=
   'GENERATOR' <GeneratorName>
   <GeneratorParameters>
   (<GeneratorInsts> / $)
   <PropertiesExpr>
   'ENDGENERATOR' (<GeneratorName> / $) ';'
<GeneratorParameters> ::=
   '('
   ( ('TYPE' / 'LITERAL' / 'OPERATOR' / 'CONSTANT')
     <Name>\','
   )\','
   ')'
<GeneratorInsts>  see GRAMMAR_NEWTYPE
<PropertiesExpr>  see GRAMMAR_NEWTYPE
$GRAMMAR_VARIABLE
Z100: 2.6.1.1   Variable
Z100: 2.3.2     Variable
Z100: 4.13      Exported variable
Z100: 5.3.3.2   Ground expression
Z100: 5.3.3.1   Expression

<VariableDef> ::=
   'DCL'
   ( 'REVEALED' ('EXPORTED' / $) /
     'EXPORTED' ('REVEALED' / $) /
     $
   )
   ( ( <VariableName> <ExportedAs> )\','
     <SortName> ( ':=' <GroundExpr> / $)
   )\','
   ';'
<ExportedAs> ::=
   ( 'AS' <RemoteVariableName> / $ )
<GroundExpr> ::= <Expr>
$GRAMMAR_VIEW
Z100: 2.6.1.2

<ViewDef> ::=
   'VIEWED'
   ( <VariableName>\',' <SortName> )\',' ';'
$GRAMMAR_TIMER
Z100: 2.8

<TimerDef> ::=
   'TIMER'
   ( <TimerName> ( <SortList> / $)
     ( <DefaultDuration> / $ )
   )\','
   ';'
<SortList> ::=
   '(' <SortName>\',' ')'
<DefaultDuration> ::=
   ':=' <DurationGroundExpr>
<DurationGroundExpr> ::= <Expr>
$GRAMMAR_REMOTE_IMPORT
<RemoteVariableDef> ::=
   'REMOTE'
   ( <RemoteVariableName>\',' <SortName>
     ( 'NODELAY' / $ )
   )\','
   ';'
<ImportedVariableDef> ::=
   'IMPORTED'
   ( <RemoteVariableName>\',' <SortName> )\','
   ';'
<RemoteProcedureDef> ::=
   'REMOTE' 'PROCEDURE' <RemoteProcedureName>
   ( 'NODELAY' / $ ) ';'
   ( <ProcedureSignature> ';' / $ )
<ImportedProcedureDef> ::=
   'IMPORTED' 'PROCEDURE' <RemoteProcedureName> ';'
   ( <ProcedureSignature> ';' / $ )
<ProcedureSignature> ::=
   ( 'FPAR' ( ('IN' / 'IN/OUT' / $) <SortName>)\','
     ( ';' 'RETURNS' <SortName> / $)
   / 'RETURNS' <SortName>
   / $
   )
$GRAMMAR_PROCEDURE
<ExternalProcedureDef> ::=
   'PROCEDURE' <ExternalProcedureName> 
   ( <ProcedureFormalPar> ';' / $ )
   ( <ProcedureResult> ';' / $ )
   'EXTERNAL' ';'
<ProcedureFormalPar> ::=
   'FPAR'
   ( ('IN' / 'IN/OUT' / $)
     <ParameterName>\',' <SortName>
   )\','
   ';'
<ProcedureResult> ::=
   'RETURNS' (<VariableName>/$) <SortName>
$GRAMMAR_TEXTUAL_PROCEDURE
<TextualProcedureDef> ::=
   <ProcedurePreamble>
   'PROCEDURE' <ProcedureIdentifier> 
   ( <FormalContextParameters> / $ )
   ( <VirtualityConstraint> / $ )
   ( <Specialization> / $ )
   ( <ProcedureFormalParameters> / $ )
   ( <ProcedureResult> / $ )
   ( <CompoundStatement> /
     <ProcedureBody> 'ENDPROCEDURE' ( <ProcedureIdentifier> / $ ) ';' 
     )
$CODE_Directive
/*#CODE
#TYPE
C_code
#HEADING
C_code
#BODY
C_code
*/

$SignalDef
SIGNAL
  SignalName,
  SignalName(SortName),
  SignalName(SortName, SortName);

$PRIO_Directive
/*#PRIO Value */
$Signallist
SIGNALLIST SignalListName =
  SignalName, SignalName, (SignalListName);

$SignallistRemotePrd
SIGNALLIST SignalListName =
  SignalName, SignalName, PROCEDURE RemotePrdName;

$Newtype_Struct
NEWTYPE SortName STRUCT
  ConponentName, ComponentName SortName;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Struct_Optional
NEWTYPE SortName STRUCT
  ConponentName SortName OPTIONAL;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Struct_Initializer
NEWTYPE SortName STRUCT
  ConponentName SortName := Value;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Struct_Bitfield
NEWTYPE SortName STRUCT
  ConponentName Integer : 4;
  ComponentName UnsignedInt : 1;
                : 0;
  ComponentName UnsignedInt : 1;
ENDNEWTYPE;

$Newtype_Choice
NEWTYPE SortName CHOICE
  ConponentName, ComponentName SortName;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Array
NEWTYPE SortName
  ARRAY(IndexSortName, ComponentSortName)
ENDNEWTYPE;

$Newtype_Bag
NEWTYPE SortName
  BAG(ComponentSortName)
ENDNEWTYPE;

$Newtype_CArray
NEWTYPE SortName
  CARRAY(Length, ComponentSortName)
ENDNEWTYPE;

$Newtype_Powerset
NEWTYPE SortName
  POWERSET(ComponentSortName)
ENDNEWTYPE;

$Newtype_Ref
NEWTYPE SortName
  REF(ComponentSortName)
ENDNEWTYPE;

$Newtype_String
NEWTYPE SortName
  STRING(ComponentSortName, EmptystringLiteralName)
ENDNEWTYPE;

$Newtype_enum
NEWTYPE SortName
  LITERALS LiteralName, LiteralName;
ENDNEWTYPE;

$Newtype_Struct_add
NEWTYPE SortName STRUCT
  ConponentName, ComponentName SortName;
  ComponentName SortName;
ADDING
  LITERALS
    LiteralName,
    LiteralName;
  OPERATORS
    OperatorName : SortName, SortName -> SortName;
  DEFAULT (. Value, Value, Value .)
ENDNEWTYPE;

$Newtype_Array_add
NEWTYPE SortName
  ARRAY(IndexSortName, ComponentSortName)
ADDING
  LITERALS
    LiteralName,
    LiteralName;
  OPERATORS
    OperatorName : SortName, SortName -> SortName;
  DEFAULT (. Value .)
ENDNEWTYPE;

$Newtype_Operator
NEWTYPE SortName
  OPERATORS
    OperatorName : SortName, SortName -> SortName;
  OPERATOR OperatorName REFERENCED;
ENDNEWTYPE;

$Newtype_Operator2
NEWTYPE SortName
  OPERATORS Add: int, int -> int;
  OPERATOR Add FPAR a,b int returns int
    { return a+b; }
ENDNEWTYPE;

$OperatorSign1
    OperatorName : SortName -> SortName;

$OperatorSign2
    OperatorName : SortName, SortName -> SortName;

$OperatorSign3
    OperatorName : SortName, SortName, SortName -> SortName;

$OperatorSign1_NAME
    OperatorName /*#NAME 'NameInC'*/
      : SortName -> SortName;

$OperatorSign2_NAME
    OperatorName /*#NAME 'NameInC'*/
      : SortName, SortName -> SortName;

$OperatorSign3_NAME
    OperatorName /*#NAME 'NameInC'*/
      : SortName, SortName, SortName -> SortName;

$NAME_Directive
/*#NAME 'NameInC'*/
$OP_Directive
/*#OP(BP)*/
$ADT_Directive
/*#ADT(BP)
#TYPE
C_code
#HEADING
C_code
#BODY
C_code
*/

$Simple_Syntype
SYNTYPE SortName = SortName
ENDSYNTYPE;

$Syntype
SYNTYPE SortName = SortName
  DEFAULT Value
  CONSTANTS Value:Value
ENDSYNTYPE;

$Integer_Syntype
SYNTYPE SortName = Integer
  CONSTANTS Value:Value
ENDSYNTYPE;

$Synonym
SYNONYM SynonymName SortName = Value;

$ExternalSynonym
SYNONYM SynonymName SortName = EXTERNAL;

$Dcl
DCL
  VariableName SortName,
  VariableName SortName;

$Dcl_Exported
DCL EXPORTED
  VariableName SortName;

$Dcl_Revealed
DCL REVEALED
  VariableName SortName;

$Imported_Variable
IMPORTED
  VariableName SortName;

$Viewed_Variable
VIEWED
  VariableName SortName;

$TimerDef
TIMER
  TimerName, TimerName;

$Timer_with_Param
TIMER
  TimerName(SortName, SortName);

$ExternalProcedure
PROCEDURE ProcedureName;
FPAR IN FparName SortName, IN/OUT FparName SortName;
EXTERNAL;

$ExternalProcedure
PROCEDURE ProcedureName;
FPAR IN FparName SortName;
RETURNS SortName;
EXTERNAL;

$TextualProcedure
PROCEDURE ProcedureName
FPAR IN FparName SortName
RETURNS SortName
{ OUTPUT SignalName; 
  RETURN Expression; }

$TextualProcedure
PROCEDURE ProcedureName;
FPAR IN FparName SortName;
START; 
RETURN;
ENDPROCEDURE;

@SDL@TEXTSYMBOL_PROCEDURE@Text symbol
$GRAMMAR
Z100: 5.2.1      Newtype
Z100: 5.3.1.9    Syntype
Z100: 5.3.1.13   Synonym
Z100: 5.3.1.12.1 Generator
Z100: 2.6.1.1    Variable
SDL-96           External procedure
Textual Algorithms Textual procedure

<TextSymbol> ::=
   ( <CodeDirective> / $ )
   ( ( <NewTypeDef>   / <SynTypeDef>    /
       <SynonymDef>   / <GeneratorDef>  /
       <VariableDef>  /        
       <ExternalProcedureDef> /
       <TextualProcedureDef> 
     )
     ( <CodeDirective> / $ )
   )*
<CodeDirective> ::=
   '/*#CODE' <CR> <Any_C_Code> '*/'


Definition of grammar see META_GRAMMAR
in a macro call symbol.
$GRAMMAR_NEWTYPE
Z100: 5.2.1      Newtype
Z100: 5.3.1.10   Structure
Z100: 5.3.1.12.2 Generator
Z100: 5.3.1.11   Inheritance
Z100: 5.2.2      Literals
Z100: 5.2.2      Operators
Z100: 5.3.1.9.1  Range condition
Z100: 5.3.2      Operator definitions
Z100: 5.4.3.3    Default assignment
Z100: 5.4.6      External properties
IBM Rational     Bit field, Initializer, Optional
IBM Rational     Choice

<NewTypeDef> ::=
   'NEWTYPE' <SortName>
   ( <FormalContextPars> / $ )
   ( <ExtendedProperties> / $ )
   <PropertiesExpr>
   ( <Constants> / $ )
   ( <ADTDirective> / $ )
   'ENDNEWTYPE' ( <SortName> / $ ) ';'
<ExtendedProperties> ::=
   <StructureDef> / <GeneratorInsts> /
   <InheritanceRule> / <ChoiceDef>
<StructureDef> ::=
   'STRUCT'
   ( <BitField> /
     ( <ComponentName>\',' <SortName>
       ( 'OPTIONAL' / <Initializer> / <BitField> / $ )
       ';'
     )
   )+
   ('ADDING' / $)
<BitField> ::=
   ':' <Expr>
<Initializer> ::= 
   ':=' <Expr>
<ChoiceDef> ::= 
   'CHOICE'
   ( <ComponentName>\',' <SortName> (<BitField> / $) ';')+
   ('ADDING' / $)
<GeneratorInsts> ::=
   ( <GeneratorInst> (';' / $) ('ADDING' / $) )+
<GeneratorInst> ::=
   <GeneratorName> '('
   ( <NameClassLiteral> / <OperatorName> /
     <SortName> / <CharStringLiteral> / <Expr>
   )\','
   ')'
<InheritanceRule> ::=
   'INHERITS' <SortName>
   ( <LiteralRenaming> / $)
   ( ('OPERATORS' / $)
     ('ALL' / '(' <InheritanceList>\',' ')' )
     (';' / $)
   / $
   )
   ('ADDING' / $)
<InheritanceList> ::=
   <InheritedOperator>\',' ( 'NOEQUALITY' / $ )
<InheritedOperator> ::=
   <OperatorName> ( '=' <OperatorName> / $)
<LiteralRenaming> ::=
   'LITERALS'
   ( (<Name> / <CharStringLiteral>) '='
     (<Name> / <CharStringLiteral>)
   )\',' ';'
<PropertiesExpr> ::=
   <Operators>
   ( <InternalProperties> / <ExternalProperties> )
   ( <DefaultAssignment> / $)
<Operators> ::=
   ( <LiteralList> / $ )
   ( 'OPERATORS'
     ( ( <OperatorSignature> /
         'ORDERING' / 'NOEQUALITY' ) ';'
       ( <OPDirective> / $ )
     )+
   / $
   )
<LiteralList> ::=
   'LITERALS'
   ( ( <CharStringLiteral> / <LiteralName> /
       <NameClassLiteral> )
     ( <OPDirective> / $ )
   )\','
   (';' / $)
<OperatorSignature> ::=
   <OperatorName> ':' <SortName>\',' '->' <SortName>
<InternalProperties> ::=
   ( <OperatorDefinitions> / $ )
   ( 'AXIOMS' <Axioms> / $)
   ( <LiteralMapping> / $)
<OperatorDefinitions> ::=
   ( <OperatorDefinition> / <TextualOperatorReference> )+
<TextualOperatorReference> ::=
   'OPERATOR' <OperatorName> 'REFERENCED' ';'
<DefaultAssignment> ::=
   'DEFAULT' <Expr> (';' / $)
<Constants> ::=
   'CONSTANTS' <RangeCondition>\','
<RangeCondition> ::=
   ( ('=' / '/=' / '<' / '>' / '<=' / '>=') <Expr> /
     <Expr> ( ':' <Expr> / $ )
   )
<FormalContextPars> ::= 
   '<' <FormalContextPar>\';' '>'
<FormalContextPar> ::= 
   ( 'SYNONYM' ( <Name> <SortName> )\','
   / 'NEWTYPE' <Name>
     ( 'ATLEAST' <SortName> / <SortSignature> / $ )
   )
<SortSignature> ::= <Operators> 'ENDNEWTYPE' (<Name>/$)
<ExternalProperties> ::=
   'ALTERNATIVE' <Name> (<Word>/$) ';'
   <ExternalDataDescription>
   ( 'ENDALTERNATIVE' / $ ) ';'
<ADTDirective> ::=
   '/*#ADT' '(' <ADTDefs> ')' <CR>
   ( '#TYPE' <CR> <Any_C_Code> / $ )
   ( '#HEADING' <CR> <Any_C_Code> / $ )
   ( '#BODY' <CR> <Any_C_Code> / $ )
   '*/'
<OPDirective> ::=
   '/*#OP' '(' <OPDefs> ')' '*/'
$GRAMMAR_SYNTYPE
Z100: 5.3.1.9    Syntype
Z100: 5.3.1.9.1  Range condition
Z100: 5.4.3.3    Default assignment

<SynTypeDef> ::=
   'SYNTYPE' <SortName> '=' <SortName>
   (<DefaultAssignment> / $) (<Constants> / $)
   'ENDSYNTYPE' (<SortName> / $) ';'
<DefaultAssignment> =
   'DEFAULT' <Expr> (';' / $)
<Constants> ::=
   'CONSTANTS' <RangeCondition>\','
<RangeCondition> ::=
   ( ('=' / '/=' / '<' / '>' / '<=' / '>=') <Expr> /
     <Expr> ( ':' <Expr> / $ )
   )
$GRAMMAR_SYNONYM
Z100: 5.3.1.13   Synonym
Z100: 4.3.1      External synonym

<SynonymDef> ::=
   'SYNONYM'
   ( <SynonymName> (<SortName> / $) '='
     ( <Expr> / 'EXTERNAL' )
   )\','
   ';'
$GRAMMAR_GENERATOR
Z100: 5.3.1.12.1

<GeneratorDef> ::=
   'GENERATOR' <GeneratorName>
   <GeneratorParameters>
   (<GeneratorInsts> / $)
   <PropertiesExpr>
   'ENDGENERATOR' (<GeneratorName> / $) ';'
<GeneratorParameters> ::=
   '('
   ( ('TYPE' / 'LITERAL' / 'OPERATOR' / 'CONSTANT')
     <Name>\','
   )\','
   ')'
<GeneratorInsts>  see GRAMMAR_NEWTYPE
<PropertiesExpr>  see GRAMMAR_NEWTYPE
$GRAMMAR_VARIABLE
Z100: 2.6.1.1   Variable
Z100: 2.3.2     Variable
Z100: 2.6.4     Revealed, exported not allowed
Z100: 5.3.3.2   Ground expression
Z100: 5.3.3.1   Expression

<VariableDef> ::=
   'DCL'
   ( <VariableName>\','
     <SortName> ( ':=' <GroundExpr> / $)
   )\','
   ';'
<GroundExpr> ::= <Expr>
$GRAMMAR_PROCEDURE
<ExternalProcedureDef> ::=
   'PROCEDURE' <ExternalProcedureName> 
   ( <ProcedureFormalPar> ';' / $ )
   ( <ProcedureResult> ';' / $ )
   'EXTERNAL' ';'
<ProcedureFormalPar> ::=
   'FPAR'
   ( ('IN' / 'IN/OUT' / $)
     <ParameterName>\',' <SortName>
   )\','
   ';'
<ProcedureResult> ::=
   'RETURNS' (<VariableName>/$) <SortName>
$GRAMMAR_TEXTUAL_PROCEDURE
<TextualProcedureDef> ::=
   <ProcedurePreamble>
   'PROCEDURE' <ProcedureIdentifier> 
   ( <FormalContextParameters> / $ )
   ( <VirtualityConstraint> / $ )
   ( <Specialization> / $ )
   ( <ProcedureFormalParameters> / $ )
   ( <ProcedureResult> / $ )
   ( <CompoundStatement> /
     <ProcedureBody> 'ENDPROCEDURE' ( <ProcedureIdentifier> / $ ) ';' 
     )
$CODE_Directive
/*#CODE
#TYPE
C_code
#HEADING
C_code
#BODY
C_code
*/

$Newtype_Struct
NEWTYPE SortName STRUCT
  ConponentName, ComponentName SortName;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Struct_Optional
NEWTYPE SortName STRUCT
  ConponentName SortName OPTIONAL;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Struct_Initializer
NEWTYPE SortName STRUCT
  ConponentName SortName := Value;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Struct_Bitfield
NEWTYPE SortName STRUCT
  ConponentName Integer : 4;
  ComponentName UnsignedInt : 1;
                : 0;
  ComponentName UnsignedInt : 1;
ENDNEWTYPE;

$Newtype_Choice
NEWTYPE SortName CHOICE
  ConponentName, ComponentName SortName;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Array
NEWTYPE SortName
  ARRAY(IndexSortName, ComponentSortName)
ENDNEWTYPE;

$Newtype_Bag
NEWTYPE SortName
  BAG(ComponentSortName)
ENDNEWTYPE;

$Newtype_CArray
NEWTYPE SortName
  CARRAY(Length, ComponentSortName)
ENDNEWTYPE;

$Newtype_Powerset
NEWTYPE SortName
  POWERSET(ComponentSortName)
ENDNEWTYPE;

$Newtype_Ref
NEWTYPE SortName
  REF(ComponentSortName)
ENDNEWTYPE;

$Newtype_String
NEWTYPE SortName
  STRING(ComponentSortName, EmptystringLiteralName)
ENDNEWTYPE;

$Newtype_enum
NEWTYPE SortName
  LITERALS LiteralName, LiteralName;
ENDNEWTYPE;

$Newtype_Struct_add
NEWTYPE SortName STRUCT
  ConponentName, ComponentName SortName;
  ComponentName SortName;
ADDING
  LITERALS
    LiteralName,
    LiteralName;
  OPERATORS
    OperatorName : SortName, SortName -> SortName;
  DEFAULT (. Value, Value, Value .)
ENDNEWTYPE;

$Newtype_Array_add
NEWTYPE SortName
  ARRAY(IndexSortName, ComponentSortName)
ADDING
  LITERALS
    LiteralName,
    LiteralName;
  OPERATORS
    OperatorName : SortName, SortName -> SortName;
  DEFAULT (. Value .)
ENDNEWTYPE;

$Newtype_Operator
NEWTYPE SortName
  OPERATORS
    OperatorName : SortName, SortName -> SortName;
  OPERATOR OperatorName REFERENCED;
ENDNEWTYPE;

$Newtype_Operator2
NEWTYPE SortName
  OPERATORS Add: int, int -> int;
  OPERATOR Add FPAR a,b int returns int
    { return a+b; }
ENDNEWTYPE;

$OperatorSign1
    OperatorName : SortName -> SortName;

$OperatorSign2
    OperatorName : SortName, SortName -> SortName;

$OperatorSign3
    OperatorName : SortName, SortName, SortName -> SortName;

$OperatorSign1_NAME
    OperatorName /*#NAME 'NameInC'*/
      : SortName -> SortName;

$OperatorSign2_NAME
    OperatorName /*#NAME 'NameInC'*/
      : SortName, SortName -> SortName;

$OperatorSign3_NAME
    OperatorName /*#NAME 'NameInC'*/
      : SortName, SortName, SortName -> SortName;

$NAME_Directive
/*#NAME 'NameInC'*/
$OP_Directive
/*#OP(BP)*/
$ADT_Directive
/*#ADT(BP)
#TYPE
C_code
#HEADING
C_code
#BODY
C_code
*/

$Simple_Syntype
SYNTYPE SortName = SortName
ENDSYNTYPE;

$Syntype
SYNTYPE SortName = SortName
  DEFAULT Value
  CONSTANTS Value:Value
ENDSYNTYPE;

$Integer_Syntype
SYNTYPE SortName = Integer
  CONSTANTS Value:Value
ENDSYNTYPE;

$Synonym
SYNONYM SynonymName SortName = Value;

$ExternalSynonym
SYNONYM SynonymName SortName = EXTERNAL;

$Dcl
DCL
  VariableName SortName,
  VariableName SortName;

$Dcl_Exported
DCL EXPORTED
  VariableName SortName;

$Dcl_Revealed
DCL REVEALED
  VariableName SortName;

$ExternalProcedure
PROCEDURE ProcedureName;
FPAR IN FparName SortName, IN/OUT FparName SortName;
EXTERNAL;

$ExternalProcedure
PROCEDURE ProcedureName;
FPAR IN FparName SortName;
RETURNS SortName;
EXTERNAL;

$TextualProcedure
PROCEDURE ProcedureName
FPAR IN FparName SortName
RETURNS SortName
{ OUTPUT SignalName; 
  RETURN Expression; }

$TextualProcedure
PROCEDURE ProcedureName;
FPAR IN FparName SortName;
START; 
RETURN;
ENDPROCEDURE;

@SDL@TEXTSYMBOL_SERVICE@Text symbol
$GRAMMAR
Z100: 5.2.1      Newtype
Z100: 5.3.1.9    Syntype
Z100: 5.3.1.13   Synonym
Z100: 5.3.1.12.1 Generator
Z100: 2.6.1.1    Variable
Z100: 2.6.1.2    View
Z100: 2.8        Timer
Z100: 4.13       Imported variable
Z100: 4.14       Imported procedure
Textual Algorithms Textual procedure

<TextSymbol> ::=
   ( <NewTypeDef>   / <SynTypeDef>    /
     <SynonymDef>   / <GeneratorDef>  /
     <VariableDef>  / <ViewDef>       /
     <TimerDef>     /
     <ImportedVariableDef>  /
     <ImportedProcedureDef> /
     <ExternalProcedureDef> /
     <TextualProcedureDef> )
   )*


Definition of grammar see META_GRAMMAR
in a macro call symbol.
$GRAMMAR_NEWTYPE
Z100: 5.2.1      Newtype
Z100: 5.3.1.10   Structure
Z100: 5.3.1.12.2 Generator
Z100: 5.3.1.11   Inheritance
Z100: 5.2.2      Literals
Z100: 5.2.2      Operators
Z100: 5.3.1.9.1  Range condition
Z100: 5.3.2      Operator definitions
Z100: 5.4.3.3    Default assignment
Z100: 5.4.6      External properties
IBM Rational     Bit field, Initializer, Optional
IBM Rational     Choice

<NewTypeDef> ::=
   'NEWTYPE' <SortName>
   ( <FormalContextPars> / $ )
   ( <ExtendedProperties> / $ )
   <PropertiesExpr>
   ( <Constants> / $ )
   ( <ADTDirective> / $ )
   'ENDNEWTYPE' ( <SortName> / $ ) ';'
<ExtendedProperties> ::=
   <StructureDef> / <GeneratorInsts> /
   <InheritanceRule> / <ChoiceDef>
<StructureDef> ::=
   'STRUCT'
   ( <BitField> /
     ( <ComponentName>\',' <SortName>
       ( 'OPTIONAL' / <Initializer> / <BitField> / $ )
       ';'
     )
   )+
   ('ADDING' / $)
<BitField> ::=
   ':' <Expr>
<Initializer> ::= 
   ':=' <Expr>
<ChoiceDef> ::= 
   'CHOICE'
   ( <ComponentName>\',' <SortName> (<BitField> / $) ';')+
   ('ADDING' / $)
<GeneratorInsts> ::=
   ( <GeneratorInst> (';' / $) ('ADDING' / $) )+
<GeneratorInst> ::=
   <GeneratorName> '('
   ( <NameClassLiteral> / <OperatorName> /
     <SortName> / <CharStringLiteral> / <Expr>
   )\','
   ')'
<InheritanceRule> ::=
   'INHERITS' <SortName>
   ( <LiteralRenaming> / $)
   ( ('OPERATORS' / $)
     ('ALL' / '(' <InheritanceList>\',' ')' )
     (';' / $)
   / $
   )
   ('ADDING' / $)
<InheritanceList> ::=
   <InheritedOperator>\',' ( 'NOEQUALITY' / $ )
<InheritedOperator> ::=
   <OperatorName> ( '=' <OperatorName> / $)
<LiteralRenaming> ::=
   'LITERALS'
   ( (<Name> / <CharStringLiteral>) '='
     (<Name> / <CharStringLiteral>)
   )\',' ';'
<PropertiesExpr> ::=
   <Operators>
   ( <InternalProperties> / <ExternalProperties> )
   ( <DefaultAssignment> / $)
<Operators> ::=
   ( <LiteralList> / $ )
   ( 'OPERATORS'
     ( ( <OperatorSignature> /
         'ORDERING' / 'NOEQUALITY' ) ';'
       ( <OPDirective> / $ )
     )+
   / $
   )
<LiteralList> ::=
   'LITERALS'
   ( ( <CharStringLiteral> / <LiteralName> /
       <NameClassLiteral> )
     ( <OPDirective> / $ )
   )\','
   (';' / $)
<OperatorSignature> ::=
   <OperatorName> ':' <SortName>\',' '->' <SortName>
<InternalProperties> ::=
   ( <OperatorDefinitions> / $ )
   ( 'AXIOMS' <Axioms> / $)
   ( <LiteralMapping> / $)
<OperatorDefinitions> ::=
   ( <OperatorDefinition> / <TextualOperatorReference> )+
<TextualOperatorReference> ::=
   'OPERATOR' <OperatorName> 'REFERENCED' ';'
<DefaultAssignment> ::=
   'DEFAULT' <Expr> (';' / $)
<Constants> ::=
   'CONSTANTS' <RangeCondition>\','
<RangeCondition> ::=
   ( ('=' / '/=' / '<' / '>' / '<=' / '>=') <Expr> /
     <Expr> ( ':' <Expr> / $ )
   )
<FormalContextPars> ::= 
   '<' <FormalContextPar>\';' '>'
<FormalContextPar> ::= 
   ( 'SYNONYM' ( <Name> <SortName> )\','
   / 'NEWTYPE' <Name>
     ( 'ATLEAST' <SortName> / <SortSignature> / $ )
   )
<SortSignature> ::= <Operators> 'ENDNEWTYPE' (<Name>/$)
<ExternalProperties> ::=
   'ALTERNATIVE' <Name> (<Word>/$) ';'
   <ExternalDataDescription>
   ( 'ENDALTERNATIVE' / $ ) ';'
<ADTDirective> ::=
   '/*#ADT' '(' <ADTDefs> ')' <CR>
   ( '#TYPE' <CR> <Any_C_Code> / $ )
   ( '#HEADING' <CR> <Any_C_Code> / $ )
   ( '#BODY' <CR> <Any_C_Code> / $ )
   '*/'
<OPDirective> ::=
   '/*#OP' '(' <OPDefs> ')' '*/'
$GRAMMAR_SYNTYPE
Z100: 5.3.1.9    Syntype
Z100: 5.3.1.9.1  Range condition
Z100: 5.4.3.3    Default assignment

<SynTypeDef> ::=
   'SYNTYPE' <SortName> '=' <SortName>
   (<DefaultAssignment> / $) (<Constants> / $)
   'ENDSYNTYPE' (<SortName> / $) ';'
<DefaultAssignment> =
   'DEFAULT' <Expr> (';' / $)
<Constants> ::=
   'CONSTANTS' <RangeCondition>\','
<RangeCondition> ::=
   ( ('=' / '/=' / '<' / '>' / '<=' / '>=') <Expr> /
     <Expr> ( ':' <Expr> / $ )
   )
$GRAMMAR_SYNONYM
Z100: 5.3.1.13   Synonym
Z100: 4.3.1      External synonym

<SynonymDef> ::=
   'SYNONYM'
   ( <SynonymName> (<SortName> / $) '='
     ( <Expr> / 'EXTERNAL' )
   )\','
   ';'
$GRAMMAR_GENERATOR
Z100: 5.3.1.12.1

<GeneratorDef> ::=
   'GENERATOR' <GeneratorName>
   <GeneratorParameters>
   (<GeneratorInsts> / $)
   <PropertiesExpr>
   'ENDGENERATOR' (<GeneratorName> / $) ';'
<GeneratorParameters> ::=
   '('
   ( ('TYPE' / 'LITERAL' / 'OPERATOR' / 'CONSTANT')
     <Name>\','
   )\','
   ')'
<GeneratorInsts>  see GRAMMAR_NEWTYPE
<PropertiesExpr>  see GRAMMAR_NEWTYPE
$GRAMMAR_VARIABLE
Z100: 2.6.1.1   Variable
Z100: 2.3.2     Variable
Z100: 4.13      Exported variable
Z100: 5.3.3.2   Ground expression
Z100: 5.3.3.1   Expression

<VariableDef> ::=
   'DCL'
   ( 'REVEALED' ('EXPORTED' / $) /
     'EXPORTED' ('REVEALED' / $) /
     $
   )
   ( ( <VariableName> <ExportedAs> )\','
     <SortName> ( ':=' <GroundExpr> / $)
   )\','
   ';'
<ExportedAs> ::=
   ( 'AS' <RemoteVariableName> / $ )
<GroundExpr> ::= <Expr>
$GRAMMAR_VIEW
Z100: 2.6.1.2

<ViewDef> ::=
   'VIEWED'
   ( <VariableName>\',' <SortName> )\',' ';'
$GRAMMAR_TIMER
Z100: 2.8

<TimerDef> ::=
   'TIMER'
   ( <TimerName> ( <SortList> / $)
     ( <DefaultDuration> / $ )
   )\','
   ';'
<SortList> ::=
   '(' <SortName>\',' ')'
<DefaultDuration> ::=
   ':=' <DurationGroundExpr>
<DurationGroundExpr> ::= <Expr>
$GRAMMAR_IMPORT
<ImportedVariableDef> ::=
   'IMPORTED'
   ( <RemoteVariableName>\',' <SortName> )\','
   ';'
<ImportedProcedureDef> ::=
   'IMPORTED' 'PROCEDURE' <RemoteProcedureName> ';'
   ( <ProcedureSignature> ';' / $ )
<ProcedureSignature> ::=
   ( 'FPAR' ( ('IN' / 'IN/OUT' / $) <SortName>)\','
     ( ';' 'RETURNS' <SortName> / $)
   / 'RETURNS' <SortName>
   / $
   )
$GRAMMAR_PROCEDURE
<ExternalProcedureDef> ::=
   'PROCEDURE' <ExternalProcedureName> 
   ( <ProcedureFormalPar> ';' / $ )
   ( <ProcedureResult> ';' / $ )
   'EXTERNAL' ';'
<ProcedureFormalPar> ::=
   'FPAR'
   ( ('IN' / 'IN/OUT' / $)
     <ParameterName>\',' <SortName>
   )\','
   ';'
<ProcedureResult> ::=
   'RETURNS' (<VariableName>/$) <SortName>
$GRAMMAR_TEXTUAL_PROCEDURE
<TextualProcedureDef> ::=
   <ProcedurePreamble>
   'PROCEDURE' <ProcedureIdentifier> 
   ( <FormalContextParameters> / $ )
   ( <VirtualityConstraint> / $ )
   ( <Specialization> / $ )
   ( <ProcedureFormalParameters> / $ )
   ( <ProcedureResult> / $ )
   ( <CompoundStatement> /
     <ProcedureBody> 'ENDPROCEDURE' ( <ProcedureIdentifier> / $ ) ';' 
     )
$Newtype_Struct
NEWTYPE SortName STRUCT
  ConponentName, ComponentName SortName;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Struct_Optional
NEWTYPE SortName STRUCT
  ConponentName SortName OPTIONAL;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Struct_Initializer
NEWTYPE SortName STRUCT
  ConponentName SortName := Value;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Struct_Bitfield
NEWTYPE SortName STRUCT
  ConponentName Integer : 4;
  ComponentName UnsignedInt : 1;
                : 0;
  ComponentName UnsignedInt : 1;
ENDNEWTYPE;

$Newtype_Choice
NEWTYPE SortName CHOICE
  ConponentName, ComponentName SortName;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Array
NEWTYPE SortName
  ARRAY(IndexSortName, ComponentSortName)
ENDNEWTYPE;

$Newtype_Bag
NEWTYPE SortName
  BAG(ComponentSortName)
ENDNEWTYPE;

$Newtype_CArray
NEWTYPE SortName
  CARRAY(Length, ComponentSortName)
ENDNEWTYPE;

$Newtype_Powerset
NEWTYPE SortName
  POWERSET(ComponentSortName)
ENDNEWTYPE;

$Newtype_Ref
NEWTYPE SortName
  REF(ComponentSortName)
ENDNEWTYPE;

$Newtype_String
NEWTYPE SortName
  STRING(ComponentSortName, EmptystringLiteralName)
ENDNEWTYPE;

$Newtype_enum
NEWTYPE SortName
  LITERALS LiteralName, LiteralName;
ENDNEWTYPE;

$Newtype_Struct_add
NEWTYPE SortName STRUCT
  ConponentName, ComponentName SortName;
  ComponentName SortName;
ADDING
  LITERALS
    LiteralName,
    LiteralName;
  OPERATORS
    OperatorName : SortName, SortName -> SortName;
  DEFAULT (. Value, Value, Value .)
ENDNEWTYPE;

$Newtype_Array_add
NEWTYPE SortName
  ARRAY(IndexSortName, ComponentSortName)
ADDING
  LITERALS
    LiteralName,
    LiteralName;
  OPERATORS
    OperatorName : SortName, SortName -> SortName;
  DEFAULT (. Value .)
ENDNEWTYPE;

$Newtype_Operator
NEWTYPE SortName
  OPERATORS
    OperatorName : SortName, SortName -> SortName;
  OPERATOR OperatorName REFERENCED;
ENDNEWTYPE;

$Newtype_Operator2
NEWTYPE SortName
  OPERATORS Add: int, int -> int;
  OPERATOR Add FPAR a,b int returns int
    { return a+b; }
ENDNEWTYPE;

$OperatorSign1
    OperatorName : SortName -> SortName;

$OperatorSign2
    OperatorName : SortName, SortName -> SortName;

$OperatorSign3
    OperatorName : SortName, SortName, SortName -> SortName;

$Simple_Syntype
SYNTYPE SortName = SortName
ENDSYNTYPE;

$Syntype
SYNTYPE SortName = SortName
  DEFAULT Value
  CONSTANTS Value:Value
ENDSYNTYPE;

$Integer_Syntype
SYNTYPE SortName = Integer
  CONSTANTS Value:Value
ENDSYNTYPE;

$Synonym
SYNONYM SynonymName SortName = Value;

$ExternalSynonym
SYNONYM SynonymName SortName = EXTERNAL;

$Dcl
DCL
  VariableName SortName,
  VariableName SortName;

$Dcl_Exported
DCL EXPORTED
  VariableName SortName;

$Dcl_Revealed
DCL REVEALED
  VariableName SortName;

$Imported_Variable
IMPORTED
  VariableName SortName;

$Viewed_Variable
VIEWED
  VariableName SortName;

$TimerDef
TIMER
  TimerName, TimerName;

$Timer_with_Param
TIMER
  TimerName(SortName, SortName);

$ExternalProcedure
PROCEDURE ProcedureName;
FPAR IN FparName SortName, IN/OUT FparName SortName;
EXTERNAL;

$ExternalProcedure
PROCEDURE ProcedureName;
FPAR IN FparName SortName;
RETURNS SortName;
EXTERNAL;

$TextualProcedure
PROCEDURE ProcedureName
FPAR IN FparName SortName
RETURNS SortName
{ OUTPUT SignalName; 
  RETURN Expression; }

$TextualProcedure
PROCEDURE ProcedureName;
FPAR IN FparName SortName;
START; 
RETURN;
ENDPROCEDURE;

@SDL@KERNEL_HEADING_MACRO@Kernel Heading
$GRAMMAR
Z100: 4.2.2

<MacroKernelHeading> ::=
   'MACRODEFINITION' <MacroName>
$MacroKernelHeading
MACRODEFINITION Name
@SDL@ADDITIONAL_HEADING_MACRO@Additional Heading
$GRAMMAR
Z100: 4.2.2

<MacroAdditionalHeading> ::=
  ( 'FPAR' <FormalParameterName>\',' / $ )
@SDL@TEXTSYMBOL_MACRO@Text symbol
$GRAMMAR
Z100: 4.2.2

No grammar possible
@SDL@MACROCALL@Macro call symbol
$GRAMMAR
Z100: 4.2.3

<MacroCallArea> ::=
   <MacroName>
   ( '(' <MacroActualParameter>\',' ')' / $ )
<MacroActualParameter> ::=
   <LexicalUnit>*
$META_GRAMMAR
The grammar used here is extended BNF.

  ','      terminal symbol
  <Sort>   non-terminal symbol
  ::=      is defined as
  $        empty
  /        or
  ( )      grouping
  *        repeat zero or more times
  +        repeat one or more times
  \        repeat over terminal
             <Sort>\',' is defined as
             <Sort> (',' <Sort>)*


Meta grammar:

<BNF-rule> ::=
   <Non-terminal> '::=' <BNF-expr>

<BNF-expr> ::=
   <BNF-Term> ( '/' <BNF-Term> )*

<BNF-Term> ::=
   <BNF-Factor>+

<BNF-Factor> ::=
   <BNF-Primary>
   ( '*'            /
     '+'            /
     '\' <Terminal> /
     $
   )

<BNF-Primary> ::=
   <Non-terminal>     /
   <Terminal>         /
   '(' <BNF-Expr> ')' /
   '$'

<Non-terminal> ::=
   '<' <Identifier> '>'

<Terminal> ::=
   ''' <Sequence-of-characters> '''
@SDL@PAGENUMBER@Pagenumber
$GRAMMAR
Z100: 2.2.5

<PageNumberArea> ::=
   ( <PageNumber>
     ( '(' <NumberOfPages> ')' / $ )
   / $
   )
@SDL@OPERATOR_REF@Operator symbol
$GRAMMAR
Operator reference in GR is an SDT extension.
Z100: 5.3.2  Referenced operator in SDL-PR

<OperatorRef> ::=
   'OPERATOR' <Name>
@SDL@KERNEL_HEADING_OPERATOR@Kernel Heading
$GRAMMAR
Z100: 5.3.2

<OperatorKernelHeading> ::=
   'OPERATOR' <Name>
@SDL@ADDITIONAL_HEADING_OPERATOR@Additional Heading
$GRAMMAR
Z100: 5.3.2
<OperatorAdditionalHeading> ::=
   ';' <FormalPar> ';' <OperatorResult> ';'
<FormalPar> ::=
   'FPAR' ( <FormalParName>\',' <SortName> )\','
<OperatorResult> ::=
   'RETURNS' (<Name> / $) <SortName>
$Param
;
FPAR
  Name1 Sort1,
  Name2 Sort2;
RETURNS Sort3;
@SDL@TEXTSYMBOL_OPERATOR@Text symbol
$GRAMMAR
Z100: 5.2.1      Newtype
Z100: 5.3.1.9    Syntype
Z100: 5.3.1.13   Synonym
Z100: 5.3.1.12.1 Generator
Z100: 2.6.1.1    Variable

<TextSymbol> ::=
   ( <CodeDirective> / $ )
   ( ( <NewTypeDef>   / <SynTypeDef>    /
       <SynonymDef>   / <GeneratorDef>  /
       <VariableDef>
     )
     ( <CodeDirective> / $ )
   )*
<CodeDirective> ::=
   '/*#CODE' <CR> <Any_C_Code> '*/'
$GRAMMAR_NEWTYPE
Z100: 5.2.1      Newtype
Z100: 5.3.1.10   Structure
Z100: 5.3.1.12.2 Generator
Z100: 5.3.1.11   Inheritance
Z100: 5.2.2      Literals
Z100: 5.2.2      Operators
Z100: 5.3.1.9.1  Range condition
Z100: 5.3.2      Operator definitions
Z100: 5.4.3.3    Default assignment
Z100: 5.4.6      External properties
IBM Rational     Bit field, Initializer, Optional
IBM Rational     Choice

<NewTypeDef> ::=
   'NEWTYPE' <SortName>
   ( <FormalContextPars> / $ )
   ( <ExtendedProperties> / $ )
   <PropertiesExpr>
   ( <Constants> / $ )
   ( <ADTDirective> / $ )
   'ENDNEWTYPE' ( <SortName> / $ ) ';'
<ExtendedProperties> ::=
   <StructureDef> / <GeneratorInsts> /
   <InheritanceRule> / <ChoiceDef>
<StructureDef> ::=
   'STRUCT'
   ( <BitField> /
     ( <ComponentName>\',' <SortName>
       ( 'OPTIONAL' / <Initializer> / <BitField> / $ )
       ';'
     )
   )+
   ('ADDING' / $)
<BitField> ::=
   ':' <Expr>
<Initializer> ::= 
   ':=' <Expr>
<ChoiceDef> ::= 
   'CHOICE'
   ( <ComponentName>\',' <SortName> (<BitField> / $) ';')+
   ('ADDING' / $)
<GeneratorInsts> ::=
   ( <GeneratorInst> (';' / $) ('ADDING' / $) )+
<GeneratorInst> ::=
   <GeneratorName> '('
   ( <NameClassLiteral> / <OperatorName> /
     <SortName> / <CharStringLiteral> / <Expr>
   )\','
   ')'
<InheritanceRule> ::=
   'INHERITS' <SortName>
   ( <LiteralRenaming> / $)
   ( ('OPERATORS' / $)
     ('ALL' / '(' <InheritanceList>\',' ')' )
     (';' / $)
   / $
   )
   ('ADDING' / $)
<InheritanceList> ::=
   <InheritedOperator>\',' ( 'NOEQUALITY' / $ )
<InheritedOperator> ::=
   <OperatorName> ( '=' <OperatorName> / $)
<LiteralRenaming> ::=
   'LITERALS'
   ( (<Name> / <CharStringLiteral>) '='
     (<Name> / <CharStringLiteral>)
   )\',' ';'
<PropertiesExpr> ::=
   <Operators>
   ( <InternalProperties> / <ExternalProperties> )
   ( <DefaultAssignment> / $)
<Operators> ::=
   ( <LiteralList> / $ )
   ( 'OPERATORS'
     ( ( <OperatorSignature> /
         'ORDERING' / 'NOEQUALITY' ) ';'
       ( <OPDirective> / $ )
     )+
   / $
   )
<LiteralList> ::=
   'LITERALS'
   ( ( <CharStringLiteral> / <LiteralName> /
       <NameClassLiteral> )
     ( <OPDirective> / $ )
   )\','
   (';' / $)
<OperatorSignature> ::=
   <OperatorName> ':' <SortName>\',' '->' <SortName>
<InternalProperties> ::=
   ( <OperatorDefinitions> / $ )
   ( 'AXIOMS' <Axioms> / $)
   ( <LiteralMapping> / $)
<OperatorDefinitions> ::=
   ( <OperatorDefinition> / <TextualOperatorReference> )+
<TextualOperatorReference> ::=
   'OPERATOR' <OperatorName> 'REFERENCED' ';'
<DefaultAssignment> ::=
   'DEFAULT' <Expr> (';' / $)
<Constants> ::=
   'CONSTANTS' <RangeCondition>\','
<RangeCondition> ::=
   ( ('=' / '/=' / '<' / '>' / '<=' / '>=') <Expr> /
     <Expr> ( ':' <Expr> / $ )
   )
<FormalContextPars> ::= 
   '<' <FormalContextPar>\';' '>'
<FormalContextPar> ::= 
   ( 'SYNONYM' ( <Name> <SortName> )\','
   / 'NEWTYPE' <Name>
     ( 'ATLEAST' <SortName> / <SortSignature> / $ )
   )
<SortSignature> ::= <Operators> 'ENDNEWTYPE' (<Name>/$)
<ExternalProperties> ::=
   'ALTERNATIVE' <Name> (<Word>/$) ';'
   <ExternalDataDescription>
   ( 'ENDALTERNATIVE' / $ ) ';'
<ADTDirective> ::=
   '/*#ADT' '(' <ADTDefs> ')' <CR>
   ( '#TYPE' <CR> <Any_C_Code> / $ )
   ( '#HEADING' <CR> <Any_C_Code> / $ )
   ( '#BODY' <CR> <Any_C_Code> / $ )
   '*/'
<OPDirective> ::=
   '/*#OP' '(' <OPDefs> ')' '*/'
$GRAMMAR_SYNTYPE
Z100: 5.3.1.9    Syntype
Z100: 5.3.1.9.1  Range condition
Z100: 5.4.3.3    Default assignment

<SynTypeDef> ::=
   'SYNTYPE' <SortName> '=' <SortName>
   (<DefaultAssignment> / $) (<Constants> / $)
   'ENDSYNTYPE' (<SortName> / $) ';'
<DefaultAssignment> =
   'DEFAULT' <Expr> (';' / $)
<Constants> ::=
   'CONSTANTS' <RangeCondition>\','
<RangeCondition> ::=
   ( ('=' / '/=' / '<' / '>' / '<=' / '>=') <Expr> /
     <Expr> ( ':' <Expr> / $ )
   )
$GRAMMAR_SYNONYM
Z100: 5.3.1.13   Synonym
Z100: 4.3.1      External synonym

<SynonymDef> ::=
   'SYNONYM'
   ( <SynonymName> (<SortName> / $) '='
     ( <Expr> / 'EXTERNAL' )
   )\','
   ';'
$GRAMMAR_GENERATOR
Z100: 5.3.1.12.1

<GeneratorDef> ::=
   'GENERATOR' <GeneratorName>
   <GeneratorParameters>
   (<GeneratorInsts> / $)
   <PropertiesExpr>
   'ENDGENERATOR' (<GeneratorName> / $) ';'
<GeneratorParameters> ::=
   '('
   ( ('TYPE' / 'LITERAL' / 'OPERATOR' / 'CONSTANT')
     <Name>\','
   )\','
   ')'
<GeneratorInsts>  see GRAMMAR_NEWTYPE
<PropertiesExpr>  see GRAMMAR_NEWTYPE
$GRAMMAR_VARIABLE
Z100: 2.6.1.1   Variable
Z100: 2.3.2     Variable
Z100: 5.3.3.2   Ground expression
Z100: 5.3.3.1   Expression

<VariableDef> ::=
   'DCL'
   ( <VariableName>\','
     <SortName> ( ':=' <GroundExpr> / $)
   )\','
   ';'
<GroundExpr> ::= <Expr>
$Newtype_Struct
NEWTYPE SortName STRUCT
  ConponentName, ComponentName SortName;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Struct_Optional
NEWTYPE SortName STRUCT
  ConponentName SortName OPTIONAL;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Struct_Initializer
NEWTYPE SortName STRUCT
  ConponentName SortName := Value;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Struct_Bitfield
NEWTYPE SortName STRUCT
  ConponentName Integer : 4;
  ComponentName UnsignedInt : 1;
                : 0;
  ComponentName UnsignedInt : 1;
ENDNEWTYPE;

$Newtype_Choice
NEWTYPE SortName CHOICE
  ConponentName, ComponentName SortName;
  ComponentName SortName;
ENDNEWTYPE;

$Newtype_Array
NEWTYPE SortName
  ARRAY(IndexSortName, ComponentSortName)
ENDNEWTYPE;

$Newtype_Bag
NEWTYPE SortName
  BAG(ComponentSortName)
ENDNEWTYPE;

$Newtype_CArray
NEWTYPE SortName
  CARRAY(Length, ComponentSortName)
ENDNEWTYPE;

$Newtype_Powerset
NEWTYPE SortName
  POWERSET(ComponentSortName)
ENDNEWTYPE;

$Newtype_Ref
NEWTYPE SortName
  REF(ComponentSortName)
ENDNEWTYPE;

$Newtype_String
NEWTYPE SortName
  STRING(ComponentSortName, EmptystringLiteralName)
ENDNEWTYPE;

$Newtype_enum
NEWTYPE SortName
  LITERALS LiteralName, LiteralName;
ENDNEWTYPE;

$Newtype_Struct_add
NEWTYPE SortName STRUCT
  ConponentName, ComponentName SortName;
  ComponentName SortName;
ADDING
  LITERALS
    LiteralName,
    LiteralName;
  OPERATORS
    OperatorName : SortName, SortName -> SortName;
  DEFAULT (. Value, Value, Value .)
ENDNEWTYPE;

$Newtype_Array_add
NEWTYPE SortName
  ARRAY(IndexSortName, ComponentSortName)
ADDING
  LITERALS
    LiteralName,
    LiteralName;
  OPERATORS
    OperatorName : SortName, SortName -> SortName;
  DEFAULT (. Value .)
ENDNEWTYPE;

$Newtype_Operator
NEWTYPE SortName
  OPERATORS
    OperatorName : SortName, SortName -> SortName;
  OPERATOR OperatorName REFERENCED;
ENDNEWTYPE;

$Newtype_Operator2
NEWTYPE SortName
  OPERATORS Add: int, int -> int;
  OPERATOR Add FPAR a,b int returns int
    { return a+b; }
ENDNEWTYPE;

$OperatorSign1
    OperatorName : SortName -> SortName;

$OperatorSign2
    OperatorName : SortName, SortName -> SortName;

$OperatorSign3
    OperatorName : SortName, SortName, SortName -> SortName;

$OperatorSign1_NAME
    OperatorName /*#NAME 'NameInC'*/
      : SortName -> SortName;

$OperatorSign2_NAME
    OperatorName /*#NAME 'NameInC'*/
      : SortName, SortName -> SortName;

$OperatorSign3_NAME
    OperatorName /*#NAME 'NameInC'*/
      : SortName, SortName, SortName -> SortName;

$NAME_Directive
/*#NAME 'NameInC'*/
$OP_Directive
/*#OP(BP)*/
$ADT_Directive
/*#ADT(BP)
#TYPE
C_code
#HEADING
C_code
#BODY
C_code
*/

$Simple_Syntype
SYNTYPE SortName = SortName
ENDSYNTYPE;

$Syntype
SYNTYPE SortName = SortName
  DEFAULT Value
  CONSTANTS Value:Value
ENDSYNTYPE;

$Integer_Syntype
SYNTYPE SortName = Integer
  CONSTANTS Value:Value
ENDSYNTYPE;

$Synonym
SYNONYM SynonymName SortName = Value;

$ExternalSynonym
SYNONYM SynonymName SortName = EXTERNAL;

$Dcl
DCL
  VariableName SortName,
  VariableName SortName;
@SDL@TEXT_REFERENCE@Text Reference
$GRAMMAR
Used to include PR text files
<TextReferenceName> ::= 
   <Name>
@SDL@CLASS_SYMBOL@Class symbol
$GRAMMAR
Used to define newtypes
<ClassName> ::= 
   <Name>
<ClassAttributes> ::=
   ( <Name> (':' / $) <SortName> ';' )*
<ClassOperators> ::=
   ( <Name> (<ClassOperatorParameters> / $) 
     (<ClassOperatorReturn> / $) ';' 
   )*
<ClassOperatorParameters> ::=
   '(' ( ('IN' / 'IN/OUT' / $)
         <Name> (':' / $) <SortName>
       )\',' ')'
<ClassOperatorReturn> ::=
   (':' / '->') <SortName>
$Attributes
attr1 : type1;
attr2 type2;
$Operators
op1;
op2(IN par1:type1, IN/OUT par2 type2);
op3(par1 type1) : type2;
op4 -> type1;
@SDL@ASSOCIATION@Association symbol
$GRAMMAR
<AssociationName> ::= 
   any text(not used when defing newtypes)
<AssociationRoleName> ::= 
   ( <RoleName> / $ ) 
   ( ('{' <TypeName> '}') / $ )
$Examples
Assume the association points at the class ABC
Rolename       struct member generated
Role1          Role1 ref_ABC
Role1 {oref}   Role1 oref_ABC
Role1 {own}    Role1 own_ABC
Role1 {myType} Role1 myType
@SDL@AGGREGATION@Aggregation symbol
$GRAMMAR
<AggregationName> ::= 
   any text(not used when defing newtypes)
<AggregationRoleName> ::= 
   ( <RoleName> / $ ) 
   ( ('{' <TypeName> '}') / $ )
$Examples
Assume the association points at the class ABC
Rolename       struct member generated
Role1          Role1 ABC
Role1 {oref}   Role1 oref_ABC
Role1 {own}    Role1 own_ABC
Role1 {myType} Role1 myType
