/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

/************************************************************
 * File:   $Id: spevent.h,v 1.114 1996/08/27 12:34:39 ibg Exp $
 * Module: SDT Tool Communication Definitions
 ************************************************************/

#ifndef _spevent_h
#define _spevent_h

/* Tool Definitions */

#define SET_ILLEGAL		0	/* illegal tool id */

#define SET_POST		1000	/* module post */
#define SET_EXTERN              2000    
#define SET_SDT			3000	/* abstract tool for common services */
#define SET_EDITOR		4000	/* abstract editor; common services */

#define SET_ORGANIZER		5000	/* SDT Organizer */
#define SET_SDLE                6000
#define SET_MSCE                7000
#define SET_SDTGATE		8000
#define SET_INFOSERVER		9000
#define SET_FILEVIEWER		10000	/* Search list manager */
#define SET_COVERAGEVIEWER	11000	/* Coverage Browser */
#define SET_XREFVIEWER		12000	/* Cross-Reference Browser */
#define SET_TYPEVIEWER		13000	/* Type Browser */
#define SET_TREEVIEWER		14000
#define SET_OVERVIEW		15000
#define SET_HELP		16000
#define SET_PREFERENCES		17000
#define SET_SIMULATOR_UI	18000
#define SET_ANALYZER		19000

#define SET_C_BASIC_TRANSLATOR	20000   /* SET_C_TRANSLATOR */
#define SET_X_TRANSLATOR	21000
#define SET_CHILL_TRANSLATOR    22000
#define SET_CSDL_TRANSLATOR	23000

#define SET_GRPR                24000
#define SET_VALIDATOR           25000
#define SET_SIMULATOR      	26000
#define SET_SDLENV		27000

#define SET_APPLICATION_LIBRARY 28000
#define SET_C_ADVANCED_TRANSLATOR 29000 /* SET_MASTER_LIBRARY */
#define SET_C_MICRO_TRANSLATOR  30000   /* SET_MICRO_C_TRANSLATOR */
#define SET_PERFORMANCE_LIBRARY 31000
#define SET_LINK                32000
#define SET_CMICRO_TESTER       33000
#define SET_HELPVIEWER          34000

#define SET_OME                 35000   /* the OM editor */
#define SET_OMINFOSERVER	36000   /* the OM info server */

#define SET_SYSTEMLOG		37000   /* system error log (debug only) */
#define SET_TE   		38000   /* the SDT text editor */
#define SET_TE_EXTERN  		39000   /* an external text editor */

/* Note: 40000 - 49000 reserved for ITEX tools, see itex.h */

#define SET_ASN2SDL		50000
#define SET_H2SDL		51000
#define SET_TELELOGIC		52000   /* currently only used for licensing purposes */
#define SET_ECHILL_TRANSLATOR   53000
#define SET_SCHILL_TRANSLATOR   54000

/* Upper limit for SDT/ITEX ... internal messages */
#define SET_CMICRO_BODYBUILDER  98000
#define SET_CMICRO_DOSTESTER    99000
#define SPUPPERLIMIT           100000



/* Message Class Manipulator Definitions */

#define SPT_MASK	1000
#define SPT_BASE	100

#define SPT_MESSAGE	(0 * SPT_BASE)
#define SPT_RPCREQUEST	(1 * SPT_BASE)
#define SPT_RPCREPLY	(2 * SPT_BASE)


#define SP_MESSAGE(M)    	(M)
#define SP_RPCREQUEST(M) 	((M)+100)
#define SP_RPCREPLY(M)   	((M)+200)

#define SP_GETMESSAGETYPE(M)	(((M)%SPT_MASK/SPT_BASE)*SPT_BASE)

#define SP_ISMESSAGE(M)		(SP_GETMESSAGETYPE(M)==SPT_MESSAGE)
#define SP_ISREQUEST(M)	 	(SP_GETMESSAGETYPE(M)==SPT_RPCREQUEST)
#define SP_ISREPLY(M)	 	(SP_GETMESSAGETYPE(M)==SPT_RPCREPLY)

#define SP_TOOLCLASS(M)		((M)-((M)%SPT_MASK))

/* Generate the appropriate reply message to message MX */
#define SP_MAKEREPLY(M) 	SP_RPCREPLY((M)-SP_GETMESSAGETYPE(M))

/* Check if message RX is a reply to message MX */
#define SP_MATCHREPLY(MX,RX) \
	(SP_ISREQUEST (MX) && SP_ISREPLY(RX) && \
	 (SP_TOOLCLASS (MX) == SP_TOOLCLASS (RX)) && \
	 ((MX)%SPT_BASE == (RX)%SPT_BASE)) 

  
/* SET_POST */

#define SESDT2CONNECT		SP_MESSAGE (SET_POST+1) /*to detect 2.X versions*/
#define SECONNECT               SP_MESSAGE (SET_POST+2)
#define SEDISCONNECT            SP_MESSAGE (SET_POST+3)
#define SEOPFAILED              SP_MESSAGE (SET_POST+4)
#define SEF_OPFAILED            "%ld\n%hd\n%hd\n%ld\n"

#define SESTARTNOTIFY           SP_MESSAGE (SET_POST+5)

#define SECHECKALIVE            SP_MESSAGE (SET_POST+6)


#define SESTART                 SP_RPCREQUEST (SET_POST+1)
#define SESTARTREPLY            SP_RPCREPLY   (SET_POST+1)

#define SEGETNOOFSUBSCRIBERS    SP_RPCREQUEST (SET_POST+2)
#define SEGETNOOFSUBSCRIBERSREPLY SP_RPCREPLY (SET_POST+2)

#define SEGETTOOLTYPE           SP_RPCREQUEST (SET_POST+3)
#define SEGETTOOLTYPEREPLY      SP_RPCREPLY   (SET_POST+3)

#define SEGETTOOLPID            SP_RPCREQUEST (SET_POST+4)
#define SEGETTOOLPIDREPLY       SP_RPCREPLY   (SET_POST+4)

#define SEADDTOOL               SP_RPCREQUEST (SET_POST+5)
#define SEADDTOOLREPLY          SP_RPCREPLY   (SET_POST+5)

#define SEADDTOOLSUBSCRIPTION   SP_RPCREQUEST  (SET_POST+6)
#define SEADDTOOLSUBSCRIPTIONREPLY SP_RPCREPLY (SET_POST+6)

#define SESTARTTRACE            SP_RPCREQUEST (SET_POST+7)
#define SESTARTTRACEREPLY       SP_RPCREPLY   (SET_POST+7)

#define SESTOPTRACE             SP_RPCREQUEST (SET_POST+8)
#define SESTOPTRACEREPLY        SP_RPCREPLY   (SET_POST+8)

#define SESTARTARG              SP_RPCREQUEST (SET_POST+9)
#define SESTARTARGREPLY         SP_RPCREPLY   (SET_POST+9)

#define SEGETCONFIG		SP_RPCREQUEST (SET_POST+10)
#define SEGETCONFIGREPLY	SP_RPCREPLY   (SET_POST+10)

#define SESYNCCONNECT           SP_RPCREQUEST (SET_POST+11)
#define SESYNCCONNECTREPLY      SP_RPCREPLY   (SET_POST+11)


/* SET_SDT */

#define SENOMESSAGE		0

#define SESTOP			SP_RPCREQUEST (SET_SDT+1)
#define SESTOPREPLY		SP_RPCREPLY (SET_SDT+1)

#define SELOCK			SP_RPCREQUEST (SET_SDT+2)
#define SELOCKREPLY		SP_RPCREPLY (SET_SDT+2)

#define SEUNLOCK		SP_RPCREQUEST (SET_SDT+3)
#define SEUNLOCKREPLY		SP_RPCREPLY (SET_SDT+3)

#define SEAVAILABLESERVICES	SP_RPCREQUEST (SET_SDT+4)
#define SEAVAILABLESERVICESREPLY SP_RPCREPLY (SET_SDT+4)

#define SESYSTEMLOGNOTIFY	SP_MESSAGE (SET_SDT+1)
#define SEDEBUGLOGNOTIFY	SP_MESSAGE (SET_SDT+2)
#define SESTOPNOTIFY		SP_MESSAGE (SET_SDT+3)
#define SEFORKEDPROCTERMNOTIFY  SP_MESSAGE (SET_SDT+4)

#define SEPRINT			SP_RPCREQUEST (SET_SDT+10)
#define SEPRINTREPLY		SP_RPCREPLY (SET_SDT+10)

#define SEPRINTCOMPUTE		SP_RPCREQUEST (SET_SDT+11)
#define SEPRINTCOMPUTEREPLY	SP_RPCREPLY (SET_SDT+11)

/* Common Graphical Tool Services */

#define SEMENUCOMMAND		SP_RPCREQUEST (SET_SDT+50)
#define SEMENUCOMMANDREPLY	SP_RPCREPLY (SET_SDT+50)

#define SEMENUADD		SP_RPCREQUEST (SET_SDT+51)
#define SEMENUADDREPLY		SP_RPCREPLY (SET_SDT+51)

#define SEMENUDELETE		SP_RPCREQUEST (SET_SDT+52)
#define SEMENUDELETEREPLY	SP_RPCREPLY (SET_SDT+52)

#define SEMENUCLEAR		SP_RPCREQUEST (SET_SDT+53)
#define SEMENUCLEARREPLY	SP_RPCREPLY (SET_SDT+53)

#define SEMENUADDITEM		SP_RPCREQUEST (SET_SDT+54)
#define SEMENUADDITEMREPLY	SP_RPCREPLY (SET_SDT+54)

#define SEMENULOAD		SP_RPCREQUEST (SET_SDT+55)
#define SEMENULOADREPLY 	SP_RPCREPLY (SET_SDT+55)

#define SEMENUSAVE		SP_RPCREQUEST (SET_SDT+56)
#define SEMENUSAVEREPLY 	SP_RPCREPLY (SET_SDT+56)

#define SEPOPUP			SP_RPCREQUEST (SET_SDT+60)
#define SEPOPUPREPLY		SP_RPCREPLY (SET_SDT+60)

#define SESHOWENDPOINT		SP_RPCREQUEST (SET_SDT+61)
#define SESHOWENDPOINTREPLY	SP_RPCREPLY (SET_SDT+61)

/* Extended data */
#define SEOBTAINGRREF           SP_RPCREQUEST (SET_SDT+70)
#define SEOBTAINGRREFREPLY      SP_RPCREPLY (SET_SDT+70)

#define SEDISPLAYKEY            SP_RPCREQUEST (SET_SDT+71)
#define SEDISPLAYKEYREPLY	SP_RPCREPLY (SET_SDT+71)

#define SELISTKEY               SP_RPCREQUEST (SET_SDT+72)
#define SELISTKEYREPLY		SP_RPCREPLY (SET_SDT+72)

#define SECREATEATTRIBUTE       SP_RPCREQUEST (SET_SDT+73)
#define SECREATEATTRIBUTEREPLY	SP_RPCREPLY (SET_SDT+73)

#define SEREADATTRIBUTE         SP_RPCREQUEST (SET_SDT+74)
#define SEREADATTRIBUTEREPLY	SP_RPCREPLY (SET_SDT+74)

#define SEUPDATEATTRIBUTE       SP_RPCREQUEST (SET_SDT+75)
#define SEUPDATEATTRIBUTEREPLY	SP_RPCREPLY (SET_SDT+75)

#define SEDELETEATTRIBUTE       SP_RPCREQUEST (SET_SDT+76)
#define SEDELETEATTRIBUTEREPLY	SP_RPCREPLY (SET_SDT+76)


/* RPC Test Messages */

#define SEABORT		        SP_RPCREQUEST (SET_SDT+99)
#define SEABORTREPLY		SP_RPCREQUEST (SET_SDT+99)

#define SERPCCANCELNOTIFY	SP_MESSAGE (SET_SDT+99)



/* SET_ORGANIZER */

#define SEPRINTSYSTEM		SP_RPCREQUEST (SET_ORGANIZER+1)
#define SEPRINTSYSTEMREPLY	SP_RPCREPLY (SET_ORGANIZER+1)

#define SESEARCH		SP_RPCREQUEST (SET_ORGANIZER+2)
#define SESEARCHREPLY		SP_RPCREPLY (SET_ORGANIZER+2)

#define SESAVEALL		SP_RPCREQUEST (SET_ORGANIZER+3)
#define SESAVEALLREPLY		SP_RPCREPLY (SET_ORGANIZER+3)

#define SESHOWREF		SP_RPCREQUEST (SET_ORGANIZER+4)
#define SESHOWREFREPLY		SP_RPCREPLY (SET_ORGANIZER+4)

#define SEOPENSYSTEM		SP_RPCREQUEST (SET_ORGANIZER+5)
#define SEOPENSYSTEMREPLY	SP_RPCREPLY (SET_ORGANIZER+5)

#define SECONVERTSYSTEM		SP_RPCREQUEST (SET_ORGANIZER+6)
#define SECONVERTSYSTEMREPLY	SP_RPCREPLY (SET_ORGANIZER+6)

#define SELISTSYSTEMFILES	SP_RPCREQUEST (SET_ORGANIZER+7)
#define SELISTSYSTEMFILESREPLY	SP_RPCREPLY (SET_ORGANIZER+7)

#define SELISTSTRUCTURE		SP_RPCREQUEST (SET_ORGANIZER+8)
#define SELISTSTRUCTUREREPLY	SP_RPCREPLY (SET_ORGANIZER+8)

#define SEGETCONNECTION		SP_RPCREQUEST (SET_ORGANIZER+9)
#define SEGETCONNECTIONREPLY	SP_RPCREPLY (SET_ORGANIZER+9)

#define SEGETCONNECTIONUP	SP_RPCREQUEST (SET_ORGANIZER+10)
#define SEGETCONNECTIONUPREPLY	SP_RPCREPLY (SET_ORGANIZER+10)

#define SECONNECTDIAGRAM	SP_RPCREQUEST (SET_ORGANIZER+11)
#define SECONNECTDIAGRAMREPLY	SP_RPCREPLY (SET_ORGANIZER+11)

#define SEREQUESTHEADING	SP_RPCREQUEST (SET_ORGANIZER+12)
#define SEREQUESTHEADINGREPLY	SP_RPCREPLY (SET_ORGANIZER+12)

#define SEMOVEIFQUIT		SP_RPCREQUEST (SET_ORGANIZER+13)
#define SEMOVEIFQUITREPLY   	SP_RPCREPLY (SET_ORGANIZER+13)

#define SESEARCHDIAGRAM		SP_RPCREQUEST (SET_ORGANIZER+14)
#define SESEARCHDIAGRAMREPLY	SP_RPCREPLY (SET_ORGANIZER+14)

#define SELISTMSC		SP_RPCREQUEST (SET_ORGANIZER+15)
#define SELISTMSCREPLY  	SP_RPCREPLY (SET_ORGANIZER+15)

#define SESETSELECTIONONDIAGRAM SP_RPCREQUEST (SET_ORGANIZER+16)
#define SESETSELECTIONONDIAGRAMREPLY SP_RPCREPLY (SET_ORGANIZER+16)

#define SEISAVAILABLE           SP_RPCREQUEST (SET_ORGANIZER+17)
#define SEISAVAILABLEREPLY      SP_RPCREPLY (SET_ORGANIZER+17)

#define SEGETDIRECTORY          SP_RPCREQUEST (SET_ORGANIZER+18)
#define SEGETDIRECTORYREPLY     SP_RPCREPLY (SET_ORGANIZER+18)

#define SECREATELINK		SP_RPCREQUEST (SET_ORGANIZER+19)
#define SECREATELINKREPLY	SP_RPCREPLY (SET_ORGANIZER+19)

#define SEDELETELINKS		SP_RPCREQUEST (SET_ORGANIZER+20)
#define SEDELETELINKSLINKREPLY	SP_RPCREPLY (SET_ORGANIZER+20)

#define SEGETENDPOINTSTRUCTURE	SP_RPCREQUEST (SET_ORGANIZER+21)
#define SEGETENDPOINTSTRUCTUREREPLY	SP_RPCREPLY (SET_ORGANIZER+21)

#define SEGETLINKCARDINALITY	SP_RPCREQUEST (SET_ORGANIZER+22)
#define SEGETLINKCARDINALITYREPLY	SP_RPCREPLY (SET_ORGANIZER+22)

#define SEGETLINKS		SP_RPCREQUEST (SET_ORGANIZER+23)
#define SEGETLINKSREPLY		SP_RPCREPLY (SET_ORGANIZER+23)

#define SEGETLINKNAMES		SP_RPCREQUEST (SET_ORGANIZER+24)
#define SEGETLINKNAMESREPLY	SP_RPCREPLY (SET_ORGANIZER+24)

#define SEGETTTCNLINKEXECUTABLE SP_RPCREQUEST (SET_ORGANIZER+25)
#define SEGETTTCNLINKEXECUTABLEREPLY	SP_RPCREPLY (SET_ORGANIZER+25)

#define SEGETASSOCLIST          SP_RPCREQUEST (SET_ORGANIZER+26)
#define SEGETASSOCLISTREPLY     SP_RPCREPLY (SET_ORGANIZER+26)

#define SENEWSYSTEM             SP_RPCREQUEST (SET_ORGANIZER+27)
#define SENEWSYSTEMREPLY        SP_RPCREPLY (SET_ORGANIZER+27)

#define SEADDEXISTING           SP_RPCREQUEST (SET_ORGANIZER+28)
#define SEADDEXISTINGREPLY      SP_RPCREPLY (SET_ORGANIZER+28)

  /* Notifications from the Organizer */
#define SESTRUCTURENOTIFY	SP_MESSAGE (SET_ORGANIZER+1)
#define SEMSCLISTNOTIFY 	SP_MESSAGE (SET_ORGANIZER+2)
#define SEDIRECTORYNOTIFY       SP_MESSAGE (SET_ORGANIZER+3)

#define SEENDPOINTSTRUCTURENOTIFY	SP_MESSAGE (SET_ORGANIZER+4)
#define SELINKCARDINALITYNOTIFY		SP_MESSAGE (SET_ORGANIZER+5)
#define SEENDPOINTCHANGESTRUCTURENOTIFY	SP_MESSAGE (SET_ORGANIZER+6)
#define SEOMSTRUCTURENOTIFY		SP_MESSAGE (SET_ORGANIZER+7)


/* SET_EDITOR */

#define SESAVE			SP_RPCREQUEST (SET_EDITOR+1)
#define SESAVEREPLY		SP_RPCREPLY (SET_EDITOR+1)

#define SECHECKSAVE		SP_RPCREQUEST (SET_EDITOR+2)
#define SECHECKSAVEREPLY	SP_RPCREPLY (SET_EDITOR+2)

#define SELOAD			SP_RPCREQUEST (SET_EDITOR+3)
#define SELOADREPLY		SP_RPCREPLY (SET_EDITOR+3)

#define SEUNLOAD		SP_RPCREQUEST (SET_EDITOR+4)
#define SEUNLOADREPLY		SP_RPCREPLY (SET_EDITOR+4)

#define SESHOW			SP_RPCREQUEST (SET_EDITOR+5)
#define SESHOWREPLY		SP_RPCREPLY (SET_EDITOR+5)

#define SEINSERTOBJECT		SP_RPCREQUEST (SET_EDITOR+6)
#define SEINSERTOBJECTREPLY	SP_RPCREPLY (SET_EDITOR+6)

#define SEREMOVEOBJECT		SP_RPCREQUEST (SET_EDITOR+7)
#define SEREMOVEOBJECTREPLY	SP_RPCREPLY (SET_EDITOR+7)

#define SESELECTOBJECT		SP_RPCREQUEST (SET_EDITOR+9)
#define SESELECTOBJECTREPLY	SP_RPCREPLY (SET_EDITOR+9)

#define SEUNSELECTOBJECT	SP_RPCREQUEST (SET_EDITOR+10)
#define SEUNSELECTOBJECTREPLY	SP_RPCREPLY (SET_EDITOR+10)

#define SESHOWOBJECT		SP_RPCREQUEST (SET_EDITOR+11)
#define SESHOWOBJECTREPLY	SP_RPCREPLY (SET_EDITOR+11)

#define SEPICKOBJECT		SP_RPCREQUEST (SET_EDITOR+12)
#define SEPICKOBJECTREPLY	SP_RPCREPLY (SET_EDITOR+12)

#define SESAVECOPY		SP_RPCREQUEST (SET_EDITOR+13)
#define SESAVECOPYREPLY		SP_RPCREPLY (SET_EDITOR+13)

#define SESAVEAS		SP_RPCREQUEST (SET_EDITOR+14)
#define SESAVEASREPLY		SP_RPCREPLY (SET_EDITOR+14)

#define SEPICKREFSYMBOL		SP_RPCREQUEST (SET_EDITOR+15)
#define SEPICKREFSYMBOLREPLY	SP_RPCREPLY (SET_EDITOR+15)

/* 3.1 */
#define SEREVERT		SP_RPCREQUEST (SET_EDITOR+16)
#define SEREVERTREPLY		SP_RPCREPLY (SET_EDITOR+16)

#define SETIDYUP		SP_RPCREQUEST (SET_EDITOR+17)
#define SETIDYUPREPLY		SP_RPCREPLY (SET_EDITOR+17)

#define SEMAKEENDPOINTPERMANENT	SP_RPCREQUEST (SET_EDITOR+18)
#define SEMAKEENDPOINTPERMANENTREPLY	SP_RPCREPLY (SET_EDITOR+18)

#define SEGETENDPOINTS		SP_RPCREQUEST (SET_EDITOR+19)
#define SEGETENDPOINTSREPLY	SP_RPCREPLY (SET_EDITOR+19)

#define SESHOWENDPOINTANCHOR		SP_RPCREQUEST (SET_EDITOR+20)
#define SESHOWENDPOINTANCHORREPLY	SP_RPCREPLY (SET_EDITOR+20)

#define SEGETOBJECTTEXT		SP_RPCREQUEST (SET_EDITOR+21)
#define SEGETOBJECTTEXTREPLY	SP_RPCREPLY (SET_EDITOR+21)


  /* Notifications from the Editors */
#define SELOADNOTIFY           SP_MESSAGE (SET_EDITOR+1)
#define SEUNLOADNOTIFY         SP_MESSAGE (SET_EDITOR+2)
#define SEREVERTNOTIFY	       SP_MESSAGE (SET_EDITOR+3)
#define SEDIRTYNOTIFY          SP_MESSAGE (SET_EDITOR+4)
#define SESAVENOTIFY           SP_MESSAGE (SET_EDITOR+5)
#define SESEARCHEDITEDNOTIFY   SP_MESSAGE (SET_EDITOR+6)
#define SESAVECOPYNOTIFY       SP_MESSAGE (SET_EDITOR+7)
#define SEPAGENOTIFY           SP_MESSAGE (SET_EDITOR+8)

#define SECREATEENDPOINTNOTIFY	SP_MESSAGE (SET_EDITOR+9)
#define SEDELETEENDPOINTNOTIFY	SP_MESSAGE (SET_EDITOR+10)
#define SEMODIFYENDPOINTNOTIFY	SP_MESSAGE (SET_EDITOR+11)
#define SEENDPOINTSNOTIFY	SP_MESSAGE (SET_EDITOR+12)

#define SEUNDIRTYNOTIFY         SP_MESSAGE (SET_EDITOR+13)


/* SET_SDLE */

#define SEUPDATEHEADING			SP_RPCREQUEST (SET_SDLE+1)
#define SEUPDATEHEADINGREPLY		SP_RPCREPLY (SET_SDLE+1)

#define SECHECKHEADING			SP_RPCREQUEST (SET_SDLE+2)
#define SECHECKHEADINGREPLY		SP_RPCREPLY (SET_SDLE+2)

#define SEUSERCHECKHEADING		SP_RPCREQUEST (SET_SDLE+3)
#define SEUSERCHECKHEADINGREPLY		SP_RPCREPLY (SET_SDLE+3)

#define SENEST				SP_RPCREQUEST (SET_SDLE+4)
#define SENESTREPLY			SP_RPCREPLY (SET_SDLE+4)

#define SELOADCOPY            	 	SP_RPCREQUEST (SET_SDLE+5)
#define SELOADCOPYREPLY      	  	SP_RPCREPLY (SET_SDLE+5)

#define SESDLECREATEDIAGRAM		SP_RPCREQUEST (SET_SDLE+6)
#define SESDLECREATEDIAGRAMREPLY	SP_RPCREPLY (SET_SDLE+6)

#define SESDLECHECKSTRUCTURE		SP_RPCREQUEST (SET_SDLE+7)
#define SESDLECHECKSTRUCTUREREPLY	SP_RPCREPLY (SET_SDLE+7)

#define SESDLEINSERTOBJECT		SP_RPCREQUEST (SET_SDLE+8)
#define SESDLEINSERTOBJECTREPLY 	SP_RPCREPLY (SET_SDLE+8)

#define SESDLECIFCREATEDIAGRAM          SP_RPCREQUEST (SET_SDLE+9)
#define SESDLECIFCREATEDIAGRAMREPLY     SP_RPCREPLY (SET_SDLE+9)

#define SESDLECIFCREATEPAGE             SP_RPCREQUEST (SET_SDLE+10)
#define SESDLECIFCREATEPAGEREPLY        SP_RPCREPLY (SET_SDLE+10)

#define SESDLECIFINSERTOBJECT           SP_RPCREQUEST (SET_SDLE+11)
#define SESDLECIFINSERTOBJECTREPLY      SP_RPCREPLY (SET_SDLE+11)



  /* Notifications from the SDLE */
#define SESDLENEWNOTIFY                 SP_MESSAGE (SET_SDLE+1)
#define SESDLELOADNOTIFY                SP_MESSAGE (SET_SDLE+2)
#define SESDLEREVERTNOTIFY	        SP_MESSAGE (SET_SDLE+3)
#define SESDLECHANGENAMENOTIFY		SP_MESSAGE (SET_SDLE+5)
#define SESDLEREFSYMADDEDNOTIFY	        SP_MESSAGE (SET_SDLE+6)
#define SESDLEREFSYMCHANGEDNOTIFY       SP_MESSAGE (SET_SDLE+7)
#define SESDLEREFSYMREMOVEDNOTIFY    	SP_MESSAGE (SET_SDLE+8)


/* SET_OME */

#define SEOMECREATEDIAGRAM		SP_RPCREQUEST (SET_OME+1)
#define SEOMECREATEDIAGRAMREPLY		SP_RPCREPLY (SET_OME+1)

#define SEOMECHECKHEADING		SP_RPCREQUEST (SET_OME+2)
#define SEOMECHECKHEADINGREPLY		SP_RPCREPLY (SET_OME+2)

#define SEOMEUSERCHECKHEADING		SP_RPCREQUEST (SET_OME+3)
#define SEOMEUSERCHECKHEADINGREPLY	SP_RPCREPLY (SET_OME+3)

#define SEOMECHECKSTRUCTURE		SP_RPCREQUEST (SET_OME+4)
#define SEOMECHECKSTRUCTUREREPLY	SP_RPCREPLY (SET_OME+4)

#define SEOMECIFCREATEDIAGRAM          SP_RPCREQUEST (SET_OME+5)
#define SEOMECIFCREATEDIAGRAMREPLY     SP_RPCREPLY (SET_OME+5)

#define SEOMECIFCREATEPAGE             SP_RPCREQUEST (SET_OME+6)
#define SEOMECIFCREATEPAGEREPLY        SP_RPCREPLY (SET_OME+6)

#define SEOMECIFINSERTOBJECT           SP_RPCREQUEST (SET_OME+7)
#define SEOMECIFINSERTOBJECTREPLY      SP_RPCREPLY (SET_OME+7)

  /* Notifications from the OME */
#define SEOMENEWNOTIFY                  SP_MESSAGE (SET_OME+1)
#define SEOMELOADNOTIFY                 SP_MESSAGE (SET_OME+2)
#define SEOMECHANGENAMENOTIFY           SP_MESSAGE (SET_OME+3)
#define SEOMSYMBOLNOTIFY		SP_MESSAGE (SET_OME+4)
#define SEOMCLEARSYMBOLNOTIFY		SP_MESSAGE (SET_OME+5)


/* SET_OMINFOSERVER */

#define SEGETALLCLASSES			SP_RPCREQUEST (SET_OMINFOSERVER+1)
#define SEGETALLCLASSESREPLY		SP_RPCREPLY (SET_OMINFOSERVER+1)

#define SEGETALLITEMS			SP_RPCREQUEST (SET_OMINFOSERVER+2)
#define SEGETALLITEMSREPLY		SP_RPCREPLY (SET_OMINFOSERVER+2)

#define SEGETALLOCCURRENCES	       	SP_RPCREQUEST (SET_OMINFOSERVER+3)
#define SEGETALLOCCURRENCESREPLY	SP_RPCREPLY (SET_OMINFOSERVER+3)

#define SEGETMODULENAME		       	SP_RPCREQUEST (SET_OMINFOSERVER+4)
#define SEGETMODULENAMEREPLY		SP_RPCREPLY (SET_OMINFOSERVER+4)


/* SET_MSCE */

#define SECHANGENAME                    SP_RPCREQUEST (SET_MSCE+1)
#define SECHANGENAMEREPLY               SP_RPCREPLY (SET_MSCE+1)

#define SEADDCOMMAND                    SP_RPCREQUEST (SET_MSCE+2)
#define SEADDCOMMANDREPLY               SP_RPCREPLY (SET_MSCE+2)

#define SEMSCECREATEDIAGRAM		SP_RPCREQUEST (SET_MSCE+3)
#define SEMSCECREATEDIAGRAMREPLY	SP_RPCREPLY (SET_MSCE+3)

#define SEMSCECLEARDIAGRAM		SP_RPCREQUEST (SET_MSCE+4)
#define SEMSCECLEARDIAGRAMREPLY	        SP_RPCREPLY (SET_MSCE+4)


  /* Notifications from the MSCE */
#define SEMSCECHANGENAMENOTIFY          SP_MESSAGE (SET_MSCE+1)
#define SEMSCENEWNOTIFY                 SP_MESSAGE (SET_MSCE+2)

/* SET_TE */

#define SETECREATEDIAGRAM       SP_RPCREQUEST (SET_TE+1)
#define SETECREATEDIAGRAMREPLY  SP_RPCREPLY (SET_TE+1)

#define SETELOADCOPY            SP_RPCREQUEST (SET_TE+2)
#define SETELOADCOPYREPLY       SP_RPCREPLY (SET_TE+2)

#define SETESHOWPOSITION        SP_RPCREQUEST (SET_TE+3)
#define SETESHOWPOSITIONREPLY   SP_RPCREPLY (SET_TE+3)

#define SETESELECTTEXT          SP_RPCREQUEST (SET_TE+4)
#define SETESELECTTEXTREPLY     SP_RPCREPLY (SET_TE+4)

#define SETENEWNOTIFY           SP_MESSAGE (SET_TE+1)

/* SET_SDTGATE */

#define SESTARTTEXTEDITOR               SP_RPCREQUEST (SET_SDTGATE+1)
#define SESTARTTEXTEDITORREPLY         SP_RPCREPLY (SET_SDTGATE+1)

#define SESTOPTEXTEDITORNOTIFY          SP_MESSAGE (SET_SDTGATE+1)


/* SET_INFOSERVER */

#define SEENUMERATESIGNALS     SP_RPCREQUEST (SET_INFOSERVER+1)
#define SEENUMERATESIGNALSREPLY SP_RPCREPLY (SET_INFOSERVER+1)

#define SELISTTYPETREES           SP_RPCREQUEST (SET_INFOSERVER+2)
#define SELISTTYPETREESREPLY      SP_RPCREPLY (SET_INFOSERVER+2)

#define SELOADDEFINITIONMAP    SP_RPCREQUEST (SET_INFOSERVER+3)
#define SELOADDEFINITIONMAPREPLY SP_RPCREPLY (SET_INFOSERVER+3)

#define SEMSCSIGNALS              SP_RPCREQUEST (SET_INFOSERVER+4)
#define SEMSCSIGNALSREPLY         SP_RPCREPLY (SET_INFOSERVER+4)

#define SEINFOEXTERNDEF           SP_RPCREQUEST (SET_INFOSERVER+5)
#define SEINFOEXTERNDEFREPLY      SP_RPCREPLY (SET_INFOSERVER+5)

#define SEINFOGETSDTREF           SP_RPCREQUEST (SET_INFOSERVER+6)
#define SEINFOGETSDTREFREPLY      SP_RPCREPLY (SET_INFOSERVER+6)

  /* Notifications from the INFOSERVER */
#define SEINVALIDATENOTIFY       SP_MESSAGE (SET_INFOSERVER+1)
#define SEINVALIDATETYPENOTIFY   SP_MESSAGE (SET_INFOSERVER+2)
#define SEINVALIDATEDEFINITIONMAPNOTIFY   SP_MESSAGE (SET_INFOSERVER+3)
#define SEINVALIDATEMSCNOTIFY    SP_MESSAGE (SET_INFOSERVER+4)



/* SET_SIMULATOR_UI */

#define SESIMUICOMMAND		SP_RPCREQUEST (SET_SIMULATOR_UI+1)
#define SESIMUICOMMANDREPLY	SP_RPCREPLY (SET_SIMULATOR_UI+1)
#define SESIMUICHANGENOTIFY   SP_MESSAGE (SET_SIMULATOR_UI+2)
#define SESIMUICHANGE	     SP_RPCREQUEST (SET_SIMULATOR_UI+2)
#define SESIMUICHANGEREPLY	SP_RPCREPLY (SET_SIMULATOR_UI+2)
#define SESIMUINOTIFY		SP_RPCREQUEST (SET_SIMULATOR_UI+3)
#define SESIMUINOTIFYREPLY	SP_RPCREPLY (SET_SIMULATOR_UI+3)
/* SESIMUINOTIFY(REPLY) renamed to SESIMUISTRING(REPLY) in 3.1 */
#define SESIMUISTRING         SP_RPCREQUEST (SET_SIMULATOR_UI+3)
#define SESIMUISTRINGREPLY    SP_RPCREPLY (SET_SIMULATOR_UI+3)




/* SET_ANALYZER */

#define SEANALYZERCOMMAND	SP_RPCREQUEST (SET_ANALYZER+1)
#define SEANALYZERCOMMANDREPLY	SP_RPCREPLY (SET_ANALYZER+1)

#define SEANALYZE		SP_RPCREQUEST (SET_ANALYZER+2)
#define SEANALYZEREPLY		SP_RPCREPLY (SET_ANALYZER+2)

#define SEGRPR                  SP_RPCREQUEST (SET_ANALYZER+3)
#define SEGRPRREPLY             SP_RPCREPLY (SET_ANALYZER+3)


/* SET_HELP */

#define SEHELPREQUEST		SP_RPCREQUEST (SET_HELP+1)
#define SEHELPREQUESTREPLY	SP_RPCREPLY (SET_HELP+1)


/* SET_PREFERENCES */

#define SEPREFERENCESNOTIFY	SP_MESSAGE (SET_PREFERENCES+1)

/* SET_VALIDATOR */

#define SEVALCOM		SP_RPCREQUEST (SET_VALIDATOR+1)
#define SEVALCOMREPLY	        SP_RPCREPLY (SET_VALIDATOR+1)
#define SEVALCOMNOTIFY          SP_MESSAGE (SET_VALIDATOR+2)

/* SET_SIMULATOR */

#define SESDLSIGNAL             SP_MESSAGE (SET_SIMULATOR+1)

/* SET_TREEVIEWER */

#define SETREE	        	SP_RPCREQUEST (SET_TREEVIEWER+1)
#define SETREEREPLY	        SP_RPCREPLY (SET_TREEVIEWER+1)

/* SET_TYPEVIEWER */

#define SETYPESHOW              SP_RPCREQUEST (SET_TYPEVIEWER+1)
#define SETYPESHOWREPLY         SP_RPCREPLY (SET_TYPEVIEWER+1)

#define SETYPEUPTODATE		SP_RPCREQUEST (SET_TYPEVIEWER+2)
#define SETYPEUPTODATEREPLY	SP_RPCREPLY (SET_TYPEVIEWER+2)

/* SET_COVERAGEVIEWER */

#define SECOVOPEN               SP_RPCREQUEST (SET_COVERAGEVIEWER+1)
#define SECOVOPENREPLY          SP_RPCREPLY   (SET_COVERAGEVIEWER+1)

#define SECOVMODE               SP_RPCREQUEST (SET_COVERAGEVIEWER+2)
#define SECOVMODEREPLY          SP_RPCREPLY   (SET_COVERAGEVIEWER+2)

#define SECOVVISIBILITY         SP_RPCREQUEST (SET_COVERAGEVIEWER+3)
#define SECOVVISIBILITYREPLY    SP_RPCREPLY   (SET_COVERAGEVIEWER+3)

/* SET_XREFVIEWER */

#define SELOADXREF              SP_RPCREQUEST (SET_XREFVIEWER+1)
#define SELOADXREFREPLY         SP_RPCREPLY   (SET_XREFVIEWER+1)

/* SET_HELPVIEWER */

#define SEHELPSHOWLINK          SP_RPCREQUEST (SET_HELPVIEWER+1)
#define SEHELPSHOWLINKREPLY	SP_RPCREPLY (SET_HELPVIEWER+1)


/* SET_ASN2SDL */

#define SEASNCOMMAND		SP_RPCREQUEST (SET_ASN2SDL+1)
#define SEASNCOMMANDREPLY	SP_RPCREPLY (SET_ASN2SDL+1)

/* SET_H2SDL */

#define SEHCOMMAND		SP_RPCREQUEST (SET_H2SDL+1)
#define SEHCOMMANDREPLY		SP_RPCREPLY (SET_H2SDL+1)



#endif /* _spevent_h */
