#
# Makefile for Sun to build the simulation host application host_smr.sct
#
# must setup variable sdtdir to point to your 
# installation ex.
# setenv sdtdir /appl/ibm/rational/5.0/sdt/sdtdir/sunos5sdtdir
#
# Output: post.o   to use when making sctworld from Master Library
# Input: tlayer.c
# includes: parser.c tcp.c, tlayer.h, sp.h, spevent.h

CC = gcc
LD = gcc
CCFlags = -c 
sctIFDEF  = -DSCTDEBCLCOM -DSUN5_GCC -DTARGETSIM
FILEFlags = -DHOST -DTCP
SOURCEdir = ../source
INCLUDE   = ../source -I$(sdtdir)/INCLUDE

Output = host_smr.sct
Input = ../source/tlayer.c


default: $(Output)

$(Output): tlayer.o
	$(LD) tlayer.o $(sdtdir)/INCLUDE/post.o -lsocket -lnsl -o $(Output)

tlayer.o: $(Input) ../source/parser.c ../source/tcp.c ../source/tlayer.h
	$(CC) $(CCFlags) $(sctIFDEF) -o tlayer.o $(SOURCEdir)/$(Input)\
		$(FILEFlags) -I$(INCLUDE)

clean:
	rm tlayer.o $(Output)

