/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*+MHDR*/
/*
+------------------------------------------------------------------------------+
#  Modulname: mg_dl.c
+------------------------------------------------------------------------------+
|  Headerfile   : MG_CTRL.H                                                    |
+------------------------------------------------------------------------------+
*/
/*-MHDR*/

#ifndef __MG_CTRL_H_
#define __MG_CTRL_H_

#include "mcod.h"
/*-----------------  Macros       --------------------------------------------*/

/*
** Timer handle
*/
#define XON_TIMER  1 
#define POLL_TIMER 2

#ifdef SDTGATE
  #ifdef XMK_WINDOWS
    #define xmk_exit(err)  MPMSendToTool ( ID_SDTMT, GateExitInd, (void*) NULL, 0 );
  #else
    #define xmk_exit(err) 
  #endif
#endif

#define CTRL_OKAY      0
#define CTRL_ERROR    -1


/*-----------------  typedefs     --------------------------------------------*/

typedef struct
{
  char  CharParam_1[256];
  char  CharParam_2[256];
  char  CharParam_3[256];
  int   IntegerParam_1;
  int   IntegerParam_2;
  int   IntegerParam_3;
} xmk_T_GateDevice;

typedef struct
{
  int CharacterLength;
  int CharacterPosition;
} xmk_T_GateCodingRules;

#ifdef SDTGATE 
extern xmk_T_GateDevice        xmk_GateDevice;
extern xmk_T_GateLineStatusCnf xmk_LineStatus;
#endif

#if defined (XMK_USE_V24)
  #define XMK_V24_DEVICE    xmk_GateDevice.CharParam_1
  #define XMK_V24_BAUD      xmk_GateDevice.IntegerParam_1
#elif defined (XMK_USE_SOCKETS)
  #define XMK_SOCKET_INTERNET_ADR  xmk_GateDevice.CharParam_1
  #define XMK_SOCKET_PORT_ADR      xmk_GateDevice.IntegerParam_1
#endif
#define GATE_PROT_FILE           xmk_GateDevice.CharParam_3
#define TIMER_POLL_RATE          xmk_GateDevice.IntegerParam_3

#define XMK_COUNT_RX_ANY_CHARS(NUM) xmk_LineStatus.chars_received+=NUM;xmk_LineStatus.is_changed ++;
#define XMK_COUNT_RX_XON            xmk_LineStatus.XON_received++;xmk_LineStatus.is_changed ++;
#define XMK_COUNT_RX_XOFF           xmk_LineStatus.XOFF_received++;xmk_LineStatus.is_changed ++;
#define XMK_COUNT_RX_FRAME_OK       xmk_LineStatus.received_frames_OK++;xmk_LineStatus.is_changed ++;
#define XMK_COUNT_RX_FRAME_NOT_OK   xmk_LineStatus.received_frames_not_OK++;xmk_LineStatus.is_changed ++;
#define XMK_SET_RX_FATAL_ERROR      xmk_LineStatus.receiver_fatal_error = XMK_ERROR;xmk_LineStatus.is_changed ++;
#define XMK_COUNT_TX_FRAMES         xmk_LineStatus.try_to_send_frames++;xmk_LineStatus.is_changed ++;
#define XMK_SET_TRANSMITTER_FATAL_ERR xmk_LineStatus.transmitter_fatal_error = XMK_ERROR;xmk_LineStatus.is_changed ++;
#define XMK_COUNT_TX_XON_XOFF(charval) if (charval == XMK_XON) xmk_LineStatus.XON_sent++;else  xmk_LineStatus.XOFF_sent++; xmk_LineStatus.is_changed ++;
#define XMK_COUNT_TX_CHAR(NUM)      xmk_LineStatus.chars_sent+=NUM;xmk_LineStatus.is_changed ++;
#define XMK_COUNT_TX_ESC            xmk_LineStatus.ESC_sent++;xmk_LineStatus.is_changed ++;

/*
** position of the sync and the length field in the message header
*/
#define CLASS_POS  GateCodingRules.CharacterPosition
#define TAG_POS    GateCodingRules.CharacterLength + GateCodingRules.CharacterPosition
#define SYNC_POS   (2 * GateCodingRules.CharacterLength) + GateCodingRules.CharacterPosition
#define LENGTH_POS (3 * GateCodingRules.CharacterLength) + GateCodingRules.CharacterPosition

/*-----------------  Functions    --------------------------------------------*/

extern void xmk_GateErrorHandler ( char * );
extern int  xmk_GateControl      ( int, int, void*, xmk_U_MsgParams*);

char* BuildHEXBuffer( unsigned char* BinBuffer, unsigned int length );
void xmk_CheckDevice(void);
void xmk_GateInit(void);
void xmk_GateDeinit(void);
void xmk_GateTrace(char* aPref, char* aBuffer);

#endif  /* ... __MG_CTRL_H_ */
