/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*+MHDR*/
/*
+------------------------------------------------------------------------------+
#  Modulname: ml_typ.h
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This Header-file is to be included from SDL-Applications and handwritten    |
|  Code by the user. Furthermore, the Cmicro Kernel includes the file.         |
|                                                                              |
|  For more information, see next pages.                                       |
|  For detailed description, see manual.                                       |
|                                                                              |
+------------------------------------------------------------------------------+
*/


#ifndef __ML_TYP_H_
#define __ML_TYP_H_

/*
FILE INDEX
SS0  User Section    - User - scaling facilities
AA0  Automatic scaling facilities
00   Utility macros
01   Main User oriented ifdef's
02   Dependent ifdef 's
03   C Library
03a  C Compiler section
03b  Final setting
04   SDL Model macro expansions
05   Utility ifdef 's
06   Constants
07   Forward Declarations
08   SDL predefined types (except SDL_PId)
09   SDL_PId
10   Signal Set
11   Procedure ( = Prd )
12   Process ( = Prs )
13   Timer
14   Signal
15   Symbol Table
16   Global Data Structure
221  _sche
222  _queu
223  _time
224  _stim
225  _err
226  _outp
227  _user
228  _main
229  Cmicro Tester
*/


/****+***************************************************************
SS0  User Section - User - scaling facilities
********************************************************************/
/* The following file is to be filled up by the users.       */
/* Do your manual scalings here ...                          */
#include "ml_mcf.h"

/****+***************************************************************
AA0  Automatic scaling facilities
********************************************************************/
/* The automatically generated file sdl_cfg.h is no longer   */
/* included here.                                            */
/* Instead it will be included in the ml_mcf.h generated by  */
/* The Bodybuilder/Targeting Expert.                         */




#ifdef XMK_USE_NO_AUTO_SCALING
  #ifdef   XMK_USED_ONLY_X_1
    /*
    ** Setting this flag cause the Cmicro Tester
    ** to produce erroneus outputs (type xPID) ...
    */
    #undef XMK_USED_ONLY_X_1
  #endif

  #define XMK_USED_TIMER
  #define XMK_USED_DYNAMIC_CREATE
  #define XMK_USED_DYNAMIC_STOP
  #define XMK_USED_SAVE
  #define XMK_USED_SIGNAL_WITH_PARAMS
  #define XMK_USED_TIMER_WITH_PARAMS
  #define XMK_USED_SENDER
  #define XMK_USED_OFFSPRING
  #define XMK_USED_PARENT
  #define XMK_USED_SELF
#endif

#ifndef XSCT_CMICRO
/*
** This define is necessary to distinguish between
** the codegenerators, especially for predefined sorts
** in the files sctpred*
*/
#define XSCT_CMICRO
#endif

/*
** The standard duration and time algorithm from Cadvanced cannot be used
** for Cmicro because limitations in timer module.
** You have to choose one of the follwing time models
*/

/*
** time is expressed as number of ticks
*/
#define XTIMEASINT_TICKS

/*
** time is expressed as real number giving number of seconds

#define XTIMEASINT_SECS

** should be filled up by the user with realisic values
#define SDT_TICKPERSEC      1 
#define SDT_NANOSECPERTICK  1 
*/

#undef  XMK_USE_STANDARD_DURATION
#undef  XMK_USE_STANDARD_TIME

/****+***************************************************************
00   Utility macros
********************************************************************/

#define COMMENT(P)
   /* to be used for inserting comments in in-line C-code in SDL. */
   /* the syntax is:  COMMENT(( your free format comment text ))   */

/*
** General purpose ....
*/
#ifndef XMK_OKAY
  #define XMK_OKAY      0
#endif

#ifndef XMK_ERROR
  #define XMK_ERROR     1
#endif

#ifndef XMK_AMBIGOUS
  #define XMK_AMBIGOUS  2
#endif

#ifndef XMK_EMPTY
  #define XMK_EMPTY     3
#endif

#define XMK_NO_PROCESS xNULLPID

#define XMK_NO_SIGNAL  ((xmk_T_SIGNAL) 0xffff)
#define XMK_NO_STATE   ((xmk_T_STATE)  0xffff)

/*
** Switches
*/
#define XMK_ON     1
#define XMK_OFF    0

/*
** Modes for the Cmicro Recorder
**
** The user can use these values to set the
** appropriate recorder mode in xmk_SetRecorderMode ()
*/
#define XMK_RECORDER_OFF     0        /* no activity from Cmicro Recorder   */
#define XMK_RECORDER_RECORD  1        /* Record mode of the Cmicro Recorder */
#define XMK_RECORDER_PLAY    2        /* Play   mode of the Cmicro Recorder */

/*
** Mapping of IO (only for Cmicro Tester)
*/
#define STDERR    stderr
#define STDOUT    stdout

/*
** Host side definitions (only for Cmicro Tester)
*/
#define XMK_WAS_PRINTED_ASCII  0x0008

/*
** New macros needed for later versions of Cmicro Tester
*/
#ifdef XMK_ADD_SDLE_TRACE
  #define XAT_FIRST_SYMBOL(SYMB_NO1, SYMB_NO2) \
          xmk_TSDL_InputID( SYMB_NO2 );
  #define XBETWEEN_SYMBOLS(SYMB_NO1,SYMB_NO2,C_LINE_NO) \
          xmk_TSDL_SymbolID( SYMB_NO2 );
  #define XBETWEEN_SYMBOLS_PRD(SYMB_NO1,SYMB_NO2,C_LINE_NO) \
          xmk_TSDL_SymbolID( SYMB_NO2 );
  #define XBETWEEN_STMTS(SYMB_NO1,SYMB_NO2,C_LINE_NO)
  #define XBETWEEN_STMTS_PRD(SYMB_NO1,SYMB_NO2,C_LINE_NO)
  #define XAT_LAST_SYMBOL
  #define XDEBUG_LABEL(LABEL_NAME)
#else
  #define XAT_FIRST_SYMBOL(SYMB_NO1, SYMB_NO2)
  #define XBETWEEN_SYMBOLS(SYMB_NO1,SYMB_NO2,C_LINE_NO)
  #define XBETWEEN_SYMBOLS_PRD(SYMB_NO1,SYMB_NO2,C_LINE_NO)
  #define XBETWEEN_STMTS(SYMB_NO1,SYMB_NO2,C_LINE_NO)
  #define XBETWEEN_STMTS_PRD(SYMB_NO1,SYMB_NO2,C_LINE_NO)
  #define XAT_LAST_SYMBOL
  #define XDEBUG_LABEL(LABEL_NAME)
#endif

/*
** New macros needed for ADT support
*/
#define XCHECK_UNION_TAG(TAG,VALUE,ASSTAG,NEQTAG,COMPNAME,CURR_VALUE,TYPEINFO)\
   if (NEQTAG(TAG,VALUE)) { \
     ASSTAG(TAG,VALUE,XASS_MR_ASS_NF); \
   }

#define XCHECK_UNION_TAG_FREE(TAG,VALUE,ASSTAG,NEQTAG,FREEFUNC,COMPNAME,CURR_VALUE,TYPEINFO) \
   if (NEQTAG(TAG,VALUE)) { \
     FREEFUNC((void **)&(TAG)); \
     ASSTAG(TAG,VALUE,XASS_MR_ASS_NF); \
   }

#define XCHECK_UNION_TAG_USAGE(TAG,VALUE,NEQTAG,COMPNAME,CURR_VALUE,TYPEINFO)

#define XCHECK_OPTIONAL_USAGE(PRESENT_VAR,COMPNAME)

#define XSET_CHOICE_TAG(TAG,VALUE,ASSTAG,NEQTAG,COMPNAME,CURR_VALUE,TYPEINFO) \
   if (NEQTAG(TAG,VALUE)) { \
     ASSTAG(TAG,VALUE,XASS_MR_ASS_NF); \
   }

#define XSET_CHOICE_TAG_FREE(TAG,VALUE,ASSTAG,NEQTAG,FREEFUNC,COMPNAME,CURR_VALUE,TYPEINFO) \
   if (NEQTAG(TAG,VALUE)) { \
     FREEFUNC((void **)&(TAG)); \
     ASSTAG(TAG,VALUE,XASS_MR_ASS_NF); \
   }

#define XCHECK_CHOICE_USAGE(TAG,VALUE,NEQTAG,COMPNAME,CURR_VALUE,TYPEINFO)

#ifdef XMK_USE_MAX_ERR_CHECK
  #define XCHECK_REF(VALUE,SORTIDNODE,REF_SORT) \
    if ( ! (void *) VALUE )\
    {\
        ErrorHandler (ERR_N_NULL_POINTER_VALUE_USED);\
    }

  #define XCHECK_OREF(VALUE,REF_TYPEINFO,REF_SORT) \
    if ( ! (void *) VALUE )\
    {\
        ErrorHandler (ERR_N_NULL_POINTER_VALUE_USED);\
    }

  #define XCHECK_OREF2(VALUE)

  #define XCHECK_OWN(VALUE,REF_TYPEINFO,REF_SORT) \
    if ( ! (void *) VALUE )\
    {\
        ErrorHandler (ERR_N_NULL_POINTER_VALUE_USED);\
    }

#else
  #define XCHECK_REF(VALUE,SORTIDNODE,REF_SORT)
  #define XCHECK_OREF(VALUE,REF_TYPEINFO,REF_SORT)
  #define XCHECK_OREF2(VALUE)
  #define XCHECK_OWN(VALUE,REF_TYPEINFO,REF_SORT)
#endif

#define xRaWF(S)

/****+***************************************************************
01   Main User oriented #ifdef
********************************************************************/

/****+***************************************************************
02   Dependent #ifdef
********************************************************************/
/*---+---------------------------------------------------------------
     Check automatically generated #ifdef
-------------------------------------------------------------------*/
#if defined(XMK_IFC_TIME) && defined(XMK_C_TIME)
  #if XMK_IFC_TIME != XMK_C_TIME
    /*
    ** If the following line is compiled/leads to an error during
    ** compilation, then the generated systemname.ifc file does not match with
    ** the generated systemname.c file. You should newly generate C code
    ** and be sure that each of the generated C files and the symbolfile
    ** is used appropriately
    */
    #error "ERROR_IllegalFileConfiguration_ifc_and_c_file_See_ml_typ.h"
  #endif
#endif


#if defined(XMK_HIGHEST_SIGNAL_NR) && !defined(XMK_USE_MORE_THAN_250_SIGNALS)
  #if XMK_HIGHEST_SIGNAL_NR > 250
    /*
    ** If the following line is compiled/leads to an error during
    ** compilation, then the amount of signals in the SDL system
    ** exceeds 250 and the define XMK_USE_MORE_THAN_250_SIGNALS should
    ** be set. Otherwise there would be runtime errors because
    ** more than 250 signals cannot be represented with an char
    ** value (the last values are reserved for internal purposes),
    ** but must be represented with an int value.
    */
    #error "ERROR_IllegalCodingOfSignalIdentification_See_ml_typ.h"
  #endif
#endif

 #if defined(XMK_USED_TIMER_WITH_PARAMS)
   /*
   ** Timers with parameters need signal with parameters,
   ** and need timers itself 
   */
   #define XMK_USED_SIGNAL_WITH_PARAMS
 #endif

/*---+---------------------------------------------------------------
     Dependent user oriented #ifdef
-------------------------------------------------------------------*/

#ifndef  XMK_USE_SENDER_PID_IN_SIGNAL
  #ifdef   XMK_USED_SENDER
     #error "ERROR_in_ml_typ.h\IllegalCombinationOfDefines_01"
  #endif

  #ifdef   XMK_USED_PARENT
     #error "ERROR_in_ml_typ.h\IllegalCombinationOfDefines_02"
  #endif
#endif


#ifndef  XMK_USE_RECEIVER_PID_IN_SIGNAL
  #ifdef   XMK_USE_PREEMPTIVE
     #error "ERROR_in_ml_typ.h\IllegalCombinationOfDefines_03"
  #endif

  #ifdef   XMK_USE_TIMESLICE
     #error "ERROR_in_ml_typ.h\IllegalCombinationOfDefines_04"
  #endif

  #ifdef   XMK_USED_DYNAMIC_CREATE
     #error "ERROR_in_ml_typ.h\IllegalCombinationOfDefines_05"
  #endif

  #ifndef  XMK_USED_ONLY_X_1
     #error "ERROR_in_ml_typ.h\IllegalCombinationOfDefines_06"
  #endif

  #ifdef   XMK_USED_TIMER_WITH_PARAMS
     /*
     ** Timers with parameters, but no receiver PID in signal header
     ** is not implemented.
     */
     #error "ERROR_in_ml_typ.h\IllegalCombinationOfDefines_07"
  #endif
#endif


/* in case of  undef  : SDL-Addressing not available         */
/* in case of  define : SDL-Addressing is  available         */

/*
** Note:XMK_USE_PID_ADDRESSING is used in generated C code !
*/
#if defined(XMK_USED_PARENT) || defined(XMK_USED_OFFSPRING)
  #define XMK_USE_PID_ADDRESSING
#endif


#ifdef  XMK_ADD_PRINTF
  /*
  ** For each C-Module there is s separate printf
  */
  #define XMK_ADD_PRINTF_KERNEL
  #define XMK_ADD_PRINTF_LIBRARY
  #define XMK_ADD_PRINTF_TESTER
  #define XMK_ADD_PRINTF_SDL
  #define XMK_ADD_PRINTF_ADDITIONAL
#endif



#ifdef XMK_ADD_PRINTF_KERNEL
  #define XMK_ADD_PRINTF_CPU
  #define XMK_ADD_PRINTF_MAIN
  #define XMK_ADD_PRINTF_OUTPUT
  #define XMK_ADD_PRINTF_QUEUE
  #define XMK_ADD_PRINTF_SCHEDULER
  #define XMK_ADD_PRINTF_TIMER
  #define XMK_ADD_PRINTF_USER
#endif



#ifdef XMK_ADD_PRINTF_LIBRARY
  #define XMK_ADD_PRINTF_COD
  #define XMK_ADD_PRINTF_DL
  #define XMK_ADD_PRINTF_COM
  #define XMK_ADD_PRINTF_ERROR
  #define XMK_ADD_PRINTF_MONITOR
  #define XMK_ADD_PRINTF_MEMORY
  #define XMK_ADD_PRINTF_PREDEFINED
#endif



#ifdef XMK_ADD_PRINTF_TESTER
  #define XMK_ADD_PRINTF_RUL
  #define XMK_ADD_PRINTF_OPT
  #define XMK_ADD_PRINTF_RING
  #define XMK_ADD_PRINTF_TSDL
  #define XMK_ADD_PRINTF_TSYS
  #define XMK_ADD_PRINTF_REC
  #define XMK_ADD_PRINTF_PLAY
#endif



/*
** -----------------------------------------------------------------
** Overall control over allowed configurations
** -----------------------------------------------------------------
*/

#ifndef XMK_ADD_MICRO_TESTER
  /*
  ** Per default, it is not allowed to use any part
  ** of the Cmicro Tester, without using the Cmicro Tester itself.
  */
  #undef XMK_USE_DISTRIBUTED
  #undef XMK_ADD_MICRO_RECORDER
  #undef XMK_ADD_MICRO_COMMAND
  #undef XMK_USE_DEBUGGING
  #undef XMK_ADD_PROFILE
  #undef XMK_ADD_TRACE_BUF
  #undef XMK_ADD_MICRO_TRACER
  #undef XMK_ADD_SDLE_TRACE
  #undef XMK_ADD_PSC_TRACE
  #undef XMK_ADD_MICRO_RECORDER
  #undef XMK_ADD_SIGNAL_FILTER
  #undef XMK_ADD_STDOUT_TRACE
  #undef XMK_ADD_FILE_TRACE
  #undef XMK_USE_COMMLINK
#endif /* ... XMK_ADD_MICRO_TESTER */

/*
** -----------------------------------------------------------------
** Control of Cmicro Kernel configuration
** -----------------------------------------------------------------
*/
#if defined(XMK_USE_PREEMPTIVE) && defined(XMK_USE_NO_RECURSION)
  /*
  ** Caution : The Cmicro Kernel uses recursion, if it
  ** is scaled preemptive !
  */
  #error "ERROR_in_ml_typ.h\IllegalCombinationOfDefines_12"
#endif

#if defined(XSYSID)
  /*
  ** If Partitioning is used
  */
  #if defined(XMK_USE_PREEMPTIVE)
    /*
    ** Caution : Preemption cannot be used together
    ** with Partitioning !
    */
    #error "ERROR_in_ml_typ.h\PreemptionNotAllowedWithPartitioning"
  #endif

  /*
  ** Over-define macro
  */
  #define XMAKENAME(P1,P2)  XCAT(P1,P2)

  /*
  **  Rename global variables and tables from User C code
  */
  #ifndef XMK_NO_REENTRANCY_PROBLEM
    #define ErrorHandler                        XMAKENAME(XSYSID,ErrorHandler)
    #define xmk_InitSystime                     XMAKENAME(XSYSID,InitializeSystemTime)
    #define xmk_SetTime                         XMAKENAME(XSYSID,SetSystemTime)
    #define xmk_NOW                             XMAKENAME(XSYSID,GetSystemTime)
    #define xAlloc                              XMAKENAME(XSYSID,OSalloc)
    #define xFree                               XMAKENAME(XSYSID,OSfree)
    #define xAlloc_SDL_Bit_String               XMAKENAME(XSYSID,AllocSDLBitstring)
    #define xFree_SDL_Bit_String                XMAKENAME(XSYSID,FreeSDLBitstring)
    #define xAlloc_SDL_Charstring               XMAKENAME(XSYSID,AllocSDLCharstring)
    #define xFree_SDL_Charstring                XMAKENAME(XSYSID,FreeSDLCharstring)
  #endif /* XMK_NO_REENTRANCY_PROBLEM */

  /*
  **  Rename global variables and tables from generated C code
  */
  #define yInit                               XMAKENAME(XSYSID,yInit)
  #define xPDTBL                              XMAKENAME(XSYSID,RootPrsTableVar)

  /*
  **  Rename environment functions
  */
  #define xInitEnv                            XMAKENAME(XSYSID,xInitEnv)
  #define xInEnv                              XMAKENAME(XSYSID,xInEnv)
  #define xOutEnv                             XMAKENAME(XSYSID,xOutEnv)
  #define xCloseEnv                           XMAKENAME(XSYSID,xCloseEnv)

  /*
  **  Rename global variables and tables from Cmicro Kernel
  */
  #define xRunPID                             XMAKENAME(XSYSID,RunPIDVar)
  #define pRunData                            XMAKENAME(XSYSID,RunDataPtr)
  #define pRunPIDTable                        XMAKENAME(XSYSID,RunPIDTablePtr)
  #define xmk_EmptySignalVar                  XMAKENAME(XSYSID,EmptySignalVar)
  #define xmk_SymbolNrVar                     XMAKENAME(XSYSID,SymbolNrVar)
  #define xmk_SignalInstPtr                   XMAKENAME(XSYSID,SignalInstPtr)
  #define xmk_SignalArrayVar                  XMAKENAME(XSYSID,SignalArrayVar)
  #define xmk_FreeListPointer                 XMAKENAME(XSYSID,FreeListPtr)
  #define xmk_Queue                           XMAKENAME(XSYSID,QueueVar)
  #define xmk_CurrentSignal                   XMAKENAME(XSYSID,CurrentSignalPtr)
  #define xmk_InterruptsDisabled              XMAKENAME(XSYSID,InterruptsDisabled)
  #define xmk_InitState                       XMAKENAME(XSYSID,QueueInitState)
  #define xmk_TimerArrayVar                   XMAKENAME(XSYSID,TimerArray)
  #define xmk_PassiveTimerPtr                 XMAKENAME(XSYSID,PassiveTimerPtr)
  #define xmk_ActiveTimerPtr                  XMAKENAME(XSYSID,ActiveTimerPtr)

  /*
  **  Rename global variables and tables from C Library
  **  Users must take care upon implementation
  **  and especially the problem of reentrancy for these functions.
  */
  #define xSDLOpError                         XMAKENAME(XSYSID,xSDLOpError)

  #ifndef XMK_NO_REENTRANCY_PROBLEM
    #define fprintf                             XMAKENAME(XSYSID,fprintf)
    #define printf                              XMAKENAME(XSYSID,printf)
  #endif /* ... XMK_NO_REENTRANCY_PROBLEM */

#else
  #define XMAKENAME(P1,P2)  P2

#endif /* ... defined(XSYSID) && defined(XMK_USE_PREEMPTIVE) */

/*
** Switch off any error check
*/
#ifdef XMK_USE_NO_ERR_CHECK
  #define ErrorHandler(errnum)
#endif



/****+***************************************************************
03   C Library
********************************************************************/

/* General */
#define XMK_B     {
#define XMK_E     }
#define XCAT(P1,P2)     P1##P2

#ifndef XMK_VOID
  #define XMK_VOID  (void)
#endif

/*
** Define XCONST as const, if the compiler in use supports "const"
** This is only the default setting for XCONST ...
*/
#define XCONST

/* Define X_REGISTER register, if the compiler in use has good support
** for register ...
*/
#define X_REGISTER

/*
** Define X_STATIC as static, if the compiler  / target in use
** has more static RAM than stack memory ...
*/
#define X_STATIC

/*
** Define XMK_END_CRITICAL_PATH and XMK_BEGIN_CRITICAL_PATH per default empty ...
** These macros are used to lock critical pathes in
** the Cmicro Kernel not only for preemption.
** The definition of these ias absolutely
** necessary if interrupts are used ...
*/
#define XMK_END_CRITICAL_PATH
#define XMK_BEGIN_CRITICAL_PATH


/*
** The intention of the following define
** is to suppress warnings of the compiler
** like "<ident> never used", which come
** in a few sections, where the user is free
** to use such variables or not
*/
#define XMK_SUPPRESS(variable)

#ifndef xmk_OPT_INT
  /*
  ** Loop counters, result values and some other variables within the
  ** Cmicro Kernel can be defined as char, or as int. It depends just on
  ** the machine in use, what should be defined behind this macro.
  ** For instance, a 8051
  ** produces a lot of overhead for int, long and pointer variables.
  ** On the other hand, some machines, like 68xxx produce more code, if
  ** they should handle char, instead of int. Define xmk_OPT_INT as what
  ** you want to in your compiler section or on the compiler command line
  ** or whatever.
  */
  #define xmk_OPT_INT int
#endif

/*
** For Controllers in Harvard architecture (e.g. Intel 8051) several
** variables can be stored in internal or external RAM/ROM.
** For  controllers in 'von Neumann' architecture the following macros
** have to be defines as follows:
*/
#define xmk_ROM_ptr  *
#define xmk_RAM_ptr  *


#ifndef XMK_KERNEL_EXIT
  #define XMK_KERNEL_EXIT(x)
#endif

/*
** default  for path and filename separation, for Unix versions
*/
#define XMK_PATH_SEPARATION_CHAR '/'  /* path/filename for unix */

/*
** Size of one char value in octet
*/
#define XMK_SIZEOF_CHAR 1

#undef  XMK_UNIX

/****+***************************************************************
03a   C Compilersection begins
********************************************************************/

#ifdef __cplusplus
  #ifdef __BORLANDC__
  #include <stddef.h> /* size_t */
  #else
  #include <cstddef> /* size_t */
  #endif
#endif

/*---+---------------------------------------------------------------
     UNIX: GNU C COMPILER
-------------------------------------------------------------------*/

#if defined(_GCC_)

#define XPP(x) x

#define XMK_UNIX

#define ECHOCTL_OFF

#undef  XCONST
#define XCONST const

/*
** On "no more memory" error the following macro is
** executed.
*/
#ifndef XMK_USE_xCloseEnv
  #define xCloseEnv()
#endif

#define XMK_NO_MORE_MEMORY \
        { fprintf (stderr, "**ERROR: No more memory available.exit\n"); xCloseEnv (); exit (-1); }

#define xptrint unsigned
#define xint32 int


#include <limits.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <time.h>
#include <termios.h>
#include <sys/fcntl.h>
#include <sys/types.h>
#include <unistd.h>

#ifdef XMK_ADD_STDIO
  #include <stdio.h>
#endif


#ifdef XMK_USE_SDL_MEM
  #include "ml_mem.h"
#endif /* XMK_USE_SDL_MEM */

#define XMK_USE_OS_ENVIRONMENT
#undef  XMK_KERNEL_EXIT
#define XMK_KERNEL_EXIT(x)  exit(x)

#include        <signal.h>

/* ... defined(_GCC_) */

/*---+---------------------------------------------------------------
     UNIX: HPUX Ansi C COMPILER
-------------------------------------------------------------------*/
#elif defined(HPUX_C)

#define XPP(x) x

#undef  xmk_OPT_INT
#define xmk_OPT_INT char

#undef X_REGISTER
#define X_REGISTER register

#define xptrint unsigned long
#define xint32 int32

#undef  XCONST
#define XCONST const

/* Define this macro outside this file in user section of ml_mcf.h */
#ifndef OS_INT_ENABLE
  #define OS_INT_ENABLE  /* critical pathes not really safe ! */
#endif

/* Define this macro outside this file in user section of ml_mcf.h */
#ifndef OS_INT_DISABLE
  #define OS_INT_DISABLE /* critical pathes not really safe ! */
#endif

#undef XMK_END_CRITICAL_PATH
#define XMK_END_CRITICAL_PATH  \
            if (xmk_InterruptsDisabled) \
                { \
                xmk_InterruptsDisabled--; \
                if (!xmk_InterruptsDisabled) \
                    OS_INT_ENABLE; \
                }

#undef XMK_BEGIN_CRITICAL_PATH
#define XMK_BEGIN_CRITICAL_PATH  \
            OS_INT_DISABLE; \
            xmk_InterruptsDisabled++;

#ifdef XMK_ADD_STDIO
#include <stdio.h>
#endif

/* ... defined(HPUX_C) */

/*---+---------------------------------------------------------------
     UNIX: HP-UX ANSI cc compiler
-------------------------------------------------------------------*/
#elif defined(HPUXANSICC)

#define XPP(x) x

#define XMK_UNIX
#define _GCC_


#undef  XCONST
#define XCONST const

/*
** On "no more memory" error the following macro is
** executed.
*/
#ifndef XMK_USE_xCloseEnv
  #define xCloseEnv()
#endif

#define XMK_NO_MORE_MEMORY \
        { fprintf (stderr, "**ERROR: No more memory available.exit\n"); xCloseEnv (); exit (-1); }

#define xptrint unsigned
#define xint32 int


#include <limits.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <time.h>
#include <termios.h>
#include <sys/fcntl.h>
#include <sys/types.h>
#include <unistd.h>
#include <termio.h>

#ifdef XMK_ADD_STDIO
  #include <stdio.h>
#endif


#ifdef XMK_USE_SDL_MEM
  #include "ml_mem.h"
#endif /* XMK_USE_SDL_MEM */

#define XMK_USE_OS_ENVIRONMENT
#undef  XMK_KERNEL_EXIT
#define XMK_KERNEL_EXIT(x)  exit(x)

#include        <signal.h>

/* ... defined HPUXANSICC */


/*---+---------------------------------------------------------------
     Windows: Microsoft C++ compiler
-------------------------------------------------------------------*/
#elif defined(MICROSOFT_C)

#define XPP(x) x

#undef  XCONST
#define XCONST const

/*
** Estimate that Windows applications are generated only
** For "GUI" application the kernel can be compiled and adapted by the user
** The "Console" application is not implemented per default
*/
#define XMK_WINDOWS

/*
** On "no more memory" error the following macro is
** executed.
*/
#ifndef XMK_USE_xCloseEnv
  #define xCloseEnv()
#endif

#ifdef GUI
  /*
  ** For Windows applications with GUI
  */
  #define XMK_NO_MORE_MEMORY \
         { MessageBox (NULL,"ERROR! No more memory", "Cmicro Kernel Error", MB_OK); xCloseEnv (); exit (-1); }
#else
  /*
  ** For Windows applications without GUI, e.g.console
  */
  #define XMK_NO_MORE_MEMORY \
         { fprintf (stderr, "**ERROR: No more memory available.exit\n"); xCloseEnv (); exit (-1); }
#endif



#define xptrint unsigned long
#define xint32 long

#include <limits.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>

#ifdef _DOS
  #include <signal.h>
#endif

#ifdef XMK_ADD_STDIO
  #include <stdio.h>
#endif

#ifdef XMK_USE_SDL_MEM
  #include "ml_mem.h"
#endif /* XMK_USE_SDL_MEM */

#undef  XMK_KERNEL_EXIT
#define XMK_KERNEL_EXIT(x)  exit(x)

#undef  XMK_PATH_SEPARATION_CHAR
#define XMK_PATH_SEPARATION_CHAR '\\'  /* path/filename for dos/windows */

/* ... MICROSOFT_C */

/*---+---------------------------------------------------------------
     Windows: BORLAND C++ compiler
-------------------------------------------------------------------*/
#elif defined(BORLAND_C)

#define XPP(x) x

#undef  XCONST
#define XCONST const

/*
** Estimate that Windows applications are generated only
** For "GUI" application the kernel can be compiled and adapted by the user
** The "Console" application is not implemented per default
*/
#define XMK_WINDOWS

/*
** On "no more memory" error the following macro is
** executed.
*/
#ifndef XMK_USE_xCloseEnv
  #define xCloseEnv()
#endif

#ifdef GUI
  /*
  ** For Windows applications with GUI
  */
  #define XMK_NO_MORE_MEMORY \
         { MessageBox (NULL,"ERROR! No more memory", "Cmicro Kernel Error", MB_OK); xCloseEnv (); exit (-1); }
#else
  /*
  ** For Windows applications without GUI, e.g.console
  */
  #define XMK_NO_MORE_MEMORY \
         { fprintf (stderr, "**ERROR: No more memory available.exit\n"); xCloseEnv (); exit (-1); }
#endif

#define xptrint unsigned long
#define xint32 long

#include <limits.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <mem.h>
#include <alloc.h>
#include <dos.h>
#include <time.h>

#ifdef XMK_ADD_STDIO
  #include <stdio.h>
  #include <conio.h>
#endif

#ifdef XMK_USE_SDL_MEM
  #include "ml_mem.h"
#endif /* XMK_USE_SDL_MEM */

#undef  XMK_KERNEL_EXIT
#define XMK_KERNEL_EXIT(x)  exit(x)

#undef  XMK_PATH_SEPARATION_CHAR
#define XMK_PATH_SEPARATION_CHAR '\\'  /* path/filename for dos/windows */



#undef  XMK_END_CRITICAL_PATH
#define XMK_END_CRITICAL_PATH

#undef  XMK_BEGIN_CRITICAL_PATH
#define XMK_BEGIN_CRITICAL_PATH



#define XMK_USE_END_PAD

#ifdef XMK_SUPPRESS
#undef XMK_SUPPRESS
#endif

/*
** See the begin of this headerfile for the
** intention of the following define ...
*/
#define XMK_SUPPRESS(variable) variable=variable;

/* ... BORLAND_C */

/*---+---------------------------------------------------------------
     DOS: MSP58C80
-------------------------------------------------------------------*/
#elif defined(MSP58C80)

#define XPP(x) x

#undef  XCONST
#define XCONST

#define xptrint unsigned
#define xint32 int


#undef XMK_END_CRITICAL_PATH
#undef XMK_BEGIN_CRITICAL_PATH

#define XMK_END_CRITICAL_PATH  if (xmk_InterruptsDisabled) {\
              xmk_InterruptsDisabled--;\
                if (!xmk_InterruptsDisabled) { asm(" EINT"); }}

#define XMK_BEGIN_CRITICAL_PATH asm(" DINT");\
              xmk_InterruptsDisabled++;

#include <stdlib.h>
#include <string.h>
#include <stddef.h>

#ifdef XMK_ADD_STDIO
  /*Warning : Compiler supports no stdio.h !*/
  #include <stdio.h>
#endif

#undef  XMK_KERNEL_EXIT
#define XMK_KERNEL_EXIT(x)

#ifdef XMK_USE_SDL_MEM
  #include "ml_mem.h"
#endif /* XMK_USE_SDL_MEM */
/*
** Configure Time units
*/

#define RTC_INI        888        /* 72Hz ~ 4,096 Mhz / 64 / RTC_INI */
#define INT_RTC        0x0004     /* Mask for RTC interrupt */
#define RTC            0x0006     /* RTC address */
#define IMR            0x0004     /* IMR address */

/*
** Size of one char value in octet
*/
#undef  XMK_SIZEOF_CHAR
#define XMK_SIZEOF_CHAR 2

/* ... MSP58C80 */


/*---+---------------------------------------------------------------
     UNIX/DOS: IARC51
-------------------------------------------------------------------*/
#elif defined(IARC51)

#define XPP(x) x

#undef  XCONST
#define XCONST const

/*
** The following definitions are possible optimizations for the
** 8051 architecture (Harvard architecture)
**
** 1. Pointer to the ROM
**    "XCONST" should be set to "const" and
**    "xmk_ROM_ptr" should be set to "code*"
*/
#undef  XCONST
#define XCONST
#undef  xmk_ROM_ptr
#define xmk_ROM_ptr     *
/*
** 2. Pointer to the X-RAM
**    "xmk_RAM_ptr" should be set to "xdata*"
**    WARNING: This does not work probably for Compiler V5.2
*/
#undef  xmk_RAM_ptr
#define xmk_RAM_ptr     *


/*
** Do not use generators from sctpred module
*/
#define XNO_LONG_MACROS
#define XNOUSEOFOCTETBITSTRING
#define XNOUSEOFOBJECTIDENTIFIER
#define XNOUSEOFASN1

#define xptrint unsigned long
#define xint32 long

#undef  xmk_OPT_INT
#define xmk_OPT_INT char

#undef  X_REGISTER
#define X_REGISTER

#undef  XMK_KERNEL_EXIT
#define XMK_KERNEL_EXIT(x)

#undef  XMK_END_CRITICAL_PATH
#define XMK_END_CRITICAL_PATH  if (xmk_InterruptsDisabled) {\
                    xmk_InterruptsDisabled--;\
                    if (!xmk_InterruptsDisabled) { ET0 = EX0 = EX1 = 1; }}

#undef  XMK_BEGIN_CRITICAL_PATH
#define XMK_BEGIN_CRITICAL_PATH ET0 = 1; EX0 = EX1 = 0;\
                  xmk_InterruptsDisabled++;

#include <limits.h>
#include <io51.h>  /* register definions for the used target */

#ifdef XMK_ADD_STDIO
  #include <stdio.h>
#endif

#ifdef XMK_USE_SDL_MEM
  #include "ml_mem.h"
#else
  #include <string.h>
#endif /* XMK_USE_SDL_MEM */

/* ... defined(IARC51) */

/*---+---------------------------------------------------------------
     DOS: KEIL_C51
-------------------------------------------------------------------*/
#elif defined(KEIL_C51)

#define XPP(x) x
/*
** The following definitions are possible optimizations for the
** 8051 architecture (Harvard architecture)
**
** 1. Pointer to the ROM
**    "XCONST" should be set to "const" in the library and
**             as "code" in the generated file.
**    "xmk_ROM_ptr" should be set to "code*"
*/
#undef  XCONST
#ifndef XSCT_CMICRO
  #define XCONST
#else
  #define XCONST
#endif
#undef  xmk_ROM_ptr
#define xmk_ROM_ptr     *
/*
** 2. Pointer to the X-RAM
**    "xmk_RAM_ptr" should be set to "xdata*"
*/
#undef  xmk_RAM_ptr
#define xmk_RAM_ptr     *

#undef  xmk_OPT_INT
#define xmk_OPT_INT char

#undef  X_REGISTER
#define X_REGISTER data

#define XNO_LONG_MACROS
#define XNOUSEOFOCTETBITSTRING
#define XNOUSEOFOBJECTIDENTIFIER
#define XNOUSEOFASN1

#define xptrint unsigned long
#define xint32 long

#undef  XMK_KERNEL_EXIT
#define XMK_KERNEL_EXIT(x) return

#undef  XMK_END_CRITICAL_PATH
#define XMK_END_CRITICAL_PATH  if (xmk_InterruptsDisabled) {\
                    xmk_InterruptsDisabled--;\
                    if (!xmk_InterruptsDisabled) { ET0 = 1; EX0 = EX1 = 0; }}

#undef  XMK_BEGIN_CRITICAL_PATH
#define XMK_BEGIN_CRITICAL_PATH ET0 = EX0 = EX1 = 0;\
                  xmk_InterruptsDisabled++;

#include <reg.h> /* register definions for the used target*/
#include <limits.h>
#include <stdlib.h>

#ifdef XMK_ADD_STDIO
  #include <stdio.h>
#endif
  
#ifdef XMK_USE_SDL_MEM
  #include "ml_mem.h"
#else
  #include <string.h>
#endif 
/* ... KEIL_C51 */

/*---+---------------------------------------------------------------
     DOS: KEIL_C166
-------------------------------------------------------------------*/
#elif defined(KEIL_C166)

#define XPP(x) x

#undef  XCONST
#define XCONST const

#define xptrint unsigned long
#define xint32 long

#include <stdlib.h>
#include <stdarg.h>
#include <reg.h>  /* register definions for the used target */

#ifdef XMK_ADD_STDIO
  #include <stdio.h>
#endif

#ifdef XMK_USE_SDL_MEM
  #include "ml_mem.h"
#else
  #include <string.h>
#endif 

#undef  XMK_KERNEL_EXIT
#define XMK_KERNEL_EXIT(x)

#undef EXIT
#define EXIT(val)

#undef XMK_END_CRITICAL_PATH
#undef XMK_BEGIN_CRITICAL_PATH

#define XMK_END_CRITICAL_PATH  if (xmk_InterruptsDisabled) {\
              xmk_InterruptsDisabled--;\
                if (!xmk_InterruptsDisabled) {IEN = 1; }}

#define XMK_BEGIN_CRITICAL_PATH IEN = 0; \
              xmk_InterruptsDisabled++;

/* ... KEIL_C166 */

/*---+---------------------------------------------------------------
     UNIX: GNU 80166
-------------------------------------------------------------------*/
#elif defined(GNU80166)

#define XPP(x) x

#undef  XCONST
#define XCONST

#define xptrint unsigned long
#define xint32 long

#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <c166.h>  /* register definions for the used target */

#ifdef XMK_ADD_STDIO
  #include <stdio.h>
#endif

#ifdef XMK_USE_SDL_MEM
  #undef   XMK_USE_memset
  #undef   XMK_USE_memcpy

  #include "ml_mem.h"

#endif 

#undef  XMK_KERNEL_EXIT
#define XMK_KERNEL_EXIT(x)

#undef EXIT
#define EXIT(val)

#undef XMK_END_CRITICAL_PATH
#undef XMK_BEGIN_CRITICAL_PATH

#define XMK_END_CRITICAL_PATH  if (xmk_InterruptsDisabled) {\
              xmk_InterruptsDisabled--;\
                if (!xmk_InterruptsDisabled) { asm(" bset psw.11"); }}

#define XMK_BEGIN_CRITICAL_PATH asm(" bclr psw.11");\
              xmk_InterruptsDisabled++;

/* ... GNU80166 */

/*---+---------------------------------------------------------------
     MS-DOS: MCC68K
-------------------------------------------------------------------*/
#elif defined(MCC68K)

#define XPP(x) x

#undef  XCONST
#define XCONST

#define xptrint unsigned long
#define xint32 long

#include <string.h>
#include <stdlib.h>


#undef  XMK_KERNEL_EXIT
#define XMK_KERNEL_EXIT(x)

#undef EXIT
#define EXIT(val)

#undef XMK_END_CRITICAL_PATH
#undef XMK_BEGIN_CRITICAL_PATH

#define XMK_END_CRITICAL_PATH  if (xmk_InterruptsDisabled) {\
              xmk_InterruptsDisabled--;\
                if (!xmk_InterruptsDisabled) { /* ENABLE INTERRUPTS HERE */ }}

#define XMK_BEGIN_CRITICAL_PATH /* DISABLE INTERRUPTS HERE  */ \
              xmk_InterruptsDisabled++;

/* ... MCC68K */


/*---+---------------------------------------------------------------
     DOS: Tasking 80166
-------------------------------------------------------------------*/
#elif defined(TCC80166)

#define XPP(x) x

#undef  XCONST
#define XCONST const

#define xptrint unsigned long
#define xint32 long

#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <c166.h> /* register definions for the used target */


#ifdef XMK_ADD_STDIO
  #include <stdio.h>
#endif
#ifdef XMK_USE_SDL_MEM
  #undef   XMK_USE_memset
  #undef   XMK_USE_memcpy

  #include "ml_mem.h"

#endif /* XMK_USE_SDL_MEM */

#undef  XMK_KERNEL_EXIT
#define XMK_KERNEL_EXIT(x)

#undef EXIT
#define EXIT(val)

#undef XMK_END_CRITICAL_PATH
#undef XMK_BEGIN_CRITICAL_PATH

#define XMK_END_CRITICAL_PATH  if (xmk_InterruptsDisabled) {\
              xmk_InterruptsDisabled--;\
                if (!xmk_InterruptsDisabled) { /* ENABLE INTERRUPTS HERE */ }}

#define XMK_BEGIN_CRITICAL_PATH /* DISABLE INTERRUPTS HERE */;\
              xmk_InterruptsDisabled++;

/* ... TCC80166 */

/*-------------------------------------------------------------------
     DOS: BSO/TASKING 80196
-------------------------------------------------------------------*/
#elif defined(TCC80C196)

#define XPP(x) x

#undef  XCONST
#define XCONST

#define xptrint unsigned long
#define xint32 long

#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <kb_sfrs.h>

#ifdef XMK_ADD_STDIO
  #include <stdio.h>
#endif

#ifdef XMK_USE_SDL_MEM
  #include "ml_mem.h"
#endif 

#undef  XMK_KERNEL_EXIT
#define XMK_KERNEL_EXIT(x)

#undef EXIT
#define EXIT(val)

#undef XMK_END_CRITICAL_PATH
#undef XMK_BEGIN_CRITICAL_PATH

#define XMK_END_CRITICAL_PATH  if (xmk_InterruptsDisabled) {\
              xmk_InterruptsDisabled--;\
                if (!xmk_InterruptsDisabled) {asm ei;}}

#define XMK_BEGIN_CRITICAL_PATH {asm di;};\
              xmk_InterruptsDisabled++;

/* ... TCC80C196 */

/*---+---------------------------------------------------------------
     DOS: IAR Compiler for Melps 7700
-------------------------------------------------------------------*/
#elif defined(IARC7700)

#define XPP(x) x

#undef  XCONST
#define XCONST const

#define xptrint unsigned int
#define xint32 int

#include <limits.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <intrins.h>

#ifdef XMK_ADD_STDIO
  #include <stdio.h>
#endif

#ifdef XMK_USE_SDL_MEM
  #include "ml_mem.h"
#endif

#undef  XMK_KERNEL_EXIT
#define XMK_KERNEL_EXIT(x)

#undef EXIT
#define EXIT(val)

#undef XMK_END_CRITICAL_PATH
#undef XMK_BEGIN_CRITICAL_PATH

#define XMK_END_CRITICAL_PATH  if (xmk_InterruptsDisabled) {\
              xmk_InterruptsDisabled--;\
                if (!xmk_InterruptsDisabled) { enable_interrupt(); }}

#define XMK_BEGIN_CRITICAL_PATH disable_interrupt(); \
              xmk_InterruptsDisabled++;

/* ... IARC7700 */

/*---+---------------------------------------------------------------
     DOS: HYPERSTONE
-------------------------------------------------------------------*/
#elif defined(HYPERSTONE)

#define XPP(x) x

#undef  XCONST
#define XCONST

#define xptrint unsigned
#define xint32 int

#include <limits.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>

#ifdef XMK_ADD_STDIO
  #include <stdio.h>
#endif

#undef XMK_END_CRITICAL_PATH
#undef XMK_BEGIN_CRITICAL_PATH

/*
** Note: Fill out the "UserFuntionToEnableInterrupts" below
** according to your project requirement
*/
#define XMK_END_CRITICAL_PATH  if (xmk_InterruptsDisabled) {\
              xmk_InterruptsDisabled--;\
                if (!xmk_InterruptsDisabled) { UserFuntionToEnableInterrupts (); }}

#define XMK_BEGIN_CRITICAL_PATH UserFuntionToDisableInterrupts (); \
              xmk_InterruptsDisabled++;

#undef  XMK_KERNEL_EXIT
#define XMK_KERNEL_EXIT(x)

/* ... HYPERSTONE */

/*---+---------------------------------------------------------------
     DOS: IAR C Compiler for Hitachi 6301 MPU family types
-------------------------------------------------------------------*/
#elif defined(IARC6301)

#define XPP(x) x

#undef  XCONST
#define XCONST

#undef  XMK_VOID
#define XMK_VOID

#define xptrint unsigned
#define xint32 int

#include <limits.h>
#include <stdlib.h>
#include <string.h>

#ifdef XMK_ADD_STDIO
  #include <stdio.h>
#endif

#undef XMK_END_CRITICAL_PATH
#undef XMK_BEGIN_CRITICAL_PATH

/*
** Note: Fill out the "UserFuntionToEnableInterrupts" below
** according to your project requirement
*/
#define XMK_END_CRITICAL_PATH  if (xmk_InterruptsDisabled) {\
              xmk_InterruptsDisabled--;\
                if (!xmk_InterruptsDisabled) { UserFuntionToEnableInterrupts (); }}

#define XMK_BEGIN_CRITICAL_PATH UserFuntionToDisableInterrupts (); \
              xmk_InterruptsDisabled++;

#undef  XMK_KERNEL_EXIT
#define XMK_KERNEL_EXIT(x)

/* ... IARC6301 */


/*---+---------------------------------------------------------------
     DOS: Thumb C Compiler for the ARM Processor
-------------------------------------------------------------------*/
#elif defined(ARM_THUMB)

#define XPP(x) x

#undef  XCONST
#define XCONST const

#define xptrint unsigned
#define xint32 int

#define X_XINT_32 int


#ifdef XMK_ADD_STDIO
  #error "ERROR_ml_typ_h_ARM_THUMB_Cannot_Use_STDIO"
#endif

#ifdef XMK_USE_SDL_MEM
  #define size_t unsigned int
  #include "ml_mem.h"
#else
  #include <stdlib.h>
  #include <string.h>
#endif

/*
** Suppress warnings in PAD functions
** (has no effect on execution)
*/
#define XMK_USE_END_PAD


#undef  XMK_KERNEL_EXIT
#define XMK_KERNEL_EXIT(x)

#undef  EXIT
#define EXIT(val)

#undef  exit
#define exit(val)

#undef XMK_END_CRITICAL_PATH
#undef XMK_BEGIN_CRITICAL_PATH

#define XMK_END_CRITICAL_PATH \
        if (xmk_InterruptsDisabled) \
        {\
          xmk_InterruptsDisabled--;\
          if (!xmk_InterruptsDisabled) \
            enable_interrupts (); \
        }

#define XMK_BEGIN_CRITICAL_PATH \
        disable_IRQ; \
        disable_FIQ; \
        xmk_InterruptsDisabled++;

/* ... ARM_THUMB */

/*---+---------------------------------------------------------------
      GREEN_HILLS
-------------------------------------------------------------------*/
#elif defined (GREEN_HILLS)

#define XPP(x) x

#undef  XCONST
#define XCONST const

#define xptrint unsigned
#define xint32 int

#include <limits.h>
#include <stdlib.h>
#include <stddef.h>

#ifdef XMK_ADD_STDIO
#include <stdio.h>
#endif

#undef XMK_END_CRITICAL_PATH
#undef XMK_BEGIN_CRITICAL_PATH

#define XMK_END_CRITICAL_PATH  if (xmk_InterruptsDisabled) {\
        xmk_InterruptsDisabled--;\
        if (!xmk_InterruptsDisabled) { UserFuntionToEnableInterrupts (); }}

#define XMK_BEGIN_CRITICAL_PATH UserFuntionToDisableInterrupts (); \
        xmk_InterruptsDisabled++;

#undef  XMK_KERNEL_EXIT
#define XMK_KERNEL_EXIT(x)

#undef  XMK_SUPPRESS
#define XMK_SUPPRESS(variable) variable=variable;

#define XMK_USE_END_PAD

/* ... GREEN_HILLS */

/*---+---------------------------------------------------------------
     DOS: ICC_HC12 C Compiler for
-------------------------------------------------------------------*/
#elif defined(ICC_HC12)

#define XPP(x) x

#define xptrint unsigned long

#define xint32 long

#undef xmk_OPT_INT
#define xmk_OPT_INT int

#undef XCONST
#define XCONST const

#undef XMK_BEGIN_CRITICAL_PATH
#define XMK_BEGIN_CRITICAL_PATH
#undef XMK_END_CRITICAL_PATH
#define XMK_END_CRITICAL_PATH

#define XMK_NO_MORE_MEMORY

#ifdef XMK_ADD_STDIO
  #include <stdio.h>
#endif

#include <hc12.h> 
#include <stdlib.h>

#include <stddef.h>


/* ... ICC_HC12 */

/*---+---------------------------------------------------------------
    Any User defined C Compiler
-------------------------------------------------------------------*/

#else

  /*
  ** If no C compiler is defined from the above list , then users
  ** may add their own C compiler in their own description file
  ** user_cc.h. The file should contain
  **
  ** #ifdef C_compiler_abbreviation
  **   ...user definitions (use any compiler above as a template) ...
  ** #endif
  */
  #include "user_cc.h"

#endif /* ... of all C compiler - defines */

/****+***************************************************************
      C Compilersection ends
********************************************************************/

/*---+---------------------------------------------------------------
03b   Final setting
-------------------------------------------------------------------*/

#ifdef __cplusplus
  typedef char * xSpecial;
  extern void * operator new (size_t pp, xSpecial vv);
#endif


#ifdef  XMK_ADD_STDIO
  /*
  ** If Cmicro is used on a host machine (or a machine which
  ** is like a host, e.g. supports printf, argc/argv when calling main)
  ** then use the template xmk_printf function
  */
  extern int xmk_printf ( char* format, ...);
#endif /* ... XMK_ADD_STDIO */

/*
** Size of an integer value. It is assumed to have 32 Bits in integers.
** If this is not true, the users should redefine the INT_MAX value
** depending on the C compiler by using
** #ifdef INT_MAX
** #undef INT_MAX
** #endif
** In the following, a max value of an "int" for 16 Bit is shown
** #define INT_MAX         32767
** In the following, a max value of an "int" for 32 Bit is shown
** #define INT_MAX         2147483647
*/
#ifndef INT_MAX
#define INT_MAX         2147483647      /* max value of an "int" for 32 Bit */
#endif

/*
** The max.value of an integer usually is defined in the limits.h
** header file from the C compiler.
**
** In the following, a max value of an "int" for 16 Bit is shown
** #define xMax_SDL_Integer         32767
** In the following, a max value of an "int" for 32 Bit is shown
** #define xMax_SDL_Integer         2147483647
*/
#ifdef  INT_MAX
#define xMax_SDL_Integer INT_MAX
#else
#define xMax_SDL_Integer 2147483647
#endif


/****+***************************************************************
04   SDL Model macro expansions
********************************************************************/

/* General defines */
#ifndef xmk_T_BOOL
  #if !defined(X_COMPACT_BOOL)
    #define xmk_T_BOOL int
    #define xbool      int
  #else
    #define xmk_T_BOOL char
    #define xbool      char
  #endif

  #define XMK_TRUE                1
  #define XMK_FALSE               0

  #define XMK_WAIT                2
  #define XMK_IGNORE              3

  #define XMK_REQUEST_FROM_UI     4
  #define XMK_RECOVERY            5

  #define XMK_START_BATCH         6

  #define XMK_NO_CONFIRMATION     7

#endif /* ... xmk_T_BOOL */

#ifndef NULL
#define NULL  ((void*)0)
#endif


#include "sctpred.h"


#define XMK_EOF     -1

#define XMK_CTRL_C      0x03        /* ctrl-c          */
#define XMK_CTRL_D      0x04        /* ctrl-d          */
#define XMK_CTRL_H      0x08        /* ctrl-h          */
#define XMK_CTRL_Q      0x11        /* ctrl-q          */
#define XMK_CTRL_U      0x15        /* ctrl-u          */
#define XMK_LF          0x0a        /* Line feed       */
#define XMK_CR          0x0d        /* Carriage return */
#define XMK_ESC         0x1b        /* Escape          */
#define XMK_XON         0x11        /* Start    */
#define XMK_XOFF        0x13        /* Stop     */


#define XMK_CTRL_BACKSP XMK_CTRL_H  /* backspace       */

#define XMK_TERMINATION_CHAR(chr) ((c==XMK_CTRL_D) || (c==XMK_CTRL_Q))

#define XMK_IS_PRINTABLE_CHAR(chr) ((c>=0x20) || (c==XMK_CTRL_H))

#if !defined(XMK_USE_MORE_THAN_250_SIGNALS)
  typedef unsigned char xmk_T_SIGNAL      ;/* Type of signal-id's  */
#else
  typedef unsigned int  xmk_T_SIGNAL      ;/* Type of signal-id's  */
#endif

#if (MAX_SDL_PROCESS_TYPES > 250)
  typedef unsigned int  xmk_T_PROCESS    ;/* Type f.processtypes  */
#else
  typedef unsigned char xmk_T_PROCESS    ;/* Type f.processtypes  */
#endif


#ifdef XMK_USE_MORE_THAN_256_INSTANCES
  typedef unsigned int  xmk_T_INSTANCE    ;/* Type f.processinst.  */
#else
  typedef unsigned char xmk_T_INSTANCE    ;/* Type f.processinst.  */
#endif


#if defined(XMK_USE_HUGE_TRANSITIONTABLES)
  typedef          int  xmk_T_OFFSET      ;/* State index table for huge systems */
  typedef unsigned int  xSYMBOLNR         ;/* Symbol-Number for      */
                                           /* yPAD-Function for huge */
  typedef unsigned int  xSTATE            ;/* Process-State          */

#else
  typedef unsigned char xmk_T_OFFSET      ;/* State index table for tiny systems */
  typedef unsigned char xSYMBOLNR         ;/* Symbol-Number for      */
                                           /* yPAD-Function for tiny */
  typedef unsigned char xSTATE            ;/* Process-State          */
#endif /* ... XMK_USE_HUGE_TRANSITIONTABLES */

typedef unsigned char xmk_T_PRIO        ;/* Type for priority    */
typedef unsigned char xmk_T_PRIOLEVEL   ;/* Type for priolevel   */
typedef unsigned long xmk_T_TIME        ;/* Type for SDL time    */

#define xmk_T_STATE   xSTATE             /* SDL-Process state      */
#define XMK_CREATE_SIGNALID ((xmk_T_SIGNAL) 0xffff)
#define XMK_NO_ASTERISK ((xmk_T_STATE) 0xffff)



#if !defined(XMK_USE_PAR_GREATER_THAN_250)
  typedef unsigned char xmk_T_MESS_LENGTH ;/* Signal.par.length    */
#else
  typedef unsigned int  xmk_T_MESS_LENGTH ;/* Signal.par.length    */
#endif

#ifdef XMK_USE_PREEMPTIVE
  typedef xSTATE      ( *xmk_T_TRANS_ADDRESS ) ( xSYMBOLNR );
#else
  typedef xSTATE      ( *xmk_T_TRANS_ADDRESS ) ( void );
#endif

/* ---------------- Variables in the PAD function ---------------- */

#define PROCESS_VARS                    unsigned char _dummy_var;

#define YPAD_TEMP_VARS

#define YPAD_OUTPUT_SIGNAL_PTR_VAR \
        unsigned char xmk_RAM_ptr xmk_OutputSignalPtr;


#define YPAD_YSVARP \
        unsigned char xmk_RAM_ptr ySVarP;

/*
** Used for two different signals in one input symbol
*/
#define INSIGNAL_NAME         xmk_SignalInstPtr ->signal
#define SIGNAL_NAME(p1,p2)    p2

#define YPAD_YVARP(VDEF_TYPE)                         \
        VDEF_TYPE     xmk_RAM_ptr yVarP =(VDEF_TYPE xmk_RAM_ptr ) pRunData;

#define YGLOBALPRD_YVARP


#ifdef  XMK_USED_SELF
  #define SDL_SELF                        xRunPID
#endif

#ifdef  XMK_USED_SENDER
  /*
  ** Use safe PID addressing when SENDER is to be checked
  ** in starttransition. This costs some RAM/ROM/Performance
  ** and might be left out if it is for sure, that no
  ** start transition tries to access "SENDER".
  */
  #define XMK_USE_SAFE_ADDRESSING
  #define SDL_SENDER                      xmk_SignalInstPtr ->send
#endif

#ifdef  XMK_USED_PARENT
  #define SDL_PARENT                      pRunPIDTable->Parent
#endif

#ifdef  XMK_USED_OFFSPRING
  #define SDL_OFFSPRING                   pRunPIDTable->Offspring
#endif


#define CURRENT_STATE_PRD               ProceduresWithStatesNotImplemented

/* ------------------ Structure of PAD function ------------------ */

#define YPAD_RESULT_TYPE                         xSTATE

#ifdef  XMK_USE_PREEMPTIVE
  #define YPAD_PROTOTYPE(functionname)           xSTATE functionname (xSYMBOLNR xmk_SymbolNrVar);
  #define YPAD_FUNCTION(functionname)            xSTATE functionname (xSYMBOLNR xmk_SymbolNrVar)
#else
  /* No Preemption - ANSI */
  #define YPAD_PROTOTYPE(functionname)           xSTATE functionname (void);
  #define YPAD_FUNCTION(functionname)            xSTATE functionname (void)
#endif

#ifdef XMK_USED_SIGNAL_WITH_PARAMS

  #if (defined(XFREESIGNALFUNCS) || defined(XMK_USERFREESIGNALFUNC))\
       && defined (XMK_USED_SIGNAL_WITH_DYN_PARAMS)
    #define XRELEASE_SIGNAL_PARS  xmk_ReleaseSignalParameter(xmk_SignalInstPtr);
  #else
    #define XRELEASE_SIGNAL_PARS
  #endif

  #if (XMK_MSG_BORDER_LEN==0)

    #define BEGIN_PAD \
            if (xmk_SignalInstPtr  != NULL ) \
            { /* if not start transition */ \
              if (xmk_SignalInstPtr ->mess_length > XMK_MSG_BORDER_LEN) \
              { ySVarP = (unsigned char xmk_RAM_ptr ) xmk_SignalInstPtr ->ParUnion.ParPtr; \
              } \
            }


  #else

    #define BEGIN_PAD \
            if (xmk_SignalInstPtr  != NULL ) \
            { /* if not start transition */ \
              if (xmk_SignalInstPtr ->mess_length > XMK_MSG_BORDER_LEN) \
              { ySVarP = (unsigned char xmk_RAM_ptr ) xmk_SignalInstPtr ->ParUnion.ParPtr; } \
              else { ySVarP = (unsigned char xmk_RAM_ptr ) xmk_SignalInstPtr ->ParUnion.ParCopy; } \
            }


  #endif

#else
 
    #define BEGIN_PAD

#endif


#ifdef XMK_USE_END_PAD
  /*
  ** Pay attention to the following define, if
  ** you do tied integration in your target ....
  ** Compilers produce a warning, if no return is found
  ** at the end of an yPAD_Function
  */
  #define END_PAD(VTYPE)  \
          return (XDASHSTATE) ;
#else
  #define END_PAD(VTYPE)
#endif


#define XSYMBOLNUMBER                           xmk_SymbolNrVar

#if defined(SCMADEBCLCOM) || defined(SCMADEBCLENVCOM) || defined(SCMADEBCOM)||\
    defined(SCMAAPPLCLENV) 
  /*
  ** Do not use Cmicro's xmk_printf when when running on host 
  */
  #define PRINTF(params)   (void)printf params;
  #define XMK_ADD_PRINTF_ERROR
  #define XMK_ADD_ERRORTABLE
#else
  #ifdef XMK_ADD_STDIO
    /* CAUTION :                                     */
    /* ------------                                  */
    /* DO NOT USE PRINTF IN THE CASE OF A SO SCALED  */
    /* PREEMPTIVE Cmicro Kernel, IF YOU ARE NOT SURE,*/
    /* THAT fprintf () IS IMPLEMENTED REENTRANT BY   */
    /* THE COMPILER IN USE !!!                       */
    #define PRINTF(params)   (void)xmk_printf params;
    #define XMK_DEBUG
  #else
    #define PRINTF(params)
  #endif

#endif

/*
** Cmicro Target Tester
*/
#ifdef XMK_ADD_MICRO_TRACER
   #define XTRACE
#endif

#ifdef XMK_ADD_TTASK
   #define XMK_TEST_TASK(p1)      xmk_TSDL_Task(p1);
#else
   #define XMK_TEST_TASK(p1)
#endif
    
#ifdef XMK_ADD_TDECISION
   #define XMK_TEST_DECISION(p1)  xmk_TSDL_Decision(p1);
#else
   #define XMK_TEST_DECISION(p1)
#endif

#ifdef XMK_ADD_TPROCEDURE
   #define XMK_TEST_PROCEDURE(p1) xmk_TSDL_Procedure(p1);
#else
   #define XMK_TEST_PROCEDURE(p1)
#endif



/*
** Execution- Trace
*/

#ifdef XMK_ADD_PRINTF_SDL
  #define BEGIN_START_TRANSITION \
          PRINTF(("START-TRANSITION\n"));

  #define PRINTF_OUTPUT(P1) \
          PRINTF(("OUTPUT: %s\n", P1));

  #define PRINTF_CREATE(P1)  \
          PRINTF(("CREATE: %s\n", P1));

  #define YPRSNAME_VAR(PRS_NAME_STRING) \
          PRINTF(("PROCESS: %s\n", PRS_NAME_STRING));

  #define XOS_TRACE_INPUT(SIG_NAME_STRING) \
          PRINTF(("INPUT: %s\n", SIG_NAME_STRING));

  #define YPRDNAME_VAR(PRD_NAME_STRING) \
          PRINTF(("PROCEDURE %s\n", PRD_NAME_STRING)); \
          XMK_TEST_PROCEDURE (PRD_NAME_STRING);

  #define xTraceTask(P1) \
          PRINTF(("TASK: %s\n", P1)); \
          XMK_TEST_TASK((P1));

  #define xTraceAssign(P1) \
          PRINTF(("ASSIGN: %s\n", P1)); \
          XMK_TEST_TASK((P1));

  #define xTraceAlg(P1) \
          PRINTF(("ALG: %s\n", P1)); \
          XMK_TEST_TASK((P1));

  #define xTraceDecision(P1) \
          PRINTF(("DECISION: %s\n", P1 )); \
          XMK_TEST_DECISION(( P1 ));

  #define xTracePrdCall(P1) \
          PRINTF(("CALL: %s\n", P1 )); \
          XMK_TEST_PROCEDURE(( P1 ));

  #define XOS_TRACE_NEXTSTATE(P1) \
          PRINTF(("Nextstate: %d\n",  P1 ));

  #define XOS_TRACE_DASHSTATE \
          PRINTF(("No state change\n" ));

  #define XOS_TRACE_STOP \
          PRINTF(("Process stopped.\n" ));

#else

  #define BEGIN_START_TRANSITION

  #define PRINTF_OUTPUT(P1)

  #define PRINTF_CREATE(P1)

  #define YPRSNAME_VAR(PRS_NAME_STRING)

  #define XOS_TRACE_INPUT(SIG_NAME_STRING)

  #define YPRDNAME_VAR(PRD_NAME_STRING) \
          XMK_TEST_PROCEDURE(PRD_NAME_STRING);

  #define xTraceTask(P1) \
          XMK_TEST_TASK((P1));

  #define xTraceAssign(P1) xTraceTask(P1)

  #define xTraceAlg(P1)    xTraceTask(P1)

  #define xTraceDecision(P1) \
          XMK_TEST_DECISION(( P1 ));

  #define XOS_TRACE_NEXTSTATE(P1)

  #define XOS_TRACE_DASHSTATE

  #define XOS_TRACE_STOP

#endif

#if  defined(XMK_ADD_PRINTF_SDL) \
  || defined(XMK_ADD_PRINTF_ADDITIONAL) \
  || defined(XMK_ADD_PRINTF_CPU) \
  || defined(XMK_ADD_PRINTF_MAIN) \
  || defined(XMK_ADD_PRINTF_OUTPUT) \
  || defined(XMK_ADD_PRINTF_QUEUE) \
  || defined(XMK_ADD_PRINTF_SCHEDULER) \
  || defined(XMK_ADD_PRINTF_TIMER) \
  || defined(XMK_ADD_PRINTF_USER) \
  || defined(XMK_ADD_PRINTF_COM) \
  || defined(XMK_ADD_PRINTF_ERROR) \
  || defined(XMK_ADD_PRINTF_MONITOR) \
  || defined(XMK_ADD_PRINTF_MEMORY) \
  || defined(XMK_ADD_PRINTF_PREDEFINED)

  #define XMK_FUNCTION(p1) \
          PRINTF(("FUNCTION: %s\n", p1));
  #define XMK_TRACE_SCHE(p1)  \
          PRINTF(("mk_sche: %s\n", p1));
  #define XMK_TRACE_EXIT(p1) \
          PRINTF(("Exit from %s\n", p1));
#else
  #define XMK_FUNCTION(p1)
  #define XMK_TRACE_SCHE(p1)
  #define XMK_TRACE_EXIT(p1)
#endif


/* ------------------------ yInit function ----------------------- */
extern void yInit (void);

/* ------------------ Actions within transitions ----------------- */
/*
** Mapping the SDL_Halt () into xCloseEnv ()
*/
#define SDL_Halt()      xCloseEnv ()

/* ---------------------------- Output --------------------------- */

#define SIGNAL_VARS

#define ALLOC_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE) \
        { SIG_IDNODE  SIG_IDNODE; \
          xmk_OutputSignalPtr = (unsigned char xmk_ROM_ptr ) &SIG_IDNODE;

#define ALLOC_SIGNAL_NPAR(SIG_NAME, SIG_IDNODE, RECEIVER)
        /* empty */

#define ALLOC_SIGNAL_PAR(SIG_NAME, SIG_IDNODE, SIG_PAR_TYPE)   \
        { SIG_PAR_TYPE  xmk_TmpSignalOutputBuffer ; \
          xmk_OutputSignalPtr = (unsigned char  xmk_RAM_ptr ) &xmk_TmpSignalOutputBuffer;

#ifndef TRANSFER_SIGNAL
#define TRANSFER_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE)
#endif

#define XSIGNALHEADERTYPE /* empty */

#ifndef TRANSFER_SIGNAL_PAR
#define TRANSFER_SIGNAL_PAR(SIG_NAME, SIG_IDNODE, P3) {
#endif

#ifndef TRANSFER_SIGNAL_NPAR
#define TRANSFER_SIGNAL_NPAR(SIG_NAME, SIG_IDNODE, P3)
#endif

#define SIGNAL_ALLOC_ERROR                      /* empty */
#define SIGNAL_ALLOC_ERROR_END                  }

#define OUTSIGNAL_DATA_PTR                      xmk_OutputSignalPtr

#if defined(XMK_USE_SIGNAL_PRIORITIES) && defined(XMK_USE_RECEIVER_PID_IN_SIGNAL)
  /*
  ** Each signal contains a Signal priority
  ** Each signal contains a Receiver PID
  */
  #ifdef XMK_USED_SIGNAL_WITH_PARAMS
    #define XMK_SF(SIG_ID_NODE,SIG_PRIO,SIG_PAR_LEN,SIG_PARA_PTR,RECEIVER) \
            xmk_Send (SIG_ID_NODE,SIG_PRIO,SIG_PAR_LEN,SIG_PARA_PTR,RECEIVER);
  #else
    #define XMK_SF(SIG_ID_NODE,SIG_PRIO,SIG_PAR_LEN,SIG_PARA_PTR,RECEIVER) \
            xmk_Send (SIG_ID_NODE,SIG_PRIO,RECEIVER);
  #endif
#endif

#if defined(XMK_USE_SIGNAL_PRIORITIES) && !defined(XMK_USE_RECEIVER_PID_IN_SIGNAL)
  /*
  ** Each signal contains a Signal priority
  ** No   signal contains a Receiver PID
  */
  #ifdef XMK_USED_SIGNAL_WITH_PARAMS
    #define XMK_SF(SIG_ID_NODE,SIG_PRIO,SIG_PAR_LEN,SIG_PARA_PTR,RECEIVER) \
            xmk_Send (SIG_ID_NODE,SIG_PRIO,SIG_PAR_LEN,SIG_PARA_PTR);
  #else
    #define XMK_SF(SIG_ID_NODE,SIG_PRIO,SIG_PAR_LEN,SIG_PARA_PTR,RECEIVER) \
            xmk_Send (SIG_ID_NODE,SIG_PRIO);
  #endif
#endif

#if !defined(XMK_USE_SIGNAL_PRIORITIES) && defined(XMK_USE_RECEIVER_PID_IN_SIGNAL)
  /*
  ** No   signal contains a Signal priority
  ** Each signal contains a Receiver PID
  */
  #ifdef XMK_USED_SIGNAL_WITH_PARAMS
    #define XMK_SF(SIG_ID_NODE,SIG_PRIO,SIG_PAR_LEN,SIG_PARA_PTR,RECEIVER) \
            xmk_Send (SIG_ID_NODE,SIG_PAR_LEN,SIG_PARA_PTR,RECEIVER);
  #else
    #define XMK_SF(SIG_ID_NODE,SIG_PRIO,SIG_PAR_LEN,SIG_PARA_PTR,RECEIVER) \
            xmk_Send (SIG_ID_NODE,RECEIVER);
  #endif
#endif

#if !defined(XMK_USE_SIGNAL_PRIORITIES) && !defined(XMK_USE_RECEIVER_PID_IN_SIGNAL)
  /*
  ** No   signal contains a Signal priority
  ** No   signal contains a Receiver PID
  */
  #ifdef XMK_USED_SIGNAL_WITH_PARAMS
    #define XMK_SF(SIG_ID_NODE,SIG_PRIO,SIG_PAR_LEN,SIG_PARA_PTR,RECEIVER) \
            xmk_Send (SIG_ID_NODE,SIG_PAR_LEN,SIG_PARA_PTR);
  #else
    #define XMK_SF(SIG_ID_NODE,SIG_PRIO,SIG_PAR_LEN,SIG_PARA_PTR,RECEIVER) \
            xmk_Send (SIG_ID_NODE);
  #endif
#endif


#define XMK_DUMMYPRIO      0xff              /* for Cmicro Tester only */


#ifdef XMK_USE_xmk_SendSimple
   /*
   ** Use simple output function when possible ...
   ** Note, that signal priorities get lost when using xmk_SendSimple Function !
   */
   #ifdef XMK_USE_RECEIVER_PID_IN_SIGNAL
     #define SDL_OUTP_NPAR(PRIO,SIG_NAME,SIG_IDNODE,RECEIVER,NUM,SIG_NAME_STRING) \
             PRINTF_OUTPUT(SIG_NAME_STRING); \
             xmk_SendSimple (SIG_IDNODE,RECEIVER);
   #else
     #define SDL_OUTP_NPAR(PRIO,SIG_NAME,SIG_IDNODE,RECEIVER,NUM,SIG_NAME_STRING) \
             PRINTF_OUTPUT(SIG_NAME_STRING); \
             xmk_SendSimple (SIG_IDNODE);
   #endif
#else
   /*
   ** No simple output function available - use complex one
   ** This output function can handle signal priorities.
   */
   #define SDL_OUTP_NPAR(PRIO,SIG_NAME,SIG_IDNODE,RECEIVER,NUM,SIG_NAME_STRING) \
           PRINTF_OUTPUT(SIG_NAME_STRING); \
           XMK_VOID XMK_SF(SIG_IDNODE,PRIO,0,(void xmk_RAM_ptr) NULL,RECEIVER);
#endif

#define SDL_OUTP_PAR(PRIO,SIG_NAME,SIG_IDNODE,RECEIVER,NUM,SIG_NAME_STRING) \
        PRINTF_OUTPUT(SIG_NAME_STRING); \
        XMK_VOID XMK_SF(SIG_IDNODE,PRIO,sizeof(NUM), \
        (void  xmk_RAM_ptr) xmk_OutputSignalPtr,RECEIVER); }

#define SDL_OUTP_NPAR_ENV(PRIO,SIG_NAME,SIG_IDNODE,RECEIVER,NUM,SIG_NAME_STRING) \
        PRINTF_OUTPUT(SIG_NAME_STRING); \
        XMK_VOID XMK_SF (SIG_IDNODE,PRIO,0,(void xmk_RAM_ptr) NULL,RECEIVER);

#define SDL_OUTP_PAR_ENV(PRIO,SIG_NAME,SIG_IDNODE,RECEIVER,NUM,SIG_NAME_STRING) \
        PRINTF_OUTPUT(SIG_NAME_STRING); \
        XMK_VOID XMK_SF (SIG_IDNODE,PRIO,sizeof (NUM), (void xmk_RAM_ptr) xmk_OutputSignalPtr ,RECEIVER); }


/*
** The following macro is used in SDL_OUTP - macro calls
** It is only generated when there are more than one Instances
** of the proccess PROC_NAME the function xmk_Determine_Receiver
** looks for the first Instance of the ProcCess that is alive
**
*/
#define TO_PROCESS(PROC_NAME) xmk_Determine_Receiver(PROC_NAME)


/*
** Macro for use in the environment functions for user
** can be used in xInEnv () or in an interrupt service routine
** Main use is to send the ENV-PID to xmk_Send () ...
*/
#define XMK_SEND_ENV(ENV_ID,SIG_IDNODE,PRIO,SIG_PAR_LEN,SIG_PTR,RECEIVER) \
        XMK_BEGIN_CRITICAL_PATH;                                          \
        xtmpPID = xRunPID ;                                               \
        xRunPID = ENV_ID ;                                                \
        XMK_SF(SIG_IDNODE,PRIO,SIG_PAR_LEN,SIG_PTR,RECEIVER);             \
        xRunPID = xtmpPID;                                                \
        XMK_END_CRITICAL_PATH;

#define XMK_SEND_TMP_VARS    xPID xtmpPID;


/* ---------------------------- Create --------------------------- */

#define STARTUP_VARS
        /* empty */

#define ALLOC_STARTUP_NPAR(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE, XNL)
        /* empty */

/*
** Not relevant for Cmicro in SDT/Tau product release ;
*/
#define ALLOC_STARTUP(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
        xmk_OutputSignalPtr = getnewmemoryfor_ALLOC_STARTUP ();

/*
** Not relevant for Cmicro in SDT/Tau product release ;
*/
#define ALLOC_STARTUP_THIS \
        xmk_OutputSignalPtr = getnewmemoryfor_ALLOC_STARTUP_THIS ();

#define STARTUP_ALLOC_ERROR
#define STARTUP_ALLOC_ERROR_END
#define STARTUP_DATA_PTR \
        xmk_OutputSignalPtr->VarP

#define SDL_CREATE(PROC_NAME, PROC_IDNODE, PROC_NAME_STRING, STARTUP_IDNODE, PRIV_DATA_TYPE, PRIO, PAD_FUNCTION) \
        PRINTF_CREATE(PROC_NAME_STRING); \
        XMK_VOID xmk_CreateProcess (XCAT(XPTID_,PROC_IDNODE));

/* ------------------------- Static Create ------------------------ */
/* Is totally done by Cmicro Kernel, via the <root-process-table>  */


/* ----------------------------- Stop ---------------------------- */
/* A stop in a SDL-Process means a return from the yPAD-Function   */
/* The Cmicro Kernel handles all further actions.                  */

#define SDL_STOP \
        XOS_TRACE_STOP; \
        return (XDORMANT);

/*
** Insert free statements when process stops
*/
#if defined(XMK_USED_DYNAMIC_STOP)
  #define XFREEVARS
#endif

/* The following Macro is inserted directly before SDL_STOP and    */
/* can be used to free () Processvariables, if wanted in special   */
/* applications ...                                                */
#ifdef XFREEVARS
    #define FREE_PROCESS_VARS
#endif



/* ---------------------------- Timers --------------------------- */

/* -- Definitions */
#define DEF_TIMER_VAR(NAME)              /* unnecessary */
#define INIT_TIMER_VAR(TIMER_VAR)        /* unnecessary */
#define INPUT_TIMER_VAR(TIMER_VAR)       /* unnecessary */
#define RELEASE_TIMER_VAR(TIMER_VAR)     /* unnecessary */

#define DEF_TIMER_VAR_PARA(yTim_twp)     /* unnecessary */
#define INIT_TIMER_VAR_PARA(yTim_twp)    /* unnecessary */
#define RELEASE_TIMER_VAR_PARA(yTim_twp) /* unnecessary */
#define INPUT_TIMER_VAR_PARA(yTim_twp)   /* unnecessary */

#define SDL_NOW                        xmk_NOW ()


#ifndef XMK_USED_TIMER_WITH_PARAMS

  #ifdef XMK_USE_TIMER_SCALE
    /*
    ** Here is a little help to scale timers.
    ** Timer scaling is always useful only when using the Cmicro Tester,
    ** so the accuracy is not a problem.
    */
    #define SDL_SET(TIME_EXPR, TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR, TIMER_NAME_STRING) \
            xmk_TimerSet((TIME_EXPR-SDL_NOW)*xmk_TimerScaleFactor+SDL_NOW, PREFIXED_TIMER_NAME);

    #define SDL_SET_DUR(TIME_EXPR, DUR_EXPR, TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR, TIMER_NAME_STRING) \
            xmk_TimerSet((TIME_EXPR-SDL_NOW)*xmk_TimerScaleFactor+SDL_NOW, PREFIXED_TIMER_NAME);

    #define SDL_SET_TICKS(TIME_EXPR, DUR_EXPR, TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR, TIMER_NAME_STRING) \
            xmk_TimerSet((TIME_EXPR-SDL_NOW)*xmk_TimerScaleFactor+SDL_NOW, PREFIXED_TIMER_NAME);
  #else
    #define SDL_SET(TIME_EXPR, TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR, TIMER_NAME_STRING) \
            xmk_TimerSet(TIME_EXPR, PREFIXED_TIMER_NAME);

    #define SDL_SET_DUR(TIME_EXPR, DUR_EXPR, TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR, TIMER_NAME_STRING) \
            xmk_TimerSet(TIME_EXPR, PREFIXED_TIMER_NAME);

    #define SDL_SET_TICKS(TIME_EXPR, DUR_EXPR, TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR, TIMER_NAME_STRING) \
            xmk_TimerSet(TIME_EXPR, PREFIXED_TIMER_NAME);
  #endif

  /* -- Reset without parameters */
  #define SDL_RESET(TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR, TIMER_NAME_STRING) \
          xmk_TimerReset(PREFIXED_TIMER_NAME);

  /* -- Active (timer active) */
  #define SDL_ACTIVE(TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR) \
          xmk_TimerActive(PREFIXED_TIMER_NAME)

#else /* ... then XMK_USED_TIMER_WITH_PARAMS */

  #ifdef XMK_USE_TIMER_SCALE
    #define SDL_SET(TIME_EXPR, TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR, TIMER_NAME_STRING) \
            xmk_TimerSet((TIME_EXPR-SDL_NOW)*xmk_TimerScaleFactor+SDL_NOW, PREFIXED_TIMER_NAME, 0);

    #define SDL_SET_DUR(TIME_EXPR, DUR_EXPR, TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR, TIMER_NAME_STRING) \
            xmk_TimerSet((TIME_EXPR-SDL_NOW)*xmk_TimerScaleFactor+SDL_NOW, PREFIXED_TIMER_NAME, 0);

    #define SDL_SET_TICKS(TIME_EXPR, DUR_EXPR, TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR, TIMER_NAME_STRING) \
            xmk_TimerSet((TIME_EXPR-SDL_NOW)*xmk_TimerScaleFactor+SDL_NOW, PREFIXED_TIMER_NAME, 0);

    /*
    ** !!! Restricted Timers with parameters : EXPR must return integer always !!!
    */

    /* -- Set with parameters */

    #define SDL_SET_WITH_1IPARA(TIME_EXPR, TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR, TIMER_NAME_STRING, EXPR) \
            xmk_TimerSet((TIME_EXPR-SDL_NOW)*xmk_TimerScaleFactor+SDL_NOW, PREFIXED_TIMER_NAME, EXPR);

    #define SDL_SET_DUR_WITH_1IPARA(TIME_EXPR, DUR_EXPR, TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_PAR_STRUCT, TIMER_VAR, TIMER_NAME_STRING, EXPR) \
            xmk_TimerSet((TIME_EXPR-SDL_NOW)*xmk_TimerScaleFactor+SDL_NOW, PREFIXED_TIMER_NAME, EXPR);

    #define SDL_SET_TICKS_WITH_1IPARA(TIME_EXPR, DUR_EXPR, TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR, TIMER_NAME_STRING, EXPR) \
            xmk_TimerSet((TIME_EXPR-SDL_NOW)*xmk_TimerScaleFactor+SDL_NOW, PREFIXED_TIMER_NAME, EXPR);
  #else
    #define SDL_SET(TIME_EXPR, TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR, TIMER_NAME_STRING) \
            xmk_TimerSet(TIME_EXPR, PREFIXED_TIMER_NAME, 0);

    #define SDL_SET_DUR(TIME_EXPR, DUR_EXPR, TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR, TIMER_NAME_STRING) \
            xmk_TimerSet(TIME_EXPR, PREFIXED_TIMER_NAME, 0);

    #define SDL_SET_TICKS(TIME_EXPR, DUR_EXPR, TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR, TIMER_NAME_STRING) \
            xmk_TimerSet(TIME_EXPR, PREFIXED_TIMER_NAME, 0);

    #define SDL_SET_WITH_1IPARA(TIME_EXPR, TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR, TIMER_NAME_STRING, EXPR) \
            xmk_TimerSet(TIME_EXPR, PREFIXED_TIMER_NAME, EXPR);

    #define SDL_SET_DUR_WITH_1IPARA(TIME_EXPR, DUR_EXPR, TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_PAR_STRUCT, TIMER_VAR, TIMER_NAME_STRING, EXPR) \
            xmk_TimerSet(TIME_EXPR, PREFIXED_TIMER_NAME, EXPR);

    #define SDL_SET_TICKS_WITH_1IPARA(TIME_EXPR, DUR_EXPR, TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR, TIMER_NAME_STRING, EXPR) \
            xmk_TimerSet(TIME_EXPR, PREFIXED_TIMER_NAME, EXPR);
  #endif /* ... XMK_USE_TIMER_SCALE */

  /* -- Reset without parameters */
  #define SDL_RESET(TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR, TIMER_NAME_STRING) \
          xmk_TimerReset(PREFIXED_TIMER_NAME, 0);

  /* -- Active (timer active) without parameters */
  #define SDL_ACTIVE(TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_VAR) \
          xmk_TimerActive(PREFIXED_TIMER_NAME, 0)

  /* -- Reset with parameters */
  #define SDL_RESET_WITH_1IPARA(TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_PAR_STRUCT, TIMER_VAR, TIMER_NAME_STRING, EXPR) \
          xmk_TimerReset(PREFIXED_TIMER_NAME, EXPR);

  /* -- Active with parameters (timer active) */
  #define SDL_ACTIVE_WITH_1IPARA(TIMER_NAME, PREFIXED_TIMER_NAME, TIMER_PAR_STRUCT, TIMER_VAR, EXPR) \
          xmk_TimerActive(PREFIXED_TIMER_NAME, EXPR)

#endif /* ... XMK_USED_TIMER_WITH_PARAMS */


/* --------------------------- Nextstate ------------------------- */
#define SDL_NEXTSTATE(STATE_NAME, STATE_IDNODE, STATE_NAME_STRING)  \
        XOS_TRACE_NEXTSTATE(STATE_IDNODE); \
        return(STATE_IDNODE);

#define SDL_DASH_NEXTSTATE \
        XOS_TRACE_DASHSTATE; \
        return(XDASHSTATE);

/* --------------------------- Decision -------------------------- */
#define XDECISION_ERROR ErrorHandler (ERR_N_SDL_DECISION_ELSE);


/* --------------------------- SDL Array ------------------------- */
#define XRANGE_ERROR    ErrorHandler (ERR_N_SDL_RANGE);
#define XINDEX_ERROR    ErrorHandler (ERR_N_SDL_RANGE);

#ifdef XECSOP
  extern void xSDLOpError (char*, char*);
#else
  #define xSDLOpError(p1,p2) ErrorHandler(ERR_N_PREDEFINED_OPERATOR_CALL);
#endif


/****+***************************************************************
05   Utility #ifdef
********************************************************************/
#define NIL 0


/****+***************************************************************
06   Constants
********************************************************************/
#define XMK_STOP              1      /* xmk_RunSDL () */
#define XMK_NORMALRETURN      0      /* xmk_RunSDL () */
#define XMK_RECORDER_TAPE_END 2      /* xmk_RunSDL () */

#ifndef xOffsetOf
#define xOffsetOf(type, field)   ((xptrint) &((type *) 0)->field)
#endif

/****+***************************************************************
07   Forward Declarations
********************************************************************/

/****+***************************************************************
08   SDL predefined types (except SDL_PId)
********************************************************************/

/****+***************************************************************
09   SDL_PId
********************************************************************/

#define SDL_pid xPID
#define SDL_Pid xPID
#define SDL_PId xPID
#define SDL_PID xPID


#ifdef XMK_USED_ONLY_X_1
/* Each SDL-Process in the System is defined as (1,1) or (0,1) or (,1) */

  #if (MAX_SDL_PROCESS_TYPES < 252)
    typedef unsigned char xPID;/* char is enough to handle < 2^8-3 processes */
                /* +---------------------------+ */
                /* +    <process-type-id>      + */
                /* +---------------------------+ */
                /* + xPID = unique process-id  + */
                /* +---------------------------+ */

    /* Reserved Values, not available for ordinary Process-type-IDs */
    #define xNULLTYPE         0xff
    #define xNULLINST         0

    #ifdef XMK_ADD_MICRO_TESTER
      #define xPID_STRUCT 0x11
    #endif
  #else

    typedef unsigned short xPID; /* int is enough to handle 2^16-3 processes */
    /* +---------------------------+------------------------+ */
    /* +     higher Byte           +  lower Byte            + */
    /* +---------------------------+------------------------+ */
    /* +                   <process-inst-id>                + */
    /* +---------------------------+------------------------+ */
    /* +               xPID = unique process-id             + */
    /* +---------------------------+------------------------+ */

    /* Reserved Values, not available for ordinary Process-type-IDs */
    #define xNULLTYPE         0xffff
    #define xNULLINST         0

    #ifdef XMK_ADD_MICRO_TESTER
      #define xPID_STRUCT 0x22
    #endif
  #endif

  #define GLOBALPID(ptype,pinst)    ptype
  #define EPIDTYPE(globalpid)       globalpid
  #define EPIDINST(globalpid)       0

#else
/* Anywhere in the System there is a process, which is not defined as */
/* (1,1) or (0,1) or (,1)                                             */

  #if (MAX_SDL_PROCESS_TYPES < 252)

    #ifdef XMK_USE_MORE_THAN_256_INSTANCES
      typedef unsigned long xPID;/* < 2^16 Instances and < 2^8-3 Types */

      /* +---------------------------+------------------------+ */
      /* +        higher word        +       lower word       + */
      /* +---------------------------+------------------------+ */
      /* +   high byte +  low byte   + high byte +  low byte  + */
      /* +---------------------------+------------------------+ */
      /* +    <process-inst-id>      +           +  <type-id> + */
      /* +---------------------------+------------------------+ */
      /* +               xPID = unique process-id             + */
      /* +---------------------------+------------------------+ */

      #define GLOBALPID(ptype,pinst) ( ptype | (pinst << 16) )
      #define EPIDTYPE(globalpid)    ((unsigned char) globalpid & 0xff)
      #define EPIDINST(globalpid)    ((unsigned int) (globalpid >> 16) & 0xffff)

      /* Reserved Value, not available for ordinary Process-type-IDs */
      #define xNULLTYPE         0x00ff
      #define xNULLINST         0xffff

      #ifdef XMK_ADD_MICRO_TESTER
        #define xPID_STRUCT 0x54
      #endif
    #else
      typedef unsigned short xPID;/* < 2^8 Instances and < 2^8-3 Types */

      /* +---------------------------+------------------------+ */
      /* +        higher byte        +      lower byte        + */
      /* +---------------------------+------------------------+ */
      /* +    <process-inst-id>      +   <process-type-id>    + */
      /* +---------------------------+------------------------+ */
      /* +               xPID = unique process-id             + */
      /* +---------------------------+------------------------+ */
      #define GLOBALPID(ptype,pinst) ( ptype | (pinst << 8) )
      #define EPIDTYPE(globalpid)    ((unsigned char) globalpid & 0xff)
      #define EPIDINST(globalpid)    ((unsigned char) (globalpid >> 8) & 0xff)

      /* Reserved Values, not available for ordinary Process-type-IDs */
      #define xNULLTYPE         0xff
      #define xNULLINST         0xff

      #ifdef XMK_ADD_MICRO_TESTER
        #define xPID_STRUCT 0x32
      #endif
    #endif


  #else
    #ifdef XMK_USE_MORE_THAN_256_INSTANCES
      typedef unsigned long xPID; /* < 2^16 Instances < 2^16-3 Types */

      /* +---------------------------+------------------------+ */
      /* +        higher word        +       lower word       + */
      /* +---------------------------+------------------------+ */
      /* +   high byte +  low byte   + high byte +  low byte  + */
      /* +---------------------------+------------------------+ */
      /* +     <process-inst-id>     +   <process-type-id>    + */
      /* +---------------------------+------------------------+ */
      /* +               xPID = unique process-id             + */
      /* +---------------------------+------------------------+ */

      #define GLOBALPID(ptype,pinst) ( ptype | (pinst << 16) )
      #define EPIDTYPE(globalpid)    ((unsigned int) globalpid & 0xffff)
      #define EPIDINST(globalpid)    ((unsigned int) (globalpid >> 16) & 0xffff)

      /* Reserved Value, not available for ordinary Process-type-IDs */
      #define xNULLTYPE         0xffff
      #define xNULLINST         0xffff

      #ifdef XMK_ADD_MICRO_TESTER
        #define xPID_STRUCT 0x64
      #endif
    #else

      typedef unsigned long xPID; /* < 2^8 Instances < 2^16-3 Types */

      /* +---------------------------+------------------------+ */
      /* +        high   word        +       low word         + */
      /* +---------------------------+------------------------+ */
      /* +   high byte +  low byte   + high byte +  low byte  + */
      /* +---------------------------+------------------------+ */
      /* +             +  <inst-id>  +   <process-type-id>    + */
      /* +---------------------------+------------------------+ */
      /* +               xPID = unique process-id             + */
      /* +---------------------------+------------------------+ */

      #define GLOBALPID(ptype,pinst) ( ptype | (pinst << 16) )
      #define EPIDTYPE(globalpid)    ((unsigned int) globalpid & 0xffff)
      #define EPIDINST(globalpid)    ((unsigned char) (globalpid >> 16) & 0xff)

      /* Reserved Values, not available for ordinary Process-type-IDs     */
      #define xNULLTYPE         0xffff
      #define xNULLINST         0x00ff

      #ifdef XMK_ADD_MICRO_TESTER
        #define xPID_STRUCT 0x44
      #endif
    #endif

  #endif
#endif
/* Reserved Value, not available for ordinary Process-type-IDs     */

#define xNULLPID          GLOBALPID(xNULLTYPE,xNULLINST)
#define SDL_NULL          xNULLPID
#define ENV               xNULLPID - 1
#define MICROKERNEL       xNULLPID - 3      /* internal purposes */
#define SET_ENVIRONMENT   xRunPID = ENV;




/* if xPID is of a basic C-type like unsigned char or int  */
/* Assignment of PIDs in Process are easy .... .           */
#ifndef XMK_USED_ONLY_X_1
#define xEq_SDL_PId(pid1,pid2) (pid1==pid2)
#define xEq_SDL_PIdNULL(pid)   (pid==xNULLPID)
#define xDef_SDL_PId(V)       *(V) = xNULLPID;
#define yDef_SDL_PId(V)       xDef_SDL_PId(V)
#define yAssF_SDL_PId(V,E,A)  { V = E; }
#define yEqF_SDL_PId(E1,E2)   (E1==E2)
#define yNEqF_SDL_PId(E1,E2)  (E1!=E2)
#else
#define xEq_SDL_PId(pid1,pid2) (pid1==pid2)
#define xEq_SDL_PIdNULL(pid)   (pid==xNULLPID)
#define xDef_SDL_PId(V)       *(V) = xNULLPID;
#define yDef_SDL_PId(V)       xDef_SDL_PId(V)
#define yAssF_SDL_PId(V,E,A)  { V = E; }
#define yEqF_SDL_PId(E1,E2)   (E1==E2)
#define yNEqF_SDL_PId(E1,E2)  (E1!=E2)
#endif

#define yDef_xPID             yDef_SDL_PId
#define yAssF_xPID            yAssF_SDL_PId
#define yEqF_xPID             yEqF_SDL_PId
#define yNEqF_xPID            yNEqF_SDL_PId




/****+***************************************************************
10   Signal Set
********************************************************************/

/****+***************************************************************
11   Procedure ( = Prd )
********************************************************************/
  #define YPRD_YSVARP

  /* EJA Nokia Warning part 2 - moving yVarP out of YPRD_TEMP_VARS */

  #define YPRD_TEMP_VARS 

  #define YPRD_OUTPUT_SIGNAL_PTR_VAR \
          unsigned char *xmk_OutputSignalPtr;

  #define YPRD_YVARP(VDEF_TYPE) \
          VDEF_TYPE *yVarP = (VDEF_TYPE*) pRunData;

  /*
  ** Define the following macros outside this headerfile in tight
  ** integrations to be able to access pid expressions in global procedures
  ** like in output to (SENDER|PARENT|OFFSPRING|SELF).
  **
  ** The macros cover :
  **    -function declaration (XGP_.*P),
  **    -function call        (XGP_.*C),
  **    -function definition for ANSI C (XGP_.*D).
  **    -function definition for KR C (XGP_.*K and XGP_.*_KD).
  ** For each of the above, there is one macro for a GP with parameters (XGP_PARAM_.*)
  ** and one further macro for a GP without parameters (XGP_NOPARAM.*).
  */

  /* Global PRD with FPAR */

  #ifndef XGP_PARAM_P
    #define XGP_PARAM_P
  #endif

  #ifndef XGP_PARAM_C
    #define XGP_PARAM_C
  #endif

  #ifndef XGP_PARAM_D
    #define XGP_PARAM_D
  #endif

  #ifndef XGP_PARAM_K
    #define XGP_PARAM_K
  #endif

  #ifndef XGP_PARAM_KD
    #define XGP_PARAM_KD
  #endif

  /* Global PRD without FPAR */

  #ifndef XGP_PARAM_PE
    #define XGP_PARAM_PE
  #endif

  #ifndef XGP_PARAM_CE
    #define XGP_PARAM_CE
  #endif

  #ifndef XGP_PARAM_DE
    #define XGP_PARAM_DE
  #endif

  #ifndef XGP_PARAM_KE
    #define XGP_PARAM_KE
  #endif


/****+***************************************************************
12   Process ( = Prs )
********************************************************************/

/* The following ID is reserved and not available for Symbolnumber    */
#define XSTART_TRANSITION 0                /* Symbolnumber in yPAD-Function */

/* The following ID is reserved and not available for signals !       */
#define XUNDEF_SIGNAL     -1
#define XFIRSTSIGNALID   ((xmk_T_SIGNAL) 0x01) /* for sym - module          */

/* The following IDs   are reserved and not available for             */
/* Proces-state-values.                                               */
#define XFIRSTSTATEID    ((xmk_T_STATE)  0x0001) /* for sym - module          */
#define XCREATION        ((xmk_T_STATE)  0xfffa)
#define XEMPTYSTATEID    ((xmk_T_STATE)  0x0000)
#define XDORMANT         ((xmk_T_STATE)  0xfffc) /* <process-state-table>     */
#define XNOTEXISTENT     ((xmk_T_STATE)  0xfffd) /* for sym - module          */
#define XDASHSTATE       ((xmk_T_STATE)  0xfffe)
#define XSTARTUP         ((xmk_T_STATE)  0xffff) /* <process-state-table>     */

#define XSAVEID          (xSYMBOLNR) 0xfffe  /* for xSYMBOLNUMBER type  */

#define X_END_ROOT_TABLE (XCONST XPDTBL xmk_ROM_ptr) 0xffff
                                         /* Table-end of <Root-Table> */

#if !defined(XMK_USE_MORE_THAN_250_SIGNALS)
  typedef unsigned char    xINPUT;       /*                           */
#else
  typedef unsigned int     xINPUT;       /*                           */
#endif

/* The following ID is reserved and not available for ordinary SIG-ID */
#define XASTERISK        (xINPUT)    0xfffd


typedef unsigned char    xINSTD;         /*                           */
typedef xptrint          xINSTDLEN;      /*                           */

/*
** <state-index-table>
*/
#ifdef XMK_USE_HUGE_TRANSITIONTABLES
  /*
  ** <state-index-table>  for huge systems
  */
  typedef int xSITBL;
#else
  /*
  ** <state-index-table>  for tiny systems
  */
  typedef unsigned char xSITBL;
#endif /* ... XMK_USE_HUGE_TRANSITIONTABLES */

/*
** <Transition-table>
*/
   typedef struct {
      xINPUT               SignalID;
      xSYMBOLNR            SymbolNr;
   } xTR_TABLE_ENTRY;

   typedef xTR_TABLE_ENTRY xTRTBL;

/*
** <PID-Table>
*/
#if defined(XMK_USED_PARENT) || defined(XMK_USED_OFFSPRING)
   typedef struct
   {
      #ifdef XMK_USED_PARENT
      xPID            Parent;
      #endif

      #ifdef XMK_USED_OFFSPRING
      xPID            Offspring;
      #endif

   } xPIDTable;
#endif

/*
** <Process-description-table>
*/

   typedef struct {

   #if defined(XMK_USED_PARENT) || defined(XMK_USED_OFFSPRING)
      xPIDTable       xmk_RAM_ptr pPIDTable; /* Pointer to PIDs for each */
                                             /* instance                   */
   #endif

      xINSTD          * pInstanceData ;    /* Pointer to Instancedata */
                                           /* Vector                     */
      xINSTDLEN        DataLength ;        /* Length of Instancedata     */
                                           /* for 1 Instance             */
                                           /* (used by SDL-BS)           */
      xmk_T_INSTANCE   MaxInstances ;      /* Max.Number of Instances    */


          #ifdef XMK_USE_TIMESLICE
            /* For special form of integration not included in SDT/Tau */
            /* product release : Time slicing.                         */
            xmk_T_TIMESLICE TimeSlice;
          #endif

      #ifdef XMK_USE_PREEMPTIVE
         /* Process-Priority can be specified with #PRIO on the SDL-Level */
         /* It is available only, if the Cmicro Kernel is scaled to       */
         /* handle preemption.                                            */
         xmk_T_PRIOLEVEL PrioLevel;
      #endif

      xmk_T_TRANS_ADDRESS yPAD_Function ; /* Address of the yPAD-Function*/

      XCONST xTRTBL           xmk_ROM_ptr TransitionTable ;
      XCONST xSITBL           xmk_ROM_ptr StateIndexTable ;
      xSTATE                  xmk_RAM_ptr ProcessStateTable ;

   } XPDTBL;
 
/****+***************************************************************
13   Timer
********************************************************************/



/****+***************************************************************
14   Signal
********************************************************************/
typedef struct
{
   #ifdef XMK_USE_RECEIVER_PID_IN_SIGNAL
      xPID              rec;         /* Receiving process                     */
   #endif

   xmk_T_SIGNAL         signal;      /* Signalcode                            */

   #ifdef XMK_USE_SIGNAL_PRIORITIES
      xmk_T_PRIO        prio;        /* Priority                              */
   #endif

   #ifdef XMK_USE_SIGNAL_TIME_STAMP
      xmk_T_TIME        timestamp;   /* Timestamp, filled through xmk_NOW()   */
                                     /* at SDL Output                         */
   #endif

   #ifdef XMK_USE_SENDER_PID_IN_SIGNAL
      xPID              send;        /* Sending process                       */
   #endif

   #if defined(XMK_USED_SIGNAL_WITH_PARAMS) || defined(XMK_USED_TIMER_WITH_PARAMS)
     xmk_T_MESS_LENGTH mess_length; /* Length of Signalparameters ..            */
                                    /* Assume, XMK_MSG_BORDER_LEN is 4, then :  */
                                    /* If length <= 4 Bytes: Data is copied  .. */
                                    /* .. into ParCopy ..                       */
                                    /* else, if                                 */
                                    /* .. length > 4 Bytes: Data is copied into */
                                    /* .. a malloc area, and ParPtr points to it*/
     #if defined  (XFREESIGNALFUNCS) && defined (XMK_USED_SIGNAL_WITH_DYN_PARAMS)
        void xmk_RAM_ptr FreePtr;
     #endif

     union
     {
        void            xmk_RAM_ptr ParPtr; /* Pointer Signalparameter */

        #if (XMK_MSG_BORDER_LEN > 0)
          unsigned char ParCopy[XMK_MSG_BORDER_LEN];
        #endif
     } ParUnion ;
   #endif

} xmk_T_MESSAGE;


typedef struct _T_E_SIGNAL
{
  /*
  ** Adress of a signal instance
  */
  xmk_T_MESSAGE       Signal;

  /*
  ** Pointer to successor signal instance
  */
  struct _T_E_SIGNAL xmk_RAM_ptr next;

  #ifdef XMK_USED_SAVE
    /*
    ** The state of the process when a signal is saved.
    */
    xmk_T_STATE         SaveState;
  #endif /* XMK_USED_SAVE */
} T_E_SIGNAL ;

#ifdef XFREESIGNALFUNCS
  extern void cm_Free_Signal (void*);
#endif

/****+***************************************************************
15   Symbol Table
********************************************************************/


/****+***************************************************************
16   Global Data Structure
********************************************************************/

/****+***************************************************************
221  _sche
********************************************************************/
/* Global Variables to access PIDs , Instancedata, Inputport etc...*/
extern xPID       xRunPID ;     /* Currently active SDL-Process-   */
                                /* Instance                        */

#if defined(XMK_USED_PARENT) || defined(XMK_USED_OFFSPRING)
extern xPIDTable xmk_RAM_ptr pRunPIDTable;
                                /* Table with PID-Values of        */
                                /* currently active processinst.   */
#endif

extern xmk_T_MESSAGE  xmk_RAM_ptr xmk_SignalInstPtr ;
                                /* Pointer to SDL-Signalparameters */
                                /* currently worked on (NULL in a  */
                                /* Start-Transition)               */
extern xINSTD        xmk_RAM_ptr pRunData;
                                /* Pointer to Data of currently    */
                                /* running SDL-Processinstance     */

#ifdef XMK_USE_PREEMPTIVE
extern T_E_SIGNAL  xmk_RAM_ptr Prio_Queue[];
extern T_E_SIGNAL  xmk_RAM_ptr Prio_CurrentSignal[];
extern xmk_T_PRIOLEVEL HighestPrioLevel;
#endif

#include "mk_sche.h"


/****+***************************************************************
222  _queu
********************************************************************/
#ifdef XMK_USE_PREEMPTIVE

#define XMK_QUEUE_ADR xmk_Queue
#define XMK_QUEUE     xmk_RAM_ptr xmk_Queue
#define XMK_QUEUE_PTR xmk_RAM_ptr xmk_RAM_ptr xmk_Queue

#define XMK_CURRENTSIGNAL_ADR xmk_CurrentSignal
#define XMK_CURRENTSIGNAL     xmk_RAM_ptr xmk_CurrentSignal
#define XMK_CURRENTSIGNAL_PTR xmk_RAM_ptr xmk_RAM_ptr xmk_CurrentSignal

#else

#define XMK_QUEUE_ADR &xmk_Queue
#define XMK_QUEUE     xmk_Queue
#define XMK_QUEUE_PTR xmk_RAM_ptr xmk_Queue

#define XMK_CURRENTSIGNAL_ADR &xmk_CurrentSignal
#define XMK_CURRENTSIGNAL     xmk_CurrentSignal
#define XMK_CURRENTSIGNAL_PTR xmk_RAM_ptr xmk_CurrentSignal

#endif

extern T_E_SIGNAL XMK_QUEUE_PTR;
extern T_E_SIGNAL XMK_CURRENTSIGNAL_PTR;


#include "mk_queu.h"


/****+***************************************************************
223  _time
********************************************************************/

#include "mk_time.h"

/****+***************************************************************
224  _stim
********************************************************************/

extern void       xmk_InitSystime   ( void );
extern void       xmk_SetTime       ( xmk_T_TIME );
extern xmk_T_TIME xmk_NOW           ( void );


/****+***************************************************************
225  _err
********************************************************************/
#ifndef XMK_USE_NO_ERR_CHECK
  #include "ml_err.h"
#endif
/****+***************************************************************
226  _outp
********************************************************************/

#include "mk_outp.h"

/****+***************************************************************
227  _user
********************************************************************/

  #ifdef XLI_LIGHT_INTEGRATION
    extern void xmk_QueryOSQueue ( void );
    #include XLI_INCLUDE
  #else
    /*
    ** Light integration macros
    */
    #define XLI_TEMP_TASK_VARS
    #define XLI_TEMP_QUEUE_VARS    
    #define XLI_OS_TASK_INIT
    #define XLI_CREATE_OS_QUEUE
    #define XLI_START_OS_TASK_SYNC
    #define XLI_END_OS_TASK_SYNC
    #define XLI_OS_QUEUE_ID
    #define XLI_GET_NEXT_MESSAGE_FROM_OS_QUEUE
    #define XLI_LISTEN_ON_OS_QUEUE_WITH_TIMEOUT(TIMEOUT)
    #define XLI_LISTEN_ON_OS_QUEUE_NO_TIMEOUT
  #endif


  #ifndef XMK_xInEnv_PARTYPE
    #define XMK_xInEnv_PARTYPE void
  #endif

  #ifndef XMK_xInEnv_PARNAME
    #define XMK_xInEnv_PARNAME
  #endif

  /*
  ** SDL Environment functions to be filled out by user
  */  
  #ifdef XMK_USE_xInitEnv
    extern void xInitEnv        ( void );
  #endif
  
  #ifdef XMK_USE_xCloseEnv
    extern void xCloseEnv       ( void );
  #endif
  
  #ifdef XMK_USE_xInEnv
    extern void xInEnv          ( XMK_xInEnv_PARTYPE );
  #endif

  #ifndef XMK_USE_NO_ERR_CHECK
    extern void ErrorHandler    (xmk_T_ERR_INF);
  #endif
  
  #if defined  (XMK_USERFREESIGNALFUNC) && defined (XMK_USED_SIGNAL_WITH_DYN_PARAMS)
    extern void xmk_UserFreeSignal    ( xmk_T_MESSAGE xmk_RAM_ptr );
  #endif

  #ifdef XMK_USE_KERNEL_WDTRIGGER
    extern void WatchdogTrigger   ( void );
    extern void xmk_InitWatchdog  ( void );
    #define XMK_WDTRIGGER_FUNCTION    WatchdogTrigger ( );
  #endif

  #ifndef XMK_USE_RECEIVER_PID_IN_SIGNAL
    extern xPID xRouteSignal       (xmk_T_SIGNAL);
  #endif

  #ifdef XMK_USED_SIGNAL_WITH_PARAMS
    #define XOUTP_PARA_NON_LAST xmk_T_MESS_LENGTH,void xmk_RAM_ptr,
    #define XOUTP_PARA_LAST     xmk_T_MESS_LENGTH,void xmk_RAM_ptr
  #else
    #define XOUTP_PARA_NON_LAST
    #define XOUTP_PARA_LAST
  #endif


  #ifdef XMK_USE_xOutEnv

    #if defined(XMK_USE_SIGNAL_PRIORITIES) && defined(XMK_USE_RECEIVER_PID_IN_SIGNAL)
      /*
      ** Each signal contains a Signal priority
      ** Each signal contains a Receiver PID
      */
      extern xmk_OPT_INT xOutEnv ( xmk_T_SIGNAL, xmk_T_PRIO, XOUTP_PARA_NON_LAST xPID );

    #endif

    #if defined(XMK_USE_SIGNAL_PRIORITIES) && !defined(XMK_USE_RECEIVER_PID_IN_SIGNAL)
      /*
      ** Each signal contains a Signal priority
      ** No   signal contains a Receiver PID
      */
      extern xmk_OPT_INT xOutEnv ( xmk_T_SIGNAL, xmk_T_PRIO, XOUTP_PARA_LAST );
    #endif

    #if !defined(XMK_USE_SIGNAL_PRIORITIES) && defined(XMK_USE_RECEIVER_PID_IN_SIGNAL)
      /*
      ** No   signal contains a Signal priority
      ** Each signal contains a Receiver PID
      */
      extern xmk_OPT_INT xOutEnv ( xmk_T_SIGNAL, XOUTP_PARA_NON_LAST xPID );
    #endif


    #if !defined(XMK_USE_SIGNAL_PRIORITIES) && !defined(XMK_USE_RECEIVER_PID_IN_SIGNAL)

      #ifdef XMK_USED_SIGNAL_WITH_PARAMS
        /*
        ** No   signal contains a Signal priority
        ** No   signal contains a Receiver PID
        */
        extern xmk_OPT_INT xOutEnv ( xmk_T_SIGNAL, XOUTP_PARA_LAST );
      #else
        /*
        ** No   signal contains a Signal priority
        ** No   signal contains a Receiver PID
        */
        extern xmk_OPT_INT xOutEnv ( xmk_T_SIGNAL );
      #endif

    #endif

  #endif /* ...XMK_USE_xOutEnv */

  #undef  XOUTP_PARA_NON_LAST
  #undef  XOUTP_PARA_LAST



/****+***************************************************************
228  _main
********************************************************************/

#include "mk_main.h"

/****+***************************************************************
229  Cmicro Tester
********************************************************************/
#ifdef XMK_ADD_MICRO_TESTER


/*
** Switches to add some code ...
*/
/*
+-----------------------------------------------------------------------------+
|         XMK_ADD_PROFILE                Using the mini profiler ...          |
|                                                                             |
|         XMK_ADD_TRACE_BUF              adds functionality of trace into     |
|                                        the RAM, which is used for target    |
|                                        applications.                        |
|                                                                             |
|         XMK_ADD_MICRO_COMMAND          adds functionality of sending and    |
|                                        receiving commands via serial link   |
|                                                                             |
|         XMK_ADD_MICRO_TRACER           adds functionality of the tracer     |
|                                        -unused- ??                          |
|                                                                             |
|         XMK_ADD_MICRO_RECORDER         adds functionality of recording      |
|                                        SDL and systemevents                 |
|                                                                             |
|         XMK_ADD_SIGNAL_FILTER          adds functionality of filtering      |
|                                        signals, in order to reduce trace    |
|                                        information ....                     |
|                                                                             |
|         XMK_ADD_STDOUT_TRACE           trace on STDOUT, if kernel running   |
|                                        on a system which supports STDOUT    |
|                                                                             |
|         XMK_ADD_FILE_TRACE             trace into file, if kernel running   |
|                                        on a system which supports files     |
|                                        e.g.has a harddisk ...               |
|                                                                             |
|         XMK_USE_COMMLINK               trace via V.24, if kernel running    |
|                                        on a system which supports a V.24    |
|                                        (or any serial communication link)   |
|                                                                             |
+-----------------------------------------------------------------------------+
*/

  /*
  ** Dimensioning ...
  */
  #define XMK_MAX_LEN_SYMBOL_NAME 256   /* for tasks and procedure names      */

  /*
  ** Maximum of symbols to count for record and play
  ** of the Cmicro Recorder
  */
  #define XMK_MAX_RECORDED_EVENT  10000

  /*
  ** Switches for the Cmicro Tracer
  */
  #ifdef XMK_ADD_MICRO_TRACER

    #define XMK_ADD_TOPTIONS              /* dynamic selection of SDL and          */
                                          /* Systemevents to trace                 */ 
    #define XMK_ADD_TSET                  /* Code to trace SDL - Set   ?           */
    #define XMK_ADD_TRESET                /* Code to trace SDL - Reset ?           */
    #define XMK_ADD_TSTATIC_CREATE        /* Code to trace SDL - static creation ? */
    #define XMK_ADD_TCREATE               /* Code to trace SDL - dynamic creation ?*/
    #define XMK_ADD_TDYNAMIC_CREATE       /* Code to trace SDL - create ?          */
    #define XMK_ADD_TINPUT                /* Code to trace SDL - input ?           */
    #define XMK_ADD_TOUTPUT               /* Code to trace SDL - output ?          */
    #define XMK_ADD_TSYS_SCHEDULE         /* Code to trace System scheduling ?     */
  #endif

  /*
  ** Switches for the Cmicro Tracer - Commands
  */
  #ifdef XMK_ADD_MICRO_COMMAND
    #define  XMK_USE_CMD_ERROR
    #define  XMK_USE_CMD_SCHEDULE
    #define  XMK_USE_CMD_SHOWPRIO
  #endif

  /*
  ** The different classes of information
  ** on the communication interface - codevalues
  ** These values are used in the "cod" module
  ** and may be changed only when knowing some
  ** internal details. Look to the coder modules.
  */
  #define XMK_MICRO_COMMAND     0xf0
  #define XMK_MICRO_TRACER      0xf1
  #define XMK_MICRO_RECORDER    0xf2
  #define XMK_SELF_TEST_SDTMT   0xf3
  #define XMK_MICRO_ENVIRONMENT 0xf4


  /*
  **  ATTENTION !! ATTENTION !! ATTENTION !! ATTENTION !! ATTENTION !!
  ** The Message Tags for the Cmicro Tester command, traces and recorder functions
  ** are generated by TMCOD
  ** See tmcod.h and tmsgdefs.rc in the mcod directory !!
  */


  /*
  ** Bitfield stored for each process in the system, the environment,
  ** and the Cmicro Kernel, to remember
  ** the trace options set by opt - Module
  ** The bitfield may be defined as int or char, the values TSDL_* following
  ** here have to be combined then, e.g.TSDL_INPUT/TSDL_OUTPUT/TSDL_NEXTSTATE/
  ** and TSDL_SAVE may be one bit in a char value.
  ** However, if the type is modified to something different from long,
  ** then sdtmt must be re-compiled.
  */
  typedef  long xmk_TRACE_SELECT;

  /*
  ** Trace options for SDL events
  ** The following values are values of the type xmk_TRACE_SELECT
  */
  #define  TSDL_STATE                 0x00000001L
  #define  TSDL_INPUT                 0x00000002L
  #define  TSDL_SAVE                  0x00000004L
  #define  TSDL_OUTPUT                0x00000008L
  #define  TSDL_CREATE                0x00000010L /* executing the create symbol */
  #define  TSDL_STOP                  0x00000020L
  #define  TSDL_STATIC_CREATE         0x00000040L /* executing the start trans.  */
  #define  TSDL_DYNAMIC_CREATE        0x00000080L /* executing the start trans.  */
  #define  TSDL_DECISION              0x00000100L
  #define  TSDL_TASK                  0x00000200L
  #define  TSDL_PROCEDURE             0x00000400L

  #define  TSDL_TIMER                 0x00001000L
  #define  TSDL_SET                   0x00002000L
  #define  TSDL_RESET                 0x00004000L
  #define  TSDL_ACTUAL_RESET          0x00008000L /* Reset, when set is performed */
  #define  TSDL_SIGNALPARAMS          0x00010000L
  #define  TSDL_DISCARD               0x00020000L
  #define  TSDL_IMPLICIT_CONSUMPTION  0x00040000L

  /*
  ** Trace options for system events
  */
  #define  TSYS_SCHEDULE              0x10000000L
  #define  TSYS_ERROR                 0x20000000L
  #define  TSYS_SHOWPRIO              0x40000000L

  /*
  ** subsection 228-051
  ** Bitmasks for the configuration
  */

  /*
  ** Kernel configuration. If set the item is compiled (included in the target executable
  */
  #define CONF_PREEMPTION              0x00000001L
  #define CONF_SIG_PRIO                0x00000002L
  #define CONF_RECEIVER_PID            0x00000004L
  #define CONF_SENDER_PID              0x00000008L
  #define CONF_SEND_SIMPLE             0x00000010L
  #define CONF_PID_ADDRESSING          0x00000020L
  #define CONF_SYSTEM_STOP             0x00000040L
  #define CONF_ERROR_CHECKS            0x00000080L
  #define CONF_USED_TIMER              0x00000100L
  #define CONF_USED_DYNAMIC_CREATE     0x00000200L
  #define CONF_USED_DYNAMIC_STOP       0x00000400L
  #define CONF_USED_SAVE               0x00000800L
  #define CONF_USED_ONLY_X_1           0x00001000L
  #define CONF_USED_TIMER_WITH_PARAMS  0x00002000L
  #define CONF_TIGHT_INTEGRATION       0x00004000L
  /*
  ** Cmicro Tester Configuration. If set the item is compiled (included in the target
  */
  #define CONF_MICRO_COMMAND           0x00010000L
  #define CONF_MICRO_PROFILE           0x00020000L
  #define CONF_MICRO_DEBUGGING         0x00040000L
  #define CONF_MICRO_TRACER            0x00080000L
  #define CONF_MICRO_SDLE_TRACE        0x00100000L
  #define CONF_MICRO_PSC_TRACE         0x00200000L
  #define CONF_MICRO_SIGNAL_FILTER     0x00400000L
  #define CONF_MICRO_TIME_STAMP        0x00800000L
  #define CONF_MICRO_RECORDER          0x01000000L
  #define CONF_MICRO_REALTIME_PLAY     0x02000000L
  #define CONF_MICRO_AUTO_MCOD         0x04000000L

  /*
  ** Cmicro Tester runtime configuration
  */
  #define CONF_TRACE_ON                0x10000000L
  #define CONF_RECORD_ON               0x20000000L
  #define CONF_PLAYER_ON               0x40000000L
  #define CONF_REALTIME_PLAYER_ON      0x80000000L



   /*
  **  ATTENTION !! ATTENTION !! ATTENTION !! ATTENTION !! ATTENTION !!
  ** The Message typedefs for the Cmicro Tester command, traces and recorder functions
  ** are generated by TMCOD
  ** See tmcod.h and tmsgdefs.rc in the mcod directory !!
  */

  /*
  ** function exported by the sche - module
  */
  extern xmk_T_STATE xmk_GetProcessState   ( xPID );


  /*
  ** maximum of chars per word
  */
  #undef  XMK_MAX_WORD_LEN
  #define XMK_MAX_WORD_LEN       256

  /*
  ** maximum amount of trace parameters
  */

  /*
  ** on target side the maximum amount of trace parameters must
  ** fit into the send buffer of the ring buffer
  ** 12 = message header + ...
  */
  #define XMK_MAX_TSDL_PARAM (XMK_MAX_SEND_ONE_ENTRY - 12)


  /*
  ** Message Tags included here !!!!!
  */
  #include "tmcod.h"

  /*
  ** From module ml_mem
  */
  extern void xmk_QueryMemory ( xmk_T_CMD_QUERY_MEMORY_CNF xmk_RAM_ptr );

  /*
  ** From module mk_queu
  */
  extern void xmk_QueryQueue ( xmk_T_CMD_QUERY_QUEUE_CNF xmk_RAM_ptr );

  /*
  ** From module mk_time
  */
#if defined(XMK_SYSTEM_INFO) || (defined(XMK_USE_DEBUGGING) && defined(XMK_ADD_CQUERY_TIMER))
  extern void xmk_QueryTimer ( xmk_T_CMD_QUERY_TIMER_CNF *);
#endif

#else

  typedef struct
  {
    int                 max_allowed_entries;
    int                 max_counter;
    int                 howmany;
    long                address;
  }  xmk_T_CMD_QUERY_QUEUE_CNF;

  typedef struct
  {
    xmk_T_TIME          now;
    int                 max_allowed_entries;
    int                 max_counter;
    int                 howmany;
    long                address;
  }  xmk_T_CMD_QUERY_TIMER_CNF;

#endif /* ... XMK_ADD_MICRO_TESTER */


#ifdef XMK_ADD_SIGNAL_FILTER
  #define XMK_ALLOW_ALL ((xmk_T_SIGNAL) 0xffffL)
#endif


/*
** Definitions for trace into the RAM on target ...
*/
#ifdef XMK_ADD_TRACE_BUF
  /*
  ** subsection 228-8
  ** Trace into the RAM within the target system
  ** The information trade can be retrieved either
  **    * by using a emulator / debugger
  **    * or by using the Cmicro Tester Command CMD_TBUF_REQ / CMD_TBUF_CNF
  */

  /* Minimum of information to be traced into RAM */
  typedef struct {

    xmk_T_SIGNAL       signal   ;
    xPID               process  ;
    xmk_T_STATE        state    ;
    xmk_T_ERR_NUM      error    ;

  } xmk_TBF_ENTRY ;

#endif /* ... XMK_ADD_TRACE_BUF */

#if defined(XMK_ADD_MICRO_TESTER)

  #include "mt_cod.h"
  #include "mt_opt.h"
  #include "mt_tsdl.h"
  #include "mt_tsys.h"

#endif

#if defined(EXTERNAL)

  #include "mt_codh.hpp"
  #include "mt_opt.h"
  #include "mt_tsdl.h"
  #include "mt_tsys.h"

#endif

/*
** Controlblock for ringbuffer trace in the memory (target)
*/
typedef struct {
  int            counter  ;        /* internal read/write counter  */
  int            buffersize     ;  /* buffersize                   */
  int            maximumentries ;  /* maximum amount of entries    */
  int            entrysize ;       /* size of one entry            */
  unsigned char  ctrl      ;       /* XMK_FIFO or XMK_RING         */
  char  xmk_RAM_ptr p_write ;      /* internal write pointer       */
  char  xmk_RAM_ptr p_read  ;      /* internal read pointer        */
  char  xmk_RAM_ptr p_buffer;      /* pointer to the ring buffer   */
} xmk_T_RING ;


#define XMK_OVERFLOW       -2      /* tag for ringbuffer full      */
#define XMK_FIFO           0       /* Use fifo a like control      */
#define XMK_RING           1       /* Use ringbuffer control       */

#include "ml_buf.h"



#ifdef XMK_ADD_MICRO_RECORDER
  #include "mt_rec.h"
  #include "mt_play.h"
#endif

#ifdef XMK_ADD_MICRO_TESTER
  #include "mg_dl.h"
#endif

#ifdef XMK_USE_MON
  #include "ml_mon.h"
#endif


extern int              xmk_GetChar      ( void );
#if defined (XMK_USE_OS_ENVIRONMENT)
  extern void             xmk_TermInit     ( void );
  extern void             xmk_TermDeinit   ( void );
#endif
extern void xmk_RAM_ptr xAlloc           (xptrint);
extern void             xFree            (void xmk_RAM_ptr xmk_RAM_ptr);

/*
** The following is used to allocate memory for predefined sorts
*/

#define XALLOC(size,idnode) (size>0 ? xAlloc(size) : 0)
#define XFREE(p,size)       xFree(p)

/*
** The following is used to allocate memory for sort "ref"
*/
#define XMALLOC(SIZE,REF_SORT) xAlloc(SIZE)

#ifdef XMK_ADD_MICRO_TESTER

  #ifdef XMK_ADD_MICRO_COMMAND
    /*
    ** The following flags may be used to reduce the amount of
    ** memory wanted for the Cmicro Tester, if some functionalities
    ** can be left out. Simply set it undef, if you don't want to use
    ** a specific command.
    */
    #ifdef XMK_ADD_CTIMER
      #define XMK_ADD_CDISABLE_TIMER
      #define XMK_ADD_CENABLE_TIMER
      #define XMK_ADD_CSET_TIMER
      #define XMK_ADD_CRESET_TIMER
      #define XMK_ADD_CRESET_ALL_TIMERS
      #define XMK_ADD_CSCALE_TIMERS
      #define XMK_ADD_CACTIVE_TIMER
    #endif /* .. XMK_ADD_CTIMER */

    #ifdef XMK_ADD_CSIGNAL
      #define XMK_ADD_CRM_QUEUE
      #define XMK_ADD_CFLUSH_SIGNAL_BY_SID
      #define XMK_ADD_CFLUSH_SIGNALS_BY_PID

    #endif /* .. XMK_ADD_CSIGNAL */

    #ifdef XMK_USE_DEBUGGING
      #ifdef XMK_ADD_CSTEPPING
        #define XMK_ADD_CSINGLE_STEP
        #define XMK_ADD_CNEXT_STEP
      #endif /* .. XMK_ADD_CSTEPPING */

      #ifdef XMK_ADD_CSYSTEMCTRL
        #define XMK_ADD_CSUSPEND
        #define XMK_ADD_CRESUME
        #define XMK_ADD_CREINIT
        #define XMK_ADD_CSHUTDOWN
      #endif /* .. XMK_ADD_CSYSTEMCTRL */

      #ifdef XMK_ADD_CBREAK_LOGIC
        #define XMK_ADD_CCONTINUE
        #ifndef XMK_MAXBREAKPOINTS
          #define XMK_MAXBREAKPOINTS   4
        #endif
      #endif /* .. XMK_ADD_CBREAK_LOGIC */
    #endif /* .. XMK_USE_DEBUGGING */

    #define XMK_USE_CMD_KILL

    #undef  XMK_ADD_CTBUF_REQ       /* not implemented for comm.interface */
  #endif /* ... XMK_ADD_MICRO_COMMAND */


  #if defined(XMK_ADD_CQUERY_PROCESS)
    typedef struct
    {
      xmk_T_TIME LastTime ;
      xmk_T_TIME MaxTime  ;
    } xmk_T_PRS_PROF ;
  #endif

  #include "mt_deb.h"
  #include "mt_cmd.h"

#endif /* ... XMK_ADD_MICRO_TESTER */

/*
** for testenvironment
*/
#ifdef XMK_RITS

  #ifdef XMK_USE_SDL_SYSTEM_STOP
    #define XMK_RITS_TEST_OK  \
       xmk_RITS_result = 2;
    #define XMK_RITS_TEST_NOK \
       xmk_RITS_result = 3;
  #else
    #define XMK_RITS_TEST_OK  \
       exit (2);
    #define XMK_RITS_TEST_NOK \
       exit (3);
  #endif

  #define XMK_RITSPRINT(a)
  #define XMK_RITSPRINT1(a,b)
  #define XMK_RITSPRINT2(a,b,c)
  #define XMK_RITSPRINT3(a,b,c,d)
 
  xmk_T_ERR_INF experr;
  extern int xmk_RITS_result;
#endif

#endif /* __ML_TYP_H_ */

