/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*+MHDR*/
/*
+------------------------------------------------------------------------------+
#  Modulname: mp_lib.h (Unix Version)
+------------------------------------------------------------------------------+
*/
/*-MHDR*/

#ifndef _MP_LIB_H
#define _MP_LIB_H

#ifdef __cplusplus
extern "C" {
#endif


/*
**  This define used for RPC-like communication
*/
#define MPM_WAITFOREVER -1

/*
**  return value for MPM-functions
*/
#define MPM_OK          0
#define MPM_ERROR       -1



/*
**  functional interface for MPM
*/

#ifdef XMK_WINDOWS
   This_file_mp_lib_c_must_be_adapted_for_Windows;
#elif defined (XMK_UNIX)
    /* for MPMListen : */
    #define MPM_NO_BLOCKING 1
    #define MPM_BLOCKING    2

    #ifndef  MPM_IS_DISCONNECTED  
      #define MPM_IS_DISCONNECTED  -1 /* return value from MPMListen */
    #endif

    int  StartTools(int);
    int  StartGate(char*);
    int  split_name(char *, char *, char *, char *);
    int  MPMInit(int);
    int  MPMSendToTool(int, int, void*, int);
    int  MPMSendToPid(int, int, void*, int);
    int  MPMBroadcast(int, void*, int);
    int  MPMListen (int);
    int  MPMRead (int, int, int, char*, int*);
    int  MPMExit(int);
#else
  The_Cmicro_Postmaster_is_available_only_for_Windows_or_UNIX;
#endif

/*
**  This function must be spent by the user
**  The parameters are:
**
**                        1. int    - message sender
**                        2. int    - message tag
**                        3. int    - message length
**                        4. void * - message data
**
** For socket - MPM : 
** MPMReceive will be called
** within MPMListen when a message was received
*/

extern void MPMReceive(int, int, int, void*);

#ifndef SDTMPM

  #define SendToGATE(msg, data, len)     MPMSendToTool(ID_SDTGATE, msg, data, len);
  #define SendToUI(msg, data, len)       MPMSendToTool(ID_SDTMTUI, msg, data, len);
  #define SendToSDTMT(msg, data, len)    MPMSendToTool(ID_SDTMT, msg, data, len);
  #define SendToLINK(msg, data, len)     MPMSendToTool(ID_SDTLINK, msg, data, len);
  #define SendToEXTERNAL(msg, data, len) MPMSendToTool(ID_EXTERNAL, msg, data, len);

  extern char MPMBuffer[];
#endif

#ifdef __cplusplus
}
#endif


#endif /* ... _MP_LIB_H */
