/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

/*+MHDR*/
/*
+------------------------------------------------------------------------------+
#  Modulname: mk_main.c
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|  This module contains the functions of the toplevel, which are to be called  |
|  by the user of the Cmicro Kernel, namely                                    |
|                                                                              |
|  -void xmk_InitSDL     ( void )                                              |
|  -void xmk_RunSDL      ( void )                                              |
|                                                                              |
|  There is another function that must be called by the user, before           |
|  xmk_InitSDL and xmk_RunSDL can be used :                                    |
|                                                                              |
|  -void xmk_InitQueue   ( void ) from the mk_queu module.                     |
|                                                                              |
|  The last function is necessary in any case if the Cmicro Tester is to be    |
|  used. This function must be called first before the queue is initialized.   |
|                                                                              |
|  -void xmk_DebugInit   ( void ) from the mt_deb  module.                     |
|                                                                              |
|  If a user forgets to call xmk_InitQueue there might be a call to the        |
|  ErrorHandler, if the Error handling is correctly configured.                |
|                                                                              |
|  Also the users have to fill up some other modules which define environment- |
|  handling, the ErrorHandler etc. These modules reside below the "template"   |
|  directory.                                                                  |
|                                                                              |
|  M1 Errormessages, which are routed to the ErrorHandler                      |
|  --------------------------------------------------------                    |
|    ERR_N_INIT_QUEUE      The queue is not correctly initialized              |
|    ERR_N_ILLEGAL_CMD     There was an unknown command received               |
|                          from Cmicro Tester                                  |
|                                                                              |
|  M2 Exported functions of this module :                                      |
|  --------------------------------------------------------                    |
|                                                                              |
|    void            xmk_InitSDL          ( void )                             |
|    void            xmk_RunSDL           ( void )                             |
|    void            xmk_MicroTesterInit( int flag )                           |
|    void            xmk_MicroTesterDeinit( void )                             |
|                                                                              |
|  M3 Static functions of this module :                                        |
|  --------------------------------------------------------                    |
|                                                                              |
|    static int      xmk_GetHostCmd       (void)                               |                                                                  |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-MHDR*/

#ifndef __MK_MAIN_C_
#define __MK_MAIN_C_


/*+IMPORT*/
/*====================  I M P O R T  =========================================*/
#include "ml_typ.h"

/*============================================================================*/
/*-IMPORT*/


/****+***************************************************************
     C++ specific
********************************************************************/
#ifdef __cplusplus
void * operator new (size_t pp, xSpecial vv) {
  return (void *)vv;
}
#endif


/*+MGG*/
/*====================  V A L U E S  O F  T H I S   M O D U L E  =============*/

/*--------------------  Constants,  Macros  ----------------------------------*/

/*
**  System is to be shutdowned when user
**  wants to.
**  Shutdown is implemented close the environment
**  and exit in the following ...
*/

#ifdef XMK_USE_xCloseEnv
  #define XMK_CLOSE_ENV xCloseEnv ();
#else
  #define XMK_CLOSE_ENV
#endif

#define XMK_MAIN_SHUTDOWN \
               if (xmk_SystemState & XMK_SYSTEM_SHUTDOWN) \
               { \
                 XMK_CLOSE_ENV; \
                 XMK_KERNEL_EXIT (0); \
               }


/*
** The following is the encoding function of the cod - module
** which is used for the serial interface ...
*/
#define ENCODE_NPAR(IDtag)  \
        xmk_Cod_Encode (XMK_MICRO_COMMAND,IDtag,(char*)NULL,0);

#define ENCODE(IDtag,infobuf,LEN)  \
        xmk_Cod_Encode (XMK_MICRO_COMMAND,IDtag,(char*)&infobuf,LEN);


/*--------------------  Typedefinitions     ----------------------------------*/

/*--------------------  Functions    -----------------------------------------*/

#ifdef XMK_USE_COMMLINK
  static int xmk_GetHostCmd (void);
#endif

/*--------------------  Variables    -----------------------------------------*/

#ifdef XMK_ADD_REALTIME_PLAY
  xmk_T_TIME xmk_StartupTime = 0;
#endif

#ifdef XMK_USE_MAX_ERR_CHECK
  unsigned char xmk_InitState = 1;
#endif

/*============================================================================*/
/*-MGG*/


/*============================================================================*/
/*-MGG*/


/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]InitSDL                                           |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|  This Function is to be called by the user before calling xmk_RunSDL ()      |
|  and implements the initialization of the whole SDL-System, namely           |
|  Timer, Queue, Processes.                                                    |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_InitSDL( void )

/*-FDEF E*/

{
  #ifdef XMK_ADD_PRINTF_MAIN
    XMK_FUNCTION("[Qualified]InitSDL");
  #endif

  xmk_InterruptsDisabled = 0;

  #if defined(XMK_ADD_CREINIT)
    /*
    ** Make a backup of the XPDTBL for allowing reinitialization later on
    ** (Reinitialization can restrictively be used for some test only)
    */
    xmk_SystemState &= ~XMK_REINIT_SYSTEM ;
    xmk_BackupXPDTBL ();
  #endif /* ... XMK_ADD_CREINIT */

  #ifdef XMK_USE_MAX_ERR_CHECK
    /*
    ** Check that user called xmk_InitQueue before
    */
    if (xmk_InitState == (unsigned char) 1)
    {
      #ifdef XMK_ADD_PRINTF_ADDITIONAL
        PRINTF(("\nxmk_InitSDL: Sorry, the queue was not initialized correctly with xmk_InitQueue ().\n\n"));
      #endif
      ErrorHandler (ERR_N_INIT_QUEUE);
      #ifdef XMK_ADD_PRINTF_MAIN
        XMK_TRACE_EXIT("[Qualified]InitSDL");
      #endif
      return;
    }
  #endif

  XMK_BEGIN_CRITICAL_PATH;

  /*
  **   Initialize Systemtime
  */
  xmk_InitSystime() ;

  /*
  **   Initialize Timer
  */
  #ifdef XMK_USED_TIMER
    xmk_InitTimer() ;
  #endif

  #ifdef XMK_ADD_REALTIME_PLAY
    /*
    ** The following variable is used to generate the timestamps for
    ** signals, which is used to enable the replay of events in realtime
    ** in the Cmicro Recorders play mode
    */
    xmk_StartupTime    = xmk_NOW () ;
  #endif /* ... XMK_ADD_REALTIME_PLAY */

  #ifdef XMK_USE_KERNEL_WDTRIGGER
    /*
    **   Initialize Watchdog (this is a user function)
    */
    xmk_InitWatchdog() ;
  #endif

  /*+PREEMPT*/
  #ifdef XMK_USE_PREEMPTIVE
    /*
    **   Initialize variables used for preemption
    */
    xmk_InitPreemptionVars();

    /*
    **  Disable preemptive scheduling during system startup
    */
    xmk_DisablePreemption();
  #endif
  /*-PREEMPT*/

  #ifdef XMK_USE_xInitEnv
    /*
    **   Initialize Environment
    */
    xInitEnv ();
  #endif

  #ifdef XMK_ADD_MICRO_TESTER

    #ifdef XMK_ADD_PSC_TRACE
      /*
      ** Initialize PSC trace
      */
      xmk_TSDL_PSC_CreateAll();
    #endif


    #if defined(XMK_ADD_MICRO_RECORDER)
      xmk_InitRecordMode ();

      XMK_END_CRITICAL_PATH;
      xmk_InitPlayMode ();
      XMK_BEGIN_CRITICAL_PATH;

    #endif /* ... XMK_ADD_MICRO_RECORDER */
  #endif /* ... XMK_ADD_MICRO_TESTER */

  /*
  **   Execute SDL Starttransitions
  */
  xmk_StartProcesses() ;

  /*+PREEMPT*/
  #ifdef XMK_USE_PREEMPTIVE
    /*
    **  Enable preemptive scheduling
    */
    xmk_EnablePreemption();
  #endif
  /*-PREEMPT*/

  /*
  **  critical path ends here, because system start phase ends
  */
  XMK_END_CRITICAL_PATH;

  #ifdef XMK_ADD_PRINTF_MAIN
    XMK_TRACE_EXIT("[Qualified]InitSDL");
  #endif

} /* END OF FUNCTION */



/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]RunSDL                                            |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|  This functions processes forever.                                           |
|  Before processing signals, SDL-timeouts are checked and a the function      |
|  "xInEnv", which must be filled out by the user, is called.                  |
|                                                                              |
|  Parameter    :                                                              |
|                                                                              |
|  Return       :                                                              |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_RunSDL (void)

/*-FDEF E*/

{
  #ifdef XMK_ADD_PRINTF_MAIN
    XMK_FUNCTION("[Qualified]RunSDL");
  #endif

  do
  {

    #ifdef XMK_ADD_MICRO_RECORDER
      if (xmk_RecorderMode == XMK_RECORDER_PLAY)
      {
        #ifdef XMK_USE_OS_ENVIRONMENT
          int c;
          c = xmk_GetChar ();
          if (XMK_TERMINATION_CHAR(c))
          {
            /* possibility to terminate the program when target          */
            /* is a PC. Attention ! Files and Communications Link are not*/
            /* closed or disabled. This is only the "emergency exit"     */
            /* of the program, which is currently running in play mode.  */
            PRINTF (( "**WARNING: User wants to quit->Using emergency exit\n"));
            XMK_KERNEL_EXIT (0);
          }
        #endif /* ... XMK_USE_OS_ENVIRONMENT */
      } /* ... if (xmk_RecorderMode == ... PLAY) */
      else
      {
        /*
        ** No activities here from the Cmicro Recorder
        ** when recording or recorder off
        ** ==> Ordinary Environment handling
        */
        #ifdef XLI_LIGHT_INTEGRATION
          xmk_QueryOSQueue();
        #else
          #ifdef XMK_USE_xInEnv
            xInEnv ();
          #endif
        #endif /* ... XMK_USE_xInEnv */

        /*
        **   Check if any timer is expired ...
        */
        #ifdef XMK_USED_TIMER
          #ifdef XMK_USE_DEBUGGING

            #if defined(XMK_ADD_CSHUTDOWN)
              XMK_MAIN_SHUTDOWN;
            #endif /* ... XMK_ADD_CSHUTDOWN */

            #if defined(XMK_ADD_CREINIT)
              /*
              **  System is to be reinitialized on user requests;
              **  This may lead to unexpected results
              **  because the hardware and physical layer initialization
              **  may fail for some reasons. Also, the buffers of the
              **  communications link will be removed here and the trace
              **  may probably not work.
              **  Reinitialization can restrictively be used for some test only.
              */
              if (xmk_SystemState & XMK_REINIT_SYSTEM)
              {
                xmk_RestoreXPDTBL ();
                xmk_InitSDL ();
              }
            #endif /* ... XMK_ADD_CREINIT */

            /*
            **  Timer expired check is only to be done
            **  if timers are not disabled
            */
            if (!(xmk_SystemState & XMK_TIMER_DISABLED))
          #endif /* ... XMK_USE_DEBUGGING */
                 xmk_ChkTimer ();
        #endif /* ... XMK_USED_TIMER */
      } /* ... if (xmk_RecorderMode == ...) */
    #else
      /*
      **   If the Cmicro Recorder is not compiled, then
      **   read in signals from the environment ...
      */
      #ifdef XLI_LIGHT_INTEGRATION
        xmk_QueryOSQueue();
      #else
        #ifdef XMK_USE_xInEnv
          #ifdef XMK_ADD_MICRO_TESTER /* TST 1008108 */
            if(!(xmk_SystemState & XMK_BREAKPOINT_HIT)) {
          #endif
              xInEnv ();
          #ifdef XMK_ADD_MICRO_TESTER 
            }
          #endif

          #if defined(XMK_ADD_CSHUTDOWN)
            XMK_MAIN_SHUTDOWN;
          #endif /* ... XMK_ADD_CSHUTDOWN */

          #if defined(XMK_USE_DEBUGGING) && defined(XMK_ADD_CREINIT)
            if (xmk_SystemState & XMK_REINIT_SYSTEM)
            {
              xmk_RestoreXPDTBL ();
              xmk_InitSDL ();
            }
          #endif
        #endif /* ... XMK_USE_xInEnv */
      #endif /* ... XLI_LIGHT_INTEGRATION */

      /*
      **   Check if any timer is expired ...
      */
      #ifdef XMK_USED_TIMER
        #ifdef XMK_USE_DEBUGGING
          /*
          **  Timer expired check is only to be done
          **  if timers aren't disabled
          */
          if (!(xmk_SystemState & XMK_TIMER_DISABLED))
        #endif /* ... XMK_USE_DEBUGGING */
            xmk_ChkTimer ();
      #endif /* XMK_USED_TIMER */
    #endif /* XMK_ADD_MICRO_RECORDER */


    #ifdef XMK_ADD_MICRO_TESTER
      #ifdef XMK_USE_COMMLINK
        (void) xmk_GetHostCmd();
      #endif /* ... XMK_USE_COMMLINK */
    #endif /* ... XMK_ADD_MICRO_TESTER */

    /*
    **   Process the signal (if some exists) ...
    */
    #ifdef XMK_USE_PREEMPTIVE
       /*
       ** Actions for preemption ...
       */
       XMK_BEGIN_CRITICAL_PATH;

       if ((HighestPrioLevel = xmk_FetchHighestPrioLevel())
            != MAX_PRIO_LEVELS)
       {
         xmk_Queue = &Prio_Queue[HighestPrioLevel];
         xmk_CurrentSignal = &Prio_CurrentSignal[HighestPrioLevel];
         XMK_END_CRITICAL_PATH;
         xmk_ProcessSignal ();
       }
       else
       {
         XMK_END_CRITICAL_PATH;
       }
    #else
       /*
       ** Actions for non preemption ...
       */
       xmk_ProcessSignal ();
    #endif  /* ... XMK_USE_PREEMPTIVE */


    #ifdef XMK_USE_KERNEL_WDTRIGGER
      /*
      **   WatchdogTrigger
      */
      XMK_WDTRIGGER_FUNCTION
    #endif /* ... XMK_USE_KERNEL_WDTRIGGER */
    /*
    ** If dynamic SDL System stop was recognized ....
    */
    #ifdef XMK_USE_SDL_SYSTEM_STOP
      if (xmk_QueueEmpty () && ! xmk_IsAnyProcessAlive () )
      {
          #ifdef XMK_ADD_PRINTF_MAIN
            XMK_TRACE_EXIT("[Qualified]RunSDL");
          #endif

          return ;

      }
    #endif /* ...XMK_USE_SDL_SYSTEM_STOP */

  }
  while (1);

} /* END OF FUNCTION */

#ifdef XMK_ADD_MICRO_TESTER

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]MicroTesterInit                                   |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|  This Function calls the host for the Cmicro Tester's configuration          |
|                                                                              |
|  Parameter    : int flag = 0   Static Init only                              |
|                          = 1-N Init from host                                |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_MicroTesterInit( void )

/*-FDEF E*/

{
  #ifdef XMK_USE_COMMLINK
    (void) xmk_DLInit();
  #endif

  xmk_InitOptions ( );

  #ifdef XMK_ADD_MICRO_RECORDER
    xmk_SetRecorderMode( XMK_RECORDER_OFF );
  #endif

  xmk_TracerActive = XMK_TRUE;

  #ifdef XMK_USE_COMMLINK
    #ifdef XMK_USE_AUTO_MCOD
    /*
    ** First message to the host.
    ** send info about C-datatypes to host
    */
      xmk_GET_DATA_CONFIG();
    #endif
    /*
    ** Get target's configuration and send it to host as start message
    */
    xmk_Encode_CMD_GET_CONFIG( CMD_GET_CONFIG_IND );


    #ifdef XMK_WAIT_ON_HOST

      /*
      ** Indicate to host, that waiting here
      */
      ENCODE_NPAR ( CMD_START_SDL_IND );

      while (xmk_GetHostCmd() != CMD_START_SDL_REQ);

    #endif  /* ... XMK_WAIT_ON_HOST */
  #endif  /* ... XMK_USE_COMMLINK */

} /* END OF FUNCTION */


/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]MicroTesterDeinit                                 |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|    This Function deinitializes the Cmicro Tester (the data link of it)       |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_MicroTesterDeinit( void )

/*-FDEF E*/

{
  #if defined (XMK_USE_COMMLINK) && defined (XMK_USE_MPM)
    char xmk_RAM_ptr p_data = NULL;
  #endif

  #ifdef XMK_ADD_CREINIT
    xmk_ClearBackupXPDTBL();
  #endif /* XMK_ADD_CREINIT */

  #ifdef XMK_USE_COMMLINK
    #if defined(XMK_USE_MPM)
      while(1)
      {
        (void) xmk_DLRead(&p_data, 0);
      }
    #else
      (void) xmk_DLDeinit();
    #endif
  #endif

}


#ifdef XMK_USE_COMMLINK

/*+FHDR S*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]GetHostCmd                                        |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|    This Function calls for Host commands and activates the decoding.         |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       : int      MessageTag                                          |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR S*/

/*+FDEF S*/

static int xmk_GetHostCmd (void)

/*-FDEF S*/

{

  #ifdef XMK_USE_PAR_GREATER_THAN_250
    char  buffer [32768];
  #else
    char  buffer [256];
  #endif
  char xmk_RAM_ptr    p_data=NULL;
  int                 MessageClass;
  int                 MessageTag=0;
  int                 MessageLength;
  int                 result;

  if (xmk_DLRead (&p_data,0) != XMK_ERROR)
  {
    result = xmk_Cod_Decode (p_data,
                             &MessageClass,
                             &MessageTag,
                             &MessageLength,
                             buffer,
                             sizeof (buffer));
    
    if (result != XMK_ERROR)
    {
      #ifdef XMK_ADD_MICRO_COMMAND
        #ifdef XMK_ADD_MICRO_ENVIRONMENT
          if( (MessageClass == XMK_MICRO_COMMAND)|| (MessageClass == XMK_MICRO_ENVIRONMENT))
        #else
          if(MessageClass == XMK_MICRO_COMMAND)
        #endif
        {
           if (xmk_HandleHostCmd ( MessageTag, (xmk_U_CMDS*) buffer ) != XMK_OKAY)
             ErrorHandler (ERR_N_ILLEGAL_CMD);
        }
      #endif
    }
  }
  return (MessageTag);
}

#endif /* ... XMK_USE_COMMLINK */
#endif /* ... XMK_ADD_MICRO_TESTER */
#endif /* ... __MK_MAIN_C_ */
