/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

/*+MHDR*/
/*
+------------------------------------------------------------------------------+
#  Modulname: ml_mon.c
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|    This module exports some functions to monitor the Cmicro Kernel and the   |
|    SDL-application.                                                          |
|                                                                              |
|  M1 Errormessages, which are routed to the ErrorHandler                      |
|  --------------------------------------------------------                    |
|    - none -                                                                  |
|                                                                              |
|  M2 Exported functions of this module :                                      |
|  --------------------------------------------------------                    |
|    void     xmk_MonPID               (char *ostring, xPID pid)               |
|    void     xmk_MonHexSingle         (char *p_text, unsigned char *p_address,|
|                                       int length)                            |
|    void     xmk_MonHex               (char *p_text, unsigned char *p_address,|
|                                       int length)                            |
|    void     xmk_MonHexAsc            (FILE* fp, char * text, char *c2,       |
|                                       unsigned char * adr, int len)          |
|    void     xmk_MonConfig ()                                                 |
|                                                                              |
|  M3 Static functions of this module :                                        |
|  --------------------------------------------------------                    |
|    - none -                                                                  |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-MHDR*/

#ifndef __ML_MON_C_
#define __ML_MON_C_


/*+IMPORT*/
/*====================  I M P O R T  =========================================*/
#include "ml_typ.h"

#ifdef XSYSID
  /*
  ** CAUTION !
  ** ============
  ** This module cannot be used when partitioning is used. The reason
  ** for this is that the functions of this module operate on global
  ** variables and partitioned systems may preempt each other when
  ** an Real Time Operating System is used.
  ** However, users can use this module as a basis for implementing
  ** their own memory management functions.
  */
  #error "ERROR_in_ml_mon_c_Module_cannot_be_used_for_Partitioning"
#endif /* ... XSYSID */

/*============================================================================*/
/*-IMPORT*/


/*+MGG*/
/*====================  V A L U E S  O F  T H I S   M O D U L E  =============*/

/*--------------------  Constants,  Macros  ----------------------------------*/

/*--------------------  Typedefinitions     ----------------------------------*/

typedef struct {
        char  *p_config_string;
        char  format;        /* 0==No  1==int */
        int   config_value;
} XMK_LOG_TABLE;


/*--------------------  Functions    -----------------------------------------*/

/*--------------------  Variables    -----------------------------------------*/


#ifdef XMK_USE_MON 

XMK_LOG_TABLE xmk_log_table [] = {

  #ifdef MAX_SDL_PROCESS_TYPES
    {"SDL-System contains processtypes :",1,MAX_SDL_PROCESS_TYPES},
  #endif

  #ifdef XMK_USED_ONLY_X_1
    {"SDL-System contains only single instance processes (1,1)",0,0},
  #else
    {"SDL-System contains multiple instance processes (1,N), where N>1",0,0},
  #endif

  #ifdef XMK_USED_TIMER
         {"Timers: YES",0,0},

    #ifdef MAX_SDL_TIMER_TYPES
           {"TIMER TYPES: ",1, MAX_SDL_TIMER_TYPES},
    #endif

    #ifdef MAX_SDL_TIMER_INSTS
           {"TIMER INSTANCES (MAXIMUM): ",1, MAX_SDL_TIMER_INSTS},
    #else
           {"TIMER INSTANCES (MAXIMUM): ",1, XMK_MAX_TIMER},
    #endif

    #ifdef XMK_USED_TIMER_WITH_PARAMS
            {"Timer with (SDL_Integer) Parameters: YES",0,0},
    #else
            {"Timer with (SDL_Integer) Parameters: NO",0,0},
    #endif

  #else
    {"Timers: NO",0,0},
  #endif /* XMK_USED_TIMER */

  #ifdef XMK_USED_DYNAMIC_CREATE
    {"Dynamic Processcreation: ON",0,0},
  #else
    {"Dynamic Processcreation: OFF",0,0},
  #endif

  #ifdef XMK_USED_DYNAMIC_STOP
    {"Dynamic Process stop: ON",0,0},
  #else
    {"Dynamic Process stop: OFF",0,0,},
  #endif

  #ifdef XMK_USED_SAVE
    {"SAVE is used: YES",0,0},
  #else
    {"SAVE is used: NO",0,0},
  #endif

  #ifdef XMK_USED_SIGNAL_WITH_PARAMS
    {"Signals with Parameters: YES",0,0},
  #else
    {"Signals with Parameters: NO",0,0},
  #endif

  #ifdef XMK_USE_SIGNAL_PRIORITIES
    {"Signals with Priorities: ON",0,0},
  #else
    {"Signals with Priorities: OFF",0,0},
  #endif

  #ifdef xDefaultPrioProcess
    {"Default priority for Processes is:",1,xDefaultPrioProcess},
  #else
    {"Default Priority for Processes is: UNDEFINED",0,0},
  #endif

  #ifdef MAX_PRIO_LEVELS
    {"Number of Prioritylevels is:",1,MAX_PRIO_LEVELS},
  #else
    {"Number of Prioritylevels is: UNDEFINED",0,0},
  #endif

  #ifdef xDefaultPrioSignal
   {"Default Priority for signals (except timers) is:",1,xDefaultPrioSignal},
  #else
   {"Default Priority for signals (except timers) is: UNDEFINED",0,0},
  #endif

  #ifdef XMK_TIMERPRIO
   { "Timer default Priority is:",1,XMK_TIMERPRIO},
  #else
   {"Timer default Priority is: UNDEFINED",0,0},
  #endif

  #ifdef XMK_MAX_SIGNALS
    {"XMK_QUEUE MAXIMUM ENTRIES :",1, XMK_MAX_SIGNALS},
  #endif

  #if defined(XMK_USED_PARENT) || defined(XMK_USED_OFFSPRING)
    {"Using PARENT/OFFSPRING: YES",0,0},
  #else
    {"Using PARENT/OFFSPRING: NO",0,0},
  #endif

  #ifdef XMK_USE_SIGNAL_TIME_STAMP
    {"Timestamps in Signals: YES",0,0},
  #else
    {"Timestamps in Signals: NO",0,0},
  #endif

  #ifdef XMK_USE_PREEMPTIVE
    {"Preemption (process priorities): ON",0,0},
  #else
    {"Preemption (process priorities): OFF",0,0},
  #endif

  #ifdef XMK_USE_TIMESLICE
    {"Preemption (Timeslicing): ON",0,0},
  #else
    {"Preemption (Timeslicing): OFF",0,0},
  #endif

  #ifdef XMK_USE_KERNEL_INIT
    {"Instance data default setting by Cmicro Kernel: ON",0,0},
  #else
    {"Instance data default setting by Cmicro Kernel: OFF",0,0},
  #endif

  #ifdef XMK_USE_SDL_SYSTEM_STOP
    {"SDL-System stop possible: YES",0,0},
  #else
    {"SDL-System stop possible: NO",0,0},
  #endif
  
  #ifdef XMK_USE_BANKSW
    {"Bankswitching: ON",0,0},
  #else
    {"Bankswitching: OFF",0,0},
  #endif

  #ifdef XMK_USE_MAX_ERR_CHECK
    {"Additional Error checks: ON (maximum)",0,0},
  #else
    {"** WARNING ** Additional Error checks are OFF !!!",0,0},
  #endif
    /* Table-End */
    {(char *) NULL,0,0}
};
#endif /* ... XMK_USE_MON */

/*============================================================================*/
/*-MGG*/

#if defined(XMK_USE_MON) 

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_MonPID                                                   |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|  Function for test purposes, free use.                                       |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_MonPID (char *ostring, xPID pid)

/*-FDEF E*/
{
    PRINTF (("%s PID     :%d\n", ostring, pid));
    PRINTF (("%s PID-TYPE:%d\n", ostring, EPIDTYPE(pid)));
    PRINTF (("%s PID-INST:%d\n", ostring, EPIDINST(pid)));

} /* END OF FUNCTION */

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_MonHexSingle                                             |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|  Function for test purposes, free use.                                       |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_MonHexSingle (char *p_text, unsigned char *p_address, int length)

/*-FDEF E*/
{
   int   i, col_cnt;

   (void)fprintf (stdout, "%s", p_text);

   col_cnt = 0;
   for (i=0; i<length; i++)
   {
     if (*p_address < 0x10)
        (void)fprintf (stdout, "0%x ", *p_address);
      else
        (void)fprintf (stdout, "%x ", *p_address);

     col_cnt  ++;
     if (col_cnt >= 8)
     {
       (void)fprintf (stdout, " ");
       col_cnt = 0;
     }

     p_address++;
     if (i>79) break;
   }

   (void)fprintf (stdout, "\n");

   return;
}


/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_MonHex                                                   |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|  Function for test purposes, free use.                                       |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_MonHex (char *p_text, unsigned char *p_address, int length)

/*-FDEF E*/
{
#define FIELD_SIZE 16
   int i;
   int NaturalValue, drest;

   PRINTF (("%s", p_text));

   NaturalValue = length / FIELD_SIZE;
   drest      = length % FIELD_SIZE;

   for (i=0; i<NaturalValue; i++)
   {
      xmk_MonHexSingle ("    ", p_address, FIELD_SIZE);
      p_address += FIELD_SIZE;
   }

   if (drest) xmk_MonHexSingle ("    ", p_address, drest);

   return;
}

/*+FHDR*/
/*
+------------------------------------------------------------------------------+
|  Functionname  : xmk_MonHexAsc                                               |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|  Function for test purposes, free use.                                       |
|  Parameter    :                                                              |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR*/

/*+FDEF*/

void    xmk_MonHexAsc (FILE* fp, char * text, char *c2, unsigned char * adr, int len)

/*-FDEF*/
{
    int i, j=0, k=0, col_cnt;
    char c;
    char *p_store;

    if (text!=NULL)
       (void)fprintf (fp, "%s%s", c2, text);

    p_store  = (char *) adr;
    col_cnt = 0 ;     /* count columns in a line */

    for (i=0; i<len; i++)
    {
       /*
       ** preceding text
       */
       if (col_cnt == 0)
         (void)fprintf (fp, "%s", c2);

       /*
       ** dump byte
       */
       if (*adr < 0x10)
         (void)fprintf (fp, "0%x ", *adr);
       else
         (void)fprintf (fp, "%x ", *adr);

       /*
       ** divide 8 to 8 columns
       */
       col_cnt ++;
       if (col_cnt == 8)
       {
         (void)fprintf (fp, "- ");
       }

       adr++;
       j++;

       /*
       ** print in character notation ...
       */
       if (j>15)
       {
          (void)fprintf (fp, "   ");
          /* ... begin at stored position ... */
          for (j=0; j<16; j++)
          {
             c= *p_store;
             if ((( c>=' ' ) && ( c<=126 )) || (c == 127))
             {
                (void)fprintf (fp, "%c", *p_store);
             }
             else
                (void)fprintf (fp, ".");

             p_store++;
          }

          p_store = (char *) adr;

          j=0;
          col_cnt = 0;
          (void)fprintf (fp, "\n");
       }

       if ( i==(len-1) ) /* Hex-Columns OK here */
       {
          /*
          ** fill up to the rest of hex columns ...
          */
          k=16-j;
          for ( ; j<16; j++)
             (void)fprintf (fp, "   ");

          (void)fprintf (fp, "   ");

          /*
          ** print rest in character notation ...
          */
          for (; k<16; k++)
          {
             c= *p_store;

             if ((( c>=' ' ) && ( c<=126 )) || (c == 127))
             {
                (void)fprintf (fp, "%c", *p_store);
             }
             else
                (void)fprintf (fp, ".");

             p_store++;
          }

          p_store = (char *) adr;

          j=0;
          (void)fprintf (fp, "\n");
       }
    }

    (void)fprintf (fp, "\n");

    return;
}


/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_MonConfig                                                |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|  Function for test purposes, free use.                                       |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_MonConfig ()

/*-FDEF E*/
{
  int i;
  PRINTF(("This is the configuration used :\n"));

  for(i = 0; (&xmk_log_table[i])->p_config_string; i++)
  {
    PRINTF(("%-53s", (&xmk_log_table[i])->p_config_string));
    
    if ((&xmk_log_table[i])->format)
    {
      PRINTF(("%d\n", (&xmk_log_table[i])->config_value));
    }
    else
    {
      /* -> no output specified! */
      PRINTF (("\n"));
    }
    PRINTF(("%s","--------------------------------------------------------\n"));
  }
}

#endif /* ... XMK_USE_MON */
#endif /* __ML_MON_C_ */
