/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*+MHDR*/
/*
+------------------------------------------------------------------------------+
#  Modulname: 8051_v24.c
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|  This module contains an example of an V.24 Interface implementation for     |
|  use with a 8051 microcontroler hardware                                     |
|  This template is checked with the access control hardware only. Furthermore |
|  it doesn't need the ringbuffer normally used ( see modul mg_dl.c)           |
|                                                                              |
|  M1 Errors detected within this module :                                     |
|  --------------------------------------------------------                    |
|  - none -                                                                    |
|                                                                              |
|  M2 Exported functions of this module :                                      |
|  --------------------------------------------------------                    |
|  void xmk_V24Init       ( void );                                            |
|  void xmk_V24Deinit     ( void );                                            |
|  bit  xmk_V24Send       ( unsigned char *, unsigned int );                   |
|  int  xmk_V24Receive    ( unsigned char *, unsigned int );                   |
|                                                                              |
|  M3 Static functions of this module :                                        |
|  --------------------------------------------------------                    |
|  static void interrupt isr_v24( void )                                       |
|  static void receiver( void )                                                |
|  static void transmitter( void )                                             |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-MHDR*/

#ifndef __8051_V24_C_
#define __8051_V24_C_

/*+IMPORT*/
/*=====================  I M P O R T  ========================================*/

/*---------------------  Headerfiles  ----------------------------------------*/

#include "ml_typ.h"
#include "8051_v24.h"

/*---------------------  Functions    ----------------------------------------*/

/*---------------------  Variables    ----------------------------------------*/

/*============================================================================*/
/*-IMPORT*/

/*+EXPORT*/
/*=====================  E X P O R T  ========================================*/

/*--------------------  Typedefinitions     ----------------------------------*/

/*--------------------  Constants,  Macros  ----------------------------------*/

/*--------------------  Functions    -----------------------------------------*/

/*---------------------  Variables    ----------------------------------------*/

/*============================================================================*/
/*-EXPORT*/

/*====================  V A L U E S  O F  T H I S   M O D U L E  =============*/

/*--------------------  Typedefinitions     ----------------------------------*/

/*--------------------  Constants,  Macros  ----------------------------------*/

#define LOWWATER  20
#define HIGHWATER ( XMK_MAX_RECEIVE_ONE_ENTRY - LOWWATER )

/*  possible Baudrates (see xmk_V24Init())
**
**      1 - 19.200 Hz
**      2 -  9.600 Hz
*/
#define BAUDRATE  1

#define Disable( s )    { s = EA ; EA = 0 ; }
#define Enable( s )     { EA  = s ; }
#define DisableSioInt    ES = 0 ;
#define EnableSioInt()  { ES = 1 ; }

#define IncEp( p )      { if( ++p == XMK_MAX_RECEIVE_ONE_ENTRY ) p = 0 ; }
#define IncSp( p )      { if( ++p == XMK_MAX_SEND_ONE_ENTRY    ) p = 0 ; }

/*--------------------  Functions    -----------------------------------------*/

static void receiver        ( void );
static void transmitter     ( void );

/*---------------------  Variables    ----------------------------------------*/

static char gotXON = XMK_FALSE;

static char sbuffer[ XMK_MAX_SEND_ONE_ENTRY ] ,    /* Transmitbuffer          */
            ebuffer[ XMK_MAX_RECEIVE_ONE_ENTRY ] ; /* Receivebuffer           */

static unsigned int  TxWritePtr , /* Write Pointer into transmit buffer       */
                     TxReadPtr ,  /* Read  Pointer into transmit buffer       */
                     AmountTX ,   /* Amount characters in the transmit buffer */

                     RxWritePtr , /* Write Pointer into receive  buffer       */
                     RxReadPtr ,  /* Read  Pointer into receive  buffer       */
                     AmountRX ;   /* Amount characters in the receive  buffer */

static bit           tblock ; /* Transmitter blocked (xOff received?), y or n */

static unsigned char handsh ; /* Handshake character                          */

static enum                   /* Receiver states                              */
{
  receive ,                   /* Receiver running                             */
  resc                        /* Receiver received Escape                     */
} restate;

static enum                   /* Transmitter states                           */
{
  ton ,                       /* Transmitter running                          */
  toff ,                      /* Transmitter is off                           */
  tesc                        /* Transmitter sends Escape                     */
} trstate;


static unsigned char trbe ;        /* Flag: Transmitterbuffer empty y or n    */
static unsigned char DelayCounter ;/* Delay Counter                           */

/*============================================================================*/


#if defined(KEIL_C51) || defined(IARC51)

/*+FHDR E*/ /*
+------------------------------------------------------------------------------+
|  Functionname : xmk_V24Init                                                  |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  Template for initialization of the serial interface.                        |
|                                                                              |
|  Parameter    :                                                              |
|  Return       :                                                              |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_V24Init( void )

/*-FDEF E*/

{
  DisableSioInt ;

  TMOD = 0x21;          /* Timer1 : Mode  = 2, C/T = 0, GATE = 0 */
  TCON = 0x45;
  TR1 = 1;              /* Timer 1 Run Control Bit */

  #if   BAUDRATE == 1   /* 19.200 Hz  */
    TH1 = 0xfd ;
    PCON |= 0x80;       /* set SMOD   */
  #elif BAUDRATE == 2   /*  9.600 Hz  */
    TH1 = 0xfd ;
    PCON &= 0x7f;       /* clear SMOD */
  #endif

  /*
  ** set SCON = 0x50
  */
  SM0 = 0 ;
  SM1 = 1 ;           /* SIO Modus 1 ( 8 Bit, 1 Startbit, 1 Stopbit )         */
  SM2 = 0 ;
  REN = 1 ;           /* enable receiver                                      */
  TI  = 0 ;           /* no transmitter interrupt                             */
  RI  = 0 ;           /* no receiver interrupt                                */

  PS = 0 ;            /* SIO interrupt lowest priority                        */

  TxWritePtr = 0 ;    /* IN pointer at the top of the transmitter buffer      */
  TxReadPtr = 0 ;     /* OUT pointer at the top of the transmitter buffer     */
  AmountTX = 0 ;      /* no character in the transmitter buffer               */

  RxWritePtr = 0 ;    /* IN pointer at the top of the receiver buffer         */
  RxReadPtr = 0 ;     /* OUT pointer at the top of the receiver buffer        */
  AmountRX = 0 ;      /* no character in the receiver buffer                  */

  tblock = 0 ;        /* transmitter blocking                                 */

  handsh = 0 ;        /* no handshake to send                                 */

  trbe   = 1 ;        /* transmitter buffer is empty                          */

  EnableSioInt() ;    /* enable SIO interrupts                                */

  EA = 1;             /* Enable all interrupts                                */

  DelayCounter = 255 ;

  restate = receive;

  trstate = ton;

} /* END OF FUNCTION */


/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_V24Deinit                                                |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  Template for deinitialization of the serial interface.                      |
|  This function isn't needed for the 8051 hardware and only implemented to be |
|  conform to the DL-layer of the Cmicro Tester.                               |
|                                                                              |
|  Parameter    :                                                              |
|  Return       :                                                              |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_V24Deinit( void )

/*-FDEF E*/

{
  return;
}


/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_V24Write                                                 |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function writes into an buffer for the serial Interface without the use|
|  of the ringbuffer                                                           |
|                                                                              |
|  Parameter    : bytes  - address of the buffer                               |
|                 anz - amount of characters to be written                     |
|  Return       : 0 - no character has been written                            |
|                 1 - characters has been written                              |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF*/

bit   xmk_V24Send (unsigned char *bytes, unsigned int anz)

/*-FDEF*/
{
  unsigned char i ;
  bit sea ;

  if( ( XMK_MAX_SEND_ONE_ENTRY - AmountTX ) < anz )     /* buffer to small     */
    return( 0 ) ;

  for( i = 0 ; i < anz ; i++ )     /* copy characters to transmitter buffer    */
  {
    sbuffer[ TxWritePtr ] = bytes[ i ] ;

    IncSp( TxWritePtr ) ; /* increment IN pointer                              */

    Disable( sea ) ;     /* because of ISR                                     */
    AmountTX++ ;
    Enable( sea ) ;
  }

  DisableSioInt ;

  if( trstate == toff )
    trstate = ton ;

  if( trbe )
    transmitter() ;

  EnableSioInt() ;
  return( 1 ) ;

} /* END OF FUNCTION */


/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_V24Receive                                               |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function reads the buffer of the serial Interface                      |
|                                                                              |
|  Parameter    : bytes - address of the buffer                                |
|                 anz - amount of readable characters  (amount)                |
|                                                                              |
|  Return       : 0 - no character read                                        |
|                 1 - one character read                                       |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF*/

int xmk_V24Receive(unsigned char *bytes, unsigned int anz)

/*-FDEF*/
{
  unsigned char i ;
  bit sea ;

  if( AmountRX < anz )      /* If less chars available than requested         */
  {
    DelayCounter-- ;
    if( !DelayCounter )
    {
      DelayCounter = 255 ;

      handsh = XMK_XON ;  /* send XON                                         */

      DisableSioInt ;

      if( trbe )          /* if transmitter buffer empty                      */
        transmitter() ;   /* activate transmitter                             */

      EnableSioInt() ;
    }
    return( 0 ) ;
  }


  for( i = 0 ; i < anz ; i++ )
  {
    bytes[ i ] = ebuffer[ RxReadPtr ] ;

    IncEp( RxReadPtr ) ;

    Disable( sea ) ;      /* because of ISR                                   */
    AmountRX-- ;
    Enable( sea ) ;

    if( AmountRX == LOWWATER )
    {
      DisableSioInt ;

      handsh = XMK_XON ;  /* send XON                                         */

      if( trbe )          /* if transmitter buffer empty                      */
        transmitter() ;   /* activate transmitter                             */

      EnableSioInt() ;
    }
  } /* end for(...) */

  return( 1 ) ;

} /* END OF FUNCTION */


/*+FHDR S*/
/*
+------------------------------------------------------------------------------+
|  Functionname : isr_v24                                                      |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  A Template for an ISR (Interrupt Service Routine) to send/receive data      |
|  via the serial interface.                                                   |
|                                                                              |
|  Parameter    :                                                              |
|  Return       :                                                              |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR S*/

/*+FDEF*/

#ifdef IARC51
  interrupt [0x23] void isr_v24()
#elif defined(KEIL_C51)
  void isr_v24() interrupt 4
#endif

/*-FDEF*/
{
  DisableSioInt ;
  if( RI )                   /* If receive requested                        */
  {
    receiver() ;             /* process ...                                 */
    RI = 0 ;                 /* receive request OK ...                      */
  }
  if( TI )                   /* If transmit requested                       */
  {
    transmitter() ;          /* process ...                                 */
    TI = 0 ;                 /* transmit request OK ...                     */
  }
  EnableSioInt() ;
} /* END OF FUNCTION */


/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : receiver                                                     |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function reads the input port of the 8051 microcontroler and inter-    |
|  prets the controlcharacters. The received character is returned             |
|                                                                              |
|  Parameter    :                                                              |
|  Return       :                                                              |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF*/
static void receiver( void )
/*-FDEF*/
{
  char Character ;

  Character = SBUF ;

  switch( restate )
  {
    case receive :
         {
           switch( Character )
           {
             case XMK_XON :
                  {
                    gotXON = XMK_TRUE;

                    tblock = 0 ;

                    if( trbe )
                      transmitter() ;

                    return ;
                  }

             case XMK_XOFF :
                  {
                    tblock = 1 ;

                    return ;
                  }

             case XMK_ESC :
                  {
                    restate = resc ;

                    return ;
                  }

           }
         }

    case resc :
         {

           ebuffer[ RxWritePtr ] = Character ;
           IncEp( RxWritePtr ) ;
           AmountRX++ ;

           if( AmountRX > HIGHWATER )
           {
             handsh = XMK_XOFF ;

             if( trbe )
               transmitter() ;
           }

           restate = receive ;
           return ;
         }
  }

} /* END OF FUNCTION */


/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : transmitter                                                  |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  The Transmitter buffer is read here and the read character is send to the   |
|  Output port of the 8051. The needes control characters are inserted here    |
|  too.                                                                        |
|                                                                              |
|  Parameter    :                                                              |
|  Return       :                                                              |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF*/
static void transmitter( void )
/*-FDEF*/
{
  char Character ;

  switch( trstate )
  {
    case toff :
         {
           if( handsh )
           {
             SBUF = handsh ;
             handsh = 0 ;
             trbe   = XMK_FALSE ;
             return ;
           }

           trbe = XMK_TRUE ;
           return ;
         }

    case ton :
         {
           if( handsh )
           {
             SBUF = handsh ;
             trbe = XMK_FALSE ;
             handsh = 0 ;
             return ;
           }

           if( tblock )
           {
             trbe = XMK_TRUE ;
             return ;
           }

           if( !AmountTX )
           {
             trstate = toff ;
             trbe = XMK_TRUE ;
             return ;
           }

           Character = sbuffer[ TxReadPtr ] ;

           if( Character == XMK_XON || Character == XMK_XOFF || Character == XMK_ESC )
           {
             SBUF = XMK_ESC ;
             trbe = XMK_FALSE ;
             trstate = tesc ;
             return ;
           }
         }


    case tesc :
         {
           Character = sbuffer[ TxReadPtr ] ;
           SBUF = Character ;
           trbe = XMK_FALSE ;
           AmountTX-- ;
           IncSp( TxReadPtr ) ;
           trstate = ton ;
           return ;
         }
    default:
             break;
  }
} /* END OF FUNCTION */


#endif /*... KEIL_C51 || IARC51 */

#endif /* ... __8051_V24_C_ */
