/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*+MHDR*/
/*
+------------------------------------------------------------------------------+
#  Modulname: ux_v24.c
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|  This module contains an example of an V.24 Interface implementation         |
|  for UNIX. It can be used as well on SUN as on HP.                           |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-MHDR*/
#ifndef __UX_V24_C_
#define __UX_V24_C_

/*+IMPORT*/
/*====================  I M P O R T  =========================================*/
#include "ux_v24.h"

#ifdef SDTGATE
  #include <sys/types.h>
  #include <sys/stat.h>
  #include <fcntl.h>
  #include <sys/uio.h>
  #include <termios.h>
  #include <sys/fcntl.h>
  #include <sys/types.h>
  #include <unistd.h>
  #include <stdio.h>
  #include <stdlib.h>
#ifdef linux
  #define CBAUD      0010017
  #include <string.h>
#endif
  #include <strings.h>

  #include "mcod.h"
  #include "mp_lib.h"
  #include "mg_dl.h"
  #include "mg_ctrl.h"
#else
  /*
  ** In all other cases this modul is for use on target
  */
  #include "ml_typ.h"

#endif

/*--------------------  Variables    -----------------------------------------*/
#ifdef SDTGATE
  extern int xmk_TargetStarted;
  extern FILE* pTraceFile;
#endif

/*--------------------  Functions    -----------------------------------------*/

/*============================================================================*/
/*-IMPORT*/

/*+MGG*/
/*====================  V A L U E S  O F  T H I S   M O D U L E  =============*/
#ifdef SDTGATE
  #define V24_ERROR_HANDLER(T,N) xmk_GateErrorHandler( T );
#else
  #define V24_ERROR_HANDLER(T,N) ErrorHandler(N);
  #define xmk_exit exit
#endif

/*--------------------  Constants,  Macros  ----------------------------------*/
#ifdef SDTGATE
  #define DEVICE_FILE "/tmp/.sdt.cmicro.device"
  #define TEMP_FILE   "/tmp/.sdt.cmicro.device.tmp"
#endif

#define CURRENT_TIME time( (void*)0L )
#define WAITTIME     1

/* defines for the control characters */
#define XMK_XON  0x11  /* Start    */
#define XMK_XOFF 0x13  /* Stop     */
#define XMK_ESC  0x1b  /* Escape   */

/* defines for the transmitter */
#define XMK_UNBLOCKED  0xAA
#define XMK_BLOCKED    0x33

/* defines for the receiver */
#define XMK_ESC_STATE        0xBB
#define XMK_NOTESC_STATE     0x44


/*
** For use on target these macros expanded clear
*/
#ifndef SDTGATE
  #define XMK_COUNT_RX_ANY_CHARS(NUM)
  #define XMK_COUNT_RX_XON
  #define XMK_COUNT_RX_XOFF
  #define XMK_COUNT_RX_FRAME_OK
  #define XMK_COUNT_RX_FRAME_NOT_OK
  #define XMK_SET_RX_FATAL_ERROR
  #define XMK_COUNT_TX_FRAMES
  #define XMK_SET_TRANSMITTER_FATAL_ERR
  #define XMK_COUNT_TX_XON_XOFF(charval)
  #define XMK_COUNT_TX_CHAR(NUM)
  #define XMK_COUNT_TX_ESC
#endif

#define SWAP_BUF_SIZE 32000
/*--------------------  Typedefinitions     ----------------------------------*/

/*--------------------  Functions    -----------------------------------------*/

  static void EnableTransmitter     ( void );
  #if 0
  static void DisableTransmitter    ( void );
  #endif

/*--------------------  Variables    -----------------------------------------*/

/*
**  Structure defined by system to store settings to be retrieved after closing
**  the tty-device, and structure to modify the tty-settings
*/
struct termios  tty_term, old_settings;

/*
**  Handle to use when accessing the tty-device
*/
int             tty_handle;

static unsigned long TimeNextXon ;

unsigned char TransmitterState;
static unsigned char ReceiverState   ;
static unsigned char swap_buffer[ SWAP_BUF_SIZE ];

/*============================================================================*/
/*-MGG*/

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_V24Init                                                  |
+------------------------------------------------------------------------------+
|                                                                              |
|                                                                              |
|  Description :                                                               |
|  Template for initialization of the serial interface.                        |
|                                                                              |
|  Parameter    :                                                              |
|  Return       :                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/
/*+FDEF E*/
void xmk_V24Init( void )
/*-FDEF E*/
{
  #ifdef SDTGATE
    FILE * GateDevices_old;
    FILE * GateDevices_new;
    FILE * ps_result;
    char line[256];
    char entry_pid[200], entry_device[200];

    GateDevices_new = fopen(TEMP_FILE ,"w");
    if(GateDevices_new == NULL)
    {
      xmk_GateErrorHandler("Problems locking the specified device");
      return;
      /*xmk_exit(-1);*/
    }
    if(!access(DEVICE_FILE , 02))
    {
      /*
      ** Get all the available PIDs
      */
      system( "ps -eaf | grep gate > .sdt.tmp" );

      GateDevices_old = fopen (DEVICE_FILE , "r" );
      if(GateDevices_old != NULL)
      {
        while(1)
        {
          if(fscanf(GateDevices_old,"%s", entry_pid) == EOF)
          {
            break;
          }
          if(fscanf(GateDevices_old,"%s", entry_device) == EOF)
          {
            break;
          }

          if(strcmp(entry_device,XMK_V24_DEVICE) == 0)
          {
            #ifdef DEBUG
              fprintf(stderr,"Opening File .sdt.tmp\n");
            #endif

            ps_result = fopen(".sdt.tmp","r");
            if(ps_result != NULL)
            {
              while(fgets(line, 255, ps_result))
              {
                if(strstr( line, entry_pid) != NULL)
                {
                  xmk_GateErrorHandler("Specified device already in use");
                  fclose(GateDevices_new);
                  fclose(GateDevices_old);
                  remove(TEMP_FILE);
                  fclose(ps_result);
                  remove(".sdt.tmp");
                  return;
                }
              }
              fclose(ps_result);
            }
            else
            {
              fclose(GateDevices_new);
              fclose(GateDevices_old);
              remove(".sdt.tmp");
              return;
            }
            remove(".sdt.tmp");
          }
          else
           fprintf(GateDevices_new,"%s %s\n", entry_pid, entry_device);
        } /* ... while(1) */
        fclose(GateDevices_old);
      }
      else
      {
        fprintf(stderr,"SDTGATE: cannot open file >%s<\n", DEVICE_FILE );
        return;
      }
    }
#endif
   /*
  **  Open the specified tty-device and get handle
  */
  tty_handle = open(XMK_V24_DEVICE, O_RDWR | O_NDELAY );

  if  ( (tty_handle < 0) ||
        (isatty(tty_handle) == 0) )
  {
    V24_ERROR_HANDLER("Opening the specified device failed.",ERR_N_OPEN_TTY);
    #ifdef SDTGATE
      fclose(GateDevices_new);
    #endif
    xmk_exit (-1);
  }

  /*
  **  If there are any characters either in the transmitter or
  **  in the receiver flush them in order to avoid confusion
  */
  tcflush(tty_handle, TCIOFLUSH);

  /*
  **  If termio-structure can't be read -> exit
  **  This one is used to retrieve the settings after program run
  */
  /*
  **  If termio-structure can't be read -> exit
  **  This one is used to modify the settings for Cmicro Tester
  */
  if ( (tcgetattr(tty_handle, &old_settings) < 0) ||
       (tcgetattr(tty_handle, &tty_term) < 0) )
  {
    V24_ERROR_HANDLER("Checking for old device settings failed.",ERR_N_GET_TTY_MODE);
    #ifdef SDTGATE
      fclose(GateDevices_new);
    #endif
    xmk_exit (-1);
  }

  /*
  **  The following settings might be confusing, but they can be explained
  **  if reading the man-pages.
  **  Some general explanations:
  **    - binary transmission is used (8bits, no parity, 1 stop bits)
  **    - XON/XOFF - protocol is realized by the software
  **    - no interpretation of special characters is done by the system
  */

  /*
  **  setting options for the input of characters
  */
  tty_term.c_iflag &= ~(BRKINT | PARMRK);
  tty_term.c_iflag &= ~(INPCK | INLCR | IGNCR | ICRNL | IUCLC);
  tty_term.c_iflag &= ~(ISTRIP | IXANY);
  tty_term.c_iflag |= (IGNBRK | IGNPAR);
  tty_term.c_iflag &= ~(IXON | IXOFF);

  /*
  **  setting options for the output
  */
  /*tty_term.c_oflag &= ~OPOST;*/
  tty_term.c_oflag = 0;

  /*
  **  setting general control options
  */
  tty_term.c_cflag &= ~(CBAUD | CSIZE);
  tty_term.c_cflag &= ~(PARENB | HUPCL | CSTOPB);
  tty_term.c_cflag |= (CLOCAL | CREAD | CS8);
  switch( XMK_V24_BAUD )
  {
     case 38400: tty_term.c_cflag |= B38400;
                 break;

     case 19200: tty_term.c_cflag |= B19200;
                 break;

     case 9600:  tty_term.c_cflag |= B9600;
                 break;

     case 4800:  tty_term.c_cflag |= B4800;
                 break;

     case 2400:  tty_term.c_cflag |= B2400;
                 break;

     case 1200:  tty_term.c_cflag |= B1200;
                 break;

     case 600:   tty_term.c_cflag |= B600;
                 break;


     default:
       V24_ERROR_HANDLER("Setting the specified baudrate failed.",ERR_N_TTY_BAUDRATE);
       xmk_exit(-1);
       break;
  }

  /*
  **  setting line control options
  */
  tty_term.c_lflag &= ~(ICANON | ECHO | ISIG | IEXTEN);
  tty_term.c_lflag |= NOFLSH;

  /*
  **  setting special character options
  */
  tty_term.c_cc[VMIN ] = 0;                     /* receive one character at a time */
  tty_term.c_cc[VTIME] = 0;                     /* don' wait for timer to expire   */
  tty_term.c_cc[VSTART] = XMK_XON;
  tty_term.c_cc[VSTOP] = XMK_XOFF;


  /*
  **  set the selected options as the tty-control-structure
  */
  if (tcsetattr(tty_handle, TCSANOW, &tty_term) < 0)
  {
    V24_ERROR_HANDLER("Setting the specified device configuration failed.",ERR_N_SET_TTY_MODE);
    #ifdef SDTGATE
      fclose(GateDevices_new);
    #endif
    xmk_exit(-1);
  }

  #ifdef SDTGATE
    remove(DEVICE_FILE);
    fprintf(GateDevices_new,"%d %s\n", (int)getpid(), XMK_V24_DEVICE);
    fclose(GateDevices_new);
    rename(TEMP_FILE, DEVICE_FILE);
    xmk_TargetStarted = XMK_TRUE;
  #endif

  /*
  **  Initialize some internal values
  */

  TransmitterState   = XMK_UNBLOCKED;
  ReceiverState      = XMK_NOTESC_STATE;

  EnableTransmitter();
}

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_V24Deinit                                                |
+------------------------------------------------------------------------------+
|                                                                              |
|                                                                              |
|  Description :                                                               |
|  Template for deinitialization of the serial interface.                      |
|                                                                              |
|  Parameter    :                                                              |
|  Return       :                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/
/*+FDEF E*/
void xmk_V24Deinit( void )
/*-FDEF E*/
{
  #ifdef SDTGATE
    FILE * GateDevices_old;
    FILE * GateDevices_new;
    char entry_pid[200], entry_device[200];
  #endif

  /*
  ** Deinitialization only makes sense, if initialization took place
  */
  if (tty_handle > 0)
  {
    /*
    **  Flush all input / output
    */
    if (tcflush(tty_handle, TCIOFLUSH) < 0)
    {
      V24_ERROR_HANDLER("Flushing the data of the specified device failed",ERR_N_TTY_IO_FLUSH);
    }

    /*
    **  retrieve options
    */
    if (tcsetattr(tty_handle, TCSANOW, &old_settings) < 0)
    {
      V24_ERROR_HANDLER("Restoring old settings of the specified communications device failed",ERR_N_RETRIEVE_TTY_MODE);
    }

    /*
    **  close tty-device
    */
    if (close (tty_handle) < 0)
    {
      V24_ERROR_HANDLER("Closing the specified communications device failed",ERR_N_CLOSE_TTY);
    }

    #ifdef SDTGATE
      if(!access(DEVICE_FILE , 02))
      {
        GateDevices_new = fopen(TEMP_FILE ,"w");
        if(GateDevices_new != NULL)
        {
          GateDevices_old = fopen (DEVICE_FILE , "r" );
          if(GateDevices_old != NULL)
          {
            while(1)
            {
              if(fscanf(GateDevices_old,"%s", entry_pid) == EOF)
                break;
              if(fscanf(GateDevices_old,"%s", entry_device) == EOF)
                break;

              if( atoi(entry_pid) != (int) getpid())
                fprintf(GateDevices_new,"%s %s\n", entry_pid, entry_device);
            }
            fclose(GateDevices_old);
          }
          fclose(GateDevices_new);
        }
        remove(DEVICE_FILE);
        rename(TEMP_FILE, DEVICE_FILE);
      } /* ... if(!access(DE */
    #endif
  }
}

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_V24Handshake                                             |
+------------------------------------------------------------------------------+
|                                                                              |
|                                                                              |
|  Description :                                                               |
|  A template to retrieve the current serial interface state.                  |
|                                                                              |
|  Parameter    :                                                              |
|  Return       :                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/
/*+FDEF E*/
void xmk_V24Handshake( void )
/*-FDEF E*/
{
  if (TimeNextXon <= CURRENT_TIME)
  {
    if (tcflow(tty_handle, TCION) < 0)
    {
      V24_ERROR_HANDLER("Sending XON handshake failed.",ERR_N_TTYI_ENABLE);
      xmk_exit(-1);
    }
    XMK_COUNT_TX_XON_XOFF(XMK_XON);

    TimeNextXon = CURRENT_TIME + WAITTIME ;
  }
}

/*+FHDR S*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_V24Receive                                               |
+------------------------------------------------------------------------------+
|                                                                              |
|                                                                              |
|  Description :                                                               |
|  Low Level function to receive data from the serial interface.               |
|                                                                              |
|  Parameter    : unsigned char *bytes     buffer                              |
|                 unsigned int anz         number of bytes                     |
|                                                                              |
|  Return       : > 0             number of bytes                              |
|                 = 0             Connection lost                              |
|                 < 0             error                                        |
+------------------------------------------------------------------------------+
*/
/*-FHDR S*/
/*+FDEF S*/
int xmk_V24Receive (unsigned char *bytes, unsigned int anz)
/*-FDEF S*/
{
  int  cnt = 0;

  if((cnt = read(tty_handle, bytes, 10000)) < 0)
  {
    V24_ERROR_HANDLER("Cannot read from serial device",ERR_N_COMMLINK_READ );
  }
  else
  {
    #ifdef SDTGATE
      if( pTraceFile != NULL)
      {
        if( cnt > 0)
        {
          xmk_GateTrace ("Target RawBuffer ", BuildHEXBuffer( bytes, cnt ));
        }
      }
    #endif
  }
  return (cnt);
}

/*+FHDR S*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_V24Send                                                  |
+------------------------------------------------------------------------------+
|                                                                              |
|                                                                              |
|  Description :                                                               |
|  Low Level function to transmit data to serial interface.                    |
|                                                                              |
|  Parameter    : unsigned char *bytes     buffer                              |
|                 unsigned int anz         number of bytes                     |
|                                                                              |
|  Return       : > 0             number of bytes                              |
|                 = 0             Connection lost                              |
|                 < 0             error                                        |
+------------------------------------------------------------------------------+
*/
/*-FHDR S*/
/*+FDEF S*/
int xmk_V24Send( unsigned char *bytes, unsigned int anz)
/*-FDEF S*/
{
  int Bytes_Written;

  Bytes_Written = write(tty_handle, bytes, anz);

  #if 0
    {
      V24_ERROR_HANDLER("Cannot write to COM device",ERR_N_COMMLINK_WRITE);
      xmk_exit (-1);
      return (XMK_ERROR);
    }
  #endif

  #ifdef SDTGATE
    if( pTraceFile != NULL)
    {
      xmk_GateTrace ("From HOST ", BuildHEXBuffer( bytes, anz ));
    }
  #endif

  return(Bytes_Written);
}


/*+FHDR S*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_ExtractControl                                           |
+------------------------------------------------------------------------------+
|                                                                              |
|                                                                              |
|  Description :                                                               |
|  This function detects control-characters in the given hex-buffer, executes  |
|  the accompanying actions and returns the cleaned up buffer.                 |
|                                                                              |
|                                                                              |
|  Parameter    : buffer - pointer to the receiver buffer                      |
|                 number - amount of characters in the receiver buffer         |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR S*/
/*+FDEF S*/
void xmk_ExtractControl( unsigned char * buffer, unsigned long * number)
/*-FDEF S*/
{
  unsigned int    help_cnt, cnt;

  cnt         = 0;
  help_cnt    = 0;

  /*
  **  for all the characters in the buffer
  */
  for (cnt=0; cnt < *number; cnt++)
  {
    /*
    **  ESC detected -> next character is a binary data
    */
    if (ReceiverState == XMK_ESC_STATE)
    {
      swap_buffer[help_cnt] = buffer[cnt];
      help_cnt++;
      ReceiverState = XMK_NOTESC_STATE;
    }
    else
    {
      /*
      **  control character detected -> enable transmitter
      */
      if (buffer[cnt] == XMK_XON)
      {
        XMK_COUNT_RX_XON;
        TransmitterState = XMK_UNBLOCKED;
      }
      /*
      **  control character detected -> disable transmitter
      */
      else if (buffer[cnt] == XMK_XOFF)
      {
        XMK_COUNT_RX_XOFF;
        TransmitterState = XMK_BLOCKED;
      }
      /*
      **  control character detected -> next character isn't to be checked
      */
      else if (buffer[cnt] == XMK_ESC)
      {
        ReceiverState = XMK_ESC_STATE;
      }
      /*
      **  copy binary data
      */
      else
      {
        swap_buffer[help_cnt] = buffer[cnt];
        help_cnt++;
      }
    }
  }

  /*
  **  Buffer contains only binary data, no control character
  **  return this buffer and the corrected number of bytes
  */
  (void)memcpy ( (void *) buffer, (void *) swap_buffer, help_cnt);
  *number = help_cnt;
}

/*+FHDR S*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_MaskControl                                              |
+------------------------------------------------------------------------------+
|                                                                              |
|                                                                              |
|  Description :                                                               |
|  This function detects assumed control-characters in the given hex-buffer    |
|  and masks them with ESC.                                                    |
|                                                                              |
|                                                                              |
|  Parameter    : buffer - pointer to the transmitter buffer                   |
|                 number - amount of characters in the transmitter buffer      |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR S*/
/*+FDEF S*/
void xmk_MaskControl( unsigned char * buffer, unsigned long * number)
/*-FDEF S*/
{
  unsigned int    help_cnt, cnt;

  help_cnt = 0;
  cnt      = 0;

  /*
  **  detect the number of characters to mask
  */
  while (help_cnt < *number)
  {
    if ( (buffer[help_cnt] == XMK_ESC) ||
         (buffer[help_cnt] == XMK_XON) ||
         (buffer[help_cnt] == XMK_XOFF))
    {
      cnt ++;
    }
    help_cnt++;
  }

  /*
  **  allocate memory for the masked buffer
  */
  cnt         = 0;
  help_cnt    = 0;


  /*
  **  for all the characters in the buffer
  */
  while (cnt < *number)
  {
    /*
    **  insert ESC, to ensure the character to be interpreted correctly
    */
    if ((buffer[cnt] == XMK_ESC) ||
        (buffer[cnt] == XMK_XON) ||
        (buffer[cnt] == XMK_XOFF))
    {
      XMK_COUNT_TX_ESC;
      swap_buffer[help_cnt] = XMK_ESC;
      help_cnt++;
    }

    swap_buffer[help_cnt] = buffer[cnt];
    cnt++;
    help_cnt++;
  }

  /*
  **  This is an error, because the size of the given buffer is too
  **  small to keep all the masked characters
  */
  if (help_cnt > SWAP_BUF_SIZE)
  {
    V24_ERROR_HANDLER( "Internal buffer size exceeded" ,ERR_N_BUF_SIZE_EXCEEDED);
    help_cnt = SWAP_BUF_SIZE;
  }

  /*
  **  Buffer contains only binary data, no control character
  **  return this buffer and the corrected number of bytes
  */
  (void)memcpy ( (void *) buffer, (void *) swap_buffer, help_cnt);
  *number = help_cnt;

}

/*+FHDR S*/
/*
+------------------------------------------------------------------------------+
|  Functionname : EnableTransmitter                                            |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function lets the suspended transmitter continue.                      |
|                                                                              |
|  Parameter    :                                                              |
|  Return       :                                                              |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR S*/
/*+FDEF S*/
static void EnableTransmitter(void)
/*-FDEF S*/
{
  if (tcflow(tty_handle, TCOON) < 0)
  {
    V24_ERROR_HANDLER("Cannot enable the specified device.",ERR_N_TTYO_ENABLE);
    xmk_exit(-1);
  }
  TransmitterState = XMK_UNBLOCKED;
}

#if 0
/*+FHDR S*/
/*
+------------------------------------------------------------------------------+
|  Functionname : DisableTransmitter                                           |
+------------------------------------------------------------------------------+
|                                                                              |
|                                                                              |
|  Description :                                                               |
|  This function suspends the transmitter.                                     |
|                                                                              |
|  Parameter    :                                                              |
|                                                                              |
|  Return       :                                                              |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR S*/
/*+FDEF S*/
static void DisableTransmitter(void)
/*-FDEF S*/
{
  if (tcflow(tty_handle, TCOOFF) < 0)
  {
    V24_ERROR_HANDLER("Cannot disable the specified device.",ERR_N_TTYO_DISABLE);
    xmk_exit(-1);
  }
  TransmitterState = XMK_BLOCKED;
}
#endif

#endif /* __UX_V24_C_ */

