/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*+MHDR*/
/*
+------------------------------------------------------------------------------+
#  Modulname: mk_cpu.c
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|    This module is a template for functions, which are to be filled up        |
|    by the user of the Cmicro Kernel.                                         |
|                                                                              |
|    1.Character read / write on hardware / OS-level                           |
|      xmk_PutString  () Unblocking function to write a string to display.     |
|                        Called within this module only (xmk_printf).          |
|      xmk_GetChar    () Unblocking Character read function. Used by the       |
|                        Cmicro Tester in some cases.                          |
|      xmk_TermInit   () Terminal initialization                               |
|      xmk_TermDeinit () Terminal deinitialization                             |
|      xmk_printf     () Same as usual printf known from ANSI C compiler.      |
|                        Can be used if C compiler does not support printf     |
|                        or sprintf function. Used by the Cmicro Tester in     |
|                        some cases.                                           |
|                                                                              |
|      Cmicro Tester                                                           |
|           !                                                                  |
|         calls                                                                |
|           !                                                                  |
|           V                                                                  |
|       xmk_printf                                                             |
|           !                                                                  |
|         calls                                                                |
|           !                                                                  |
|           V                                                                  |
|       xmk_PutString                                                          |
|                                                                              |
|    2.Functions for dynamic memory handling.                                  |
|      This is an intermediate layer to the compiler function library          |
|      The following functions exists                                          |
|      xAlloc                () Used for memory allocation                     |
|      xFree                 () Used to free memory                            |
+------------------------------------------------------------------------------+
*/
/*-MHDR*/

#ifndef __MK_CPU_C_
#define __MK_CPU_C_

 
/*+IMPORT*/
/*====================  I M P O R T  =========================================*/
#include "ml_typ.h"


#ifdef XMK_UNIX
  #include <unistd.h>
  #include <signal.h>
  #include <errno.h>
#endif

#ifdef XMK_WINDOWS
  #include <windows.h>
#endif
 
#if defined(linux) || defined(XMK_UNIX) 
  #include <stdarg.h>
#endif

#if defined(BORLAND_C) 
  #include <stdarg.h>
#endif

#if defined(MICROSOFT_C)
  #include <stdarg.h>
  #ifdef __cplusplus
    extern "C"
    {
      #include <conio.h>
    }
  #endif
#endif

 
/*============================================================================*/
/*-IMPORT*/
 
 
/*+MGG*/
/*====================  V A L U E S  O F  T H I S   M O D U L E  =============*/
 
/*--------------------  Constants,  Macros  ----------------------------------*/

#ifdef XSYSID 
  /* 
  ** CAUTION ! 
  ** ============ 
  ** This module cannot be used when partitioning is used. The reason 
  ** for this is that the functions of this module operate on global 
  ** variables and partitioned systems may preempt each other when 
  ** an Real Time Operating System is used. 
  ** However, users can use this module as a basis for implementing 
  ** their own terminal and memory management functions.  
  */ 
  #error "ERROR_in_mk_cpu_c_Module_cannot_be_used_for_Partitioning" 
#endif /* ... XSYSID */ 


#ifdef P
#undef P
#endif
 
/*--------------------  Typedefinitions     ----------------------------------*/

#define xmk_exit exit
/*--------------------  Functions    -----------------------------------------*/
#ifdef XMK_UNIX
  static void sig_catch(int);
#endif

/*--------------------  Variables    -----------------------------------------*/
 
#ifdef XMK_UNIX
  struct termios tty_buf, xmk_OldTTYSettings;
#endif

/*============================================================================*/
/*-MGG*/
 
/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_PutString                                                |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  A template for how to print out a character string, terminated with 0.      |
|                                                                              |
|  CAUTION                                                                     |
|  ==========                                                                  |
|  The function must return immediately, i.e.may not be blocking on the        |
|  output device. If the user does not care about this restriction, the correct|
|  function of other program parts cannot be guaranteed.                       |
|                                                                              |
|  Parameter    : char * Param1 Pointer to string, terminated with 0           |
|                 int    length string length                                  |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
static void xmk_PutString ( char * Param1 )
/*-FDEF E*/
{

  /*
  ** NEVER CALL xmk_printf here !!!!!
  ** NEITHER USE XMK_PRINTF macros !!!!!
  */
  #if defined(XMK_UNIX)

    (void)fprintf (stdout,"%s", Param1);

  #elif defined(BORLAND_C)

    #ifdef XMK_WINDOWS
      (void)fprintf (stdout,"%s", Param1);
    #else
      /* Non Console applications do not support fprintf in Windows !!! */
      xmk_PutString_is_not_filled_yet = 0; 
    #endif

  #elif defined(MICROSOFT_C)
    #ifdef XMK_WINDOWS
      (void)fprintf (stdout,"%s", Param1);
    #else
      /* Non Console applications do not support fprintf in Windows !!! */
      xmk_PutString_is_not_filled_yet = 0; 
    #endif
  #else         
    /*
    ** User must add his own C compiler here
    */
    xmk_PutString_is_not_filled_yet = 0; 

  #endif                

  return ;
}


/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_GetChar                                                  |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  A template to ask the OS, if the user has typed any key and which one.      |
|  If the user has pressed no key, the function returns with EOF.              |
|  If any key was pressed, the function returns with the key value.            |
|                                                                              |
|  CAUTION                                                                     |
|  ==========                                                                  |
|  The function must return immediately, i.e.may not be blocking on the        |
|  input device. If the user does not care about this restriction, the correct |
|  function of other program parts cannot be guaranteed.                       |
|                                                                              |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       : int    - character or XMK_EOF                                |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/
 
/*+FDEF E*/
int xmk_GetChar ( void )
/*-FDEF E*/
{
  #ifdef XMK_UNIX
    int cnt;
    static char c;
  #endif

  #if defined(BORLAND_C) || defined(MICROSOFT_C)
    int c;
  #endif
 
  #ifdef XMK_ADD_PRINTF_CPU
    XMK_FUNCTION("xmk_GetChar");
  #endif
 
  #if defined(XMK_UNIX)
 
    cnt = read ( STDIN_FILENO , (void *) &c, 1 );
 
    if (cnt < 0)
    {
      (void)fprintf (STDOUT," cnt is : %d", cnt);
    }
 
    if (cnt>0)
    {
      return (((int) c) & 0xff);
    }
 
    return ((int) XMK_EOF);

  #elif defined(BORLAND_C) || defined(MICROSOFT_C)

    if (! kbhit () ) return (XMK_EOF);
 
    c = _getch ( );
 
    if (XMK_IS_PRINTABLE_CHAR(c))
      (void)fprintf (STDOUT, "%c", (char) c);
  
    return (c);
 
  #else

    #ifdef XMK_ADD_PRINTF_CPU
      XMK_TRACE_EXIT("xmk_GetChar");
    #endif
 
    return (XMK_FALSE);
 
  #endif
}
 
#ifdef XMK_UNIX

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : sig_catch                                                    |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  A template to react on any UNIX process signal. This function represents    |
|  the signal handler, that is called by UNIX in the case if it was defined    |
|  correctly with the "signal()" C function. The initialization of all signals |
|  and their handling is done within the xmk_TermInit () C function within this|
|  module.                                                                     |
|                                                                              |
|  Parameter    : int signo - Signal's number                                  |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/
 
/*+FDEF E*/
static void sig_catch(int signo)
/*-FDEF E*/
{
  static int sema = 0;
  int i = 6; /* Wati 6 seconds before exit */

  XMK_SUPPRESS(SIGNO);

  /*
  ** Only one signal is handled here
  */
  if (sema) return;
  sema = 1;
 
  (void)fprintf(stderr, "**ERR:Using emergency exit due to system signal.\n");
  
  #ifdef XMK_RITS
    if (experr == 255)
    {
      XMK_RITS_TEST_OK
    }
  #endif
  
  while (i--)
  {
    (void)fprintf(stderr, ".");
    (void)sleep (1);
  }

  xmk_exit(0);
}
 
#endif /* ... XMK_UNIX */

#if defined (XMK_USE_OS_ENVIRONMENT) 
/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_TermInit                                                 |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  A template to initialize the user terminal.                                 |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/
 
/*+FDEF E*/
void        xmk_TermInit ( void )
/*-FDEF E*/
{
  #ifdef XMK_ADD_PRINTF_CPU
    XMK_FUNCTION("xmk_TermInit");
  #endif

  #ifdef XMK_UNIX
    if (signal(SIGHUP, sig_catch) == SIG_ERR)
      (void)fprintf(stderr, "Warning: Could not set signalhandler on UNIX signal SIGHUP (problem ignored).\n");

    if (signal(SIGSEGV, sig_catch) == SIG_ERR)
      (void)fprintf(stderr, "Warning: Could not set signalhandler on UNIX signal SIGSEGV (problem ignored).\n");

    if (signal(SIGPIPE, sig_catch) == SIG_ERR)
      (void)fprintf(stderr, "Warning: Could not set signalhandler on UNIX signal SIGPIPE (problem ignored).\n");

    if (signal(SIGINT, sig_catch) == SIG_ERR)
      (void)fprintf(stderr, "Warning: Could not set signalhandler on UNIX signal SIGINT (problem ignored).\n");

    if (signal(SIGQUIT, sig_catch) == SIG_ERR)
      (void)fprintf(stderr, "Warning: Could not set signalhandler on UNIX signal SIGQUIT (problem ignored).\n");

    if (signal(SIGTERM, sig_catch) == SIG_ERR)
      (void)fprintf(stderr, "Warning: Could not set signalhandler on UNIX signal SIGTERM (problem ignored).\n");
    
    #ifdef HPUXANSICC
      if (signal(SIGCHLD, sig_catch) == SIG_ERR)
        (void)fprintf(stderr, "Warning: Could not set signalhandler on UNIX signal SIGCLD (problem ignored).\n");
    #else 
      if (signal(SIGCLD, sig_catch) == SIG_ERR)
        (void)fprintf(stderr, "Warning: Could not set signalhandler on UNIX signal SIGCLD (problem ignored).\n");  
    #endif
    
    if (tcflush(STDIN_FILENO, TCIOFLUSH) == -1)
    {
      (void)fprintf(stderr, "Warning: Could not flush terminal (problem ignored).\n");
    }
 
    /*
    ** Read the current tty settings ...
    */
    if (tcgetattr(STDIN_FILENO, &tty_buf) == -1)
    {
      (void)fprintf(stderr, "Warning: Could not get current terminal settings (problem ignored).\n");
    }
 
    /*
    ** Save the current tty settings
    */
    (void)memcpy ((void*) &xmk_OldTTYSettings,
                  (void*) &tty_buf,
                  sizeof (xmk_OldTTYSettings));
 
    /*
    ** Modify the current tty settings to canonical without echo ...
    ** (fgetc must return immediately when no key was pressed)
    */
    tty_buf.c_lflag &= ~ICANON;
    tty_buf.c_cc[VMIN]  = 0;
    tty_buf.c_cc[VTIME] = 0;
    tty_buf.c_cc[VERASE] = 8;

    #ifdef ECHOCTL_OFF
      tty_buf.c_lflag &= ~ECHOCTL;
    #endif
 
    /*
    ** Write the new tty settings ...
    */
    if (tcsetattr(STDIN_FILENO, TCSAFLUSH, &tty_buf) == -1)
    {
      (void)fprintf(stderr, "Warning: Could not initialize terminal (problem ignored).\n");
    }
  #endif
 
  #ifdef XMK_ADD_PRINTF_CPU
    XMK_TRACE_EXIT("xmk_TermInit");
  #endif
 
  }
 
/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_TermDeinit                                               |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  A template to initialize the user terminal.                                 |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/
 
/*+FDEF E*/
void        xmk_TermDeinit ( void )
/*-FDEF E*/
{
  #ifdef XMK_ADD_PRINTF_CPU
    XMK_FUNCTION("xmk_TermDeinit");
  #endif
 
  #ifdef XMK_UNIX
 
    /*
    ** Restore the old terminal settings ...
    */
    if (tcsetattr(STDIN_FILENO, TCSANOW, &xmk_OldTTYSettings) == -1)
    {
      (void)fprintf(stderr, "Warning: Could not reset terminal (problem ignored).\n");
    }
  #endif
 
  #ifdef XMK_ADD_PRINTF_CPU
    XMK_TRACE_EXIT("xmk_TermDeinit");
  #endif
 
} 
#endif /* ... #if defined (XMK_USE_OS_ENVIRONMENT) */

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_printf                                                   |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  A template to print a string by using var args.                             |
|                                                                              |
|  This function is called from any place in the Cmicro Library, Cmicro Kernel |
|  or generated C code, if the printf functionality is compiled with at least  |
|  one of the XMK_ADD_PRINTF* defines.                                         |
|  The function must return immediately, i.e.may not be blocking on the output |  
|  device. If the user does not care about this restriction, the correct       |   
|  function of other program parts cannot be guaranteed.                       |
|  The function can be used for ANSI C compilers only, because optional        |
|  argument lists are used like in the printf function of the standard C       |
|  library.                                                                    |
|                                                                              |
|  Parameter    : char* format        Usual printf convention                  |
|                 ...                 var args                                 |
|                                                                              |
|  Return       : int                 without any meaning, because this is     |
|                                     is used to let declaration look like     |
|                                     declaration for printf.                  |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
int        xmk_printf ( char* format, ... )
/*-FDEF E*/
{

  #if defined(BORLAND_C) || defined(MICROSOFT_C) || defined (_GCC_)
    char* strg = (char*) malloc(512 * sizeof (char));
    va_list params;

    va_start (params, format); 
    vsprintf (strg, format, params);

    XMK_BEGIN_CRITICAL_PATH 
      xmk_PutString (strg);
    XMK_END_CRITICAL_PATH 

    va_end (params);
    free (strg);
  #else
    /*
    ** User must add his own C compiler here
    */
    #error "xmk_printf not_filled yet"
  #endif
  return (0);

} 

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xAlloc                                                       |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  A template for memory allocation.                                           |
|  The function is called from any place in the Cmicro Library, Cmicro Kernel  |
|  Cmicro Tester or generated C code, if memory is to be allocated dynamically |
|  The user may choose between the dynamic memory allocation functions from the|
|  C compiler or operating system or the dynamic memory allocation functions   |
|  from Cmicro.                                                                |
|                                                                              |
|  Parameter    : unsigned int Size     requested memory area block - size     |
|                                                                              |
|  Return       : SDL_Charstring        Pointer to allocated area or NULL,     |
|                                       if no dynamic allocation was possible. |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
void xmk_RAM_ptr xAlloc( xptrint  Size )
/*-FDEF E*/
{
  void xmk_RAM_ptr P;

#ifdef XMK_USE_SDL_MEM
  /*
  ** XMK_USE_SDL_MEM : Use Cmicro memory management
  */
  P =  (void xmk_RAM_ptr) xmk_Calloc ( 1, Size );

#else
  /*
  ** ! XMK_USE_SDL_MEM : Use memory management from C Compiler or RTOS 
  */
  #if defined(IARC51)
    /*
    ** Use memory management from C Compiler or RTOS 
    */
    /* alternative implementation: ( if calloc() is not available ) */
    {
      P = (char xmk_RAM_ptr) malloc((unsigned)Size);
      (void)memset(P, 0, (int)Size);
    }
  #else
    /* alternative implementation: ( if calloc() is not available ) */
    {
      P = (void xmk_RAM_ptr)calloc((unsigned)1, (unsigned)Size);
    }
  #endif

#endif /* ... XMK_USE_SDL_MEM */

  /*
  ** ERROR CHECK : No more memory ?
  */
  if ( ! P )
  {
    #ifdef XMK_NO_MORE_MEMORY
      XMK_NO_MORE_MEMORY;
    #else
      /*
      ** ====================
      **    CAUTION !!!
      ** ====================
      ** The user must define the macro XMK_NO_MORE_MEMORY.
      **
      ** The user defines the reaction on "No more memory available"
      ** by filling this macro.
      **
      ** An example for an appropriate reaction could look like :
      ** * Display Error (if possible), 
      ** * go into a safe state and call exit() C function.
      **   Note: The term safe state refers to everything that must be done in this case
      **   like for example backing up data, terminating any network connections etc.
      ** * exit / reset program
      **
      ** DO NOT USE xmk_printf because this uses malloc (512) !!!!
      **
      ** An example for XMK_NO_MORE_MEMORY could look like : 
      ** #define XMK_NO_MORE_MEMORY \
         { fprintf (stderr, "**ERROR: No more memory available.exit\n"); xCloseEnv ();exit (-1); }
      */
      #error "ERROR_in_mk_cpu_c_You_Must_Define_XMK_NO_MORE_MEMORY"
    #endif
  }
  return (P);

}
 
 
/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xFree                                                        |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This is the counter part of xAlloc. The function is called when a memory    |
|  block that was allocated with xAlloc before can be deallocated again.       |
|                                                                              |
|  Parameter    : void **                      the memory block which should   |
|                                              be freed                        |
|                                                                              |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
void xFree( void xmk_RAM_ptr xmk_RAM_ptr  P )
/*-FDEF E*/
{

#ifdef XMK_USE_SDL_MEM
  /*
  ** Use Cmicro memory management
  */
  if (! *P)
  {
    return ;
  }

  xmk_Free(*P);
  *P = (void xmk_RAM_ptr)0;
  return ;
#else
  /*
  ** Use memory management from C Compiler or RTOS 
  */
  if (! *P) 
  {
    return ;
  }

  #if defined(_GCC_)
   free((char xmk_RAM_ptr)*P);
  #else
   free(*P);
  #endif

 *P = (void xmk_RAM_ptr)0;

#endif /* ... XMK_USE_SDL_MEM */

}

#endif /* ... __MK_CPU_C_*/
