/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*+MHDR*/
/*
+------------------------------------------------------------------------------+
#  Modulname: mk_user.c
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|    This module contains functions, which are to be filled up by the user.    |
|                                                                              |
|    These are :                                                               |
|                                                                              |
|    1.main                                                                    |
|                                                                              |
|    2.Functions for central errorhandling                                     |
|      ErrorHandler                                                            |
|      xSDLOpError                                                             | 
|      Gate_printf                                                             |
|      xmk_UserFreeSignal                                                      |
|      xmk_UserErrAction                                                       |
|      xmk_UserWarnAction                                                      |
|                                                                              |
|    3.Functions for the Cmicro Kernel (optional in order to optimize)         |
|      xRouteSignal                                                            |
|                                                                              |
|    4.Functions to trigger a hardware-Watchdog                                |
|      WatchdogTrigger                                                         |
|      xmk_InitWachdog                                                         |
|                                                                              | 
|    5.Function for Call Stack                                                 |   
|      xmk_CallStackPush                                                       |
|      xmk_CallStackPop                                                        |
|      xmk_CallStackTrace                                                      |       
|                                                                              |       
|    6.Light Integration                                                       |
|      xmk_QueryOSQueue                                                        |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-MHDR*/

#ifndef __MK_USER_C_
#define __MK_USER_C_

/*+IMPORT*/
/*====================  I M P O R T  =========================================*/
#include "ml_typ.h"

#ifdef XSYSID 
  /* 
  ** CAUTION ! 
  ** ============ 
  ** This module cannot be used when partitioning is used. The reason 
  ** for this is that the functions of this module operate on global 
  ** variables and partitioned systems may preempt each other when 
  ** an Real Time Operating System is used. 
  ** However, users can use this module as a basis for implementing 
  ** their own environment function.  
  */ 
  #error "ERROR_in_mk_user_c_Module_cannot_be_used_for_Partitioning" 
#endif /* ... XSYSID */ 


#if defined(XMK_USE_MPM)
    #define SDTGATE
    #include "mcod.h"
    #include "mcodlib.hpp"
    #include "mp_lib.h"
#endif

#if defined(SCMADEBCLENVCOM) || defined(SCMADEBCLCOM) || defined(SCMADEBCOM)
  extern char MPMBuffer[];
  extern xmk_T_GateLineStatusCnf xmk_LineStatus;
#endif

/*============================================================================*/
/*-IMPORT*/


/*+MGG*/
/*====================  V A L U E S  O F  T H I S   M O D U L E  =============*/

/*--------------------  Constants,  Macros  ----------------------------------*/
#if defined(SCMADEBCLENVCOM) || defined(SCMADEBCLCOM) || defined(SCMADEBCOM)
  #define PostToSDTMT(msg, data, len) \
          MPMSendToTool(ID_SDTMT, msg, data, len); \
          xmk_LineStatus.received_frames_OK++; \
          xmk_LineStatus.chars_received+=len;
        
  #define MAX_CALL_STACK_ARRAY 256
#endif

/*---+---------------------------------------------------------------
     Check automatically generated #ifdef
-------------------------------------------------------------------*/
#if defined(XMK_IFC_TIME) && defined(XMK_CFG_TIME)
  #if XMK_IFC_TIME != XMK_CFG_TIME
    /*
    ** If the following line is compiled/leads to an error during
    ** compilation, then the generated systemname.ifc file does not match with
    ** the generated sdl_cfg.h file. You should newly generate C code
    ** and be sure that each of the generated C files and the symbolfile
    ** is used appropriately
    */
    #error "ERROR_IllegalFileConfiguration_ifc_and_sdl_cfg_file_See_mk_user.c"
  #endif
#endif
 

/*--------------------  Typedefinitions     ----------------------------------*/

/*--------------------  Functions    -----------------------------------------*/
#if defined(SCMADEBCLENVCOM) || defined(SCMADEBCLCOM) || defined(SCMADEBCOM)
  static void Gate_printf              ( char * );
#endif
/*--------------------  Variables    -----------------------------------------*/
#ifdef XMK_ADD_CQUERY_ERROR
  xmk_T_ERR_INF xmk_LastStoredError = 0;
#endif

#ifdef XMK_RITS
  int xmk_RITS_result = 0;
#endif

#if defined(SCMADEBCLENVCOM) || defined(SCMADEBCLCOM) || defined(SCMADEBCOM)
  /* Call Stack emulation and trace */
  char * CallStackPointerArray [MAX_CALL_STACK_ARRAY];
  int    CallStackPointer = -1;
#endif

#ifdef XMK_USE_SDL_MEM
  char _user_defined_Memory_Area[XMK_MAX_MALLOC_SIZE];
#endif


/*============================================================================*/
/*-MGG*/

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : main                                                         |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|    This is a simple implementation of the main function. If the functionality|
|    doesn't fulfill the users needs, the user should change this function.    |
|    For target applications the define XMK_USE_OS_ENVIRONMENT is to be unset. |
|    If the Cmicro Tester is conditionally compiled (XMK_ADD_MICRO_TESTER),    |
|    the initialization is performed via the host.                             |
|    The trace is fully initialized, e.g.all events will be traced.            |
|    If the xmk_Malloc/xmk_Free functions of Cmicro are to be used             |
|    (XMK_USE_SDL_MEM), then the user must supply a variable named             |
|    #ifdef XMK_USE_SDL_MEM                                                    |
|    _user_defined_Memory_Area[XMK_MAX_MALLOC_SIZE]);                          |
|    #endif                                                                    |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
#ifdef XLI_LIGHT_INTEGRATION
  XLI_SDL_TASK_FUNCTION
#else
  int main()
#endif
/*-FDEF E*/
{

  XLI_TEMP_TASK_VARS;
  /*
  ** Initialisation of the OS task can be done here
  */
  XLI_OS_TASK_INIT;

  #ifdef XMK_ADD_PRINTF_SCHEDULER
    XMK_FUNCTION("main");
  #endif

  #ifdef XMK_USE_SDL_MEM
    /*
    **  You have to spend a memory area (size: XMK_MAX_MALLOC_SIZE t.b.d. in ml_mcf.h) ,
    **  which will be managed by the module ml_mem.c
    */
    xmk_MemInit(&_user_defined_Memory_Area[0], &_user_defined_Memory_Area[XMK_MAX_MALLOC_SIZE]);
  #endif

  #ifdef XMK_USE_OS_ENVIRONMENT
    /*
    ** Try to initialize the terminal
    ** i.e.to enable a non blocking Character read function.
    */
    xmk_TermInit ();
  #endif /* ... XMK_USE_OS_ENVIRONMENT */

  /*
  ** Init OS Queue for Light Integrations only 
  */
  XLI_CREATE_OS_QUEUE;

  /*
  ** OS task sync for Light Integrations only 
  */  
  XLI_START_OS_TASK_SYNC; 

  #ifdef XMK_USE_DEBUGGING
    /*
    ** Initialization of debugging takes place here
    */
    xmk_DebugInit();
  #endif

  /*
  **   initialize the signal queue
  */
  xmk_InitQueue() ;


  #ifdef XMK_ADD_MICRO_TESTER
    /*
    ** Initialize Cmicro Tester ...
    */
    xmk_MicroTesterInit( );
  #endif

  #ifdef XMK_USE_KERNEL_WDTRIGGER
    xmk_InitWatchdog ( );
  #endif
  
  /* C o n f i r m  c u r r e n t        */
  /* S D L - S Y S T E M - S C A L I N G */
  #if defined (XMK_USE_MON) && defined (XMK_ADD_PRINTF_ADDITIONAL) 
    xmk_MonConfig ();
  #endif

  /*
  ** I n i t i a l i z e   C m i c r o   K e r n e l ...
  */
  xmk_InitSDL ();
  #ifdef XMK_ADD_PRINTF_ADDITIONAL
    PRINTF (("Init done\n"));
  #endif


  /*
  ** R u n   C m i c r o   K e r n e l  ...
  */

  #ifdef XMK_ADD_PRINTF_ADDITIONAL
    PRINTF (("Starting .... done\n"));
  #endif

  xmk_RunSDL ();

  #ifdef XMK_USE_xCloseEnv
    /*
    ** Close Interfaces at the environment
    */
    xCloseEnv ();
  #endif

  #if defined (XMK_USE_OS_ENVIRONMENT)
    /*
    ** Deinitialize the terminal
    */
    xmk_TermDeinit ();
  #endif

  /*
  ** Quit the program ...
  */
  #ifdef XMK_ADD_PRINTF_ADDITIONAL
    PRINTF (("Bye bye...\n"));
  #endif

  #ifdef XMK_ADD_MICRO_TESTER
    xmk_MicroTesterDeinit();
  #endif

  #ifdef XMK_ADD_PRINTF_SCHEDULER
    XMK_TRACE_EXIT("main");
  #endif

  XLI_END_OS_TASK_SYNC;
  
  #ifdef XMK_RITS
    XMK_KERNEL_EXIT(xmk_RITS_result);
  #else
    XMK_KERNEL_EXIT (0);
  #endif

} /* END OF FUNCTION */



#if defined(XECSOP)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xSDLOpError                                                  |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This is a function which is to filled up by the user. The function is an    |
|  central error handling function for ADTs. It is compiled only if XECSOP     |
|  was defined in ml_mcf.h.                                                    |
|                                                                              |
|  Parameter    :                                                              |
|            char *xmk_String1,     - the SDL ADT operators name plus detail   |
|            char *xmk_String2,     - the reason for failure                   |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
void xSDLOpError ( char * xmk_String1, char *xmk_String2 )
/*-FDEF E*/
{

  #ifdef XMK_ADD_PRINTF_USER
      XMK_FUNCTION("xSDLOpError");
  #endif

  #ifdef XMK_ADD_PRINTF_ADDITIONAL
    PRINTF (("ERR:IN ADT:%s\n%s\n", xmk_String1, xmk_String2));
  #endif

  ErrorHandler (ERR_N_PREDEFINED_OPERATOR_CALL);  

  #ifdef XMK_ADD_PRINTF_USER
    XMK_TRACE_EXIT("xSDLOpError");
  #endif

} /* END OF FUNCTION */

#endif /* #if defined(XECSOP) */


#ifndef XMK_USE_NO_ERR_CHECK

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : ErrorHandler                                                 |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This is a function which is to filled up by the user. The function is the   |
|  central ErrorHandler. The Cmicro Kernel, Cmicro Tester as well as the       |
|  SDL-Application are the main clients of this function.                      |
|                                                                              |
|  Parameter    :                                                              |
|            xmk_T_ERR_INF error_info   -   given error number                 |
|                                      (see headerfile *err.h)                 |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
void ErrorHandler ( xmk_T_ERR_INF error_info )
/*-FDEF E*/
{
  #ifdef XMK_ADD_ERRORTABLE
    xmk_T_ERR_NUM i; /* for all error entries */
  #endif

  xmk_T_ERR_NUM error_nr;

  #ifdef XMK_ADD_PRINTF_USER
    XMK_FUNCTION("ErrorHandler");
  #endif

  /*
  ** extract the error number from the error information
  */    
  error_nr = (xmk_T_ERR_NUM)error_info;
  
  #ifdef XMK_ADD_CQUERY_ERROR
    /* Variable stores the last errornumber for the command interface ... */
    xmk_LastStoredError = error_info ;
  #endif

  #ifdef XMK_RITS
    /*
    ** For testing errorhandling with a regression test
    */
    if (experr == error_info)
    {
      XMK_RITS_TEST_OK
    }
  #endif

  #ifdef XMK_ADD_TSYS_ERROR
    /*
    ** Trace of Errors via communication interface ...
    ** Note : Not all error situations can be traced
    **        (i.e.an error on the communication interface)
    */
    if(error_info !=  ERR_N_RING_WRITE_LENGTH)
    {  
      xmk_tsys_error (error_info);
    }

  #endif

  #if defined(XMK_WARN_ACTION_HANG_UP) || defined(XMK_ERR_ACTION_HANG_UP)
      while (1);
  #endif

  #ifdef XMK_ADD_ERRORTABLE
    for ( i = 0 ; err_text[i].infnr != 0 ; i++ )
    {
      if ( err_text[i].infnr == error_info )
      {
        if (XMK_IS_FATAL(error_info))
        {
          #ifdef XMK_ADD_PRINTF_ERROR
            (void)fprintf (stderr, "\n**ERR: %d %s\n", error_nr, err_text[i].p_text ) ;
          #endif
          
          #ifdef XMK_ERR_ACTION_USER
            xmk_UserErrAction( error_nr );
          #endif
          
          #ifdef XMK_ADD_PRINTF_ADDITIONAL
            PRINTF (("ERR: ErrorNumber=%d\n", error_nr));
          #endif
        }
        else
        {
          #ifdef XMK_ADD_PRINTF_ERROR
            (void)fprintf (stderr, "\n**WARNING: %d %s\n", error_nr, err_text[i].p_text ) ;
          #endif
          
          #ifdef XMK_WARN_ACTION_USER
            xmk_UserWarnAction ( error_nr );
          #endif
          
          #ifdef XMK_ADD_PRINTF_ADDITIONAL
            PRINTF (("WARNING: ErrorNumber=%d\n", error_nr));
          #endif
        }
        
        #ifdef XMK_ADD_PRINTF_USER
         XMK_TRACE_EXIT("ErrorHandler");
        #endif
        
        return;         
      }
    }
    (void)fprintf (stderr, "\n**ERR:ILLEGAL ERROR MESSAGE:%d\n", error_nr ) ;
    XMK_TRACE_EXIT("ErrorHandler");    

  #else /* no XMK_ADD_ERRORTABLE */
    if (XMK_IS_FATAL(error_info))
    {
      (void)fprintf (stderr, "\n**ERR: %d\n", error_nr ) ;
    
      #ifdef XMK_ERR_ACTION_USER
        xmk_UserErrAction( error_nr );
      #endif
    
      #ifdef XMK_ADD_PRINTF_ADDITIONAL
        PRINTF (("ERR: ErrorNumber=%d\n", error_nr));
      #endif
    }
    else
    {
      (void)fprintf (stderr, "\n**WARNING: %d\n", error_nr ) ;
    
      #ifdef XMK_WARN_ACTION_USER
        xmk_UserWarnAction ( error_nr );
      #endif
    
      #ifdef XMK_ADD_PRINTF_ADDITIONAL
        PRINTF (("WARNING: ErrorNumber=%d\n", error_nr));
      #endif
    }
  
  #endif/* ... XMK_ADD_ERRORTABLE */
  
  #ifdef XMK_ADD_PRINTF_USER
   XMK_TRACE_EXIT("ErrorHandler");
  #endif
      
} /* END OF FUNCTION */
#endif /* ...  ! XMK_USE_NO_ERR_CHECK */

#ifndef XMK_USE_RECEIVER_PID_IN_SIGNAL

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xRouteSignal                                                 |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                 This function is called by the Cmicro Kernel, if SDL signals |
|                 have no receiver.                                            |
|                 (undef  XMK_USE_RECEIVER_PID_IN_SIGNAL)                      |
|                 This might be useful in very small systems in order to spare |
|                 some RAM memory.                                             |
|                 The following restrictions apply :                           |
|                   * The SDL System must not contain anything other than the  |
|                     following process declaration. (x,1)                     |
|                   * For each Signal in the SDL System, there is to be only   |
|                     one Receiver process (no signal may be sent to more than |
|                     one processtype).                                        |
|                   * no dynamic process creation is used                      |
|                     (Create-Symbol is not used)                              |
|                                                                              |
|                 Note, timers are represented as signals, and that this       |
|                 xRouteSignal - function also has to map timers to Receiver   |
|                 Processes.                                                   |
|                                                                              |
|                 Important Rule : Each Signal- and Timer is represented by    |
|                 a systemwide unique integer number.                          |
|                                                                              |
|  Parameter    : xmk_T_SIGNAL  - xmk_TmpSignalID                              |
|                                                                              |
|  Return       : xPID  Process - PID or xNULLPID, if no receiver is defined   |
|                                     for the given signal.                    |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
xPID xRouteSignal  ( xmk_T_SIGNAL xmk_TmpSignalID )
/*-FDEF E*/
{
  /*
  ** P L E A S E _ M O D I F Y _ T H E _ F O L L O W I N G _ C O D E 
  ** P L E A S E _ M O D I F Y _ T H E _ F O L L O W I N G _ C O D E 
  ** P L E A S E _ M O D I F Y _ T H E _ F O L L O W I N G _ C O D E 
  */
  #error "ERROR_xRouteSignal_not_filled_yet"

  /*
  ** Please insert appropriate code here to map Signal ID's
  ** to Process - Type - ID's (XPTID_ProcessName in generated code).
  ** Keep in mind that this function might be called from within
  ** a critical path.
  ** Include <systemname>.ifc to get signal names and process' XPTID
  */
  /* Example:
  switch (xmk_TmpSignalID)
  {
    case SDL_Timer1  : return (XPTID_ProcessName);
    case SDL_Timer2  : return (XPTID_ProcessName);
    case SDL_Timer3  : return (XPTID_ProcessName);
    case SDL_TimerN  : return (XPTID_ProcessName);

    case SDL_Signal1 : return (XPTID_ProcessName);
    case SDL_Signal2 : return (XPTID_ProcessName);
    case SDL_Signal3 : return (XPTID_ProcessName);
    case SDL_SignalN : return (XPTID_ProcessName);

    default          : ErrorHandler (ERR_N_NO_RCV); 
                       return (xNULLPID);
  }
  */
} /* END OF FUNCTION */

#endif /* ... XMK_USE_RECEIVER_PID_IN_SIGNAL */

#ifdef XMK_USE_KERNEL_WDTRIGGER
/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : WatchdogTrigger                                              |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                 If scaled so, this function is called by the Cmicro Kernel   |
|                 each time an SDL-transition is executed.                     |
|                                                                              |
|                 ** CAUTION **                                                |
|                 -------------------                                          |
|                 Be sure, that the timeout used for the Watchdog is longer    |
|                 than the longest SDL-Transition (in the case of non preemp-  |
|                 tive Cmicro Kernel). If the Cmicro Kernel is scaled to       |
|                 work preemptive, then the Watchdog Trigger should not be     |
|                 used, because the execution time of transitions can never    |
|                 be calculated.                                               |
|                                                                              |
|                                                                              |
|                                                                              |
|  Parameter    :                                                              |
|                 void                                                         |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
void WatchdogTrigger ( void )
/*-FDEF E*/
{
  
  
  #ifdef XMK_ADD_PRINTF_USER
    XMK_FUNCTION("WatchdogTrigger");
  #endif /* ... XMK_ADD_PRINTF_USER */

   /* ........................................... */
   /* ........................................... */
   /* ........................................... */

  #ifdef XMK_ADD_PRINTF_USER
    XMK_TRACE_EXIT("WatchdogTrigger");
  #endif /* ... XMK_ADD_PRINTF_USER */


} /* END OF FUNCTION */

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_InitWatchdog                                             |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                                                                              |
|                                                                              |
|  Parameter    :                                                              |
|                 void                                                         |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
void xmk_InitWatchdog ( void )
/*-FDEF E*/
{
  
  #ifdef XMK_ADD_PRINTF_USER
    XMK_FUNCTION("xmk_InitWatchdog");
  #endif /* ... XMK_ADD_PRINTF_USER */

   /* ........................................... */
   /* ........................................... */
   /* ........................................... */

  #ifdef XMK_ADD_PRINTF_USER
    XMK_TRACE_EXIT("xmk_InitWatchdog");
  #endif /* ... XMK_ADD_PRINTF_USER */


} /* END OF FUNCTION */

#endif /* XMK_USE_KERNEL_WDTRIGGER */

#if defined(SCMADEBCLENVCOM) || defined(SCMADEBCLCOM) || defined(SCMADEBCOM)
/*+FHDR S*/
/*
+------------------------------------------------------------------------------+
|  Functionname : Gate_printf                                                  |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                                                                              |
|  Parameter    : -                                                            |
|  Return       : -                                                            |
+------------------------------------------------------------------------------+
*/
/*-FHDR S*/

/*+FDEF S*/
static void Gate_printf (char * errtext)
/*-FDEF S*/
{
  int       result;
  xmk_U_MsgParams tmp_MessageParams;

  tmp_MessageParams.v_GateStringInd.String = errtext;
  result = MCODEncode (GateStringInd,
           &tmp_MessageParams, MPMBuffer, sizeof (xmk_T_GateStringInd));
  PostToSDTMT (GateStringInd, MPMBuffer, result);
}


/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_CallStackPush                                            |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|  Function for test purposes, free use.                                       |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
void xmk_CallStackPush (XCONST char * SectionName, XCONST char * fname)
/*-FDEF E*/
{

  #define OVERFLOW_INFO "-Call Stack trace overflow-"
  char *p;

  if (CallStackPointer > (MAX_CALL_STACK_ARRAY-2))
  {
    free ( CallStackPointerArray [CallStackPointer] );
    p= (char*) malloc (sizeof (OVERFLOW_INFO));
    strcpy (p, OVERFLOW_INFO);
    CallStackPointerArray [CallStackPointer] = p;
  } 
  else 
  {
    int len = ( strlen (SectionName) + strlen (fname) + 2 );
    /* use post-increment */
    CallStackPointer  ++;
    CallStackPointerArray [CallStackPointer] = (char*) malloc (len);
    strcpy (CallStackPointerArray [CallStackPointer], SectionName);
    strcat (CallStackPointerArray [CallStackPointer], fname);
  } 
}


/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_CallStackPop                                             |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|  Function for test purposes, free use.                                       |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
void xmk_CallStackPop (XCONST char * fname)
/*-FDEF E*/
{
  if (CallStackPointer >= 0)
  {
    free ( CallStackPointerArray [CallStackPointer] );
    CallStackPointerArray [CallStackPointer]  = 0;
    CallStackPointer --;
  } 
}

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_CallStackTrace                                           |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|  Function for test purposes, free use.                                       |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
void xmk_CallStackTrace(FILE* fp, char *Text)
/*-FDEF E*/
{
  int i;
  char buf [4096];

  if (CallStackPointer < 0) 
  {
    sprintf (buf, "\nCall stack when in function:%s\n<No call stack information available>", Text);
    Gate_printf (buf);
    return;
  }

  sprintf (buf, "Call stack when in function:%s\n", Text);
  Gate_printf (buf);
  for (i=0; i < CallStackPointer; i++) 
  {
    sprintf (buf, "         [ %-30s () ]\n",  CallStackPointerArray [i]);
    Gate_printf (buf);
  }

  sprintf  (buf, "\n");
  Gate_printf (buf);

}

#endif /* #if defined(SCMADEBCLENVCOM) || defined(SCMADEBCLCOM) || defined(SCMADEBCOM) */

#ifdef XMK_USERFREESIGNALFUNC
/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_UserFreeSignal                                              |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  : A function, which should be used, if the cmicro kernel has   |
|                 no possiblity to free the signal parameter in an error case. |
|                 signal->FreePtr is a pointer to the Parameter which should   |
|                 be freed.                                                    |
|                 signal->signal contain the signal number                     |
|  Parameter    : xmk_T_MESSAGE xmk_RAM_ptr signal                             |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
void xmk_UserFreeSignal (xmk_T_MESSAGE xmk_RAM_ptr signal)
/*-FDEF E*/
{
  /*
  ** insert your code here
  */ 
}
#endif /* #ifdef XMK_USERFREESIGNALFUNC */

#ifdef XMK_ERR_ACTION_USER
/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_UserErrAction                                            |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  : A function, which can filled by the user to perform actions  |
|                 for his own error handling                                   |
|  Parameter    : xmk_T_ERR_NUM ErrorNumber                                    |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
void xmk_UserErrAction (xmk_T_ERR_NUM ErrorNumber)
/*-FDEF E*/
{
  /*
  ** insert your code here
  */ 
}
#endif /* #ifdef XMK_ERR_ACTION_USER */

#ifdef XMK_WARN_ACTION_USER
/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_UserWarnAction                                            |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  : A function, which should be used, if the cmicro kernel has   |
|                 no possiblity to free the signal parameter in an error case. |
|                 signal->FreePtr is a pointer to the Parameter which should   |
|                 be freed.                                                    |
|                 signal->signal contain the signal number                     |
|  Parameter    : xmk_T_MESSAGE xmk_RAM_ptr signal                             |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
void xmk_UserWarnAction (xmk_T_ERR_NUM ErrorNumber)
/*-FDEF E*/
{
  /*
  ** insert your code here
  */
}
#endif /* #ifdef XMK_WARN_ACTION_USER */

#ifdef XLI_LIGHT_INTEGRATION
/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : xmk_QueryOSQueue                                             |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
void xmk_QueryOSQueue (void)
{
    #ifdef XMK_USED_TIMER
      xmk_T_TIME ExpirationTime  = 0;
    #endif
    
    XLI_TEMP_QUEUE_VARS;

    /*
    ** If there are signals in the SDL queue,
    ** process the signals first
    */ 
    #if defined(XMK_USED_SAVE)
    /*
    ** If there are signals in the SDL queue and
    ** If not all of them are saved,
    ** process the signals first
    */ 
    if ( ! xmk_SaveSignalsOnly ())
    #else
    /*
    ** If there are signals in the SDL queue,
    ** process the signals first
    */ 
    if ( ! xmk_QueueEmpty ())
    #endif
    {
      /* 
      ** There are signals in the queue;
      ** 
      ** Get the next message from the OS queue,
      ** without suspending the SDL Task 
      */
      XLI_GET_NEXT_MESSAGE_FROM_OS_QUEUE;
    }
    else
    {
    #ifdef XMK_USED_TIMER
      /* 
      ** There are no signals or only saved signals in the queue.
      ** Check if any timer is active and calculate the remaining time.
      */
      if ( xmk_NextTimerExpiry( &ExpirationTime ) )
      {
        /*
        ** (No signals in SDL queue.)
        ** There is a timer active and ExpirationTime contains
        ** the absolute time at which the timer expires.
        ** Listen on OS queue by blocking.
        */
        XLI_LISTEN_ON_OS_QUEUE_WITH_TIMEOUT(ExpirationTime-xmk_NOW());
      }
      else
      #endif /* ... XMK_USED_TIMER */
      {
        /* 
        ** (No signals in SDL queue.)
        ** NO timers are currently active in the SDL system,
        */
        XLI_LISTEN_ON_OS_QUEUE_NO_TIMEOUT;
      }
    } /* ... if ( xmk_SaveSignalsOnly () != XMK_TRUE ) */

    #ifdef XMK_USE_xInEnv
    XLI_CALL_xInEnv;
    #endif
}
#endif /* ...XLI_LIGHT_INTEGRATION */
#endif /* ... __MK_USER_C_ */

