/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*+MHDR*/
/*
+------------------------------------------------------------------------------+
#  Modulname: mt_cmd.c
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|    This module handles the commandline interface of the Cmicro Tester,       |
|    for the target side.                                                      |
|                                                                              |
|    On the target side, the commands, which are received on the communications|
|    link, are to be mapped to Cmicro Kernel and Cmicro Library function calls.|
|    I.e.a command which requests the setting of a breakpoint, is mapped to the|
|    function belonging to the Cmicro Kernel, assigned for breakpoint setting. |
|                                                                              |
|    Exported functions for target side                                        |
|    =================================================================         |
|    extern int  [Qualified]HandleHostCmd (int,xmk_U_CMDS*);                   |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-MHDR*/

#ifndef __MT_CMD_C_
#define __MT_CMD_C_

/*+IMPORT*/
/*====================  I M P O R T  =========================================*/
#include "ml_typ.h"
/*--------------------  Functions    -----------------------------------------*/

/*--------------------  Variables    -----------------------------------------*/

#if defined(XMK_ADD_MICRO_TESTER) && defined(XMK_ADD_CQUERY_ERROR)
  /*
  ** Variable supported / filled by the users ErrorHandler () in user - module
  */
  extern xmk_T_ERR_INF xmk_LastStoredError ;
#endif /* ... defined(XMK_ADD_MICRO_TESTER) && defined(XMK_ADD_CQUERY_ERROR) */

#if defined(XMK_ADD_MICRO_TESTER) && defined(XMK_ADD_CQUERY_PROCESS)
  extern xmk_T_PRS_PROF xmk_ProcessProfiles [] ;
#endif

#if defined(XMK_ADD_MICRO_TESTER) && defined(XMK_ADD_SDLE_TRACE)
  extern xmk_OPT_INT xmk_SDLE_TracerActive;
#endif

#ifdef XMK_ADD_CQUERY_PROCESS
  extern XCONST XPDTBL xmk_ROM_ptr xPDTBL[];
#endif
/*============================================================================*/
/*-IMPORT*/


/*+MGG*/
/*====================  V A L U E S  O F  T H I S   M O D U L E  =============*/

/*--------------------  Constants,  Macros  ----------------------------------*/

#ifdef XMK_ADD_MICRO_TESTER
  /*
  ** The encoding functions of the cod - module
  ** which are used for the serial interface ...
  */
  #define ENCODE(IDtag,infobuf,LEN)  \
          xmk_Cod_Encode (XMK_MICRO_COMMAND,IDtag,(char*)infobuf,LEN);

  #define ENCODE_NPAR(IDtag)  \
          xmk_Cod_Encode (XMK_MICRO_COMMAND,IDtag,(char*)NULL,0);

  /*
  ** A special case is, where the information, which is to be
  ** transferred, is of variable length ...
  */
  #define ENCODE_NAME(IDtag,infobuf,LEN)  \
          len = LEN - sizeof (infobuf.name) + strlen (infobuf.name); \
          xmk_Cod_Encode (XMK_MICRO_COMMAND,IDtag,(char*)&infobuf,len);
#endif

/*--------------------  Typedefinitions     ----------------------------------*/

/*--------------------  Functions    -----------------------------------------*/
#ifdef XMK_ADD_CQUERY_PROCESS
  static int  xmk_GetStates(xPID aPid);
#endif
/*--------------------  Variables    -----------------------------------------*/

/*============================================================================*/
/*-MGG*/


#if defined(XMK_ADD_MICRO_COMMAND)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]HandleHostCmd                                     |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|    This function is used on the target side to map the commands to           |
|    the functions of the Cmicro Kernel and / or the Cmicro Tester.            |
|    Either a command has been received via the communications interface, or   |
|    it is generated in the Cmicro Kernel. Nearly all commands produce         |
|    a message, which is sent to the host.                                     |
|                                                                              |
|  Parameter    : int         cmd_tag      command tag to deal with            |
|                 xmk_U_CMDS *p_cmd_vars   params of cmd.to deal with          |
|                                                                              |
|  Return       : XMK_OKAY                 Always OK                           |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
int
xmk_HandleHostCmd (
  int         cmd_tag,
  xmk_U_CMDS* p_cmd_vars)
/*-FDEF E*/
{
  int result = XMK_ERROR ;

  switch (cmd_tag)
  {
    case CMD_GET_CONFIG_REQ:
      /*
      ** Command completely answered here
      */
      return ( xmk_Encode_CMD_GET_CONFIG( CMD_GET_CONFIG_CNF ) );
      /*break;*/

    #ifdef XMK_ADD_CSUSPEND
    case CMD_SUSPEND_REQ                  :        /*  "SUSP"     */
      result = xmk_SystemSuspend ();
      break;
    #endif /* ... XMK_ADD_CSUSPEND */

    #ifdef XMK_ADD_CRESUME
    case CMD_RESUME_REQ                   :        /*  "RESUME"   */
      result = xmk_SystemResume ();
      break;
    #endif /* ... XMK_ADD_CRESUME */

    #ifdef XMK_ADD_CREINIT
    case CMD_SYSTEM_REINIT_REQ            :        /*  "REINIT"   */
      result = xmk_SystemReInit ();
      return (XMK_OKAY);
      /*break;*/
    #endif /* ... XMK_ADD_CREINIT */

    #ifdef XMK_ADD_CSHUTDOWN
    case CMD_SYSTEM_SHUTDOWN_REQ          :        /*  "SHUT"     */
      result = xmk_SystemShutdown ();
      return (XMK_OKAY);
      /*break;*/
    #endif /* ... XMK_ADD_CSHUTDOWN */

    #ifdef XMK_ADD_CSINGLE_STEP
    case CMD_SINGLE_STEP_REQ              :        /*  "STEP"     */
      result = xmk_SingleStep ();
      break;

    case CMD_NEXT_STEP_REQ                :        /*  "NSTEP"    */
      result = xmk_NextStep ();
      break;

    case CMD_EXIT_SINGLE_STEP_REQ         :        /*  "EX-S"     */
      result = xmk_SystemContinue ();
      break;
    #endif /* ... XMK_ADD_CSINGLE_STEP */

    #ifdef XMK_ADD_CDISABLE_TIMER
    case CMD_DISABLE_TIMER_REQ            :        /*  "DIS-T"    */
      result = xmk_DisableTimer ();
      break;
    #endif /* ... XMK_ADD_CDISABLE_TIMER */

    #ifdef XMK_ADD_CENABLE_TIMER
    case CMD_ENABLE_TIMER_REQ             :        /*  "ENA-T"    */
      result = xmk_EnableTimer ();
      break;
    #endif /* ... XMK_ADD_CENABLE_TIMER */

    #if defined(XMK_ADD_CSCALE_TIMERS) && defined(XMK_USE_TIMER_SCALE)
    case CMD_SCALE_TIMER_REQ              :        /*  "SCALE-T"   */
      xmk_TimerScaleFactor = p_cmd_vars->v_CMD_SCALE_TIMER_REQ.ScaleFactor;
      result = XMK_OKAY;
      break;
    #endif /* ... (XMK_ADD_CSCALE_TIMERS) && XMK_USE_TIMER_SCALE */

    #ifdef XMK_ADD_CCONTINUE
    case CMD_SYSTEM_CONTINUE_REQ          :        /*  "CONT"     */
      result = xmk_NextStep ();
      break;
    #endif /* ... XMK_ADD_CCONTINUE */

    #ifdef XMK_ADD_CBREAK_LOGIC
    case CMD_SET_BREAKPOINT_REQ           :        /*  "BP"       */
      result = xmk_SetBreakpoint   (p_cmd_vars-> v_CMD_SET_BREAKPOINT_REQ.pid        ,
                                    p_cmd_vars-> v_CMD_SET_BREAKPOINT_REQ.signalID   ,
                                    p_cmd_vars-> v_CMD_SET_BREAKPOINT_REQ.stateID    );
      break;

    case CMD_BREAK_INPUT_REQ               :        /*  "BPI"      */
      result = xmk_SetBreakpoint   (p_cmd_vars-> v_CMD_BREAK_INPUT_REQ.pid        ,
                                    p_cmd_vars-> v_CMD_BREAK_INPUT_REQ.signalID   ,
                                    XMK_NO_STATE );
      break;

    case CMD_BREAK_STATE_REQ               :        /*  "BPS"      */
      result = xmk_SetBreakpoint   (p_cmd_vars-> v_CMD_BREAK_STATE_REQ.pid        ,
                                    XMK_NO_SIGNAL                         ,
                                    p_cmd_vars-> v_CMD_BREAK_STATE_REQ.stateID    );
      break;

    case CMD_CLEAR_BREAKPOINT_REQ         :        /*  "BC"       */
      result = xmk_ClearBreakpointIndex (p_cmd_vars->v_CMD_CLEAR_BREAKPOINT_REQ.number );
      break;

    case CMD_CLEAR_ALL_BREAKPOINT_REQ     :        /*  "BA"       */
      result = xmk_ClearAllBreakpoints ();
      break;

    case CMD_QUERY_BREAKPOINT_REQ         :        /*  "?BREAK"   */
      {
        xmk_T_CMD_QUERY_BREAKPOINT_CNF *p;
        p = xmk_QueryBreakpoint ( p_cmd_vars-> v_CMD_QUERY_BREAKPOINT_REQ.entry );
        ENCODE (CMD_QUERY_BREAKPOINT_CNF, p, sizeof (xmk_T_CMD_QUERY_BREAKPOINT_CNF));
        return (XMK_OKAY); /* Command completely answered here */
        /*break;*/
      }

    /* case CMD_BREAK_HIT_IND                :
    **
    ** This case is detected within the Cmicro Kernel in module mk_sche.c,
    ** where it is checked, if any of the breakpoints set becomes true.
    ** The BP hit is signalled directly from mk_sche module.
    */

    #endif /* ...  XMK_ADD_CBREAK_LOGIC */

    #ifdef XMK_ADD_CCREATE_PROCESS
    case CMD_CREATE_PROCESS_REQ           :        /*  "CREATE"   */
      {
        xPID tmpPID;
        xmk_T_INSTANCE instanceID ;
        tmpPID = xRunPID;
        xRunPID = p_cmd_vars->v_CMD_CREATE_PROCESS_REQ.ParentPID;
        instanceID = xmk_CreateProcess ( EPIDTYPE ( p_cmd_vars->v_CMD_CREATE_PROCESS_REQ.ProcessTypeID ) );
        xRunPID=tmpPID;
        if (instanceID != xNULLINST)
          result = XMK_OKAY;
        else result = XMK_ERROR;
        break;
      }
    #endif /* ... XMK_ADD_CCREATE_PROCESS */

    #ifdef XMK_ADD_CQUERY_ERROR
    case CMD_QUERY_ERROR_REQ              :        /*  "?ERR"     */
      {
        xmk_T_CMD_QUERY_ERROR_CNF ErrorDescription;
        ErrorDescription.LastErrorNumber = xmk_LastStoredError;
        ENCODE (CMD_QUERY_ERROR_CNF, &ErrorDescription, sizeof(xmk_T_CMD_QUERY_ERROR_CNF));
        return (XMK_OKAY); /* Command completely answered here */
        /*break;*/
      }
    #endif

    #ifdef XMK_ADD_SDLE_TRACE
    case CMD_START_SDLE_REQ:
         {
           xmk_SDLE_TracerActive = XMK_TRUE;
           ENCODE(CMD_START_SDLE_CNF, NULL, 0)
           return(XMK_OKAY);
           /*break;*/
         }

    case CMD_STOP_SDLE_REQ:
         {
            xmk_SDLE_TracerActive = XMK_FALSE;
            ENCODE(CMD_STOP_SDLE_CNF, NULL, 0)
            return(XMK_OKAY);
            /*break;*/
         }
    #endif /* ... XMK_ADD_SDLE_TRACE */

    #if defined(XMK_ADD_CTBUF_REQ) && defined(XMK_ADD_TRACE_BUF)
    case CMD_TBUF_REQ                     :        /*  "?TRACEB"  */
        /*For special integration: procedure to transmit the tracebuffer from target to host.*/
      break;
    #endif

    #ifdef XMK_ADD_CKILL_PROCESS
    case CMD_KILL_PROCESS_REQ             :        /*  "KILL"     */
      {
        xPID tmpPID;
        result = xmk_KillProcess ( p_cmd_vars->v_CMD_KILL_PROCESS_REQ.pid );
        if (result == XMK_TRUE)
        {
          tmpPID = xRunPID;
          xRunPID = p_cmd_vars->v_CMD_KILL_PROCESS_REQ.pid;
          xmk_TSDL_State(XDORMANT);
          result = XMK_OKAY  ;
          xRunPID = tmpPID;
        }
        else
          result = XMK_ERROR ;
        break;
      }
    #endif /* ... XMK_ADD_CKILL_PROCESS */

    #ifdef XMK_ADD_CQUERY_PROCESS
    case CMD_QUERY_PROCESS_REQ            :        /*  "?PROCESS" */
      {
        xmk_GetStates(p_cmd_vars->v_CMD_QUERY_PROCESS_REQ.pid);
        return (XMK_OKAY); /* Command completely answered here */
      }
    /* break; */

    #endif /* ... XMK_ADD_CQUERY_PROCESS */

    #ifdef XMK_ADD_CQUERY_PROCESS
    case CMD_QUERY_PROCESS_PROF_REQ            :        /*  "?PROCESS-PROFILE" */
      {
        xmk_T_CMD_QUERY_PROCESS_PROF_CNF Measurements ;

        Measurements.LastTime = xmk_ProcessProfiles [EPIDTYPE(p_cmd_vars->v_CMD_QUERY_PROCESS_PROF_REQ.pid)].LastTime ;
        Measurements.MaxTime  = xmk_ProcessProfiles [EPIDTYPE(p_cmd_vars->v_CMD_QUERY_PROCESS_PROF_REQ.pid)].MaxTime ;

        ENCODE (CMD_QUERY_PROCESS_PROF_CNF, &Measurements, sizeof(xmk_T_CMD_QUERY_PROCESS_PROF_CNF));
        return (XMK_OKAY); /* Command completely answered here */
       }
       /*break;*/
    #endif /* ... XMK_ADD_CQUERY_PROCESS */

   #if defined (XMK_SYSTEM_INFO) || (defined(XMK_ADD_CNEXTSTATE) && defined(XMK_USE_DEBUGGING))
    case CMD_NEXT_STATE_REQ            :            /*  "NEXTSTATE" */
      {
        result = xmk_SetProcessState ( p_cmd_vars->v_CMD_NEXT_STATE_REQ.pid,
                                       p_cmd_vars->v_CMD_NEXT_STATE_REQ.state);
      }
      break;
   #endif /* ... XMK_SYSTEM_INFO) || (defined(XMK_ADD_CNEXTSTATE && defined(XMK_USE_DEBUGGING)) */

    #ifdef XMK_ADD_CQUERY_MEM
    case CMD_QUERY_MEMORY_REQ              :        /*  "?MEMORY"   */
      {
        xmk_T_CMD_QUERY_MEMORY_CNF MemoryState ;
        xmk_QueryMemory ( &MemoryState );
        ENCODE (CMD_QUERY_MEMORY_CNF, &MemoryState, sizeof(xmk_T_CMD_QUERY_MEMORY_CNF) );
        return (XMK_OKAY); /* Command completely answered here */
      }
      /*break;*/
    #endif /* ... XMK_ADD_CQUERY_MEM */

    #ifdef XMK_ADD_CQUERY_QUEUE
    case CMD_QUERY_QUEUE_REQ              :        /*  "?QUEUE"   */
      {
        xmk_T_CMD_QUERY_QUEUE_CNF QueueState ;
        xmk_QueryQueue ( &QueueState );
        ENCODE (CMD_QUERY_QUEUE_CNF, &QueueState, sizeof(xmk_T_CMD_QUERY_QUEUE_CNF) );
      }
      #ifdef XMK_ADD_PROFILE
      {
        xmk_T_CMD_SIGNAL_QUEUE_ENTRY_IND SignalEntry;
        xmk_T_MESSAGE xmk_RAM_ptr sig;

        for(sig = xmk_FirstSignal(); sig != NULL; sig = xmk_NextSignal())
        {
          SignalEntry.signal = sig->signal;

    #ifdef XMK_USE_SIGNAL_PRIORITIES
            SignalEntry.prio   = sig->prio;
          #else
            SignalEntry.prio   = 0xff;
          #endif

    #ifdef XMK_USE_SENDER_PID_IN_SIGNAL
            SignalEntry.send   = sig->send;
          #else
            SignalEntry.send   = xNULLPID;
          #endif

          #ifdef XMK_USE_RECEIVER_PID_IN_SIGNAL
            SignalEntry.rec    = sig->rec;
          #else
            SignalEntry.rec    = xNULLPID;
          #endif

          ENCODE (CMD_SIGNAL_QUEUE_ENTRY_IND, &SignalEntry, sizeof(xmk_T_CMD_SIGNAL_QUEUE_ENTRY_IND) );
        }
      }
      #endif /* ... XMK_ADD_PROFILE */
      return (XMK_OKAY); /* Command completely answered here */
      /*break;*/
    #endif /* ... XMK_ADD_CQUERY_QUEUE */

    #ifdef XMK_ADD_CRM_QUEUE
    case CMD_RMQUEUE_REQ                  :        /*  "RM-Q"     */
        xmk_InitQueue ();
        result = XMK_OKAY ;
      break;
    #endif /* ... XMK_ADD_CRM_QUEUE */

    #ifdef XMK_ADD_CFLUSH_SIGNAL_BY_SID
    case CMD_FLUSH_SIGNAL_BY_SID_REQ      :        /*  "RM-SIG"   */
      {
        xPID tmpPID;
        tmpPID = xRunPID;
        xRunPID = p_cmd_vars->v_CMD_FLUSH_SIGNAL_BY_SID_REQ.pid ;
        xmk_RemoveSignalBySignalID (p_cmd_vars->v_CMD_FLUSH_SIGNAL_BY_SID_REQ.signalID);
        xRunPID = tmpPID;
        result = XMK_OKAY ;
      }
      break;
    #endif /* ... XMK_ADD_CFLUSH_SIGNAL_BY_SID */

    #ifdef XMK_ADD_CFLUSH_SIGNALS_BY_PID
    case CMD_FLUSH_SIGNALS_BY_PID_REQ     :        /* "RM-ALL-SIG" */
        xmk_RemoveSignalsByProcessID (p_cmd_vars->v_CMD_FLUSH_SIGNALS_BY_PID_REQ.pid);
        result = XMK_OKAY ;
      break;
    #endif /* ... XMK_ADD_CFLUSH_SIGNALS_BY_PID */

    #if defined(XMK_ADD_CSET_TIMER) && defined(XMK_USED_TIMER)
    case CMD_SET_TIMER_REQ                :        /*  "SET"      */
      {
        xPID tmpPID;

        #ifdef XMK_USE_MAX_ERR_CHECK
        if (p_cmd_vars->v_CMD_SET_TIMER_REQ.timerID <= MAX_SDL_TIMER_TYPES)
        #endif
        {
          tmpPID  = xRunPID;
          xRunPID = p_cmd_vars->v_CMD_SET_TIMER_REQ.pid ;
          #ifdef XMK_USED_TIMER_WITH_PARAMS
            xmk_TimerSet (p_cmd_vars->v_CMD_SET_TIMER_REQ.time + xmk_NOW(),
                          p_cmd_vars->v_CMD_SET_TIMER_REQ.timerID,
                          p_cmd_vars->v_CMD_SET_TIMER_REQ.TimerValue);
          #else
            xmk_TimerSet (p_cmd_vars->v_CMD_SET_TIMER_REQ.time + xmk_NOW(),
                          p_cmd_vars->v_CMD_SET_TIMER_REQ.timerID);
          #endif

          xRunPID = tmpPID;
          /*
          ** all possible errorcases handled by ErrorHandler on target
          */
          result = XMK_OKAY;
        }
        break;
      }
    #endif /* ... XMK_ADD_CSET_TIMER && XMK_USED_TIMER */

    #if defined(XMK_ADD_CACTIVE_TIMER) && defined(XMK_USED_TIMER)
    case CMD_ACTIVE_TIMER_REQ       :              /*  "ACTIVE"   */
      {
        xmk_T_CMD_ACTIVE_TIMER_CNF CnfData;
        xPID tmpPID;

        #ifdef XMK_USE_MAX_ERR_CHECK
        if (p_cmd_vars->v_CMD_ACTIVE_TIMER_REQ.timerID <= MAX_SDL_TIMER_TYPES)
        #endif
        {
          tmpPID  = xRunPID;
          xRunPID = p_cmd_vars->v_CMD_ACTIVE_TIMER_REQ.pid ;
          CnfData.TimerActive = XMK_FALSE;

          #ifdef XMK_USED_TIMER_WITH_PARAMS
            if ( xmk_TimerActive (p_cmd_vars->v_CMD_ACTIVE_TIMER_REQ.timerID,
                                  p_cmd_vars->v_CMD_ACTIVE_TIMER_REQ.TimerValue ) )
            {
              CnfData.TimerActive = XMK_TRUE;
            }
          #else
            if ( xmk_TimerActive (p_cmd_vars->v_CMD_ACTIVE_TIMER_REQ.timerID) )
            {
              CnfData.TimerActive = XMK_TRUE;
            }
          #endif

          xRunPID = tmpPID;
          ENCODE (CMD_ACTIVE_TIMER_CNF, &CnfData, sizeof(xmk_T_CMD_ACTIVE_TIMER_CNF) );
          return (XMK_OKAY); /* Command completely answered here */
          /* break; */
        }
        #ifdef XMK_USE_MAX_ERR_CHECK
          break;
        #endif
      }
    #endif /* ... XMK_ADD_CQUERY_SINGLE_TIMER && XMK_USED_TIMER */

    #if defined(XMK_ADD_CRESET_TIMER) && defined(XMK_USED_TIMER)
    case CMD_RESET_TIMER_REQ              :        /*  "RESET"    */
      {
        xPID      tmpPID;
        tmpPID  = xRunPID;
        #ifdef XMK_USE_MAX_ERR_CHECK
        if (p_cmd_vars->v_CMD_RESET_TIMER_REQ.timerID <= MAX_SDL_TIMER_TYPES)
        #endif
        {
          xRunPID = p_cmd_vars->v_CMD_RESET_TIMER_REQ.pid ;
          #ifdef XMK_USED_TIMER_WITH_PARAMS
            xmk_TimerReset (p_cmd_vars->v_CMD_RESET_TIMER_REQ.timerID,
                            p_cmd_vars->v_CMD_RESET_TIMER_REQ.TimerValue);
          #else
            xmk_TimerReset (p_cmd_vars->v_CMD_RESET_TIMER_REQ.timerID);
          #endif
          xRunPID = tmpPID;
          /*
          ** all possible errorcases handled by ErrorHandler on target
          */
          result = XMK_OKAY;
        }
        break;
      }
    #endif /* ... XMK_ADD_CRESET_TIMER && XMK_USED_TIMER */

    #if defined(XMK_ADD_CRESET_ALL_TIMERS) && defined(XMK_USED_TIMER)
    case CMD_RESET_ALL_TIMERS_REQ         :        /* "RESET-ALL-T" */
        xmk_ResetAllTimer (p_cmd_vars->v_CMD_RESET_ALL_TIMERS_REQ.pid);
        result = XMK_OKAY ;
      break;
    #endif /* ... XMK_ADD_CRESET_ALL_TIMERS && XMK_USED_TIMER */

    #if defined(XMK_ADD_CQUERY_TIMER) && defined(XMK_USED_TIMER)
    case CMD_QUERY_TIMER_REQ              :        /*  "?TIMER"   */
      {
        xmk_T_CMD_QUERY_TIMER_CNF TimerState ;
        xmk_QueryTimer (&TimerState) ;
        ENCODE (CMD_QUERY_TIMER_CNF, &TimerState, sizeof(xmk_T_CMD_QUERY_TIMER_CNF) );
      }
      #ifdef XMK_ADD_PROFILE
      {
        xmk_T_CMD_TIMER_QUEUE_ENTRY_IND TimerEntry;
        xmk_T_TIMER xmk_RAM_ptr tim;

        for(tim = xmk_FirstTimer(); tim != NULL; tim = xmk_NextTimer())
        {
          TimerEntry.timer       = tim->Signal;
          TimerEntry.expire_time = tim->Time;

          #ifdef XMK_USE_RECEIVER_PID_IN_SIGNAL
            TimerEntry.owner     = tim->OwnerProcessPID;
          #else
            TimerEntry.owner     = xNULLPID;
          #endif

          #ifdef XMK_USED_TIMER_WITH_PARAMS
            TimerEntry.TimerValue = tim->TimerParValue;
          #endif

          ENCODE (CMD_TIMER_QUEUE_ENTRY_IND, &TimerEntry, sizeof(xmk_T_CMD_TIMER_QUEUE_ENTRY_IND) );
        }
      }
      #endif /* ... XMK_ADD_PROFILE */
      return (XMK_OKAY); /* Command completely answered here */
        /*break;*/
    #endif /* ... XMK_ADD_CQUERY_TIMER && XMK_USED_TIMER */

    case CMD_NPAR_OUTPUT_FROM_ENV_REQ                :        /*  "OUTPUT-NPAR"   */
      {
        xmk_T_CMD_NPAR_OUTPUT_FROM_ENV_REQ *p = (xmk_T_CMD_NPAR_OUTPUT_FROM_ENV_REQ *) p_cmd_vars;
        XMK_SEND_TMP_VARS;

        XMK_SEND_ENV( ENV,
                      p->signal,
                      xDefaultPrioSignal,
                      0,
                      (void xmk_RAM_ptr) NULL,
                      p->rec);

        result = XMK_OKAY;
        break;
      }

    case CMD_PAR_OUTPUT_FROM_ENV_REQ                :        /*  "OUTPUT-PAR"   */
      {
        xmk_T_CMD_PAR_OUTPUT_FROM_ENV_REQ *p = (xmk_T_CMD_PAR_OUTPUT_FROM_ENV_REQ *) p_cmd_vars;
        XMK_SEND_TMP_VARS;

        XMK_SEND_ENV( ENV,
                      p->signal,
                      xDefaultPrioSignal,
                      p->mess_length,
                      (void*) &p->parametercopy,
                      p->rec);

        result = XMK_OKAY;
        break;
      }


    #ifdef XMK_ADD_MICRO_RECORDER
    case CMD_REC_OFF                      :        /*  "REC-OFF"  */
      result = xmk_SetRecorderMode (XMK_RECORDER_OFF);
      break;

    case CMD_REC_PLAY                     :        /*  "REC-PLAY" */
      result = xmk_SetRecorderMode (XMK_RECORDER_PLAY);
      break;

    case CMD_REC_RECORD                   :        /*  "REC-ON"   */
      result = xmk_SetRecorderMode (XMK_RECORDER_RECORD);
      break;
    #endif /* ... XMK_ADD_MICRO_RECORDER */


    #ifdef XMK_ADD_MICRO_TRACER
    case CMD_TRACE_ON                     :        /*  "TR-ON"    */
      xmk_TracerActive                 = XMK_TRUE  ;
      result = XMK_OKAY;
      break;

    case CMD_TRACE_OFF                    :        /*  "TR-OFF"   */
      xmk_TracerActive                 = XMK_FALSE ;
      result = XMK_OKAY;
      break;

    #ifdef XMK_ADD_TOPTIONS
    case CMD_TRACE_PROCESS                :        /*  "TR-PROCESS"  */
      result = xmk_OptionsSymbol (p_cmd_vars->v_CMD_TRACE_PROCESS.pid,
                                  p_cmd_vars->v_CMD_TRACE_PROCESS.bitmask);
      break;
    #endif /* (XMK_ADD_TOPTIONS) */

    #ifdef XMK_ADD_SIGNAL_FILTER
    case CMD_TRACE_SIGNAL                 :        /*  "TR-SIGNAL"   */
      result = xmk_OptionsSignal (p_cmd_vars->v_CMD_TRACE_SIGNAL.signalID,
                                  (unsigned char) (p_cmd_vars->v_CMD_TRACE_SIGNAL.bitmask));
      break;
    #endif /* (XMK_ADD_SIGNAL_FILTER)*/

    #endif /* XMK_ADD_MICRO_TRACER */


    #ifdef XMK_WAIT_ON_HOST
    case CMD_START_SDL_REQ                :        /* "Go-Forever" */
      {
        ENCODE_NPAR( CMD_START_SDL_CNF );
        return( XMK_OKAY );
        /* break; */
      }
    #endif

    #ifdef XMK_ADD_MICRO_ENVIRONMENT
    case CMD_EXT_OUTPUT_FROM_ENV_REQ :
      {
        xmk_T_CMD_EXT_OUTPUT_FROM_ENV_REQ *p = (xmk_T_CMD_EXT_OUTPUT_FROM_ENV_REQ *) p_cmd_vars;
        XMK_SEND_TMP_VARS;

        XMK_SEND_ENV( ENV,
                      p->signal,
                      xDefaultPrioSignal,
                      p->mess_length,
                      (void*) &p->parametercopy,
                      p->rec);

        result = XMK_OKAY;
        break;
      }
    #endif

    default :
      result = XMK_ERROR ;
      break;
  }

  if (result == XMK_OKAY)
  {
    ENCODE_NPAR ( CMD_OKAY_CNF );
  }
  else
  {
    ENCODE_NPAR ( CMD_ERROR_CNF );
  }
  return (XMK_OKAY);

}

#ifdef XMK_ADD_CQUERY_PROCESS

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]GetStates                                         |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                                                                              |
|  Parameter    : xPID aPid                                                    |
|                                                                              |
|  Return       : XMK_OKAY                 Always OK                           |
|                 XMK_ERROR                                                    |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
static int xmk_GetStates ( xPID aPid)
/*-FDEF E*/
{
  xmk_T_CMD_QUERY_PROCESS_CNF cnf;

  if (EPIDTYPE(aPid) != xNULLTYPE)
  {
    if (EPIDINST(aPid) != xNULLINST)
    {
     /*
     ** this is for one specific process instance
     */
     cnf.state = xmk_GetProcessState(aPid);
    }
    else
    {
     /*
     ** this is for one specific process type, sending the state of all
     ** instances of this type
     */
     xmk_T_INSTANCE inst;
     for (inst = 0; inst < xPDTBL[EPIDTYPE(aPid)]->MaxInstances; inst++)
     {
       cnf.state = xmk_GetProcessState(GLOBALPID(EPIDTYPE(aPid),inst));
       ENCODE (CMD_QUERY_PROCESS_CNF, &cnf, sizeof(xmk_T_CMD_QUERY_PROCESS_CNF));
   }
     cnf.state = XNOTEXISTENT;
    }
    ENCODE (CMD_QUERY_PROCESS_CNF, &cnf, sizeof(xmk_T_CMD_QUERY_PROCESS_CNF));
    return (XMK_OKAY);
  }
  else
  {
    /*
    ** this is for ALL possible instances of ALL types
    */
    if (EPIDINST(aPid) == xNULLINST)
    {
     xmk_T_PROCESS type;
     xmk_T_INSTANCE inst;

   for ( type = 0; type < MAX_SDL_PROCESS_TYPES; type++)
     {
       for ( inst = 0; inst < xPDTBL[type]->MaxInstances; inst++)
       {
         cnf.state = xmk_GetProcessState(GLOBALPID(type,inst));
         ENCODE (CMD_QUERY_PROCESS_CNF, &cnf, sizeof(xmk_T_CMD_QUERY_PROCESS_CNF));
       }
       cnf.state = XNOTEXISTENT;
       ENCODE (CMD_QUERY_PROCESS_CNF, &cnf, sizeof(xmk_T_CMD_QUERY_PROCESS_CNF));
     }
     cnf.state = XNOTEXISTENT;
     ENCODE (CMD_QUERY_PROCESS_CNF, &cnf, sizeof(xmk_T_CMD_QUERY_PROCESS_CNF));
     return (XMK_OKAY);
    }
  }
  return (XMK_ERROR);
}
#endif /* XMK_ADD_CQUERY_PROCESS */

#endif /* ... XMK_ADD_MICRO_COMMAND */

#endif /* __MT_CMD_C_ */
