/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*+MHDR*/
/*
+------------------------------------------------------------------------------+
#  Modulname: mt_deb.c
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|                  This module puts some functions at the user's disposal      |
|                  which in connection with the Cmicro Tester allows restricted|
|                  debugging within the target.                                |
|                                                                              |
|  Functions:                                                                  |
|                                                                              |
|    void              [Qualified]DebugInit             (void)                 |
|    unsigned char     [Qualified]SystemSuspend         (void)                 |
|    unsigned char     [Qualified]SystemResume          (void)                 |
|    unsigned char     [Qualified]SystemReInit          (void)                 |
|    unsigned char     [Qualified]SystemShutdown        (void)                 |
|    unsigned char     [Qualified]SingleStep            (void)                 |
|    unsigned char     [Qualified]DisableTimer          (void)                 |
|    unsigned char     [Qualified]EnableTimer           (void)                 |
|    unsigned char     [Qualified]NextStep              (void)                 |
|    unsigned char     [Qualified]SystemContinue        (void)                 |
|    unsigned char     [Qualified]SetBreakpoint         (xPID, xmk_T_SIGNAL,   |
|                                                 xmk_T_STATE)                 |
|    unsigned char     [Qualified]ClearBreakpointIndex  (int)                  |
|    unsigned char     [Qualified]ClearBreakpoint       (xPID, xmk_T_SIGNAL,   |
|                                                 xmk_T_STATE)                 |
|    unsigned char     [Qualified]ClearAllBreakpoints   (void)                 |
|    xmk_T_BOOL        [Qualified]CheckIfBreakpointTrue (xPID, xmk_T_SIGNAL,   |
|                                                 xmk_T_STATE)                 |
|    xmk_T_CMD_QUERY_BREAKPOINT_CNF* [Qualified]QueryBreakpoint (unsigned char)|
|    void              [Qualified]BackupXPDTBL           ( void )              |
|    void              [Qualified]RestoreXPDTBL          ( void )              |
|    void              [Qualified]ClearBackupXPDTBL      ( void )              |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-MHDR*/

#ifndef __MT_DEB_C_
#define __MT_DEB_C_

/*+IMPORT*/
/*====================  I M P O R T  =========================================*/
#include "ml_typ.h"

/*--------------------  Variables    -----------------------------------------*/
extern XCONST XPDTBL xmk_ROM_ptr xPDTBL[];

/*============================================================================*/
/*-IMPORT*/


/*+MGG*/
/*====================  V A L U E S  O F  T H I S   M O D U L E  =============*/

/*--------------------  Constants,  Macros  ----------------------------------*/

/*--------------------  Typedefinitions     ----------------------------------*/

/*--------------------  Functions    -----------------------------------------*/

/*--------------------  Variables    -----------------------------------------*/
unsigned int xmk_SystemState;


#ifdef XMK_USE_DEBUGGING

#ifdef XMK_ADD_CBREAK_LOGIC
  static unsigned int  xmk_NumOfBreakpoints;
  static xmk_T_CMD_QUERY_BREAKPOINT_CNF xmk_BP[XMK_MAXBREAKPOINTS];
#endif /* ... XMK_ADD_CBREAK_LOGIC */

#if defined(XMK_ADD_CREINIT)
  /*
  ** The following variable is used to backup the
  ** information which process instances should be created during
  ** SDL start-up.
  **
  ** A good place to call xmk_BackupXPDTBL is before
  ** the call to xmk_InitSDL (). The reason for having a
  ** xmk_BackupXPDTBL and xmk_RestoreXPDTBL function is
  ** that the information about which process are to be
  ** started statically during system start-up is lost
  ** and the Tester command "reinit" would fail without
  ** backing up the information.
  ** Note, that "reinit" is in itself quite difficult to
  ** be implemented as the user must take care about all
  ** the correct initialization in the environment !!
  */
  #ifdef XMK_USED_ONLY_X_1
    /*
    ** One char value per process type in this case is efficient enough
    */
    static char xmk_BackupArray [MAX_SDL_PROCESS_TYPES];
  #else
    /*
    ** An array of process types, where one char value per 8 process instances
    ** is used. This is to allow a lot of instances per process type to be
    ** stored here as efficient as possible.
    */
    static char * xmk_BackupArray [MAX_SDL_PROCESS_TYPES];
  #endif

#endif /* ... #if defined(XMK_ADD_CREINIT) */


/*============================================================================*/
/*-MGG*/


/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]DebugInit                                         |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                  This function initializes the debugging facilities.         |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_DebugInit ()

/*-FDEF E*/
{
  #ifdef XMK_ADD_CBREAK_LOGIC
    /*
    **  Reset the breakpoint-list
    */
    xmk_ClearAllBreakpoints();
  #endif

  /*
  **  Set debugging system state to 'no command set'
  */
  xmk_SystemState = XMK_NO_CMD_SET;
}

#if defined (XMK_ADD_CCONTINUE) || defined (XMK_ADD_CSINGLE_STEP)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]SystemContinue                                    |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                  This function proceeds execution of a stopped system.       |
|                  System could have been stopped via xmk_SystemShutdown or    |
|                  xmk_SingleStep.                                             |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       :  XMK_ERROR            - System couldn't be continued         |
|                  XMK_OKAY             - System will be continued             |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

unsigned char xmk_SystemContinue ()

/*-FDEF E*/
{
  /*
  **  Check if system was suspended
  */
  if (    (xmk_SystemState & XMK_SYSTEM_SHUTDOWN)
       || (xmk_SystemState & XMK_SINGLE_STEPPING))
  {
    XMK_BEGIN_CRITICAL_PATH;

    /*
    **  Check if system was shutdown and continue
    */
    if (xmk_SystemState & XMK_SYSTEM_SHUTDOWN)
        xmk_SystemState &= ~XMK_SYSTEM_SHUTDOWN;

    /*
    **  Check if single-stepping and reset
    */
    if (xmk_SystemState & XMK_SINGLE_STEPPING)
        xmk_SystemState &= ~XMK_SINGLE_STEPPING;

    XMK_END_CRITICAL_PATH;
    return (XMK_OKAY);
  }

  return (XMK_ERROR);
}

#endif /* ... defined (XMK_ADD_CCONTINUE) || defined (XMK_ADD_CSINGLE_STEP) */

#if defined (XMK_ADD_CNEXT_STEP) || defined (XMK_ADD_CCONTINUE)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]NextStep                                          |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                  This function proceeds system execution up to the next      |
|                  breakpoint/step.                                            |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       :  XMK_ERROR            - System couldn't be continued         |
|                  XMK_OKAY             - System will be continued             |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

unsigned char xmk_NextStep ()

/*-FDEF E*/
{
  /*
  **  Check if system was stopped by breakpoint or stepping
  */
  if (xmk_SystemState & XMK_SINGLE_STEPPING)
  {
    /*
    **  Next step is to be executed if system is stopped
    */
    if (!(xmk_SystemState & XMK_SYSTEM_NEXT_STEP))
    {
      XMK_BEGIN_CRITICAL_PATH;
        xmk_SystemState |= XMK_SYSTEM_NEXT_STEP;
		if(xmk_SystemState & XMK_BREAKPOINT_HIT)
		{
          xmk_SystemState &= ~XMK_BREAKPOINT_HIT;
		}
      XMK_END_CRITICAL_PATH;
      return (XMK_OKAY);
    }
  }

  /*
  **  proceed system execution up to the next breakpoint
  */
  if (xmk_SystemState & XMK_BREAKPOINT_HIT)
  {
    XMK_BEGIN_CRITICAL_PATH;
      xmk_SystemState &= ~XMK_BREAKPOINT_HIT;
      xmk_SystemState |= XMK_SYSTEM_NEXT_STEP;
    XMK_END_CRITICAL_PATH;
    return (XMK_OKAY);
  }

  /*
  **  command failed because option wasn't set
  */
  return (XMK_ERROR);
}

#endif /* ... XMK_ADD_CNEXT_STEP */

#ifdef XMK_ADD_CSUSPEND

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]SystemSuspend                                     |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                  This function hinders further transitions from execution,   |
|                  though the currently active transition can't be stopped.    |
|                                                                              |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       :  XMK_ERROR            - System couldn't be suspended         |
|                  XMK_OKAY             - System will be suspended             |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

unsigned char xmk_SystemSuspend ()

/*-FDEF E*/
{
  /*
  **  Suspending the system only makes sense
  **  if it is not already suspended
  */
  if (!(xmk_SystemState & XMK_SYSTEM_SUSPENDED))
  {
    XMK_BEGIN_CRITICAL_PATH;
      xmk_SystemState |= XMK_SYSTEM_SUSPENDED;
    XMK_END_CRITICAL_PATH;
    return (XMK_OKAY);
  }
  /*
  **  System already suspended - command failed
  */
  return (XMK_ERROR);
}

#endif /* ... XMK_ADD_CSUSPEND */

#ifdef XMK_ADD_CRESUME

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]SystemResume                                      |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                  This function proceeds system execution if the system       |
|                  was suspended.                                              |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       :  XMK_ERROR            - System wasn't suspended              |
|                  XMK_OKAY             - System execution will be continued   |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

unsigned char xmk_SystemResume ()

/*-FDEF E*/
{
  /*
  **  Check whether the system is suspended or not
  **  proceeding execution only makes sense if the
  **  execution was stopped.
  */
  if (xmk_SystemState & XMK_SYSTEM_SUSPENDED)
  {
    XMK_BEGIN_CRITICAL_PATH;
    xmk_SystemState &= ~XMK_SYSTEM_SUSPENDED;
    XMK_END_CRITICAL_PATH;
    return (XMK_OKAY);
  }
  /*
  **  Resuming a non-suspended system makes no sense
  **  so the command failed
  */
  return (XMK_ERROR);
}

#endif /* ... XMK_ADD_CRESUME */

#if defined(XMK_ADD_CREINIT)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]SystemReInit                                      |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                  This function restarts the SDL-system, but the currently    |
|                  active transitions are executed up to the SDL-STOP or       |
|                  SDL-NEXTSTATE.                                              |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       :  XMK_ERROR            - System is already reinitialized      |
|                  XMK_OKAY             - System will be reinitialized         |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

unsigned char xmk_SystemReInit ()

/*-FDEF E*/
{
  XCONST XPDTBL xmk_ROM_ptr pProcess;

  xmk_T_PROCESS Process;

  #ifndef XMK_USED_ONLY_X_1
    xmk_T_INSTANCE Instance ;
  #endif

  /*
  **  Check for the system not already being in reinitialization
  */
  if (    !(xmk_SystemState & XMK_REINIT_SYSTEM)
       && !(xmk_SystemState & XMK_SYSTEM_SHUTDOWN))
  {

    XMK_BEGIN_CRITICAL_PATH;

    /*
    **  o.k. System is to be reinitialized
    */
    xmk_SystemState |= XMK_REINIT_SYSTEM;
    Process = 0;

    /*
    **  load process description table
    */


    /*
    **  for all the defined process-types
    */
    for (Process = 0; Process < MAX_SDL_PROCESS_TYPES; Process ++)
    {
      pProcess = xPDTBL[Process];

      #ifndef XMK_USED_ONLY_X_1
        /*
        **  stop all the defined process-instances
        */
        for (Instance = 0; Instance < pProcess->MaxInstances; Instance++)
        {
          xmk_KillProcess(GLOBALPID(Process, Instance));
          /*
          ** Values of ProcessStateTable are set as automatic variables.
          ** There is no possibility to store the process declaration
          ** header (staticinstances,maxinstances) from SDL.
          ** all process will set to STARTUP when reinitializing.
          */
          pProcess->ProcessStateTable[Instance] = XSTARTUP;
        }
      #else
        /*
        **  stop the only defined instance
        */
        xmk_KillProcess(GLOBALPID(Process, 0));
        pProcess->ProcessStateTable[0] = XSTARTUP;
      #endif

      pProcess++;
    }

    XMK_END_CRITICAL_PATH;

    /*
    **  system reinitialization is in process...
    */
    return(XMK_OKAY);
  }
  return(XMK_ERROR);
}

#endif /*  ....XMK_ADD_CREINIT */

#ifdef XMK_ADD_CSHUTDOWN

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]SystemShutdown                                    |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                   This function stops system-execution, the user can         |
|                   restart the system with the Resume-command.                |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       :  XMK_ERROR            - System is already reinitialized      |
|                  XMK_OKAY             - System will be reinitialized         |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

unsigned char xmk_SystemShutdown ()

/*-FDEF E*/
{

    XMK_BEGIN_CRITICAL_PATH;
    /*
    **  correct the system's state
    */
    xmk_SystemState &= ~XMK_REINIT_SYSTEM;

    /*
    **  re-initialization is in progress
    */
    xmk_SystemState |= XMK_SYSTEM_SHUTDOWN;
    XMK_END_CRITICAL_PATH;

    /*
    **  command succeeded
    */
    return (XMK_OKAY);
}

#endif /*  .......XMK_ADD_CSHUTDOWN */

#ifdef XMK_ADD_CSINGLE_STEP

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]SingleStep                                        |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                  The single-step mode leads to the system stopping before    |
|                  the consumption of any signal. The user has further         |
|                  system execution under control.                             |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       :  XMK_ERROR            - System is already single stepped     |
|                  XMK_OKAY             - System will be in single stepping    |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

unsigned char xmk_SingleStep ()

/*-FDEF E*/
{

  /*
  **  Check whether the system is in single-stepping
  **  or not. Single-stepping only makes sense
  **  if it is not already in process.
  */
  if (!(xmk_SystemState & XMK_SINGLE_STEPPING))
  {
    XMK_BEGIN_CRITICAL_PATH;
    xmk_SystemState |= XMK_SINGLE_STEPPING;
    XMK_END_CRITICAL_PATH;
    return (XMK_OKAY);
  }
  /*
  **  Single-stepping is already in process,
  **  so the command failed
  */
  return (XMK_ERROR);
}

#endif /* ... XMK_ADD_CSINGLE_STEP */

#ifdef XMK_ADD_CBREAK_LOGIC

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]SetBreakpoint                                     |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                 This function sets a breakpoint for the process processID    |
|                 either for receiving the signal signalID or for the state    |
|                 change into the state stateID.                               |
|                                                                              |
|  Parameter    : processID - process breakpoint should be set for             |
|                             XMK_ALL_PROCESSES - set for all processes        |
|                             global process ID - set for exactly this one     |
|                             XMK_NO_PROCESS    - breakpoint not set           |
|                                                                              |
|                 signalID  - signal the breakpoint should be set for          |
|                             XMK_ALL_SIGNALS   - set for all signals          |
|                             global signal ID  - set for exactly this one     |
|                             XMK_NO_SIGNAL     - breakpoint not set           |
|                                                                              |
|                 stateID   - state the breakpoint should be set for           |
|                             XMK_ALL_STATES    - set for all states           |
|                             global state ID   - set for exactly this one     |
|                             XMK_NO_STATE      - breakpoint not set           |
|                                                                              |
|                                                                              |
|  Return       :  XMK_ERROR            - Breakpoint could not be set          |
|                  XMK_OKAY             - Breakpoint is set                    |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
unsigned char
xmk_SetBreakpoint (
  xPID         processID,
  xmk_T_SIGNAL signalID,
  xmk_T_STATE  stateID)
/*-FDEF E*/
{
  unsigned int i;
  xmk_T_BOOL   already_set = XMK_FALSE;

  /*
  **  Check if breakpoint already set
  */
  for (i=0; i < XMK_MAXBREAKPOINTS; i++)
  {
    if (   (xmk_BP[i].pid       == (xPID) processID)
        && (xmk_BP[i].signalID  == (xmk_T_SIGNAL) signalID)
        && (xmk_BP[i].stateID   == (xmk_T_STATE) stateID))

      already_set = XMK_TRUE;
  }

  /*
  **  If breakpoint not already set
  */
  if (already_set == XMK_FALSE)
  {
    /*
    **  Search for a free breakpoint
    */
    for (i=0; i < XMK_MAXBREAKPOINTS; i++)
    {
      if (xmk_BP[i].pid == XMK_NO_PROCESS)
      {
        XMK_BEGIN_CRITICAL_PATH;
        /*
        **  Set the breakpoint's parameters
        */
        xmk_BP[i].pid       = (xPID) processID;
        xmk_BP[i].signalID  = (xmk_T_SIGNAL) signalID;
        xmk_BP[i].stateID   = (xmk_T_STATE) stateID;

        xmk_SystemState |= XMK_BREAKPOINT_SET;
        xmk_NumOfBreakpoints++;

        XMK_END_CRITICAL_PATH;
        return (XMK_OKAY);
      }
    }
  }
  /*
  **  No more breakpoints available or breakpoint already set
  */
  return (XMK_ERROR);
}

#endif /* ... XMK_ADD_CBREAK_LOGIC */

#ifdef XMK_ADD_CBREAK_LOGIC

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]QueryBreakpoint                                   |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                 This functions fills the given pointer with the list of the  |
|                 breakpoints. Furthermore in the given integer value the      |
|                 number of breakpoints set within the list is returned.       |
|                                                                              |
|  Parameter    : Number - Number of breakpoints set within that list          |
|                                                                              |
|                                                                              |
|  Return       : BPList - List of breakpoints                                 |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

xmk_T_CMD_QUERY_BREAKPOINT_CNF * xmk_QueryBreakpoint ( unsigned char Number )

/*-FDEF E*/
{
  /*
  **  return the pointer to the breakpoint-list
  */
  return (&xmk_BP[Number]);
}

#endif /* ... XMK_ADD_CBREAK_LOGIC */

#ifdef XMK_ADD_CBREAK_LOGIC

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]ClearBreakpointIndex                              |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                 This function removes the given breakpointnumber from the    |
|                 list of active breakpoints.                                  |
|                                                                              |
|  Parameter    : int       - number breakpoint number                         |
|                                                                              |
|  Return       :  XMK_ERROR            - Breakpoint could not be reset        |
|                  XMK_OKAY             - Breakpoint is reset                  |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

unsigned char xmk_ClearBreakpointIndex ( int Nr )

/*-FDEF E*/
{
  if ( Nr > XMK_MAXBREAKPOINTS-1)
    return (XMK_ERROR);

  XMK_BEGIN_CRITICAL_PATH;

  /*
  ** check only the pid is enough
  */
  if ( xmk_BP[Nr].pid != (xPID) XMK_NO_PROCESS)
  {
    /*
    **  reset the breakpoint's parameters
    */
    xmk_BP[Nr].pid       = (xPID) XMK_NO_PROCESS;
    xmk_BP[Nr].signalID  = (xmk_T_SIGNAL) XMK_NO_SIGNAL;
    xmk_BP[Nr].stateID   = (xmk_T_STATE) XMK_NO_STATE;

    xmk_NumOfBreakpoints--;

    if (xmk_NumOfBreakpoints == 0)
      xmk_SystemState &= ~XMK_BREAKPOINT_SET;

    XMK_END_CRITICAL_PATH;
    return (XMK_OKAY);
  }
  else
  {
    XMK_END_CRITICAL_PATH;
    return(XMK_ERROR);
  }
}

#endif /* ... XMK_ADD_CBREAK_LOGIC */

#ifdef XMK_ADD_CBREAK_LOGIC

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]CheckIfBreakpointTrue                             |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                 This function checks for the current system state to be      |
|                 set as breakpoint.                                           |
|                                                                              |
|  Parameter    : processID - process breakpoint should be checked for         |
|                             XMK_ALL_PROCESSES - set for all processes        |
|                             global process ID - set for exactly this one     |
|                                                                              |
|                 signalID  - signal the breakpoint should be checked for      |
|                             XMK_ALL_SIGNALS   - set for all signals          |
|                             global signal ID  - set for exactly this one     |
|                             XMK_NO_SIGNAL     - system currently not         |
|                                                 consuming a signal.          |
|                                                                              |
|                 stateID   - state the breakpoint should be checked for       |
|                             XMK_ALL_STATES    - set for all states           |
|                             global state ID   - set for exactly this one     |
|                             XMK_NO_STATE      - system currently not         |
|                                                 changing state.              |
|                 BreakHitDescr - description of the breakpoint                |
|                                                                              |
|  Return       :  XMK_TRUE   - System reached a breakpoint                    |
|                  XMK_FALSE  - System didn't reach a breakpoint               |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/
/*+FDEF E*/
xmk_T_BOOL xmk_CheckIfBreakpointTrue (
           xPID                    processID,
           xmk_T_SIGNAL            signalID,
           xmk_T_STATE             stateID)
/*-FDEF E*/
{
  #if defined(XMK_ADD_MICRO_COMMAND)
    xmk_T_CMD_BREAK_HIT_IND BreakHitDescr ;
  #endif

  unsigned int i;

  XMK_BEGIN_CRITICAL_PATH;

  /*
  **  if current system state deals with a signal
  **  the system has to be checked for having reached
  **  the next breakpoint.
  */
  if ((!(signalID == XMK_NO_SIGNAL)) && (xmk_SystemState & XMK_BP_WAS_STATE))
  {
    xmk_SystemState &= ~XMK_SYSTEM_NEXT_STEP;
  }

  /*
  **  if next breakpoint is to be skipped
  */
  if (!(xmk_SystemState & XMK_SYSTEM_NEXT_STEP))
  {
    /*
    **  Compare current system state with the breakpoint list
    */
    for ( i=0; i < XMK_MAXBREAKPOINTS; i++)
    {
      if (    (xmk_BP[i].pid       == processID)
           && (xmk_BP[i].signalID  == signalID )
           /*&& (xmk_BP[i].stateID   == stateID)*/)
      {
        if(xmk_BP[i].stateID == XMK_NO_STATE)
        {
          /*
          **  we ignore the parameter stateID here
          **  this breaks on every input of signalID
          */
          /*xmk_SystemState &= ~XMK_BP_WAS_INPINSTATE;
          xmk_SystemState |= XMK_BP_WAS_STATE;*/
          xmk_SystemState &= ~XMK_BP_WAS_STATE;
        }
        else
        {
          if (xmk_BP[i].stateID == stateID)
          {
          /*
          **  this breaks on input of signalID in state stateID
          */
            /*xmk_SystemState |= XMK_BP_WAS_INPINSTATE;*/
			xmk_SystemState &= ~XMK_BP_WAS_INPINSTATE;
          }
		  else
		  {
            XMK_END_CRITICAL_PATH;
			return (XMK_FALSE);
		  }
        }
        XMK_END_CRITICAL_PATH;

        /*
        **  system reached a breakpoint
        **  - copy struct to message
        **  - return XMK_TRUE
        */
        #if defined(XMK_ADD_MICRO_COMMAND)
          BreakHitDescr.BPId    = i;
          BreakHitDescr.pid     = xmk_BP[i].pid;
          BreakHitDescr.SigId   = xmk_BP[i].signalID;
          BreakHitDescr.StateId = /*xmk_BP[i].*/stateID;
          BreakHitDescr.Time    = xmk_NOW();

          xmk_Cod_Encode ( XMK_MICRO_COMMAND, CMD_BREAK_HIT_IND,
                           (char*)&BreakHitDescr, sizeof(xmk_T_CMD_BREAK_HIT_IND));
        #endif /* ... defined(XMK_ADD_MICRO_COMMAND) */

        xmk_SystemState |= XMK_BREAKPOINT_HIT;

        return (XMK_TRUE);
      }
    }
  }
  else
  {
    xmk_SystemState &= ~XMK_SYSTEM_NEXT_STEP;
  }

  XMK_END_CRITICAL_PATH;

  /*
  **  given system state is not a breakpoint
  */
  return (XMK_FALSE);
}

#endif /* ... XMK_ADD_CBREAK_LOGIC */

#ifdef XMK_ADD_CBREAK_LOGIC

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]ClearAllBreakpoints                               |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                 This function resets all breakpoints.                        |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       : XMK_OKAY             - All Breakpoints are reset             |
|                 XMK_ERROR            - Command failed                        |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

unsigned char xmk_ClearAllBreakpoints ()

/*-FDEF E*/
{
  unsigned int i;

  XMK_BEGIN_CRITICAL_PATH;

  /*
  **  for all the breakpoints
  */
  for (i=0; i < XMK_MAXBREAKPOINTS; i++)
  {
    /*
    **  reset the breakpoints' parameters
    */
    xmk_BP[i].pid       = (xPID) XMK_NO_PROCESS;
    xmk_BP[i].signalID  = (xmk_T_SIGNAL) XMK_NO_SIGNAL;
    xmk_BP[i].stateID   = (xmk_T_STATE) XMK_NO_STATE;
  }

  xmk_SystemState &= ~XMK_BREAKPOINT_SET;
  xmk_NumOfBreakpoints = 0;
  XMK_END_CRITICAL_PATH;
  return (XMK_OKAY);
}

#endif /* ... XMK_ADD_CBREAK_LOGIC */

#endif  /* ...XMK_USE_DEBUGGING */

#ifdef XMK_ADD_CDISABLE_TIMER

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]DisableTimer                                      |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                 With the help of this function the user can preserve timers  |
|                 from being checked. Keep in mind that this means a change    |
|                 in the system's behaviour.                                   |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       :  XMK_ERROR            - Timers couldn't be disabled          |
|                                         either no timers are used            |
|                                         or they are already disabled         |
|                                                                              |
|                  XMK_OKAY             - Timers are disabled                  |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

unsigned char xmk_DisableTimer()

/*-FDEF E*/
{
  #ifdef XMK_USED_TIMER
    /*
    **  prevent timers from being checked
    */
    if (!(xmk_SystemState & XMK_TIMER_DISABLED))
    {
      XMK_BEGIN_CRITICAL_PATH;
      xmk_SystemState |= XMK_TIMER_DISABLED;
      XMK_END_CRITICAL_PATH;
      return (XMK_OKAY);
    }
  #endif
  /*
  **  Timers already disabled, or not used
  **  so the command failed
  */
  return (XMK_ERROR);
}

#endif /* ... XMK_ADD_CDISABLE_TIMER */

#ifdef XMK_ADD_CENABLE_TIMER

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]EnableTimer                                       |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                 With the help of this function the user can turn on the      |
|                 timer checking again.                                        |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       :  XMK_ERROR            - Timers couldn't be enabled           |
|                                         either no timers are used            |
|                                         or they are already enabled          |
|                                                                              |
|                  XMK_OKAY             - Timers are enabled                   |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

unsigned char xmk_EnableTimer()

/*-FDEF E*/
{
  #ifdef XMK_USED_TIMER
    /*
    **  turn on timer checking
    */
    if (xmk_SystemState & XMK_TIMER_DISABLED)
    {
      XMK_BEGIN_CRITICAL_PATH;
      xmk_SystemState &= ~XMK_TIMER_DISABLED;
      XMK_END_CRITICAL_PATH;
      return (XMK_OKAY);
    }
  #endif
  /*
  **  Timers already enabled, or not used
  **  so the command failed
  */
  return (XMK_ERROR);

}

#endif /* ... XMK_ADD_CENABLE_TIMER */

#if defined(XMK_ADD_CREINIT) && defined(XMK_USE_DEBUGGING)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]BackupXPDTBL                                      |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|    This function copies the xPDTBL into a buffer to allow a reinitialization |
|    of the target                                                             |
|                                                                              |
|    This function is used to backup the information about static process      |
|    creation.                                                                 |
|                                                                              |
|    A good place to call xmk_BackupXPDTBL is before the call to               |
|    xmk_InitSDL (). The reason for having a xmk_BackupXPDTBL                  |
|    and xmk_RestoreXPDTBL function is that the information about which        |
|    process is to started statically during system start up is lost           |
|    and the reinitialization would fail without backing up the information.   |
|                                                                              |
|  Parameter    : -                                                            |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_BackupXPDTBL ( void )

/*-FDEF E*/

{
  static               int BackupAlreadyDone = XMK_FALSE ;
  xmk_T_PROCESS        Process  ;

  #ifndef XMK_USED_ONLY_X_1
    char                *p ;
    /*
    ** Loop over instances of a type only if more than 1 instance ...
    */
    xmk_T_INSTANCE Instance ;
  #endif

  XCONST XPDTBL              xmk_ROM_ptr pProcessType ;

  /*
  ** Do Backup once only
  */
  if (BackupAlreadyDone)
  {
    return ;
  }
  BackupAlreadyDone = XMK_TRUE;

  #ifdef XMK_USED_ONLY_X_1
    /*
    **  Loop in <root-process-table>
    */
    Process = 0;
    while ( (pProcessType = xPDTBL [Process]) != X_END_ROOT_TABLE )
    {
      /*
      ** Store XDORMANT/XSTARTUP values from generated C code in Backup Array
      */
      xmk_BackupArray [Process] = pProcessType->ProcessStateTable[0];
      Process ++;
    }
  #else
    /*
    **  Loop in <root-process-table>
    */
    Process = 0;
    while ( (pProcessType = xPDTBL [Process]) != X_END_ROOT_TABLE )
    {
      /*
      ** Preserve memory for all the backup data
      ** ( 1 Bit per prs instance, 1 byte extra )
      */
      p = (char*) xAlloc ( 1 + ( pProcessType->MaxInstances / 8 ) );
      if (!p) return ;

      /*
      ** Enter memory block into array of pointers
      */
      xmk_BackupArray [Process] = p;

      Instance = 0 ;
      /*
      **  Loop in <process-state-table> for all instances of this processtype
      */
      while(  Instance < pProcessType->MaxInstances )
      {
        /*
        ** Do the backup ...
        ** ( as xAlloc was being used to alloc memory, all the bits
        **   are set to 0; so we only have to handle "set bit" case )
        */
        if ( pProcessType->ProcessStateTable[ Instance ] == XSTARTUP )
        {
          p[(Instance>>3)] |= (1<<  (Instance & 0x07) );
        }

        Instance++ ;
      }
      Process++ ;
    } /* END WHILE (testing processtypes) */
  #endif /* ... XMK_USED_ONLY_X_1 */

} /* END OF FUNCTION */


/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]RestoreXPDTBL                                     |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|    This function is used to restore the information about static process     |
|    creation.                                                                 |
|                                                                              |
|    This function copies the backup of the xPDTBL from the buffer back into   |
|    state tables in order to allow reinitialization.                          |
|                                                                              |
|    A good place to call xmk_RestoreXPDTBL is within the XMK_MAIN_SHUTDOWN    |
|    macro in mk_main.c.                                                       |
|                                                                              |
|  Parameter    : -                                                            |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_RestoreXPDTBL( void )

/*-FDEF E*/

{
  xmk_T_PROCESS        Process  ;
  XCONST XPDTBL xmk_ROM_ptr   pProcessType ;

  #ifndef XMK_USED_ONLY_X_1
    char *p;
    /*
    ** Loop over instances of a type only if more than 1 instance ...
    */
    xmk_T_INSTANCE Instance ;
  #endif


  #ifdef XMK_USED_ONLY_X_1
    /*
    **  Loop in <root-process-table>
    */
    Process = 0;
    while ( (pProcessType = xPDTBL [Process]) != X_END_ROOT_TABLE )
    {
      /*
      ** Restore XDORMANT/XSTARTUP values from Backup Array
      */
      pProcessType->ProcessStateTable[0] = xmk_BackupArray [Process];
      Process ++;
    }
  #else
    /*
    **  Loop in <root-process-table>
    */
    Process = 0;
    while ( (pProcessType = xPDTBL [Process]) != X_END_ROOT_TABLE )
    {
      p = xmk_BackupArray [Process];

      Instance = 0 ;
      /*
      **  Loop in <process-state-table> for all instances of this processtype
      */
      while( Instance < pProcessType->MaxInstances )
      {
        /*
        ** Do the restore ...
        */
        if ( p[(Instance>>3)] & (1<<(Instance & 0x07)) )
        {
          pProcessType->ProcessStateTable[Instance] = XSTARTUP ;
        }
        else
        {
          pProcessType->ProcessStateTable[Instance] = XDORMANT ;
        }
        Instance++ ;
      }
      Process++ ;
    } /* END WHILE (testing processtypes) */
  #endif /* ... XMK_USED_ONLY_X_1 */

} /* END OF FUNCTION */

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]clearBackupXPDTBL                                 |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|    This function is used to give up dynamically allocated memory for the     |
|    Backup table at the end of the program.                                   |
|                                                                              |
|                                                                              |
|    A good place to call xmk_clearBackupXPDTBL is at the xmk_MicroTesterDeinit|
|    function                                                                  |
|                                                                              |
|  Parameter    : -                                                            |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/
/*+FDEF E*/
void xmk_ClearBackupXPDTBL( void )
/*-FDEF E*/
{
  #ifdef XMK_USED_ONLY_X_1
  /* nothing to do, no dynamic memory allocated*/
  #else
    unsigned int i;
    for (i = 0; i < MAX_SDL_PROCESS_TYPES; i++)
    {
      xFree((void xmk_RAM_ptr xmk_RAM_ptr)&xmk_BackupArray[i]);
    }
  #endif /* ... XMK_USED_ONLY_X_1 */
}
#endif /* ... #if defined(XMK_ADD_CREINIT) && defined (XMK_USE_DEBUGGING) */

#endif /* __MT_DEB_C_ */
