/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*+MHDR*/
/*
+------------------------------------------------------------------------------+
#  Modulname: mt_rec.c
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|    This module contains the "record" function of the recorder.               |
|                                                                              |
|    Information, which is build by the Cmicro Recorder during the execution of|
|    a SDL system, consists of some subinformation. The subinformations are :  |
|                                                                              |
|      * <Counter value section>                                               |
|      * <Event section>, which consists of either                             |
|          *  signal sent from SDL to Environment                              |
|          *  signal sent from Environment to SDL                              |
|          *  timer has been expired SDL internally (can be seen as an event   |
|             in the environment)                                              |
|                                                                              |
|    The <Counter value section> is always stored first in a Cmicro Recorder   |
|    Information. The <Event section> is always stored second in a Cmicro      |
|    Recorder Information.                                                     |
|                                                                              |
|    The <Counter value section> is stored only in that case, when a           |
|    <Event section> is to be stored, i.e.if an environment signal has been    |
|    detected. The both sections are pairs, but in error situations, it might  |
|    be the case, that only the first <Counter value section> is stored.       |
|                                                                              |
|    Note :                                                                    |
|    =======                                                                   |
|    To store information means to transfer the information via the            |
|    communications link in this context.                                      |
|                                                                              |
|    Each Subinformation is tagged with a XMK_MICRO_* Tag, in order to identify|
|    the class of information (is it tracer, is it recorder, or is it common). |
|                                                                              |
|                                                                              |
|  M1 Errormessages, which are routed to the ErrorHandler                      |
|  --------------------------------------------------------                    |
|    ERR_N_RECORD_MAX_EXCEEDED   The counter value for recorded events is      |
|                                overrun                                       |
|    ERR_N_RECORD_OUTPUT         Parameters do not fit into frame              |
|                                                                              |
|  M2 Exported functions of this module :                                      |
|  --------------------------------------------------------                    |
|    [Qualified]InitRecordMode  ( )    - initialization                        |
|    [Qualified]Record          ( )    - record an event, the function which is|
|                                 a part of the Cmicro Kernel; it is to be     |
|                                 executed, where the Cmicro Kernel is running.|
|    [Qualified]RecordSDLInput  ( )    - record SDL inp., the function which is|
|                                 a part of the Cmicro Kernel; it is to be     |
|                                 executed, where the Cmicro Kernel is running.|
|    [Qualified]RecordSDLOutput ( )    - record SDL Output, the function which |
|                                 is a part of the Cmicro Kernel; it is to be  |
|                                 executed, where the Cmicro Kernel is running.|
|                                                                              |
|  M3 Static functions of this module :                                        |
|  --------------------------------------------------------                    |
|    [Qualified]StoreCounterValue ( )  - store the event counter either on -   |
|                                 communicationsinterface or directly into file|
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-MHDR*/

#ifndef __MT_REC_C_
#define __MT_REC_C_

/*+IMPORT*/
/*====================  I M P O R T  =========================================*/
#include "ml_typ.h"

extern xmk_OPT_INT    xmk_MaxProcessTypes ;
extern xmk_T_SIGNAL   TimerBorder     ;

/*============================================================================*/
/*-IMPORT*/


/*+MGG*/
/*====================  V A L U E S  O F  T H I S   M O D U L E  =============*/

/*--------------------  Constants,  Macros  ----------------------------------*/
#ifdef XMK_USE_PREEMPTIVE
  #define CNT(var_non_preempt,var_preempt) shall_count = var_preempt;
#else
  #define CNT(var_non_preempt,var_preempt) shall_count = var_non_preempt;
#endif

#define IF_NONPREEMP_NO  XMK_FALSE
#define IF_NONPREEMP_YES XMK_TRUE
#define IF_PREEMP_NO     XMK_FALSE
#define IF_PREEMP_YES    XMK_TRUE

/*
** The following expression returns true, if a signal is not a timer
*/
#define INPUT_IS_NOT_A_TIMER       (p_Message->signal > TimerBorder)
#define OUTPUT_IS_NOT_A_TIMER      (sig > TimerBorder)

#define RECEIVER_IS_NOT_ENV  ( EPIDTYPE(rec)     < xmk_MaxProcessTypes )
#define SENDER_IS_NOT_ENV    ( EPIDTYPE(xRunPID) < xmk_MaxProcessTypes )

#define SZ(P1)               sizeof (P1)

/*
** This is either
** configuration 1,2,3, or
** configuration 4,5,6, if the Cmicro Kernel is compiled
**
*/
#define ASSIGN_MSC_Decision(dval)
#define ASSIGN_MSC_ProcedureName(pname)
#define ASSIGN_MSC_TaskName(tname)
#define ASSIGN_MSC_SetId(id)
#define ASSIGN_MSC_ResetId(id)
#define ASSIGN_MSC_Signal(id)
#define ASSIGN_MSC_State(pid,id)
#define ASSIGN_MSC_Prio(priority)
#define ASSIGN_MSC_Process(pid)
#define ASSIGN_MSC_Receiver(receiver)
#define ASSIGN_MSC_Sender(sender)
#define ASSIGN_MSC_SignalParameters(ptr,messlen)
#define ASSIGN_MSC_TimeStamp(stamp)
#define ASSIGN_MSC_CountRecordedEvent(P1)

#define DCL_MSC_ITEM(cmd,str)
#define ASSIGN_MSC_ITEM(cmd,str)
#define MSCE_WRITE(IDtag,infobuf)

#ifdef  XMK_USE_COMMLINK
    /*
    ** ---------------------------------------------
    ** Definitions to Record via communications link
    ** ---------------------------------------------
    */
    #define ASSIGN_COM_Decision(dval)
    #define ASSIGN_COM_ProcedureName(pname)
    #define ASSIGN_COM_TaskName(tname)
    #define ASSIGN_COM_SetId(id)
    #define ASSIGN_COM_ResetId(id)
    #define ASSIGN_COM_Signal(id) \
            info.signal = id;

    #define ASSIGN_COM_Prio(priority) \
            info.prio = priority ;

    #define ASSIGN_COM_Receiver(receiver) \
            info.rec     = receiver;

    #define ASSIGN_COM_Sender(sender) \
            info.send    = sender;

    #define ASSIGN_COM_SignalParameters(ptr,messlen)   \
              if (parameters_wanted) \
              { \
                if (messlen > sizeof (info.parametercopy)) \
                { \
                  ErrorHandler (ERR_N_RECORD_OUTPUT); \
                  messlen = sizeof (info.parametercopy); \
                } \
                memcpy ((char *) info.parametercopy, \
                         (char *) ptr, messlen); \
                info.mess_length = messlen; \
              } \
              else \
              { \
                info.mess_length = 0; \
              }

    #define ASSIGN_COM_TimeStamp(stamp) \
            info.timestamp = stamp ;

    #define ASSIGN_COM_CountRecordedEvent(P1) \
            info.CountRecordedEvent = P1;

    #define DCL_COM_ITEM(cmd,str)

    #define ASSIGN_COM_ITEM(cmd,str)

    /*
    ** The following is the encoding function of the cod - module
    ** which is used for the serial interface ...
    */
    #define ENCODE(IDtag,infobuf,LEN)  \
            xmk_Cod_Encode (XMK_MICRO_RECORDER,IDtag,(char*)&infobuf,LEN);

    /*
    ** A special case is, where the information, which is to be
    ** transferred, is of variable length ...
    */
    #define ENCODE_OUTPUT(IDtag,buf,LEN)  \
            len = LEN - sizeof (buf.parametercopy) + buf.mess_length; \
            xmk_Cod_Encode (XMK_MICRO_RECORDER,IDtag,(char*)&buf,len);

#else

    #define ASSIGN_COM_Decision(dval)
    #define ASSIGN_COM_ProcedureName(pname)
    #define ASSIGN_COM_TaskName(tname)
    #define ASSIGN_COM_SetId(id)
    #define ASSIGN_COM_ResetId(id)
    #define ASSIGN_COM_Signal(id)
    #define ASSIGN_COM_State(pid,id)
    #define ASSIGN_COM_Prio(priority)
    #define ASSIGN_COM_Process(pid)
    #define ASSIGN_COM_Receiver(receiver)
    #define ASSIGN_COM_Sender(sender)
    #define ASSIGN_COM_SignalParameters(ptr,messlen)
    #define ASSIGN_COM_TimeStamp(stamp)
    #define ASSIGN_COM_CountRecordedEvent(P1)
    #define COM_WRITE(command,info)

    #define DCL_COM_ITEM(cmd,str)

    #define ASSIGN_COM_ITEM(cmd,str)

    #define ENCODE(IDtag,infobuf,LEN)
    #define ENCODE_NAME(IDtag,infobuf,LEN)
    #define ENCODE_OUTPUT(IDtag,buf,LEN)

#endif  /* ... XMK_USE_COMMLINK */

/*
** ----------------------------------
** Definitions to record to TBF
** ----------------------------------
*/
#define ASSIGN_TBF_Decision(dval)
#define ASSIGN_TBF_ProcedureName(pname)
#define ASSIGN_TBF_TaskName(tname)
#define ASSIGN_TBF_SetId(id)
#define ASSIGN_TBF_ResetId(id)
#define ASSIGN_TBF_Signal(id)
#define ASSIGN_TBF_State(pid,id)
#define ASSIGN_TBF_Prio(priority)
#define ASSIGN_TBF_Process(pid)
#define ASSIGN_TBF_Receiver(receiver)
#define ASSIGN_TBF_Sender(sender)
#define ASSIGN_TBF_SignalParameters(ptr,messlen)
#define ASSIGN_TBF_TimeStamp(stamp)
#define ASSIGN_TBF_CountRecordedEvent(P1)

#define ASSIGN_TBF_ITEM(cmd,str)

#define DCL_TBF_ITEM(cmd,str)

#define TBF_WRITE(cmd,info)


/*
** ----------------------------------
** Definitions to record to STDOUT
** ----------------------------------
*/
#define ASSIGN_STDOUT_Decision(dval)
#define ASSIGN_STDOUT_ProcedureName(pname)
#define ASSIGN_STDOUT_TaskName(tname)
#define ASSIGN_STDOUT_SetId(id)
#define ASSIGN_STDOUT_ResetId(id)
#define ASSIGN_STDOUT_Signal(id)
#define ASSIGN_STDOUT_State(pid,id)
#define ASSIGN_STDOUT_Prio(priority)
#define ASSIGN_STDOUT_Process(pid)
#define ASSIGN_STDOUT_Receiver(receiver)
#define ASSIGN_STDOUT_Sender(sender)
#define ASSIGN_STDOUT_SignalParameters(ptr,messlen)
#define ASSIGN_STDOUT_TimeStamp(stamp)
#define ASSIGN_STDOUT_CountRecordedEvent(P1)

#define DCL_STDOUT_ITEM(cmd,str)

#define ASSIGN_STDOUT_ITEM(cmd,str)

#define STDOUT_WRITE(command,info)

#define WLINEFEED


#ifdef XMK_ADD_FILE_TRACE
      /*
      ** ----------------------------------
      ** Definitions to record into a FILE
      ** ----------------------------------
      */
      #define ASSIGN_FILE_Decision(dval)
      #define ASSIGN_FILE_ProcedureName(pname)
      #define ASSIGN_FILE_TaskName(tname)
      #define ASSIGN_FILE_SetId(id)
      #define ASSIGN_FILE_ResetId(id)
      #define ASSIGN_FILE_Signal(id)
      #define ASSIGN_FILE_State(pid,id)
      #define ASSIGN_FILE_Prio(priority)
      #define ASSIGN_FILE_Process(pid)
      #define ASSIGN_FILE_Receiver(receiver)
      #define ASSIGN_FILE_Sender(sender)
      #define ASSIGN_FILE_SignalParameters(ptr,messlen)
      #define ASSIGN_FILE_TimeStamp(stamp)
      #define ASSIGN_FILE_CountRecordedEvent(P1)

      #define DCL_FILE_ITEM(cmd,str)

      #define ASSIGN_FILE_ITEM(cmd,str)

      #define FILE_WRITE(command,info)

#else

    #define ASSIGN_FILE_Decision(dname)
    #define ASSIGN_FILE_ProcedureName(pname)
    #define ASSIGN_FILE_TaskName(tname)
    #define ASSIGN_FILE_SetId(id)
    #define ASSIGN_FILE_ResetId(id)
    #define ASSIGN_FILE_Signal(id)
    #define ASSIGN_FILE_State(pid,id)
    #define ASSIGN_FILE_Prio(priority)
    #define ASSIGN_FILE_Process(pid)
    #define ASSIGN_FILE_Receiver(receiver)
    #define ASSIGN_FILE_Sender(sender)
    #define ASSIGN_FILE_SignalParameters(ptr,messlen)
    #define ASSIGN_FILE_TimeStamp(stamp)
    #define ASSIGN_FILE_CountRecordedEvent(P1)

    #define DCL_FILE_ITEM(cmd,str)

    #define ASSIGN_FILE_ITEM(cmd,str)

    #define FILE_WRITE(command,info)

#endif  /* ... XMK_ADD_FILE_TRACE */


/*--------------------  Typedefinitions     ----------------------------------*/

/*---------------------  Functions    ----------------------------------------*/
#ifdef XMK_ADD_MICRO_RECORDER

static void xmk_StoreCounterValue ( void );


/*---------------------  Variables    ----------------------------------------*/

static unsigned int CountRecordedEvent = 0;




/*============================================================================*/
/*-MGG*/

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]InitRecordMode                                    |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|    This function initializes the record mode of the Cmicro Recorder.         |
|    It is to be called directly before initialization of the SDL system.      |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_InitRecordMode (void)

/*-FDEF E*/
{
  /*
  ** Initialize counter
  */
  CountRecordedEvent = 0;
}

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]Record                                            |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function counts the SDL events. The global variable CountRecordedEvent |
|  is incremented for each event. If an environmentsignal is detected, then    |
|  the counter is resetd and counting starts again.                            |
|                                                                              |
|  Parameter    : int event  - tag of the SDL event                            |
|                                                                              |
|  Return       : XMK_OKAY   - everythings works fine                          |
|                 XMK_ERROR  - the errorcounter is overrun                     |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

int xmk_Record ( int event )

/*-FDEF E*/
{
  xmk_T_BOOL shall_count = XMK_FALSE;
                                  /* is it an event, which modifies the  */
                                  /* counter ?                           */


  /*
  ** Check, if recorder is off
  */
  if ( xmk_RecorderMode == XMK_RECORDER_OFF ) return (XMK_OKAY);

  /*
  ** Check, if record mode is set
  */
  if ( xmk_RecorderMode != XMK_RECORDER_RECORD ) return (XMK_OKAY);


  /*
  ** Check overflow ...
  */
  if (CountRecordedEvent > XMK_MAX_RECORDED_EVENT)
  {
    ErrorHandler (ERR_N_RECORD_MAX_EXCEEDED);

    /*
    ** Return
    */
    return (XMK_ERROR);
  }

  switch ( event )
  {
    /*
    **  N o r m a l  S D L -  e v e n t s
    */
    case CMD_TTASK           : CNT (IF_NONPREEMP_YES,IF_PREEMP_YES); break;
    case CMD_TSET            : CNT (IF_NONPREEMP_YES,IF_PREEMP_YES); break;
    case CMD_TRESET          : CNT (IF_NONPREEMP_YES,IF_PREEMP_YES); break;
    case CMD_TACTUAL_RESET   : CNT (IF_NONPREEMP_NO, IF_PREEMP_NO);  break;
    case CMD_TSTOP           : CNT (IF_NONPREEMP_YES,IF_PREEMP_YES); break;
    case CMD_TSTATE          : CNT (IF_NONPREEMP_YES,IF_PREEMP_YES); break;
    case CMD_TSTATIC_CREATE  : CNT (IF_NONPREEMP_YES,IF_PREEMP_YES); break;
    case CMD_TCREATE         : CNT (IF_NONPREEMP_YES,IF_PREEMP_YES); break;
    case CMD_TDYNAMIC_CREATE : CNT (IF_NONPREEMP_YES,IF_PREEMP_YES); break;
    case CMD_TDECISION       : CNT (IF_NONPREEMP_YES,IF_PREEMP_YES); break;
    case CMD_TSAVE           : CNT (IF_NONPREEMP_YES,IF_PREEMP_YES); break;
    case CMD_TTIMER          : CNT (IF_NONPREEMP_YES,IF_PREEMP_YES); break;
    case CMD_TPROCEDURE      : CNT (IF_NONPREEMP_YES,IF_PREEMP_YES); break;

    case CMD_TINPUT          : /* Not handled here ! */
                               CNT (IF_NONPREEMP_NO, IF_PREEMP_NO) ; break;

    case CMD_TOUTPUT         : /* Not handled here ! */
                               CNT (IF_NONPREEMP_NO, IF_PREEMP_NO) ; break;

    /*
    **  E x c e p t i o n a l   S D L -  e v e n t s
    */
    case CMD_TDISCARD               : CNT (IF_NONPREEMP_YES,IF_PREEMP_YES) ; break;
    case CMD_TIMPLICIT_CONSUMPTION  : CNT (IF_NONPREEMP_YES,IF_PREEMP_YES) ; break;

    /*
    **  S y s t e m  -  e v e n t s
    */
    case CMD_TSYS_ERROR      : CNT (IF_NONPREEMP_NO, IF_PREEMP_NO) ; break;
    case CMD_TSYS_SCHEDULE   : CNT (IF_NONPREEMP_NO, IF_PREEMP_NO) ; break;
    case CMD_TSYS_SHOWPRIO   : CNT (IF_NONPREEMP_NO, IF_PREEMP_NO) ; break;

    default                  : CNT (IF_NONPREEMP_NO, IF_PREEMP_NO) ; break;
  }

  if (shall_count)
  {
    XMK_BEGIN_CRITICAL_PATH;

    /*
    ** Count the event
    */
    CountRecordedEvent ++ ;

    XMK_END_CRITICAL_PATH;
  }

  /*
  ** Return
  */
  return (XMK_OKAY);
}

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]RecordSDLInput                                    |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  Input of a signal is only possible for processes within the                 |
|  SDL system. An input can be either an ordinary SDL signal or                |
|  Timer which has been expired.                                               |
|                                                                              |
|  Parameter    : xmk_T_MESSAGE *p_Message                                     |
|                                                                              |
|  Return       : XMK_OKAY     in any case                                     |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

int  xmk_RecordSDLInput ( xmk_T_MESSAGE * p_Message )

/*-FDEF E*/
{
  xmk_T_BOOL shall_count = XMK_FALSE;
                                  /* is it an event, which modifies the  */
                                  /* counter ?                           */

  /*
  ** Check, if recorder is off
  */
  if ( xmk_RecorderMode == XMK_RECORDER_OFF ) return (XMK_OKAY);

  if (! (INPUT_IS_NOT_A_TIMER) )
  {
   CNT (IF_NONPREEMP_YES, IF_PREEMP_YES);
  }
  else
  {
   CNT (IF_NONPREEMP_YES, IF_PREEMP_YES);
  }

  if (shall_count)
  {
    XMK_BEGIN_CRITICAL_PATH;

    /*
    ** Count the event and do nothing else ...
    */
    CountRecordedEvent ++ ;

    XMK_END_CRITICAL_PATH;
    return (XMK_OKAY);
  }


  /*
  ** If input is not to be counted, then it is to be recorded as
  ** an <Event section>.
  ** ====> This is not implemented here.
  */

  /*
  ** Return
  */
  return (XMK_OKAY);
}


/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]RecordSDLOutput                                   |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called in the case of an output of a timer or a signal     |
|  in the direction SDL->ENV or ENV->SDL.                                      |
|                                                                              |
|  If it is a timer or an output from ENV->SDL, then the complete event and    |
|  the parameters belonging to it is sent to the host as <event section>,      |
|  together with the current global countervalue sent as the                   |
|  <counter value section>.                                                    |
|                                                                              |
|  Parameter    : xmk_T_SIGNAL       sig                                       |
|                 xmk_T_PRIO         prio                                      |
|                 xmk_T_TIME         timestamp                                 |
|                 xmk_T_MESS_LENGTH  info_len                                  |
|                 void              *p_info                                    |
|                 xPID               rec                                       |
|                                                                              |
|  Return       : XMK_OKAY                                                     |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

int xmk_RecordSDLOutput ( xmk_T_SIGNAL       sig        ,
                          xmk_T_PRIO         prio       ,
                          xmk_T_TIME         timestamp  ,
                          xmk_T_MESS_LENGTH  info_len   ,
                          void              *p_info     ,
                          xPID               rec )

/*-FDEF E*/
{
  xmk_T_CMD_TOUTPUT  info               ;
  xmk_T_BOOL         parameters_wanted  ;
  xmk_T_BOOL         shall_count        ;
  int                len                ;
  int                command            ;
  xPID               send               ;

  /*
  ** Check, if recorder is off
  */
  if ( xmk_RecorderMode == XMK_RECORDER_OFF ) return (XMK_OKAY);

  /*
  ** Is it an SDL signal (not a timer) send internally in the SDL system ?
  */
  if (( SENDER_IS_NOT_ENV ) && ( OUTPUT_IS_NOT_A_TIMER ))
  {
    /*
    ** ----------------------------------------------
    ** -> No, internal output is to be counted only.
    ** ----------------------------------------------
    */
    CNT (IF_NONPREEMP_YES, IF_PREEMP_YES);
    if (shall_count)
    {
      XMK_BEGIN_CRITICAL_PATH;

      /*
      ** Count the event and do nothing else ...
      */
      CountRecordedEvent ++ ;

      XMK_END_CRITICAL_PATH;
      return (XMK_OKAY);
    }
  }

  /*
  ** It is the environment which performs an output, or an expired timer ...
  */
  command = CMD_RECORD_OUTPUT_ENV2SDL;

  /*
  ** ----------------------------------------------
  ** -> External output is to be recorded, begin here ....
  ** ----------------------------------------------
  */


  /*
  ** ----------------------------------------------
  ** Evaluate the sender PID, if the output is a timer expiry ...
  ** ----------------------------------------------
  */
  if (! OUTPUT_IS_NOT_A_TIMER)
    send   =  rec;                      /* Output is a timer            */
  else
    send   =  xRunPID;                  /* Output is an ordinary signal */

  /*
  ** ----------------------------------------------
  ** Some preparations ...
  ** ----------------------------------------------
  */
  #ifdef XMK_USED_SIGNAL_WITH_PARAMS
    /*
    ** Determine, if parameters of the signal are to be traced ...
    */
    if (info_len == 0)
    {
      /*
      ** Signal with no parameters ...
      */
      p_info             = (char *) NULL;
      parameters_wanted  = XMK_FALSE;
    }
    else
    {
      parameters_wanted = XMK_TRUE;
    }
  #else
    p_info            = (char *) NULL ;
    parameters_wanted = XMK_FALSE;
  #endif


  /*
  ** ----------------------------------------------
  ** Store the <Counter value section>
  ** ----------------------------------------------
  */
  xmk_StoreCounterValue ();




  /*
  ** ----------------------------------------------
  ** Store the <Event section>
  ** ----------------------------------------------
  */
  ASSIGN_FILE_Sender             (send);
  ASSIGN_FILE_Receiver           (rec);
  ASSIGN_FILE_Signal             (sig);
  ASSIGN_FILE_Prio               (prio);
  ASSIGN_FILE_TimeStamp          (timestamp);
  ASSIGN_FILE_SignalParameters   (p_info, info_len);

  ASSIGN_STDOUT_Sender           (send);
  ASSIGN_STDOUT_Receiver         (rec);
  ASSIGN_STDOUT_Signal           (sig);
  ASSIGN_STDOUT_Prio             (prio);
  ASSIGN_STDOUT_TimeStamp        (timestamp);
  ASSIGN_STDOUT_SignalParameters (p_info, info_len);

  ASSIGN_COM_Sender              (send);
  ASSIGN_COM_Receiver            (rec);
  ASSIGN_COM_Signal              (sig);
  ASSIGN_COM_Prio                (prio);
  ASSIGN_COM_TimeStamp           (timestamp);
  ASSIGN_COM_SignalParameters    (p_info, info_len);

  ASSIGN_TBF_Sender              (send);
  ASSIGN_TBF_Receiver            (rec);
  ASSIGN_TBF_Signal              (sig);
  ASSIGN_TBF_Prio                (prio);
  ASSIGN_TBF_TimeStamp           (timestamp);
  ASSIGN_TBF_SignalParameters    (p_info, info_len);

  ASSIGN_MSC_Sender              (send);
  ASSIGN_MSC_Receiver            (rec);
  ASSIGN_MSC_Signal              (sig);
  ASSIGN_MSC_Prio                (prio);
  ASSIGN_MSC_TimeStamp           (timestamp);
  ASSIGN_MSC_SignalParameters    (p_info, info_len);

  /*
  ** Write into File ...
  */
  FILE_WRITE ( command, info );

  /*
  ** Write to STDOUT ...
  */
  STDOUT_WRITE ( command, info );

  /*
  ** record into tracebuffer ..
  */
  TBF_WRITE ( command, tbf );

  /*
  ** Send via serial interface ...
  */
  ENCODE_OUTPUT ( command, info, SZ(xmk_T_CMD_TOUTPUT) );

  /*
  ** Draw Message sequence charts diagram ...
  */
  MSCE_WRITE ( command, info );




  /*
  ** Return
  */
  return (XMK_OKAY);

}


/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]StoreCounterValue                                 |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function stores the current value of the event counter, i.e.           |
|  it builds the <Counter value section> and stores by sending it to host.     |
|                                                                              |
|  After storing the value, the global variable containing the counter value   |
|  is reset.                                                                   |
|                                                                              |
|  Parameter    : void                                                         |
|                                                                              |
|  Return       : void                                                         |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

static void xmk_StoreCounterValue ( void )

/*-FDEF E*/
{
  xmk_T_CMD_RECORD_COUNT_IND info;

  /*
  ** Store the <Counter value section>
  */
  ASSIGN_FILE_CountRecordedEvent       (CountRecordedEvent);

  ASSIGN_STDOUT_CountRecordedEvent     (CountRecordedEvent);

  ASSIGN_TBF_CountRecordedEvent        (CountRecordedEvent);

  ASSIGN_COM_CountRecordedEvent        (CountRecordedEvent);

  ASSIGN_MSC_CountRecordedEvent       (CountRecordedEvent);

  /*
  ** Write into File ...
  */
  FILE_WRITE ( CMD_RECORD_COUNT_IND, info );

  /*
  ** Write to STDOUT ...
  */
  STDOUT_WRITE ( CMD_RECORD_COUNT_IND, info );

  /*
  ** record into tracebuffer ..
  */
  TBF_WRITE ( CMD_RECORD_COUNT_IND, tbf );

  /*
  ** Send via serial interface ...
  */
  ENCODE ( CMD_RECORD_COUNT_IND, info, SZ(xmk_T_CMD_RECORD_COUNT_IND) );

  /*
  ** Draw Message sequence charts diagram ...
  */
  MSCE_WRITE ( CMD_RECORD_COUNT_IND, info );

  XMK_BEGIN_CRITICAL_PATH;

  /*
  ** Begin a new <Counter value section>
  */
  CountRecordedEvent = 0 ;

  XMK_END_CRITICAL_PATH;

}

#endif /* ... XMK_ADD_MICRO_RECORDER */

#endif /* __MT_REC_C_ */
