/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*+MHDR*/
/*
+------------------------------------------------------------------------------+
#  Modulname: mt_tsdl.c
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|  This Module exports functions to trace SDL-Actions. The functions contained |
|  in this module are not to be called by the users (with one exception, please|
|  see below).                                                                 |
|                                                                              |
|  The Cmicro Kernel and the Cmicro Tester itself uses / represents the        |
|  functions contained here.                                                   |
|                                                                              |
|  One simple exception may be valid : If a user writes SDL-Processes by hand, |
|  he possible can use two trace-mechanisms, namely SDL-Task - function        |
|  xmk_TSDL_Task, and SDL-Decision, function xmk_TSDL_Decision.                |
|                                                                              |
|  Its possible to trace either into the RAM, into a file, onto the screen,    |
|  or via a V24 interface.                                                     |
|                                                                              |
|  The modul is common for all the above mentioned trace methods. The functions|
|  exported here are called directly by the Cmicro Kernel, if the Cmicro Tester|
|  or part of the Cmicro Tester are involved when executing the SDL System. So,|
|  this module is more a part of the Cmicro Kernel.                            |
|                                                                              |
|  Due to the possibility to run the Cmicro Kernel / the Cmicro Tester on      |
|  different systems, and the possibilities to direct the traceoutput to       |
|  different devices (like HDD, screen, serial interface, RAM and MSC editor)  |
|  the module behaves a little like a chameleon.                               |
|                                                                              |
|  M1 Errormessages, which are routed to the ErrorHandler                      |
|  --------------------------------------------------------                    |
|    ERR_N_TRACE_OUTPUT          General error (like Parameters do not fit into|
|                                frame                                         |
|                                                                              |
|  M2 Exported functions of this module :                                      |
|  --------------------------------------------------------                    |
|  *34void [Qualified]TSDL_PrintString (char *p)                               |
|  *3 void [Qualified]TSDL_Task( char *TaskName )                              |
|  *1 void [Qualified]TSDL_Set ( xmk_T_SIGNAL )                                |
|  *1 void [Qualified]TSDL_Reset ( xmk_T_SIGNAL )                              |
|  *1 void [Qualified]TSDL_ActualReset (xmk_T_SIGNAL Signal  )                 |
|  *1 void [Qualified]TSDL_State( xmk_T_STATE State )                          |
|  *1 void [Qualified]TSDL_Discard(xmk_OPT_INT,xmk_T_MESSAGE *p_Message,       |
|                           xmk_T_STATE State )                                |
|  *1 void [Qualified]TSDL_PSC_CreateAll( void );                              |
|  *1 void [Qualified]TSDL_StaticCreate( xPID )                                |
|  *1 void [Qualified]TSDL_Create( xmk_T_MESSAGE *p_CreMsg )                   |
|  *1 void [Qualified]TSDL_DynamicCreate( xPID, xPID )                         |
|  *3 void [Qualified]TSDL_Decision( char *DecisionName )                      |
|  *1 void [Qualified]TSDL_Save( xmk_T_MESSAGE *p_Message )                    |
|  *1 void [Qualified]TSDL_Input( xmk_T_MESSAGE *p_Message, xmk_T_STATE State )|
|  *3 void [Qualified]TSDL_Procedure( char *ProcedureName )                    |
|  *1 xmk_OPT_INT [Qualified]TSDL_Output ( xmk_T_SIGNAL sig, xmk_T_PRIO prio, .|
|  *1 void [Qualified]TSDL_ImplicitConsumption  (xmk_T_MESSAGE *, xmk_T_STATE )|
|  *1 void [Qualified]TSDL_PSC_CreateAll        ( void )                       |
|  *1 void [Qualified]TSDL_SymbolID             ( int )                        |
|  *1 void [Qualified]TSDL_InputID              ( int )                        |
|                                                                              |
|  Possible Callers of the functions exported by this module :                 |
|      *1 == Cmicro Kernel                                                     |
|      *2 == Cmicro Tester                                                     |
|      *3 == Generated C-Code from the SDL-Application                         |
|      *4 == The User                                                          |
|                                                                              |
|  M3 Static functions of this module :                                        |
|  --------------------------------------------------------                    |
|    -no-                                                                      |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-MHDR*/

#ifndef __MT_TSDL_C_
#define __MT_TSDL_C_


/*+IMPORT*/
/*=====================  I M P O R T  ========================================*/

/*---------------------  Headerfiles  ----------------------------------------*/
#include "ml_typ.h"

/*---------------------  Functions    ----------------------------------------*/

/*---------------------  Variables    ----------------------------------------*/

extern XCONST XPDTBL xmk_ROM_ptr xPDTBL[] ;

/*============================================================================*/
/*-IMPORT*/

/*+EXPORT*/
/*=====================  E X P O R T  ========================================*/

/*--------------------  Typedefinitions     ----------------------------------*/

/*--------------------  Constants,  Macros  ----------------------------------*/

/*---------------------  Functions    ----------------------------------------*/

/*---------------------  Variables    ----------------------------------------*/

/*============================================================================*/
/*-EXPORT*/

/*====================  V A L U E S  O F  T H I S   M O D U L E  =============*/

#ifdef XMK_ADD_MICRO_TESTER

/*--------------------  Constants,  Macros  ----------------------------------*/
#ifdef XMK_ADD_MICRO_RECORDER
  #define PLAY(p1)                          (void) xmk_Play (p1);
  #define PLAY_INPUT(p1)                    (void) xmk_Play (CMD_TINPUT);
  #define PLAY_OUTPUT(p1,p2,p3,p4,p5,p6)  \
        (void) xmk_PlaySDLOutput(p1,p2,p3,p4,p5,p6);
  #define RECORD(p1)                        (void) xmk_Record(p1);

  #define RECORD_INPUT(p1)                  (void) xmk_RecordSDLInput(p1);

  #define RECORD_OUTPUT(p1,p2,p3,p4,p5,p6)  \
          (void) xmk_RecordSDLOutput(p1,p2,p3,p4,p5,p6);
#else
  #define PLAY(p1)
  #define PLAY_INPUT(p1)
  #define PLAY_OUTPUT(p1,p2,p3,p4,p5,p6)
  #define RECORD(p1)
  #define RECORD_INPUT(p1)
  #define RECORD_OUTPUT(p1,p2,p3,p4,p5,p6)
#endif

/*
** Automatic and manual scaling possibilities
** -- internal definitions --
*/
#ifdef XMK_USE_SIGNAL_PRIORITIES
  #define XCOND_PRIO(prio)          prio
#else
  #define XCOND_PRIO(prio)          XMK_DUMMYPRIO
#endif

#ifdef XMK_USE_SIGNAL_TIME_STAMP
  #define XCOND_TIMESTAMP(stamp)    stamp
#else
  #define XCOND_TIMESTAMP(stamp)    0
#endif

#ifdef XMK_USED_SIGNAL_WITH_PARAMS
  #define XCOND_DATA_LEN(info_len)  info_len
  #define XCOND_DATA(p_info)        p_info
#else
  #define XCOND_DATA_LEN(info_len)  0
  #define XCOND_DATA(p_info)        (void *) NULL
#endif

#ifdef XMK_USE_RECEIVER_PID_IN_SIGNAL
  #define XCOND_RECEIVER(Receiver)  Receiver
#else
  #define XCOND_RECEIVER(Receiver)  xRouteSignal(sig)
#endif


/*
** Definition of trace - filedescriptors
*/
#define fn_trace1  STDOUT        /* for trace on STDOUT */


/*
** Sizeof use in assignments
*/
#define SZ(STR)    sizeof (STR)

/*
** The following expression returns true, if a signal is not a timer
*/
#define INPUT_IS_NOT_A_TIMER      (p_Message->signal > TimerBorder)
#define OUTPUT_IS_NOT_A_TIMER     (sig > TimerBorder)

/*
** The following expression returns true, if the trace is switched on
*/
#define SYMBOLWANTED(ppid,symbolno) xmk_IsSymbolWanted (ppid,symbolno)

/*
** The following expression returns true, if the trace is switched on
*/
#define SIGNALWANTED(signalid)      xmk_IsSignalWanted (signalid)


/*
** SDL Object identification  ....
*/
#ifdef XMK_ADD_MICRO_TESTER
  #define ITEM(tag,str)
#else
  #define ITEM(tag,str)
#endif


/*
** The following is used for the case, where
** no receiver pid is contained in each signal header
*/
#ifdef XMK_USE_RECEIVER_PID_IN_SIGNAL
  #define ASS_REC(p1,p2,p3)  p1 = p2;
#else
  #define ASS_REC(p1,p2,p3)  p1 = p3;
#endif


/*
** The following is used for the case, where
** no sender pid is contained in each signal header
*/
#ifdef XMK_USE_SENDER_PID_IN_SIGNAL
  #define ASS_SEND(p1,p2,p3)  p1 = p2;
#else
  #define ASS_SEND(p1,p2,p3)  p1 = p3;
#endif

/*
** The following is used for the case, where
** no signal priority is contained in each signal header
*/
#ifdef XMK_USE_SIGNAL_PRIORITIES
  #define ASS_PRIO(p1,p2,p3)  p1 = p2;
#else
  #define ASS_PRIO(p1,p2,p3)  p1 = p3;
#endif


/*
** The following is used for the case, where
** no timestamp is contained in each signal header
*/
#ifdef XMK_USE_SIGNAL_TIME_STAMP
  #define ASS_TIMESTAMP(p1,p2,p3)  p1 = p2 ;
#else
  #define ASS_TIMESTAMP(p1,p2,p3)  p1 = p3 ;
#endif

/*
** The following is used for the case, where
** no timestamp is contained in each signal header
*/
#ifdef XMK_USED_SIGNAL_WITH_PARAMS
  #define ASS_LENGTH(p1,p2,p3)  p1 = p2 ;
#else
  #define ASS_LENGTH(p1,p2,p3)  p1 = p3 ;
#endif


/*
** ----------------------------------
** Definitions to trace with MSC
** ----------------------------------
*/

#define ASSIGN_MSC_PrintString(str)
#define ASSIGN_MSC_Decision(dname)
#define ASSIGN_MSC_ProcedureName(pname)
#define ASSIGN_MSC_TaskName(tname)
#define ASSIGN_MSC_Time(time)
#define ASSIGN_MSC_TimerVal(Value)
#define ASSIGN_MSC_SetId(id)
#define ASSIGN_MSC_ResetId(id)
#define ASSIGN_MSC_Signal(id)
#define ASSIGN_MSC_State(pid,id)
#define ASSIGN_MSC_Prio(priority)
#define ASSIGN_MSC_Parent(pid)
#define ASSIGN_MSC_Process(pid)
#define ASSIGN_MSC_Receiver(receiver)
#define ASSIGN_MSC_Sender(sender)
#define ASSIGN_MSC_SignalParameters(ptr,messlen)
#define ASSIGN_MSC_TimeStamp(stamp)
#define DCL_MSC_ITEM(cmd,str)
#define ASSIGN_MSC_ITEM(cmd,str)
#define MSCE_WRITE(IDtag,infobuf)


#ifdef  XMK_USE_COMMLINK
  /*
  ** --------------------------------------------
  ** Definitions to trace via communications link
  ** --------------------------------------------
  */
  #define ASSIGN_COM_PrintString(str) \
          info.name_length = strlen ( str ); \
          if ( info.name_length >= XMK_MAX_PRINT_STRING ) \
          { \
            info.name_length = XMK_MAX_PRINT_STRING -1; \
          } \
          memcpy ( info.name, str, info.name_length ); \
          info.name [info.name_length] = '\0';

  #ifdef XMK_ADD_TDECISION
    #define ASSIGN_COM_Decision(dname) \
            info.name_length = strlen (dname); \
            AssignString (info.name, sizeof (info.name), dname);
  #endif

  #ifdef XMK_ADD_TPROCEDURE
    #define ASSIGN_COM_ProcedureName(pname) \
            info.name_length = strlen (pname); \
            AssignString (info.name, sizeof (info.name), pname);
  #endif

  #ifdef XMK_ADD_TTASK
    #define ASSIGN_COM_TaskName(tname) \
            info.name_length = strlen (tname); \
            AssignString (info.name, sizeof (info.name), tname);
  #endif

  #define ASSIGN_COM_Time(Time) \
          info.time = Time;

  #ifdef XMK_USED_TIMER_WITH_PARAMS
    #define ASSIGN_COM_TimerVal(Value) \
            info.TimerValue = Value;
  #else
    #define ASSIGN_COM_TimerVal(Value) \
            info.TimerValue = 0;
  #endif

  #define ASSIGN_COM_SetId(id) \
          info.timer = id;

  #define ASSIGN_COM_ResetId(id) \
          info.timer = id;

  #define ASSIGN_COM_Signal(id) \
          info.signal = id;

  #define ASSIGN_COM_State(pid,id) \
          info.state = id;

  #define ASSIGN_COM_Prio(priority) \
          info.prio = priority ;

  #define ASSIGN_COM_Parent(pid) \
          info.parent = pid;

  #define ASSIGN_COM_Process(pid) \
          info.process = pid;

  #define ASSIGN_COM_Receiver(receiver) \
          info.rec     = receiver;

  #define ASSIGN_COM_Sender(sender) \
          info.send    = sender;

  #define ASSIGN_COM_SignalParameters(ptr,messlen)   \
            if (parameters_wanted) \
            { \
              if (messlen > sizeof (info.parametercopy)) \
              { \
                ErrorHandler (ERR_N_TRACE_OUTPUT); \
                messlen = sizeof (info.parametercopy); \
              } \
              memcpy ((char *) info.parametercopy, \
                       (char *) ptr, messlen); \
              info.mess_length = messlen; \
              /* info.SignalParameters = ptr ;*/ \
            } \
            else \
            { \
              info.mess_length = 0; \
              /* info.SignalParameters = ptr ;*/ \
            }

  #define ASSIGN_COM_TimeStamp(stamp) \
          info.timestamp = stamp ;

  #define DCL_COM_ITEM(cmd,str)

  #define ASSIGN_COM_ITEM(cmd,str)

  /*
  ** The following is the encoding function of the cod - module
  ** which is used for the serial interface ...
  */
  #define ENCODE(IDtag,infobuf,LEN)  \
          xmk_Cod_Encode (XMK_MICRO_TRACER,IDtag,(char*)&infobuf,LEN);

  /*
  ** A special case is, where the information, which is to be
  ** transferred, is of variable length ...
  */
  #define ENCODE_NAME(IDtag,infobuf,LEN)  \
          xmk_Cod_Encode (XMK_MICRO_TRACER,IDtag,(char*)&infobuf, \
          LEN - sizeof (infobuf.name) + strlen (infobuf.name));

  /*
  ** A special case is, where the information, which is to be
  ** transferred, is of variable length ...
  */
  #define ENCODE_OUTPUT(IDtag,buf,LEN)  \
          xmk_Cod_Encode (XMK_MICRO_TRACER,IDtag,(char*)&buf, \
          LEN - sizeof (buf.parametercopy) + buf.mess_length);


#else

  #define ASSIGN_COM_PrintString(str)
  #define ASSIGN_COM_Decision(dname)
  #define ASSIGN_COM_ProcedureName(pname)
  #define ASSIGN_COM_TaskName(tname)
  #define ASSIGN_COM_Time(time)
  #define ASSIGN_COM_TimerVal(Value)
  #define ASSIGN_COM_SetId(id)
  #define ASSIGN_COM_ResetId(id)
  #define ASSIGN_COM_Signal(id)
  #define ASSIGN_COM_State(pid,id)
  #define ASSIGN_COM_Prio(priority)
  #define ASSIGN_COM_Parent(pid)
  #define ASSIGN_COM_Process(pid)
  #define ASSIGN_COM_Receiver(receiver)
  #define ASSIGN_COM_Sender(sender)
  #define ASSIGN_COM_SignalParameters(ptr,messlen)
  #define ASSIGN_COM_TimeStamp(stamp)
  #define COM_WRITE(command,info)

  #define DCL_COM_ITEM(cmd,str)

  #define ASSIGN_COM_ITEM(cmd,str)

  #define ENCODE(IDtag,infobuf,LEN)
  #define ENCODE_NAME(IDtag,infobuf,LEN)
  #define ENCODE_OUTPUT(IDtag,buf,LEN)

#endif  /* ... XMK_USE_COMMLINK */

#ifdef  XMK_ADD_TRACE_BUF
  /*
  ** ----------------------------------
  ** Definitions to trace to TBF
  ** ----------------------------------
  */
  #define ASSIGN_TBF_PrintString(str)

  #define ASSIGN_TBF_Decision(dname)

  #define ASSIGN_TBF_ProcedureName(pname)

  #define ASSIGN_TBF_TaskName(tname)

  #define ASSIGN_TBF_Time(time)

  #define ASSIGN_TBF_TimerVal(Value)

  #define ASSIGN_TBF_SetId(id) \
          tbf.signal = id;

  #define ASSIGN_TBF_ResetId(id) \
          tbf.signal = id;

  #define ASSIGN_TBF_Signal(id) \
          tbf.signal = id;

  #define ASSIGN_TBF_State(pid,id)

  #define ASSIGN_TBF_Prio(priority)

  #define ASSIGN_TBF_Parent(pid)

  #define ASSIGN_TBF_Process(pid)

  #define ASSIGN_TBF_Receiver(receiver)

  #define ASSIGN_TBF_Sender(sender)

  #define ASSIGN_TBF_SignalParameters(ptr,messlen)

  #define ASSIGN_TBF_TimeStamp(stamp)

  #define ASSIGN_TBF_ITEM(cmd,str) \
          memset ((unsigned char*) &tbf, 0, sizeof (tbf));

  #define DCL_TBF_ITEM(cmd,str) \
          xmk_TBF_ENTRY tbf ;

  /*
  ** Writing the tracebuffer ...
  */
  #define TBF_WRITE(cmd,info) \
          xmk_RingWrite (&xtbf_controlblock, (char *) &tbf, sizeof (tbf) )

  /*
  ** The TBF-Controlblock ...
  */
  extern xmk_T_RING xtbf_controlblock ;

#else

  #define ASSIGN_TBF_PrintString(str)
  #define ASSIGN_TBF_Decision(dname)
  #define ASSIGN_TBF_ProcedureName(pname)
  #define ASSIGN_TBF_TaskName(tname)
  #define ASSIGN_TBF_Time(time)
  #define ASSIGN_TBF_TimerVal(Value)
  #define ASSIGN_TBF_SetId(id)
  #define ASSIGN_TBF_ResetId(id)
  #define ASSIGN_TBF_Signal(id)
  #define ASSIGN_TBF_State(pid,id)
  #define ASSIGN_TBF_Prio(priority)
  #define ASSIGN_TBF_Parent(pid)
  #define ASSIGN_TBF_Process(pid)
  #define ASSIGN_TBF_Receiver(receiver)
  #define ASSIGN_TBF_Sender(sender)
  #define ASSIGN_TBF_SignalParameters(ptr,messlen)
  #define ASSIGN_TBF_TimeStamp(stamp)

  #define DCL_TBF_ITEM(cmd,str)

  #define ASSIGN_TBF_ITEM(cmd,str)

  #define TBF_WRITE(command,info)

#endif  /* ... XMK_ADD_TRACE_BUF */

#ifdef  XMK_ADD_STDOUT_TRACE
  /*
  ** ----------------------------------
  ** Definitions to trace to STDOUT
  ** ----------------------------------
  */
  #define ASSIGN_STDOUT_PrintString(str) \
          (void)fprintf (fn_trace1, "%s %s", c2, str);

  #define ASSIGN_STDOUT_Decision(dname) \
          (void)fprintf (fn_trace1, "%s%s ", c2, dname);

  #define ASSIGN_STDOUT_ProcedureName(pname) \
          (void)fprintf (fn_trace1, "%s%s ", c2, pname);

  #define ASSIGN_STDOUT_TaskName(tname) \
          (void)fprintf (fn_trace1, "%s%s ", c2, tname);

  #define ASSIGN_STDOUT_Time(Time) \
          (void)fprintf (fn_trace1, "%stime       :%d (int)", c2, Time );

  #ifdef XMK_USED_TIMER_WITH_PARAMS
    #define ASSIGN_STDOUT_TimerVal(Value) \
            (void)fprintf (fn_trace1, "%stimervalue :%d (int)", c2, Value );
  #else
    #define ASSIGN_STDOUT_TimerVal(Value)
  #endif


  #define ASSIGN_STDOUT_SetId(id) \
          (void)fprintf (fn_trace1, "%stimer      :%d ", c2, id );

  #define ASSIGN_STDOUT_ResetId(id) \
          (void)fprintf (fn_trace1, "%stimer      :%d ", c2, id );

  #define ASSIGN_STDOUT_Signal(id) \
          (void)fprintf (fn_trace1, "%ssignal     :%d ", c2, id );

  #define ASSIGN_STDOUT_State(pid,id) \
          (void)fprintf (fn_trace1, "%sstate      :%d ", c2, id );

  #define ASSIGN_STDOUT_Prio(priority) \
          (void)fprintf (fn_trace1, "%sprio       :%d ", c2, priority );

  #define ASSIGN_STDOUT_Process(pid) \
          (void)fprintf (fn_trace1, "%sprocess    :%d:%d ", c2, EPIDTYPE(pid), EPIDINST(pid) );

  #define ASSIGN_STDOUT_Parent(pid) \
          (void)fprintf (fn_trace1, "%sparent     :%d:%d ", c2, EPIDTYPE(pid), EPIDINST(pid) );

  #define ASSIGN_STDOUT_Receiver(receiver) \
          (void)fprintf (fn_trace1, "%srec        :%d:%d ", c2, EPIDTYPE(receiver), EPIDINST(receiver) );

  #define ASSIGN_STDOUT_SignalParameters(ptr,messlen) \
            (void)sprintf ( buf,    "%sparameters :\n", c2); \
            if (messlen != 0) \
            { \
              if (ptr != (char *) NULL)      \
                xmk_MonHexAsc (fn_trace1, buf, "     ", \
                          (unsigned char*) ptr, messlen); \
              else \
                (void)fprintf (fn_trace1, "%sparamet.len:%d\n", c2, messlen); \
            }

  #define ASSIGN_STDOUT_Sender(sender) \
          (void)fprintf (fn_trace1, "%ssnd        :%s ", c2, EPIDTYPE(sender), EPIDINST(sender) );

  #define ASSIGN_STDOUT_TimeStamp(stamp) \
          (void)fprintf (fn_trace1, "%stime       :%d ", c2, stamp );

  #define DCL_STDOUT_ITEM(cmd,str)

  #define ASSIGN_STDOUT_ITEM(cmd,str) \
          (void)fprintf (fn_trace1, "%s%s", c1, str);

  #define STDOUT_WRITE(command,info) \
          (void)fprintf (fn_trace1, "\n\n");

  #define WLINEFEED \
          (void)fprintf (fn_trace1, "\n");

#else
  #define ASSIGN_STDOUT_PrintString(str)
  #define ASSIGN_STDOUT_Decision(dname)
  #define ASSIGN_STDOUT_ProcedureName(pname)
  #define ASSIGN_STDOUT_TaskName(tname)
  #define ASSIGN_STDOUT_Time(time)
  #define ASSIGN_STDOUT_TimerVal(Value)
  #define ASSIGN_STDOUT_SetId(id)
  #define ASSIGN_STDOUT_ResetId(id)
  #define ASSIGN_STDOUT_Signal(id)
  #define ASSIGN_STDOUT_State(pid,id)
  #define ASSIGN_STDOUT_Prio(priority)
  #define ASSIGN_STDOUT_Parent(pid)
  #define ASSIGN_STDOUT_Process(pid)
  #define ASSIGN_STDOUT_Receiver(receiver)
  #define ASSIGN_STDOUT_Sender(sender)
  #define ASSIGN_STDOUT_SignalParameters(ptr,messlen)
  #define ASSIGN_STDOUT_TimeStamp(stamp)

  #define DCL_STDOUT_ITEM(cmd,str)

  #define ASSIGN_STDOUT_ITEM(cmd,str)

  #define STDOUT_WRITE(command,info)

  #define WLINEFEED

#endif  /* ... XMK_ADD_STDOUT_TRACE */

#ifdef XMK_ADD_FILE_TRACE
    /*
    ** ----------------------------------
    ** Definitions to trace into a FILE
    ** ----------------------------------
    */
    #define ASSIGN_FILE_PrintString(str)

    #define ASSIGN_FILE_Decision(dname) \
            (void)fprintf (fn_trace, "DECISION:%s", dname);

    #define ASSIGN_FILE_ProcedureName(pname) \
            (void)fprintf (fn_trace, "PROC:%s", pname);

    #define ASSIGN_FILE_TaskName(tname) \
            (void)fprintf (fn_trace, "TASK:%s", tname);

    #define ASSIGN_FILE_Time(time) \
            (void)fprintf (fn_trace, "time       :%d (int)", time );

    #ifdef XMK_USED_TIMER_WITH_PARAMS
      #define ASSIGN_FILE_TimerVal(Value) \
              (void)fprintf (fn_trace, "timer-value:%d (int)", Value );
    #else
      #define ASSIGN_FILE_TimerVal(Value)
    #endif

    #define ASSIGN_FILE_SetId(id) \
            (void)fprintf (fn_trace, "SET:%d", id );

    #define ASSIGN_FILE_ResetId(id) \
            (void)fprintf (fn_trace, "SET:%d", id );

    #define ASSIGN_FILE_Signal(id) \
            (void)fprintf (fn_trace, "signal:%d", id );

    #define ASSIGN_FILE_State(pid,id) \
            (void)fprintf (fn_trace, "state:%d", id );

    #define ASSIGN_FILE_Prio(priority) \
            (void)fprintf (fn_trace, "prio:%d", priority );

    #define ASSIGN_FILE_Parent(pid) \
            (void)fprintf (fn_trace, "parent:%d:%d", EPIDTYPE(pid), EPIDINST(pid) );

    #define ASSIGN_FILE_Process(pid) \
            (void)fprintf (fn_trace, "process:%d:%d", EPIDTYPE(pid), EPIDINST(pid) );

    #define ASSIGN_FILE_Receiver(receiver) \
            (void)fprintf (fn_trace, "rec:%d:%d", EPIDTYPE(receiver), EPIDINST(receiver) );

    #define ASSIGN_FILE_Sender(sender) \
            (void)fprintf (fn_trace, "send:%d:%d", EPIDTYPE(sender), EPIDINST(sender) );

    #define ASSIGN_FILE_SignalParameters(ptr,messlen)

    #define ASSIGN_FILE_TimeStamp(stamp) \
            (void)fprintf (fn_trace, "time:%d", stamp );

    #define DCL_FILE_ITEM(cmd,str) \
            extern FILE * fn_trace ;

    #define ASSIGN_FILE_ITEM(cmd,str)

    #define FILE_WRITE(command,info)

#else

  #define ASSIGN_FILE_PrintString(str)
  #define ASSIGN_FILE_Decision(dname)
  #define ASSIGN_FILE_ProcedureName(pname)
  #define ASSIGN_FILE_TaskName(tname)
  #define ASSIGN_FILE_Time(time)
  #define ASSIGN_FILE_TimerVal(value)
  #define ASSIGN_FILE_SetId(id)
  #define ASSIGN_FILE_ResetId(id)
  #define ASSIGN_FILE_Signal(id)
  #define ASSIGN_FILE_State(pid,id)
  #define ASSIGN_FILE_Prio(priority)
  #define ASSIGN_FILE_Parent(pid)
  #define ASSIGN_FILE_Process(pid)
  #define ASSIGN_FILE_Receiver(receiver)
  #define ASSIGN_FILE_Sender(sender)
  #define ASSIGN_FILE_SignalParameters(ptr,messlen)
  #define ASSIGN_FILE_TimeStamp(stamp)

  #define DCL_FILE_ITEM(cmd,str)

  #define ASSIGN_FILE_ITEM(cmd,str)

  #define FILE_WRITE(command,info)

#endif  /* ... XMK_ADD_FILE_TRACE */


/*--------------------  Typedefinitions     ----------------------------------*/

/*---------------------  Functions   ----------------------------------------*/
#if defined (XMK_ADD_TDECISION) || defined (XMK_ADD_TPROCEDURE) || defined (XMK_ADD_TTASK)
  static void  AssignString   (char *, int, const char *);
#endif

/*---------------------  Variables    ----------------------------------------*/

#ifdef XMK_ADD_SDLE_TRACE
  /*
  ** Flag to store the state of the SDLE symbol trace (on/off)
  */
  xmk_OPT_INT xmk_SDLE_TracerActive = XMK_FALSE;
#endif

xmk_T_SIGNAL   TimerBorder      = MAX_SDL_TIMER_TYPES ;

#ifdef XMK_ADD_STDOUT_TRACE
  /*
  ** Column 1 is used to print the name of the SDL action (INPUT, TASK ....)
  ** Column 2 is used to print the values behind that task
  */
  static char *c1    = "  ";
  static char *c2    = "\n     ";
  static char  buf [128]        ; /* format strings        */
#endif

#endif /* ... XMK_ADD_MICRO_TESTER */

/*============================================================================*/

#ifdef XMK_ADD_MICRO_TESTER

#ifdef XMK_ADD_PSC_TRACE

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]TSDL_PSC_CreateAll                                |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description  :                                                              |
|    This function sends the process-Ids of all processes included in the      |
|    system to the host, to generate the instance axis in the PSC.             |
|                                                                              |
|    The function is called only once, and performs initialization of all      |
|    instanceaxes of static processinstances.                                  |
|                                                                              |
|  Parameter    : -                                                            |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_TSDL_PSC_CreateAll ( void )

/*-FDEF E*/
{
  xmk_T_PROCESS           Process          ;
  xmk_T_INSTANCE          Instance         ;
  XPDTBL  xmk_ROM_ptr     pProcessType     ;
  xmk_TPSC_Create         info             ;

  #ifdef XMK_ADD_PRINTF_TSDL
    XMK_FUNCTION("[Qualified]TSDL_PSC_CreateAll");
  #endif

  Process = 0;

  /*
  **  Loop in <root-process-table>
  */
  while ( (pProcessType = xPDTBL [Process]) != X_END_ROOT_TABLE )
  {
        Instance = 0 ;

        /*
        **  Loop in <process-state-table> for all instances of this processtype
        */
        while( ( Instance < pProcessType->MaxInstances ))
        {
          /*
          ** Set up informations for PSC
          */
          info.process = GLOBALPID(Process,Instance);

          /*
          ** Send via serial interface ...
          */
          ENCODE ( CMD_TPSC_CREATE, info, SZ(xmk_T_CMD_TPSC_CREATE) );

          Instance++ ;
        } /* END WHILE (testing processinstances) */
    Process++ ;
  } /* END WHILE (testing processtypes) */

  #ifdef XMK_ADD_PRINTF_TESTER
    XMK_TRACE_EXIT ("[Qualified]TSDL_PSC_CreateAll");
  #endif

} /* END OF FUNCTION */

#endif  /* ... XMK_ADD_PSC_TRACE */

#if defined(XMK_ADD_CPRINT_STRING)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]TSDL_PrintString                                  |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|                 This function encodes the given string into a message and    |
|                 sends it via the communications interface.                   |
|                                                                              |
|  Parameter    : char * p      pointer to string, terminated with '\0'        |
|                                                                              |
|  Return       : void                                                         |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void      xmk_TSDL_PrintString ( const char * PrintString )

/*-FDEF E*/
{

  xmk_T_CMD_PRINT_STRING info;

    DCL_TBF_ITEM    ( CMD_PRINT_STRING, "  USER:")
    DCL_FILE_ITEM   ( CMD_PRINT_STRING, "  USER:")
    DCL_STDOUT_ITEM ( CMD_PRINT_STRING, "  USER:")
    DCL_COM_ITEM    ( CMD_PRINT_STRING, "  USER:")
    DCL_MSC_ITEM    ( CMD_PRINT_STRING, "  USER:")

  #ifdef XMK_ADD_PRINTF_TSDL
    XMK_FUNCTION("[Qualified]TSDL_PrintString");
  #endif

    ITEM ( CMD_TPRINT_STRING, "USER:");

    ASSIGN_FILE_ITEM   ( CMD_PRINT_STRING, "  USER:");
    ASSIGN_STDOUT_ITEM ( CMD_PRINT_STRING, "  USER:");
    ASSIGN_COM_ITEM    ( CMD_PRINT_STRING, "  USER:");
    ASSIGN_TBF_ITEM    ( CMD_PRINT_STRING, "  USER:");
    ASSIGN_MSC_ITEM    ( CMD_PRINT_STRING, "  USER:");

    /*
    ** Set stringlength and cut off characters if buffer too small
    */
    ASSIGN_FILE_PrintString   (PrintString);
    ASSIGN_STDOUT_PrintString (PrintString);
    ASSIGN_COM_PrintString    (PrintString);
    ASSIGN_TBF_PrintString    (PrintString);
    ASSIGN_MSC_PrintString    (PrintString);

    /*
    ** Write into File ...
    */
    FILE_WRITE ( CMD_PRINT_STRING, info );

    /*
    ** Write to STDOUT ...
    */
    STDOUT_WRITE ( CMD_PRINT_STRING, info );

    /*
    ** Trace into tracebuffer ..
    */
    TBF_WRITE ( CMD_PRINT_STRING, tbf );

    /*
    ** Send via serial interface ...
    */
    ENCODE_NAME ( CMD_PRINT_STRING, info, SZ(xmk_T_CMD_PRINT_STRING) );

    /*
    ** Draw Message sequence charts diagram ...
    */
    MSCE_WRITE ( CMD_PRINT_STRING, info );

} /* END OF FUNCTION */

#endif /* ... defined(XMK_ADD_CPRINT_STRING)  */

#if defined( XMK_ADD_TTASK)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]TSDL_Task                                         |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called when a SDL Task       is executed in generated code.|
|                                                                              |
|  Parameter    :                                                              |
|                 char *TaskName - Pointer to the name of the task             |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_TSDL_Task( const char *TaskName )

/*-FDEF E*/

{
  xmk_T_CMD_TTASK  info   ;

  #ifdef XMK_ADD_PRINTF_TSDL
    XMK_FUNCTION("[Qualified]TSDL_Task");
  #endif


  /*
  ** Action for the Cmicro Recorder
  */
  RECORD ( CMD_TTASK );

  if( SYMBOLWANTED ( xRunPID, TSDL_TASK ) )
  {

    DCL_TBF_ITEM        ( CMD_TTASK, "  TASK:")
    DCL_FILE_ITEM       ( CMD_TTASK, "  TASK:")
    DCL_STDOUT_ITEM     ( CMD_TTASK, "  TASK:")
    DCL_COM_ITEM        ( CMD_TTASK, "  TASK:")
    DCL_MSC_ITEM        ( CMD_TTASK, "  TASK:")

    ITEM ( CMD_TTASK, "TASK:");

    ASSIGN_FILE_ITEM       ( CMD_TTASK, "  TASK:");
    ASSIGN_STDOUT_ITEM     ( CMD_TTASK, "  TASK:");
    ASSIGN_COM_ITEM        ( CMD_TTASK, "  TASK:");
    ASSIGN_TBF_ITEM        ( CMD_TTASK, "  TASK:");
    ASSIGN_MSC_ITEM        ( CMD_TTASK, "  TASK:");

    ASSIGN_FILE_Process    (xRunPID);
    ASSIGN_FILE_TaskName   (TaskName);

    ASSIGN_STDOUT_Process  (xRunPID);
    ASSIGN_STDOUT_TaskName (TaskName);

    ASSIGN_COM_Process     (xRunPID);
    ASSIGN_COM_TaskName    (TaskName);

    ASSIGN_TBF_Process     (xRunPID);
    ASSIGN_TBF_TaskName    (TaskName);

    ASSIGN_MSC_Process     (xRunPID);
    ASSIGN_MSC_TaskName    (TaskName);

    /*
    ** Write into File ...
    */
    FILE_WRITE ( CMD_TTASK, info );

    /*
    ** Write to STDOUT ...
    */
    STDOUT_WRITE ( CMD_TTASK, info );

    /*
    ** Trace into tracebuffer ..
    */
    TBF_WRITE ( CMD_TTASK, tbf );

    /*
    ** Send via serial interface ...
    */
    ENCODE_NAME ( CMD_TTASK, info, SZ(xmk_T_CMD_TTASK) );

    /*
    ** Draw Message sequence charts diagram ...
    */
    MSCE_WRITE ( CMD_TTASK, info );


  } /* END IF */

  /*
  ** Action for the Cmicro Recorder
  */
  PLAY ( CMD_TTASK );

} /* END OF FUNCTION */

#endif /* ... XMK_ADD_TTASK */

#if defined( XMK_ADD_TSET) && defined (XMK_USED_TIMER)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]TSDL_Set                                          |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called when a SDL Timer Set  is executed in generated code.|
|                                                                              |
|  Parameter    :                                                              |
|                 xmk_T_SIGNAL timer - ID of the timer                         |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_TSDL_Set      ( xmk_T_SIGNAL timer,
                         xmk_T_TIME   time
                         #ifdef XMK_USED_TIMER_WITH_PARAMS
                             , SDL_Integer TimerParValue
                         #endif
                         )
/*-FDEF E*/

{
  xmk_T_CMD_TSET   info ;

  #ifdef XMK_ADD_PRINTF_TSDL
    XMK_FUNCTION("[Qualified]TSDL_Set");
  #endif

  /*
  ** Action for the Cmicro Recorder
  */
  RECORD ( CMD_TSET );

  if( SYMBOLWANTED ( xRunPID, TSDL_SET ) )
  {
    DCL_FILE_ITEM       ( CMD_TSET, "  SET:")
    DCL_STDOUT_ITEM     ( CMD_TSET, "  SET:")
    DCL_COM_ITEM        ( CMD_TSET, "  SET:")
    DCL_TBF_ITEM        ( CMD_TSET, "  SET:")
    DCL_MSC_ITEM        ( CMD_TSET, "  SET:")

    ITEM ( CMD_TSET, "SET:");

    ASSIGN_FILE_ITEM       ( CMD_TSET, "  SET:");
    ASSIGN_STDOUT_ITEM     ( CMD_TSET, "  SET:");
    ASSIGN_COM_ITEM        ( CMD_TSET, "  SET:");
    ASSIGN_TBF_ITEM        ( CMD_TSET, "  SET:");
    ASSIGN_MSC_ITEM        ( CMD_TSET, "  SET:");

    ASSIGN_FILE_Process    (xRunPID);
    ASSIGN_FILE_SetId      (timer);
    ASSIGN_FILE_Time       (time);
    ASSIGN_FILE_TimerVal   (TimerParValue);

    ASSIGN_STDOUT_Process  (xRunPID);
    ASSIGN_STDOUT_SetId    (timer);
    ASSIGN_STDOUT_Time     (time);
    ASSIGN_STDOUT_TimerVal (TimerParValue);

    ASSIGN_COM_Process     (xRunPID);
    ASSIGN_COM_SetId       (timer);
    ASSIGN_COM_Time        (time);
    ASSIGN_COM_TimerVal    (TimerParValue);

    ASSIGN_TBF_Process     (xRunPID);
    ASSIGN_TBF_SetId       (timer);
    ASSIGN_TBF_Time        (time);
    ASSIGN_TBF_TimerVal    (TimerParValue);

    ASSIGN_MSC_Process     (xRunPID);
    ASSIGN_MSC_SetId       (timer);
    ASSIGN_MSC_Time        (time);
    ASSIGN_MSC_TimerVal    (TimerParValue);

    /*
    ** Write into File ...
    */
    FILE_WRITE ( CMD_TSET, info );

    /*
    ** Write to STDOUT ...
    */
    STDOUT_WRITE ( CMD_TSET, info );

    /*
    ** Trace into tracebuffer ..
    */
    TBF_WRITE ( CMD_TSET, tbf );

    /*
    ** Send via serial interface ...
    */
    ENCODE ( CMD_TSET, info, SZ(xmk_T_CMD_TSET) );

    /*
    ** Draw Message sequence charts diagram ...
    */
    MSCE_WRITE ( CMD_TSET, info );

  } /* END IF */

  /*
  ** Action for the Cmicro Recorder
  */
  PLAY ( CMD_TSET );

} /* END OF FUNCTION */

#endif /* ... XMK_ADD_TSET && XMK_USED_TIMER */

#if defined( XMK_ADD_TRESET) && defined (XMK_USED_TIMER)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]TSDL_Reset                                        |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called when a SDL Timer Resetis executed in generated code.|
|                                                                              |
|  Parameter    :                                                              |
|                 xmk_T_SIGNAL sid - ID of the timer                           |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/
void xmk_TSDL_Reset    ( xmk_T_SIGNAL timer
                         #ifdef XMK_USED_TIMER_WITH_PARAMS
                            , SDL_Integer TimerParValue
                         #endif
                       )
/*-FDEF E*/

{
  xmk_T_CMD_TRESET  info ;

  #ifdef XMK_ADD_PRINTF_TSDL
    XMK_FUNCTION("[Qualified]TSDL_Reset");
  #endif

  /*
  ** Action for the Cmicro Recorder
  */
  RECORD ( CMD_TRESET );

  if( SYMBOLWANTED ( xRunPID, TSDL_RESET ) )
  {
    DCL_FILE_ITEM       ( CMD_TRESET, "  RESET:")
    DCL_STDOUT_ITEM     ( CMD_TRESET, "  RESET:")
    DCL_COM_ITEM        ( CMD_TRESET, "  RESET:")
    DCL_TBF_ITEM        ( CMD_TRESET, "  RESET:")
    DCL_MSC_ITEM        ( CMD_TRESET, "  RESET:")

    ITEM ( CMD_TRESET, "RESET:");

    ASSIGN_FILE_ITEM       ( CMD_TRESET, "  RESET:");
    ASSIGN_STDOUT_ITEM     ( CMD_TRESET, "  RESET:");
    ASSIGN_COM_ITEM        ( CMD_TRESET, "  RESET:");
    ASSIGN_TBF_ITEM        ( CMD_TRESET, "  RESET:");
    ASSIGN_MSC_ITEM        ( CMD_TRESET, "  RESET:");

    ASSIGN_FILE_Process    (xRunPID);
    ASSIGN_FILE_ResetId    (timer);
    ASSIGN_FILE_TimerVal   (TimerParValue);

    ASSIGN_STDOUT_Process  (xRunPID);
    ASSIGN_STDOUT_ResetId  (timer);
    ASSIGN_STDOUT_TimerVal (TimerParValue);

    ASSIGN_COM_Process     (xRunPID);
    ASSIGN_COM_ResetId     (timer);
    ASSIGN_COM_TimerVal    (TimerParValue);

    ASSIGN_TBF_Process     (xRunPID);
    ASSIGN_TBF_ResetId     (timer);
    ASSIGN_TBF_TimerVal    (TimerParValue);

    ASSIGN_MSC_Process     (xRunPID);
    ASSIGN_MSC_ResetId     (timer);
    ASSIGN_MSC_TimerVal    (TimerParValue);

    /*
    ** Write into File ...
    */
    FILE_WRITE ( CMD_TRESET, info );

    /*
    ** Write to STDOUT ...
    */
    STDOUT_WRITE ( CMD_TRESET, info );

    /*
    ** Trace into tracebuffer ..
    */
    TBF_WRITE ( CMD_TRESET, tbf );

    /*
    ** Send via serial interface ...
    */
    ENCODE ( CMD_TRESET, info, SZ(xmk_T_CMD_TRESET) );

    /*
    ** Draw Message sequence charts diagram ...
    */
    MSCE_WRITE ( CMD_TRESET, info );

  } /* END IF */

  /*
  ** Action for the Cmicro Recorder
  */
  PLAY ( CMD_TRESET );

} /* END OF FUNCTION */

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]TSDL_ActualReset                                  |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called when an implicit SDL Timer Resetis executed in      |
|  generated code. That is the case, of a timer, which is currently running,   |
|  is to be set.                                                               |
|                                                                              |
|  Parameter    :                                                              |
|                 xmk_T_SIGNAL sid - ID of the timer                           |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_TSDL_ActualReset ( xmk_T_SIGNAL timer
                            #ifdef XMK_USED_TIMER_WITH_PARAMS
                              , SDL_Integer TimerParValue
                            #endif
                          )
/*-FDEF E*/

{
  xmk_T_CMD_TACTUAL_RESET  info ;

  #ifdef XMK_ADD_PRINTF_TSDL
    XMK_FUNCTION("[Qualified]TSDL_ActualReset");
  #endif

  /*
  ** Action for the Cmicro Recorder
  */
  RECORD ( CMD_TACTUAL_RESET );

  if( SYMBOLWANTED ( xRunPID, TSDL_RESET ) )
  {
    DCL_FILE_ITEM       ( CMD_TACTUAL_RESET, "  ACTUAL_RESET:")
    DCL_STDOUT_ITEM     ( CMD_TACTUAL_RESET, "  ACTUAL_RESET:")
    DCL_COM_ITEM        ( CMD_TACTUAL_RESET, "  ACTUAL_RESET:")
    DCL_TBF_ITEM        ( CMD_TACTUAL_RESET, "  ACTUAL_RESET:")
    DCL_MSC_ITEM        ( CMD_TACTUAL_RESET, "  ACTUAL_RESET:")

    ITEM ( CMD_TACTUAL_RESET, "ACTUAL_RESET:");

    ASSIGN_FILE_ITEM       ( CMD_TACTUAL_RESET, "  ACTUAL_RESET:");
    ASSIGN_STDOUT_ITEM     ( CMD_TACTUAL_RESET, "  ACTUAL_RESET:");
    ASSIGN_COM_ITEM        ( CMD_TACTUAL_RESET, "  ACTUAL_RESET:");
    ASSIGN_TBF_ITEM        ( CMD_TACTUAL_RESET, "  ACTUAL_RESET:");
    ASSIGN_MSC_ITEM        ( CMD_TACTUAL_RESET, "  ACTUAL_RESET:");

    ASSIGN_FILE_Process    (xRunPID);
    ASSIGN_FILE_ResetId    (timer);
    ASSIGN_FILE_TimerVal   (TimerParValue);

    ASSIGN_STDOUT_Process  (xRunPID);
    ASSIGN_STDOUT_ResetId  (timer);
    ASSIGN_STDOUT_TimerVal (TimerParValue);

    ASSIGN_COM_Process     (xRunPID);
    ASSIGN_COM_ResetId     (timer);
    ASSIGN_COM_TimerVal    (TimerParValue);

    ASSIGN_TBF_Process     (xRunPID);
    ASSIGN_TBF_ResetId     (timer);
    ASSIGN_TBF_TimerVal    (TimerParValue);

    ASSIGN_MSC_Process     (xRunPID);
    ASSIGN_MSC_ResetId     (timer);
    ASSIGN_MSC_TimerVal    (TimerParValue);

    /*
    ** Write into File ...
    */
    FILE_WRITE ( CMD_TACTUAL_RESET, info );

    /*
    ** Write to STDOUT ...
    */
    STDOUT_WRITE ( CMD_TACTUAL_RESET, info );

    /*
    ** Trace into tracebuffer ..
    */
    TBF_WRITE ( CMD_TACTUAL_RESET, tbf );

    /*
    ** Send via serial interface ...
    */
    ENCODE ( CMD_TACTUAL_RESET, info, SZ(xmk_T_CMD_TACTUAL_RESET) );

    /*
    ** Draw Message sequence charts diagram ...
    */
    MSCE_WRITE ( CMD_TACTUAL_RESET, info );

  } /* END IF */

  /*
  ** Action for the Cmicro Recorder
  */
  PLAY ( CMD_TACTUAL_RESET );

} /* END OF FUNCTION */


#endif /* ... XMK_ADD_TRESET && XMK_USED_TIMER */

#if defined( XMK_ADD_TSTATE) || defined (XMK_ADD_CKILL_PROCESS)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]TSDL_State                                        |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called when a Nextstate is executed in generated code.     |
|  Parameter    :                                                              |
|                 xmk_T_STATE State - Name of the SDL state                    |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_TSDL_State( xmk_T_STATE State )

/*-FDEF E*/

{

  #ifdef XMK_ADD_PRINTF_TSDL
    XMK_FUNCTION("[Qualified]TSDL_State");
  #endif

  if( State != XDORMANT )
  {
    /*
    ** Action for the Cmicro Recorder
    */
    RECORD ( CMD_TSTATE );
    if( SYMBOLWANTED ( xRunPID, TSDL_STATE ) )
    {
      xmk_T_CMD_TSTATE  info ;

      DCL_FILE_ITEM       ( CMD_TSTATE, "  NEXTSTATE:")
      DCL_STDOUT_ITEM     ( CMD_TSTATE, "  NEXTSTATE:")
      DCL_COM_ITEM        ( CMD_TSTATE, "  NEXTSTATE:")
      DCL_TBF_ITEM        ( CMD_TSTATE, "  NEXTSTATE:")
      DCL_MSC_ITEM        ( CMD_TSTATE, "  NEXTSTATE:")

      ITEM ( CMD_TSTATE, "NEXTSTATE:");

      ASSIGN_FILE_ITEM       ( CMD_TNEXTSTATE, "  NEXTSTATE:");
      ASSIGN_STDOUT_ITEM     ( CMD_TNEXTSTATE, "  NEXTSTATE:");
      ASSIGN_COM_ITEM        ( CMD_TNEXTSTATE, "  NEXTSTATE:");
      ASSIGN_TBF_ITEM        ( CMD_TNEXTSTATE, "  NEXTSTATE:");
      ASSIGN_MSC_ITEM        ( CMD_TNEXTSTATE, "  NEXTSTATE:");

      ASSIGN_FILE_Process    (xRunPID);
      ASSIGN_FILE_State      (xRunPID, State);

      ASSIGN_STDOUT_Process  (xRunPID);
      ASSIGN_STDOUT_State    (xRunPID, State);

      ASSIGN_COM_Process     (xRunPID);
      ASSIGN_COM_State       (xRunPID, State);

      ASSIGN_TBF_Process     (xRunPID);
      ASSIGN_TBF_State       (xRunPID, State);

      ASSIGN_MSC_Process     (xRunPID);
      ASSIGN_MSC_State       (xRunPID, State);

      /*
      ** Write into File ...
      */
      FILE_WRITE ( CMD_TSTATE, info );

      /*
      ** Write to STDOUT ...
      */
      STDOUT_WRITE ( CMD_TSTATE, info );
      WLINEFEED;

      /*
      ** Trace into tracebuffer ..
      */
      TBF_WRITE ( CMD_TSTATE, tbf );

      /*
      ** Send via serial interface ...
      */
      ENCODE ( CMD_TSTATE, info, SZ(xmk_T_CMD_TSTATE) );

      /*
      ** Draw Message sequence charts diagram ...
      */
      MSCE_WRITE ( CMD_TSTATE, info );

    } /* END IF */

    /*
    ** Action for the Cmicro Recorder
    */
    PLAY ( CMD_TSTATE );

  } /* END IF */
  
#if defined (XMK_USED_DYNAMIC_STOP) || defined (XMK_ADD_CKILL_PROCESS)
  else
  {
    /*
    ** Action for the Cmicro Recorder
    */
    RECORD ( CMD_TSTOP );

    if( SYMBOLWANTED ( xRunPID, TSDL_STOP ) )
    {
    xmk_T_CMD_TSTOP   info ;

      DCL_FILE_ITEM       ( CMD_TSTOP, "  STOP:")
      DCL_STDOUT_ITEM     ( CMD_TSTOP, "  STOP:")
      DCL_COM_ITEM        ( CMD_TSTOP, "  STOP:")
      DCL_TBF_ITEM        ( CMD_TSTOP, "  STOP:")
      DCL_MSC_ITEM        ( CMD_TSTOP, "  STOP:")

      ITEM ( CMD_TSTOP, "STOP:");

      ASSIGN_FILE_ITEM       ( CMD_TSTOP, "  STOP:");
      ASSIGN_STDOUT_ITEM     ( CMD_TSTOP, "  STOP:");
      ASSIGN_COM_ITEM        ( CMD_TSTOP, "  STOP:");
      ASSIGN_TBF_ITEM        ( CMD_TSTOP, "  STOP:");
      ASSIGN_MSC_ITEM        ( CMD_TSTOP, "  STOP:");

      ASSIGN_FILE_Process    (xRunPID);

      ASSIGN_STDOUT_Process  (xRunPID);

      ASSIGN_COM_Process     (xRunPID);

      ASSIGN_TBF_Process     (xRunPID);

      ASSIGN_MSC_Process     (xRunPID);

      /*
      ** Write into File ...
      */
      FILE_WRITE ( CMD_TSTOP, info );

      /*
      ** Write to STDOUT ...
      */
      STDOUT_WRITE ( CMD_TSTOP, info );
      WLINEFEED;

      /*
      ** Trace into tracebuffer ..
      */
      TBF_WRITE ( CMD_TSTOP, tbf );

      /*
      ** Send via serial interface ...
      */
      ENCODE ( CMD_TSTOP, info, SZ(xmk_T_CMD_TSTOP) );

      /*
      ** Draw Message sequence charts diagram ...
      */
      MSCE_WRITE ( CMD_TSTOP, info );
    } /*END IF*/

    /*
    ** Action for the Cmicro Recorder
    */
    PLAY ( CMD_TSTOP );

  } /* END ELSE */
#endif /* ... XMK_USED_DYNAMIC_STOP || XMK_ADD_CKILL_PROCESS */

} /* END OF FUNCTION */

#endif /* ... XMK_ADD_TSTATE  */

#if defined( XMK_ADD_TDISCARD)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]TSDL_Discard                                      |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called when a SDL Signal is discarded. This is the case,   |
|  where the receiving process is not in a state, where the signal is defined. |
|                                                                              |
|  Parameter    :                                                              |
|                xmk_T_MESSAGE *p_Message - Pointer to the signal, which was   |
|                                           discarded                          |
|                xmk_T_STATE State        - SDL state of the receiver process  |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_TSDL_Discard ( xmk_T_MESSAGE *p_Message,
                        xmk_T_STATE State )
/*-FDEF E*/

{
  xmk_T_CMD_TDISCARD  info ;
  xPID                rec  ;
  xPID                send ;

  #ifdef XMK_ADD_PRINTF_TSDL
    XMK_FUNCTION("[Qualified]TSDL_Discard");
  #endif

  /*
  ** Action for the Cmicro Recorder
  */
  RECORD ( CMD_TDISCARD );

  ASS_REC  (rec,  p_Message->rec, xRouteSignal (p_Message->signal) );

  if( SYMBOLWANTED ( rec, TSDL_DISCARD ) )
  {

    DCL_FILE_ITEM       ( CMD_TDISCARD, "**ERR DISCARD:")
    DCL_STDOUT_ITEM     ( CMD_TDISCARD, "**ERR DISCARD:")
    DCL_COM_ITEM        ( CMD_TDISCARD, "**ERR DISCARD:")
    DCL_TBF_ITEM        ( CMD_TDISCARD, "**ERR DISCARD:")
    DCL_MSC_ITEM        ( CMD_TDISCARD, "**ERR DISCARD:")

    ITEM ( CMD_TDISCARD, "**ERR DISCARD:");

    ASSIGN_FILE_ITEM       ( CMD_TDISCARD, "**ERR DISCARD:");
    ASSIGN_STDOUT_ITEM     ( CMD_TDISCARD, "**ERR DISCARD:");
    ASSIGN_COM_ITEM        ( CMD_TDISCARD, "**ERR DISCARD:");
    ASSIGN_TBF_ITEM        ( CMD_TDISCARD, "**ERR DISCARD:");
    ASSIGN_MSC_ITEM        ( CMD_TDISCARD, "**ERR DISCARD:");

    ASS_SEND (send, p_Message->send, xNULLPID);

    ASSIGN_FILE_Process    (xRunPID);
    ASSIGN_FILE_State      (xRunPID, State);
    ASSIGN_FILE_Signal     (p_Message->signal);

    ASSIGN_STDOUT_Process  (xRunPID);
    ASSIGN_STDOUT_State    (xRunPID, State);
    ASSIGN_STDOUT_Signal   (p_Message->signal);

    ASSIGN_COM_Process     (xRunPID);
    ASSIGN_COM_State       (xRunPID, State);
    ASSIGN_COM_Signal      (p_Message->signal);

    ASSIGN_TBF_Process     (xRunPID);
    ASSIGN_TBF_State       (xRunPID, State);
    ASSIGN_TBF_Signal      (p_Message->signal);

    ASSIGN_MSC_Process     (xRunPID);
    ASSIGN_MSC_State       (xRunPID, State);
    ASSIGN_MSC_Signal      (p_Message->signal);

    /*
    ** Write into File ...
    */
    FILE_WRITE ( CMD_TDISCARD, info );

    /*
    ** Write to STDOUT ...
    */
    STDOUT_WRITE ( CMD_TDISCARD, info );

    /*
    ** Trace into tracebuffer ..
    */
    TBF_WRITE ( CMD_TDISCARD, tbf );

    /*
    ** Send via serial interface ...
    */
    ENCODE ( CMD_TDISCARD, info, SZ(xmk_T_CMD_TDISCARD) );

    /*
    ** Draw Message sequence charts diagram ...
    */
    MSCE_WRITE ( CMD_TDISCARD, info );
  } /* END IF */


  /*
  ** Action for the Cmicro Recorder
  */
  PLAY ( CMD_TDISCARD );

  XMK_SUPPRESS(rec);
  XMK_SUPPRESS(send);
  XMK_SUPPRESS(State)
  XMK_SUPPRESS(p_Message);


} /* END OF FUNCTION */


#endif /* ... XMK_ADD_TDISCARD */

#if defined( XMK_ADD_TIMPLICIT_CONSUMPTION)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]TSDL_ImplicitConsumption                          |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called when an implicit consumption of an SDL Signal is    |
|  performed.                                                                  |
|                                                                              |
|  Parameter    :                                                              |
|                xmk_T_MESSAGE *p_Message - Pointer to the signal, which was   |
|                                           implicitely consumed               |
|                xmk_T_STATE State        - SDL state of the receiver process  |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_TSDL_ImplicitConsumption ( xmk_T_MESSAGE *p_Message,
                                    xmk_T_STATE State )
/*-FDEF E*/

{
  xmk_T_CMD_TIMPLICIT_CONSUMPTION  info ;
  xPID                             rec  ;
  xPID                             send ;

  #ifdef XMK_ADD_PRINTF_TSDL
    XMK_FUNCTION("[Qualified]TSDL_ImplicitConsumption");
  #endif

  /*
  ** Action for the Cmicro Recorder
  */
  RECORD ( CMD_TIMPLICIT_CONSUMPTION );

  ASS_REC  (rec,  p_Message->rec, xRouteSignal (p_Message->signal) );

  if( SYMBOLWANTED ( rec, TSDL_IMPLICIT_CONSUMPTION ) )
  {

    DCL_FILE_ITEM       ( CMD_TIMPLICIT_CONSUMPTION, "**Warning IMPLICIT CONSUMPTION:")
    DCL_STDOUT_ITEM     ( CMD_TIMPLICIT_CONSUMPTION, "**Warning IMPLICIT CONSUMPTION:")
    DCL_COM_ITEM        ( CMD_TIMPLICIT_CONSUMPTION, "**Warning IMPLICIT CONSUMPTION:")
    DCL_TBF_ITEM        ( CMD_TIMPLICIT_CONSUMPTION, "**Warning IMPLICIT CONSUMPTION:")
    DCL_MSC_ITEM        ( CMD_TIMPLICIT_CONSUMPTION, "**Warning IMPLICIT CONSUMPTION:")

    ITEM ( CMD_TIMPLICIT_CONSUMPTION, "**Warning IMPLICIT CONSUMPTION:");

    ASSIGN_FILE_ITEM       ( CMD_TIMPLICIT_CONSUMPTION, "**Warning IMPLICIT CONSUMPTION:");
    ASSIGN_STDOUT_ITEM     ( CMD_TIMPLICIT_CONSUMPTION, "**Warning IMPLICIT CONSUMPTION:");
    ASSIGN_COM_ITEM        ( CMD_TIMPLICIT_CONSUMPTION, "**Warning IMPLICIT CONSUMPTION:");
    ASSIGN_TBF_ITEM        ( CMD_TIMPLICIT_CONSUMPTION, "**Warning IMPLICIT CONSUMPTION:");
    ASSIGN_MSC_ITEM        ( CMD_TIMPLICIT_CONSUMPTION, "**Warning IMPLICIT CONSUMPTION:");

    ASS_SEND (send, p_Message->send, xNULLPID);

    ASSIGN_FILE_Process    (xRunPID);
    ASSIGN_FILE_State      (xRunPID, State);
    ASSIGN_FILE_Signal     (p_Message->signal);

    ASSIGN_STDOUT_Process  (xRunPID);
    ASSIGN_STDOUT_State    (xRunPID, State);
    ASSIGN_STDOUT_Signal   (p_Message->signal);

    ASSIGN_COM_Process     (xRunPID);
    ASSIGN_COM_State       (xRunPID, State);
    ASSIGN_COM_Signal      (p_Message->signal);

    ASSIGN_TBF_Process     (xRunPID);
    ASSIGN_TBF_State       (xRunPID, State);
    ASSIGN_TBF_Signal      (p_Message->signal);

    ASSIGN_MSC_Process     (xRunPID);
    ASSIGN_MSC_State       (xRunPID, State);
    ASSIGN_MSC_Signal      (p_Message->signal);

    /*
    ** Write into File ...
    */
    FILE_WRITE ( CMD_TIMPLICIT_CONSUMPTION, info );

    /*
    ** Write to STDOUT ...
    */
    STDOUT_WRITE ( CMD_TIMPLICIT_CONSUMPTION, info );

    /*
    ** Trace into tracebuffer ..
    */
    TBF_WRITE ( CMD_TIMPLICIT_CONSUMPTION, tbf );

    /*
    ** Send via serial interface ...
    */
    ENCODE ( CMD_TIMPLICIT_CONSUMPTION, info, SZ(xmk_T_CMD_TIMPLICIT_CONSUMPTION) );

    /*
    ** Draw Message sequence charts diagram ...
    */
    MSCE_WRITE ( CMD_TIMPLICIT_CONSUMPTION, info );
  } /* END IF */


  /*
  ** Action for the Cmicro Recorder
  */
  PLAY ( CMD_TIMPLICIT_CONSUMPTION );


  XMK_SUPPRESS(rec);
  XMK_SUPPRESS(send);
  XMK_SUPPRESS(State)
  XMK_SUPPRESS(p_Message);


} /* END OF FUNCTION */


#endif /* ... xmk_TSDL_ImplicitConsumption */

#if defined( XMK_ADD_TSTATIC_CREATE)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]TSDL_StaticCreate                                 |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called for each SDL processinstance, which is created      |
|  during system startup.                                                      |
|                                                                              |
|  Parameter    :                                                              |
|                 xPID ProcessToBeCreated - PID of the process, which is       |
|                                           to be created ...                  |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_TSDL_StaticCreate( xPID ProcessToBeCreated )

/*-FDEF E*/

{
  xmk_T_CMD_TSTATIC_CREATE  info ;

  #ifdef XMK_ADD_PRINTF_TSDL
    XMK_FUNCTION("[Qualified]TSDL_StaticCreate");
  #endif

  /*
  ** Action for the Cmicro Recorder
  */
  RECORD ( CMD_TSTATIC_CREATE );

  if( SYMBOLWANTED ( ProcessToBeCreated, TSDL_STATIC_CREATE ) )
  {
    DCL_FILE_ITEM       ( CMD_TSTATIC_CREATE, "STATIC_CREATE:")
    DCL_STDOUT_ITEM     ( CMD_TSTATIC_CREATE, "STATIC_CREATE:")
    DCL_COM_ITEM        ( CMD_TSTATIC_CREATE, "STATIC_CREATE:")
    DCL_TBF_ITEM        ( CMD_TSTATIC_CREATE, "STATIC_CREATE:")
    DCL_MSC_ITEM        ( CMD_TSTATIC_CREATE, "STATIC_CREATE:")

    ITEM ( CMD_TSTATIC_CREATE, "STATIC_CREATE:");

    ASSIGN_FILE_ITEM       ( CMD_TSTATIC_CREATE, "STATIC_CREATE:");
    ASSIGN_STDOUT_ITEM     ( CMD_TSTATIC_CREATE, "STATIC_CREATE:");
    ASSIGN_COM_ITEM        ( CMD_TSTATIC_CREATE, "STATIC_CREATE:");
    ASSIGN_TBF_ITEM        ( CMD_TSTATIC_CREATE, "STATIC_CREATE:");
    ASSIGN_MSC_ITEM        ( CMD_TSTATIC_CREATE, "STATIC_CREATE:");

    ASSIGN_FILE_Process    (ProcessToBeCreated);

    ASSIGN_STDOUT_Process  (ProcessToBeCreated);

    ASSIGN_COM_Process     (ProcessToBeCreated);

    ASSIGN_TBF_Process     (ProcessToBeCreated);

    ASSIGN_MSC_Process     (ProcessToBeCreated);

    /*
    ** Write into File ...
    */
    FILE_WRITE ( CMD_TSTATIC_CREATE, info );

    /*
    ** Write to STDOUT ...
    */
    STDOUT_WRITE ( CMD_TSTATIC_CREATE, info );

    /*
    ** Trace into tracebuffer ..
    */
    TBF_WRITE ( CMD_TSTATIC_CREATE, tbf );

    /*
    ** Send via serial interface ...
    */
    ENCODE ( CMD_TSTATIC_CREATE, info, SZ(xmk_T_CMD_TSTATIC_CREATE) );

  } /* END IF */

  /*
  ** Action for the Cmicro Recorder
  */
  PLAY ( CMD_TSTATIC_CREATE );

} /* END OF FUNCTION */


#endif /* ... XMK_ADD_TSTATIC_CREATE */

#if defined(XMK_ADD_TCREATE) && (defined (XMK_USED_DYNAMIC_CREATE) || defined (XMK_ADD_CCREATE_PROCESS))


/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]TSDL_Create                                       |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called when a SDL Create     is executed in generated code.|
|                                                                              |
|  Parameter    :                                                              |
|                 xmk_T_MESSAGE *p_CreMsg - Pointer to the Create Signal       |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_TSDL_Create( xmk_T_MESSAGE *p_CreMsg )

/*-FDEF E*/

{
  xmk_T_CMD_TCREATE  info               ;
  xPID               ProcessToBeCreated ;

  #ifdef XMK_ADD_PRINTF_TSDL
    XMK_FUNCTION("[Qualified]TSDL_Create");
  #endif

  /*
  ** Action for the Cmicro Recorder
  */
  RECORD ( CMD_TCREATE );

  if( SYMBOLWANTED ( xRunPID, TSDL_CREATE ) )
  {
    DCL_FILE_ITEM       ( CMD_TCREATE, "  CREATE:")
    DCL_STDOUT_ITEM     ( CMD_TCREATE, "  CREATE:")
    DCL_COM_ITEM        ( CMD_TCREATE, "  CREATE:")
    DCL_TBF_ITEM        ( CMD_TCREATE, "  CREATE:")
    DCL_MSC_ITEM        ( CMD_TCREATE, "  CREATE:")

    ITEM ( CMD_TCREATE, "CREATE:");

    ASSIGN_FILE_ITEM       ( CMD_TCREATE, "  CREATE:");
    ASSIGN_STDOUT_ITEM     ( CMD_TCREATE, "  CREATE:");
    ASSIGN_COM_ITEM        ( CMD_TCREATE, "  CREATE:");
    ASSIGN_TBF_ITEM        ( CMD_TCREATE, "  CREATE:");
    ASSIGN_MSC_ITEM        ( CMD_TCREATE, "  CREATE:");

    ASS_REC (ProcessToBeCreated, p_CreMsg->rec, xNULLPID);

    ASSIGN_FILE_Parent     (xRunPID);
    ASSIGN_FILE_Process    (ProcessToBeCreated);

    ASSIGN_STDOUT_Parent   (xRunPID);
    ASSIGN_STDOUT_Process  (ProcessToBeCreated);

    ASSIGN_COM_Parent      (xRunPID);
    ASSIGN_COM_Process     (ProcessToBeCreated);

    ASSIGN_TBF_Parent      (xRunPID);
    ASSIGN_TBF_Process     (ProcessToBeCreated);

    ASSIGN_MSC_Parent      (xRunPID);
    ASSIGN_MSC_Process     (ProcessToBeCreated);

    /*
    ** Write into File ...
    */
    FILE_WRITE ( CMD_TCREATE, info );

    /*
    ** Write to STDOUT ...
    */
    STDOUT_WRITE ( CMD_TCREATE, info );

    /*
    ** Trace into tracebuffer ..
    */
    TBF_WRITE ( CMD_TCREATE, tbf );

    /*
    ** Send via serial interface ...
    */
    ENCODE ( CMD_TCREATE, info, SZ(xmk_T_CMD_TCREATE) );

    /*
    ** Draw Message sequence charts diagram ...
    */
    MSCE_WRITE ( CMD_TCREATE, info );
  } /* END IF */

  /*
  ** Action for the Cmicro Recorder
  */
  PLAY ( CMD_TCREATE );

} /* END OF FUNCTION */

#endif /* ... ((XMK_ADD_TCREATE) && (XMK_USED_DYNAMIC_CREATE)) || (XMK_ADD_CCREATE_PROCESS) */

#if defined( XMK_ADD_TDYNAMIC_CREATE) && defined (XMK_USED_DYNAMIC_CREATE)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]TSDL_DynamicCreate                                |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called directly before executing the starttransition of    |
|  a dynamically created process.                                              |
|                                                                              |
|  Parameter    :                                                              |
|                 xPID Parent             - PID of the parent process, which   |
|                                           created the Created process.       |
|                 xPID CreatedProcess     - PID of the process, which is going |
|                                           to be executed now.                |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_TSDL_DynamicCreate ( xPID Parent, xPID CreatedProcess )

/*-FDEF E*/

{
  xmk_T_CMD_TDYNAMIC_CREATE  info ;

  #ifdef XMK_ADD_PRINTF_TSDL
    XMK_FUNCTION("[Qualified]TSDL_DynamicCreate ");
  #endif

  /*
  ** Action for the Cmicro Recorder
  */
  RECORD ( CMD_TDYNAMIC_CREATE );

  if( SYMBOLWANTED ( CreatedProcess, TSDL_DYNAMIC_CREATE ) )
  {
    DCL_FILE_ITEM       ( CMD_TDYNAMIC_CREATE, "DYNAMIC_CREATE:")
    DCL_STDOUT_ITEM     ( CMD_TDYNAMIC_CREATE, "DYNAMIC_CREATE:")
    DCL_COM_ITEM        ( CMD_TDYNAMIC_CREATE, "DYNAMIC_CREATE:")
    DCL_TBF_ITEM        ( CMD_TDYNAMIC_CREATE, "DYNAMIC_CREATE:")
    DCL_MSC_ITEM        ( CMD_TDYNAMIC_CREATE, "DYNAMIC_CREATE:")

    ITEM ( CMD_TDYNAMIC_CREATE, "DYNAMIC_CREATE:");

    ASSIGN_FILE_ITEM       ( CMD_TDYNAMIC_CREATE, "DYNAMIC_CREATE:");
    ASSIGN_STDOUT_ITEM     ( CMD_TDYNAMIC_CREATE, "DYNAMIC_CREATE:");
    ASSIGN_COM_ITEM        ( CMD_TDYNAMIC_CREATE, "DYNAMIC_CREATE:");
    ASSIGN_TBF_ITEM        ( CMD_TDYNAMIC_CREATE, "DYNAMIC_CREATE:");
    ASSIGN_MSC_ITEM        ( CMD_TDYNAMIC_CREATE, "DYNAMIC_CREATE:");

    ASSIGN_FILE_Parent     (Parent);
    ASSIGN_FILE_Process    (CreatedProcess);

    ASSIGN_STDOUT_Parent   (Parent);
    ASSIGN_STDOUT_Process  (CreatedProcess);

    ASSIGN_COM_Parent      (Parent);
    ASSIGN_COM_Process     (CreatedProcess);

    ASSIGN_TBF_Parent      (Parent);
    ASSIGN_TBF_Process     (CreatedProcess);

    ASSIGN_MSC_Parent      (Parent);
    ASSIGN_MSC_Process     (CreatedProcess);

    /*
    ** Write into File ...
    */
    FILE_WRITE ( CMD_TDYNAMIC_CREATE, info );

    /*
    ** Write to STDOUT ...
    */
    STDOUT_WRITE ( CMD_TDYNAMIC_CREATE, info );

    /*
    ** Trace into tracebuffer ..
    */
    TBF_WRITE ( CMD_TDYNAMIC_CREATE, tbf );

    /*
    ** Send via serial interface ...
    */
    ENCODE ( CMD_TDYNAMIC_CREATE, info, SZ(xmk_T_CMD_TDYNAMIC_CREATE) );

  } /* END IF */

  /*
  ** Action for the Cmicro Recorder
  */
  PLAY ( CMD_TDYNAMIC_CREATE );

} /* END OF FUNCTION */


#endif /* ... XMK_ADD_TDYNAMIC_CREATE && defined (XMK_USED_DYNAMIC_CREATE) */


#if defined( XMK_ADD_TDECISION)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]TSDL_Decision                                     |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called when a SDL Decision   is executed in generated code.|
|                                                                              |
|  Parameter    :                                                              |
|                 char* DecisionName - Pointer to the Result of the decision   |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_TSDL_Decision( const char * DecisionName )

/*-FDEF E*/

{
  xmk_T_CMD_TDECISION  info ;

  #ifdef XMK_ADD_PRINTF_TSDL
    XMK_FUNCTION("[Qualified]TSDL_Decision");
  #endif


  /*
  ** Action for the Cmicro Recorder
  */
  RECORD ( CMD_TDECISION );

  if( SYMBOLWANTED ( xRunPID, TSDL_DECISION ) )
  {

    DCL_FILE_ITEM       ( CMD_TDECISION, "  DECISION:")
    DCL_STDOUT_ITEM     ( CMD_TDECISION, "  DECISION:")
    DCL_COM_ITEM        ( CMD_TDECISION, "  DECISION:")
    DCL_TBF_ITEM        ( CMD_TDECISION, "  DECISION:")
    DCL_MSC_ITEM        ( CMD_TDECISION, "  DECISION:")

    ITEM ( CMD_TDECISION, "DECISION:");

    ASSIGN_FILE_ITEM       ( CMD_TDECISION, "  DECISION:");
    ASSIGN_STDOUT_ITEM     ( CMD_TDECISION, "  DECISION:");
    ASSIGN_COM_ITEM        ( CMD_TDECISION, "  DECISION:");
    ASSIGN_TBF_ITEM        ( CMD_TDECISION, "  DECISION:");
    ASSIGN_MSC_ITEM        ( CMD_TDECISION, "  DECISION:");

    ASSIGN_FILE_Process    (xRunPID);
    ASSIGN_FILE_Decision   (DecisionName);

    ASSIGN_STDOUT_Process  (xRunPID);
    ASSIGN_STDOUT_Decision (DecisionName);

    ASSIGN_COM_Process     (xRunPID);
    ASSIGN_COM_Decision    (DecisionName);

    ASSIGN_TBF_Process     (xRunPID);
    ASSIGN_TBF_Decision    (DecisionName);

    ASSIGN_MSC_Process     (xRunPID);
    ASSIGN_MSC_Decision    (DecisionName);

    /*
    ** Write into File ...
    */
    FILE_WRITE ( CMD_TDECISION, info );

    /*
    ** Write to STDOUT ...
    */
    STDOUT_WRITE ( CMD_TDECISION, info );

    /*
    ** Trace into tracebuffer ..
    */
    TBF_WRITE ( CMD_TDECISION, tbf );

    /*
    ** Send via serial interface ...
    */
    ENCODE_NAME ( CMD_TDECISION, info, SZ(xmk_T_CMD_TDECISION) );

    /*
    ** Draw Message sequence charts diagram ...
    */
    MSCE_WRITE ( CMD_TDECISION, info );

  } /* END IF */

  /*
  ** Action for the Cmicro Recorder
  */
  PLAY ( CMD_TDECISION);

  /*
  ** Suppress compiler warnings
  */
  XMK_SUPPRESS(info);

} /* END OF FUNCTION */

#endif /* ... XMK_ADD_TDECISION */

#if defined( XMK_ADD_TSAVE) && defined(XMK_USED_SAVE)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]TSDL_Save                                         |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called when a SDL Save is executed in the Cmicro Kernel.   |
|                                                                              |
|  Parameter    :                                                              |
|                 xmk_T_MESSAGE *p_Message - Pointer to "saved" Signal         |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_TSDL_Save( xmk_T_MESSAGE *p_Message )

/*-FDEF E*/

{
  xmk_T_CMD_TSAVE  info ;
  xPID             rec  ;

  #ifdef XMK_ADD_PRINTF_TSDL
    XMK_FUNCTION("[Qualified]TSDL_Save");
  #endif

  /*
  ** Action for the Cmicro Recorder
  */
  RECORD ( CMD_TSAVE );

  ASS_REC (rec, p_Message->rec, xRouteSignal (p_Message->signal) );

  if( SYMBOLWANTED ( rec, TSDL_SAVE ) )
  {
    DCL_FILE_ITEM       ( CMD_TSAVE, "SAVE:")
    DCL_STDOUT_ITEM     ( CMD_TSAVE, "SAVE:")
    DCL_COM_ITEM        ( CMD_TSAVE, "SAVE:")
    DCL_TBF_ITEM        ( CMD_TSAVE, "SAVE:")
    DCL_MSC_ITEM        ( CMD_TSAVE, "SAVE:")

    #ifdef XMK_ADD_SIGNAL_FILTER
      /*
      ** Filter active for the current signal ?
      */
      if ( ! (SIGNALWANTED ( p_Message->signal ) )) return ;
    #endif

    ITEM ( CMD_TSAVE, "SAVE:");

    ASSIGN_FILE_ITEM       ( CMD_TSAVE, "SAVE:");
    ASSIGN_STDOUT_ITEM     ( CMD_TSAVE, "SAVE:");
    ASSIGN_COM_ITEM        ( CMD_TSAVE, "SAVE:");
    ASSIGN_TBF_ITEM        ( CMD_TSAVE, "SAVE:");
    ASSIGN_MSC_ITEM        ( CMD_TSAVE, "SAVE:");

    ASSIGN_FILE_Process    (rec);
    ASSIGN_FILE_Signal     (p_Message->signal);

    ASSIGN_STDOUT_Process  (rec);
    ASSIGN_STDOUT_Signal   (p_Message->signal);

    ASSIGN_COM_Process     (rec);
    ASSIGN_COM_Signal      (p_Message->signal);

    ASSIGN_TBF_Process     (rec);
    ASSIGN_TBF_Signal      (p_Message->signal);

    ASSIGN_MSC_Process     (rec);
    ASSIGN_MSC_Signal      (p_Message->signal);

    /*
    ** Write into File ...
    */
    FILE_WRITE ( CMD_TSAVE, info );

    /*
    ** Write to STDOUT ...
    */
    STDOUT_WRITE ( CMD_TSAVE, info );

    /*
    ** Trace into tracebuffer ..
    */
    TBF_WRITE ( CMD_TSAVE, tbf );

    /*
    ** Send via serial interface ...
    */
    ENCODE ( CMD_TSAVE, info, SZ(xmk_T_CMD_TSAVE) );

    /*
    ** Draw Message sequence charts diagram ...
    */
    MSCE_WRITE ( CMD_TSAVE, info );

  } /* END IF */

  /*
  ** Action for the Cmicro Recorder
  */
  PLAY ( CMD_TSAVE );

} /* END OF FUNCTION */

#endif /* ... XMK_ADD_TSAVE */

#if defined( XMK_ADD_TINPUT)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]TSDL_Input                                        |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called when a SDL Input is executed by the micro Kernel.   |
|                                                                              |
|  Parameter    :                                                              |
|                 xmk_T_MESSAGE *p_Message - Pointer to SDL Signal to Input    |
|                 xmk_T_STATE    State     - State of the receiving SDL process|
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_TSDL_Input( xmk_T_MESSAGE *p_Message, xmk_T_STATE State )

/*-FDEF E*/

{
  xmk_T_CMD_TINPUT  info    ;
  xmk_OPT_INT       command ;
  xmk_T_PRIO        prio    ;
  xPID              send    ;

  #ifdef XMK_ADD_PRINTF_TSDL
    XMK_FUNCTION("[Qualified]TSDL_Input");
  #endif

  /*
  ** Action for the Cmicro Recorder
  */
  RECORD_INPUT ( p_Message );

  #ifdef XMK_USE_RECEIVER_PID_IN_SIGNAL
    /*
    ** If sender pid is known
    */
    if ( EPIDTYPE ( p_Message->send ) >= MAX_SDL_PROCESS_TYPES)
    {
      if( ! ( SYMBOLWANTED ( EPIDTYPE ( p_Message->send ) , TSDL_INPUT ) ) )
      {
        /*
        ** if sender pid is environment & trace not wanted
        */
        return;
      }
    }
  #endif


  if( SYMBOLWANTED ( xRunPID, TSDL_INPUT ) )
  {
    DCL_FILE_ITEM       ( CMD_TINPUT, "INPUT:")
    DCL_STDOUT_ITEM     ( CMD_TINPUT, "INPUT:")
    DCL_COM_ITEM        ( CMD_TINPUT, "INPUT:")
    DCL_TBF_ITEM        ( CMD_TINPUT, "INPUT:")
    DCL_MSC_ITEM        ( CMD_TINPUT, "INPUT:")

    #ifdef XMK_ADD_SIGNAL_FILTER
      /*
      ** Filter active for the current signal ?
      */
      if ( ! (SIGNALWANTED ( p_Message->signal ) )) return ;
    #endif

    ITEM ( CMD_TINPUT, "INPUT:");

    ASSIGN_FILE_ITEM       ( CMD_TINPUT, "INPUT:");
    ASSIGN_STDOUT_ITEM     ( CMD_TINPUT, "INPUT:");
    ASSIGN_COM_ITEM        ( CMD_TINPUT, "INPUT:");
    ASSIGN_TBF_ITEM        ( CMD_TINPUT, "INPUT:");
    ASSIGN_MSC_ITEM        ( CMD_TINPUT, "INPUT:");

    /*
    ** Remember :
    ** Timer-ID's can be differentiated from
    ** ordinary SDL-Signals by the upper limit
    ** of Timer-ID.s
    */

    if (! (INPUT_IS_NOT_A_TIMER) )
    {

     command = CMD_TTIMER ;
     /*
     ** The following assignment is necessary, because the sender
     ** PID in a signal instance in the queue doesn't carry the
     ** correct value. This is no problem for the Cmicro Kernel,
     ** but looks suspicious when tracing ...
     */
     ASS_SEND (send, p_Message->rec, xNULLPID);
    }
    else
    {
     command = CMD_TINPUT ;
     ASS_SEND (send, p_Message->send, xNULLPID);
    }

    ASS_PRIO (prio, p_Message->prio, XMK_DUMMYPRIO);

    ASSIGN_FILE_Sender     (send);
    ASSIGN_FILE_Receiver   (xRunPID);
    ASSIGN_FILE_Signal     (p_Message->signal);
    ASSIGN_FILE_State      (xRunPID, State);
    ASSIGN_FILE_Prio       (prio);

    ASSIGN_STDOUT_Sender   (send);
    ASSIGN_STDOUT_Receiver (xRunPID);
    ASSIGN_STDOUT_Signal   (p_Message->signal);
    ASSIGN_STDOUT_State    (xRunPID, State);
    ASSIGN_STDOUT_Prio     (prio);

    ASSIGN_COM_Sender      (send);
    ASSIGN_COM_Receiver    (xRunPID);
    ASSIGN_COM_Signal      (p_Message->signal);
    ASSIGN_COM_State       (xRunPID, State);
    ASSIGN_COM_Prio        (prio);

    ASSIGN_TBF_Sender      (send);
    ASSIGN_TBF_Receiver    (xRunPID);
    ASSIGN_TBF_Signal      (p_Message->signal);
    ASSIGN_TBF_State       (xRunPID, State);
    ASSIGN_TBF_Prio        (prio);

    ASSIGN_MSC_Sender      (send);
    ASSIGN_MSC_Receiver    (xRunPID);
    ASSIGN_MSC_Signal      (p_Message->signal);
    ASSIGN_MSC_State       (xRunPID, State);
    ASSIGN_MSC_Prio        (prio);

    /*
    ** Write into File ...
    */
    FILE_WRITE ( command, info );

    /*
    ** Write to STDOUT ...
    */
    STDOUT_WRITE ( command, info );

    /*
    ** Trace into tracebuffer ..
    */
    TBF_WRITE ( command, tbf );

    /*
    ** Send via serial interface ...
    */
    ENCODE ( command, info, SZ(xmk_T_CMD_TINPUT) );

    /*
    ** Draw Message sequence charts diagram ...
    */
    MSCE_WRITE ( command, info );


    XMK_SUPPRESS(command);
  } /* END IF */

  /*
  ** Action for the Cmicro Recorder
  */
  PLAY_INPUT ( CMD_TINPUT );

} /* END OF FUNCTION */


#endif /* ... XMK_ADD_TINPUT */

#if defined( XMK_ADD_TPROCEDURE)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]TSDL_Procedure                                    |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called when a SDL Procedure  is executed in generated code.|
|                                                                              |
|  Parameter    :                                                              |
|                 char *ProcedureName - Pointer to the SDL Procedure Name      |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_TSDL_Procedure( char *ProcedureName )

/*-FDEF E*/

{
  xmk_T_CMD_TPROCEDURE info ;

  #ifdef XMK_ADD_PRINTF_TSDL
    XMK_FUNCTION("[Qualified]TSDL_Procedure");
  #endif

  /*
  ** Action for the Cmicro Recorder
  */
  RECORD ( CMD_TPROCEDURE );

  if( SYMBOLWANTED ( xRunPID, TSDL_PROCEDURE ) )
  {
    DCL_FILE_ITEM       ( CMD_TPROCEDURE, "  PROCEDURE:")
    DCL_STDOUT_ITEM     ( CMD_TPROCEDURE, "  PROCEDURE:")
    DCL_COM_ITEM        ( CMD_TPROCEDURE, "  PROCEDURE:")
    DCL_TBF_ITEM        ( CMD_TPROCEDURE, "  PROCEDURE:")
    DCL_MSC_ITEM        ( CMD_TPROCEDURE, "  PROCEDURE:")

    ITEM ( CMD_TPROCEDURE, "PROCEDURE:");

    ASSIGN_FILE_ITEM       ( CMD_TPROCEDURE, "  PROCEDURE:");
    ASSIGN_STDOUT_ITEM     ( CMD_TPROCEDURE, "  PROCEDURE:");
    ASSIGN_COM_ITEM        ( CMD_TPROCEDURE, "  PROCEDURE:");
    ASSIGN_TBF_ITEM        ( CMD_TPROCEDURE, "  PROCEDURE:");
    ASSIGN_MSC_ITEM        ( CMD_TPROCEDURE, "  PROCEDURE:");

    ASSIGN_FILE_Process         (xRunPID);
    ASSIGN_FILE_ProcedureName   (ProcedureName);

    ASSIGN_STDOUT_Process       (xRunPID);
    ASSIGN_STDOUT_ProcedureName (ProcedureName);

    ASSIGN_COM_Process          (xRunPID);
    ASSIGN_COM_ProcedureName    (ProcedureName);

    ASSIGN_TBF_Process          (xRunPID);
    ASSIGN_TBF_ProcedureName    (ProcedureName);

    ASSIGN_MSC_Process          (xRunPID);
    ASSIGN_MSC_ProcedureName    (ProcedureName);

    /*
    ** Write into File ...
    */
    FILE_WRITE ( CMD_TPROCEDURE, info );

    /*
    ** Write to STDOUT ...
    */
    STDOUT_WRITE ( CMD_TPROCEDURE, info );

    /*
    ** Trace into tracebuffer ..
    */
    TBF_WRITE ( CMD_TPROCEDURE, tbf );

    /*
    ** Send via serial interface ...
    */
    ENCODE_NAME ( CMD_TPROCEDURE, info, SZ(xmk_T_CMD_TPROCEDURE) );

    /*
    ** Draw Message sequence charts diagram ...
    */
    MSCE_WRITE ( CMD_TPROCEDURE, info );

  } /* END IF */

  /*
  ** Action for the Cmicro Recorder
  */
  PLAY ( CMD_TPROCEDURE );

} /* END OF FUNCTION */

#endif /* ... XMK_ADD_TPROCEDURE */

#if defined( XMK_ADD_TOUTPUT)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]TSDL_Output                                       |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function is called when a SDL Output is performed in the Cmicro Kernel.|
|                                                                              |
|  First, the function checks the parameters of the signal, if wanted.         |
|                                                                              |
|  Then is makes a difference between ordinary signals and timer signals, which|
|  are to be traced differently.                                               |
|                                                                              |
|  Parameter    :                                                              |
|                   xmk_T_SIGNAL       sig                                     |
|                   xmk_T_PRIO         prio                                    |
|                   xmk_T_TIME         timestamp                               |
|                   xmk_T_MESS_LENGTH  info_len                                |
|                   void              *p_info                                  |
|                   xPID               rec                                     |
|                                                                              |
|  Return       :                                                              |
|                 XMK_OKAY  - Parameters OK                                    |
|                 XMK_ERROR - Parameters NOT OK                                |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

xmk_OPT_INT xmk_TSDL_Output ( xmk_T_SIGNAL        sig,
                              xmk_T_PRIO          prio,
                              xmk_T_TIME          timestamp,
                              xmk_T_MESS_LENGTH   info_len,
                              void               *p_info,
                              xPID                rec )

/*-FDEF E*/

{
  /*
  **   Defines
  */

  xmk_T_CMD_TOUTPUT  info               ;
  xmk_T_BOOL         parameters_wanted  ;
  int                len                ;

  #ifdef XMK_ADD_PRINTF_TSDL
    XMK_FUNCTION("[Qualified]TSDL_Output");
  #endif

  /*
  ** Action for the Cmicro Recorder
  */
  RECORD_OUTPUT ( sig                         ,
                  XCOND_PRIO      (prio)      ,
                  XCOND_TIMESTAMP (timestamp) ,
                  XCOND_DATA_LEN  (info_len)  ,
                  XCOND_DATA      (p_info)    ,
                  XCOND_RECEIVER  (rec)       );

  /*
  ** No trace, if the signal is a "timer expired" signal,
  ** which is produced in one of the TIM modules ...
  */
  if (! (OUTPUT_IS_NOT_A_TIMER) )
     return ( XMK_OKAY );


  if( SYMBOLWANTED ( xRunPID, TSDL_OUTPUT ) )
  {
    DCL_FILE_ITEM       ( CMD_TOUTPUT, "  OUTPUT:")
    DCL_STDOUT_ITEM     ( CMD_TOUTPUT, "  OUTPUT:")
    DCL_COM_ITEM        ( CMD_TOUTPUT, "  OUTPUT:")
    DCL_TBF_ITEM        ( CMD_TOUTPUT, "  OUTPUT:")
    DCL_MSC_ITEM        ( CMD_TOUTPUT, "  OUTPUT:")

    #ifdef XMK_ADD_SIGNAL_FILTER
      /*
      ** Filter active for the current signal ?
      */
      if ( ! (SIGNALWANTED ( sig ) )) return (XMK_OKAY);
    #endif

    ITEM ( CMD_TOUTPUT, "OUTPUT:");

    ASSIGN_FILE_ITEM       ( CMD_TOUTPUT, "  OUTPUT:");
    ASSIGN_STDOUT_ITEM     ( CMD_TOUTPUT, "  OUTPUT:");
    ASSIGN_COM_ITEM        ( CMD_TOUTPUT, "  OUTPUT:");
    ASSIGN_TBF_ITEM        ( CMD_TOUTPUT, "  OUTPUT:");
    ASSIGN_MSC_ITEM        ( CMD_TOUTPUT, "  OUTPUT:");

    #ifdef XMK_USED_SIGNAL_WITH_PARAMS
      /*
      ** Determine, if parameters of the signal are to be traced ...
      */
      if (SYMBOLWANTED (xRunPID, TSDL_SIGNALPARAMS))
        parameters_wanted = XMK_TRUE;
      else
        parameters_wanted = XMK_FALSE;

      if (info_len == 0)
      {
        /*
        ** Signal with no parameters ...
        */
        p_info             = (char *) NULL;
        parameters_wanted  = XMK_FALSE;
      }
    #else
      p_info            = (char *) NULL ;
      parameters_wanted = XMK_FALSE;
    #endif


    ASSIGN_FILE_Sender             (xRunPID);
    ASSIGN_FILE_Receiver           (rec);
    ASSIGN_FILE_Signal             (sig);
    ASSIGN_FILE_Prio               (prio);
    ASSIGN_FILE_TimeStamp          (timestamp);
    ASSIGN_FILE_SignalParameters   (p_info, info_len);

    ASSIGN_STDOUT_Sender           (xRunPID);
    ASSIGN_STDOUT_Receiver         (rec);
    ASSIGN_STDOUT_Signal           (sig);
    ASSIGN_STDOUT_Prio             (prio);
    ASSIGN_STDOUT_TimeStamp        (timestamp);

    if (parameters_wanted)
    {
      ASSIGN_STDOUT_SignalParameters (p_info, info_len);
    }

    ASSIGN_COM_Sender              (xRunPID);
    ASSIGN_COM_Receiver            (rec);
    ASSIGN_COM_Signal              (sig);
    ASSIGN_COM_Prio                (prio);
    ASSIGN_COM_TimeStamp           (timestamp);
    ASSIGN_COM_SignalParameters    (p_info, info_len);

    ASSIGN_TBF_Sender              (xRunPID);
    ASSIGN_TBF_Receiver            (rec);
    ASSIGN_TBF_Signal              (sig);
    ASSIGN_TBF_Prio                (prio);
    ASSIGN_TBF_TimeStamp           (timestamp);
    ASSIGN_TBF_SignalParameters    (p_info, info_len);

    ASSIGN_MSC_Sender              (xRunPID);
    ASSIGN_MSC_Receiver            (rec);
    ASSIGN_MSC_Signal              (sig);
    ASSIGN_MSC_Prio                (prio);
    ASSIGN_MSC_TimeStamp           (timestamp);
    ASSIGN_MSC_SignalParameters    (p_info, info_len);

    /*
    ** Write into File ...
    */
    FILE_WRITE ( CMD_TOUTPUT, info );

    /*
    ** Write to STDOUT ...
    */
    STDOUT_WRITE ( CMD_TOUTPUT, info );

    /*
    ** Trace into tracebuffer ..
    */
    TBF_WRITE ( CMD_TOUTPUT, tbf );

    /*
    ** Send via serial interface ...
    */
    ENCODE_OUTPUT ( CMD_TOUTPUT, info, SZ(xmk_T_CMD_TOUTPUT) );

    /*
    ** Draw Message sequence charts diagram ...
    */
    MSCE_WRITE ( CMD_TOUTPUT, info );

  } /* END IF */


  /*
  ** Action for the Cmicro Recorder
  */
  PLAY_OUTPUT   ( sig                         ,
                  XCOND_PRIO      (prio)      ,
                  XCOND_TIMESTAMP (timestamp) ,
                  XCOND_DATA_LEN  (info_len)  ,
                  XCOND_DATA      (p_info)    ,
                  XCOND_RECEIVER  (rec)       );


  return ( XMK_OKAY ) ;

} /* END OF FUNCTION */


#endif /* ... XMK_ADD_TOUTPUT */

#if defined (XMK_ADD_TDECISION) || defined (XMK_ADD_TPROCEDURE) || defined (XMK_ADD_TTASK)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : AssignString                                                 |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|  This function assignes the value of a given sourcestring to a destination-  |
|  string. If the destination string is too small, and has the size N,         |
|  only N - 1 bytes are assigned. The Nth byte, which is written to the end    |
|  of the string is a C stringterminator \0, so that this function can be used |
|  to copy strings, by ensuring, that no fatal overwriting is done.            |
|                                                                              |
|  Parameter    : char * p_dest                                                |
|                 int    destsize                                              |
|                 const char * p_source                                        |
|                                                                              |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

static void  AssignString ( char * p_dest, int destsize, const char * p_source )

/*-FDEF E*/

{
  /*
  ** Declare
  */
  int    sourcesize;

  /*
  ** Get the string length of source
  */
  sourcesize = strlen (p_source);

  /*
  ** reserve 1 byte at the end
  */
  destsize -- ;

  /*
  ** compare sizes
  */
  if (destsize < sourcesize)
  {
    /* dest buffer too small */
    /* correct source size   */
    sourcesize = destsize ;
  }

  /*
  ** Do copy
  */
  memcpy (p_dest, p_source, sourcesize);
  p_dest [sourcesize] = '\0' ;

}
#endif /* (XMK_ADD_TDECISION) || (XMK_ADD_TPROCEDURE) || (XMK_ADD_TTASK) */

#if defined( XMK_ADD_SDLE_TRACE)

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]TSDL_SymbolID                                     |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|    This function is used for SDL editor trace generation. The value of       |
|    XBETWEENSYMBOLS macros is transferred to the host.                        |
|                                                                              |
|  Parameter    :  int SymbolID                                                |
|  Return       : -                                                            |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_TSDL_SymbolID( int SymbolID )

/*-FDEF E*/

{
  xmk_T_CMD_TBETWEEN_SYMBOLS  info   ;

  #ifdef XMK_ADD_PRINTF_TSDL
    XMK_FUNCTION("[Qualified]TSDL_SymbolID");
  #endif

  if((xmk_SDLE_TracerActive != XMK_FALSE) && SYMBOLWANTED(xRunPID, 0xffffffffL))
  {
    info.process = xRunPID;
    info.number = SymbolID;

    /*
    ** Send via serial interface ...
    */
    ENCODE ( CMD_TBETWEEN_SYMBOLS, info, SZ(xmk_T_CMD_TBETWEEN_SYMBOLS) );
  }

} /* END OF FUNCTION */

/*+FHDR E*/
/*
+------------------------------------------------------------------------------+
|  Functionname : [Qualified]TSDL_InputID                                      |
+------------------------------------------------------------------------------+
|                                                                              |
|  Description :                                                               |
|    This function is used for SDL editor trace generation. The value of       |
|    XATFIRSTSYMBOL macros is transferred to the host.                         |
|                                                                              |
|  Parameter    :  int SymbolID                                                |
|  Return       : -                                                            |
|                                                                              |
|                                                                              |
+------------------------------------------------------------------------------+
*/
/*-FHDR E*/

/*+FDEF E*/

void xmk_TSDL_InputID( int SymbolID )

/*-FDEF E*/

{
  xmk_T_CMD_TAT_FIRST_SYMBOL  info   ;

  #ifdef XMK_ADD_PRINTF_TSDL
    XMK_FUNCTION("[Qualified]TSDL_SymbolID");
  #endif

  if((xmk_SDLE_TracerActive != XMK_FALSE) && SYMBOLWANTED(xRunPID, 0xffffffffL))
  {
    info.process = xRunPID;
    info.number = SymbolID;

    /*
    ** Send via serial interface ...
    */
    ENCODE ( CMD_TAT_FIRST_SYMBOL, info, SZ(xmk_T_CMD_TAT_FIRST_SYMBOL) );
  }

} /* END OF FUNCTION */

#endif /* ... XMK_ADD_SDLE_TRACE */

#endif /* ... XMK_ADD_MICRO_TESTER */

#endif /* __MT_TSDL_C_ */
