/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#include "er/ber/ber_base.h"

#ifndef CODER_REMOVE_BER

/**************************************************/
/************** Buffers operations ****************/
/**************************************************/

/**************************************************
 * NAME: BERAppendMemory
 *       
 *
 */

void
BERAppendMemory(tCoder* Coder, tVMSULong Length)
{
  tVMSULong EDataLen = Coder->ER.MemEnd - (Coder->ER.DataCurr + 1);
  tVMSULong DataEnd = Coder->ER.DataEnd - Coder->ER.MemStart;
  tVMSULong MemEnd = Coder->ER.MemEnd - Coder->ER.MemStart;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERAppendMemory\n");
#endif

  Coder->ER.MemStart = BufAppendMemory(Coder, Length);
  Coder->ER.MemEnd = Coder->ER.MemStart + MemEnd + Length;
  Coder->ER.DataEnd = Coder->ER.MemStart + DataEnd;
  memmove(Coder->ER.MemEnd - EDataLen, Coder->ER.MemStart + (MemEnd - EDataLen), EDataLen);
  Coder->ER.DataCurr = Coder->ER.MemEnd - EDataLen - 1;
}

/**************************************************
 * NAME: BERAppendData
 *       
 *
 */

void 
BERAppendData(tCoder* Coder, tVMSULong Length)
{
  unsigned char* DataEnd = Coder->ER.DataEnd;
  tBufAppendBufFunc AppendFunc = BufGetAppendBufFunc(Coder);

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERAppendData\n");
#endif

  if (AppendFunc)
    {
      AppendFunc(Coder, Length);
      Coder->ER.DataEnd = BufGetDataEnd(Coder, &Coder->ER.BitEnd);
    }
  DECODING_ERROR_HANDLER_EXP(Coder->ER.DataEnd - DataEnd < (long)Length,
                             Coder, ec_DEC_NoMoreDataForRead, NO_ARGS);
}

/**************************************************
 * NAME: BERIsEOC
 *       
 *
 */

char BERIsEOC(tCoder* Coder)
{
  if (Coder->ER.DataEnd - Coder->ER.DataCurr < 2)
    BERAppendData(Coder, 2 - (Coder->ER.DataEnd - Coder->ER.DataCurr));
  return (*(Coder->ER.DataCurr) == 0) && (*(Coder->ER.DataCurr + 1) == 0);
}

/**************************************************/
/*************** Identifier Octet *****************/
/**************************************************/

/**************************************************
 * NAME: BEREncodeIdentifierOctet
 *       
 *
 */

void
BEREncodeIdentifierOctet(tCoder* Coder, unsigned char EncForm, tASN1Tag* Tag)
{
  unsigned char Len = 0;
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeIdentifierOctet\n");
#endif

  if (Tag->Number > 0x1E)
    {
      long FreeMem = Coder->ER.DataCurr + 1 - Coder->ER.DataEnd;

      Len = 1;
      if (Tag->Number & 0xFFFFFF80)
        {
          Len = 2;
          if (Tag->Number & 0xFFFFC000)
            {
              Len = 3;
              if (Tag->Number & 0xFFE00000)
                {
                  Len = 4;
                  if (Tag->Number & 0xF0000000)
                    {
                      Len = 5;
                      if (FreeMem < Len)
                        BERAppendMemory(Coder, Len - FreeMem + 1);
                      *(Coder->ER.DataCurr - 4) = (unsigned char)((Tag->Number >> 28) | 0x80);
                    }
                  else
                  if (FreeMem < Len)
                    BERAppendMemory(Coder, Len - FreeMem + 1);
                  *(Coder->ER.DataCurr - 3) = (unsigned char)((Tag->Number >> 21) | 0x80);
                }
              else
              if (FreeMem < Len)
                BERAppendMemory(Coder, Len - FreeMem + 1);
              *(Coder->ER.DataCurr - 2) = (unsigned char)((Tag->Number >> 14) | 0x80);
            }
          else
          if (FreeMem < Len)
            BERAppendMemory(Coder, Len - FreeMem + 1);
          *(Coder->ER.DataCurr - 1) = (unsigned char)((Tag->Number >> 7) | 0x80);
        }
      else
      if (FreeMem < Len)
        BERAppendMemory(Coder, Len - FreeMem + 1);
      *(Coder->ER.DataCurr) = (unsigned char)(Tag->Number & 0x7F);
      *(Coder->ER.DataCurr - Len) = (unsigned char)(Tag->Class | EncForm | 0x1F);
    }
  else
    {
      if (Coder->ER.DataCurr < Coder->ER.DataEnd)
        BERAppendMemory(Coder, Coder->ER.DataEnd - Coder->ER.DataCurr);
      *(Coder->ER.DataCurr) = (unsigned char)(Tag->Class | EncForm | Tag->Number);
    }
  Coder->ER.DataCurr -= Len + 1;
}

/**************************************************
 * NAME: BERPeekIdentifierOctet
 *       
 *
 */

void 
BERPeekIdentifierOctet(tCoder* Coder, unsigned char* EncForm, tBERTag* Tag)
{
  unsigned char* CurrByte = Coder->ER.DataCurr;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERPeekIdentifierOctet\n");
#endif

  if (CurrByte == Coder->ER.DataEnd)
    BERAppendData(Coder, 1);
  Tag->Number = (tASN1TagClassNumber)(*CurrByte & 0x1F);
  Tag->Class = (tASN1TagClass)(*CurrByte & 0xC0);
  *EncForm = (unsigned char)(*CurrByte & 0x20);
  if (Tag->Number == 0x1F)
    {
      CurrByte++;
      if (CurrByte == Coder->ER.DataEnd)
        BERAppendData(Coder, 1);
      Tag->Number = 0;
      while (((*CurrByte & 0x80) != 0) && (CurrByte - Coder->ER.DataCurr < 6))
        {
          Tag->Number |= (tASN1TagClassNumber)(*CurrByte & 0x7F);
          Tag->Number <<= 7;
          CurrByte++;
          if (CurrByte == Coder->ER.DataEnd)
            BERAppendData(Coder, 1);
        }
      Tag->Number |= *CurrByte;
      DECODING_ERROR_HANDLER_EXP(((CurrByte - Coder->ER.DataCurr >= 6) && ((*CurrByte & 0x80) != 0)),
                                 Coder, ec_DEC_TooBigTagNumber, NO_ARGS);
    }
}

/**************************************************
 * NAME: BERDecodeIdentifierOctet
 *       
 *
 */

void
BERDecodeIdentifierOctet(tCoder* Coder, unsigned char* EncForm, tBERTag* Tag)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeIdentifierOctet\n");
#endif

  if (Coder->ER.DataEnd == Coder->ER.DataCurr)
    BERAppendData(Coder, 1);
  Tag->Number = (tASN1TagClassNumber)(*(Coder->ER.DataCurr) & 0x1F);
  Tag->Class = (tASN1TagClass)(*(Coder->ER.DataCurr) & 0xC0);
  *EncForm = (unsigned char)(*(Coder->ER.DataCurr) & 0x20);
  if (Tag->Number == 0x1F)
    {
      unsigned char CurrByte = 1;

      Coder->ER.DataCurr++;
      if (Coder->ER.DataEnd == Coder->ER.DataCurr)
        BERAppendData(Coder, 1);
      Tag->Number = 0;
      while (((*(Coder->ER.DataCurr) & 0x80) != 0) && (CurrByte < 6))
        {
          Tag->Number |= (tASN1TagClassNumber)(*(Coder->ER.DataCurr) & 0x7F);
          Tag->Number <<= 7;
          Coder->ER.DataCurr++;
          if (Coder->ER.DataEnd == Coder->ER.DataCurr)
            BERAppendData(Coder, 1);
        }
      Tag->Number |= *(Coder->ER.DataCurr);
      DECODING_ERROR_HANDLER_EXP((CurrByte >= 6) && ((*Coder->ER.DataCurr & 0x80) != 0),
                                 Coder, ec_DEC_TooBigTagNumber, NO_ARGS);
    }
  Coder->ER.DataCurr++;
}

/**************************************************/
/******************** Length **********************/
/**************************************************/

/**************************************************
 * NAME: BEREncodeDefiniteLength
 *       
 *
 */

void
BEREncodeDefiniteLength(tCoder* Coder, tVMSULong Length)
{
  unsigned char Len = 0;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeDefiniteLength\n");
#endif

  if (Length & 0xFFFFFF80)
    {
      long FreeMem = Coder->ER.DataCurr + 1 - Coder->ER.DataEnd;

      Len = 1;
      if (Length & 0xFFFFFF00)
        {
          Len = 2;
          if (Length & 0xFFFF0000)
            {
              Len = 3;
              if (Length & 0xFF000000)
                {
                  Len = 4;
                  if (FreeMem < Len)
                    BERAppendMemory(Coder, Len - FreeMem + 1);
                  *(Coder->ER.DataCurr - 3) = (unsigned char)(Length >> 24);
                }
              else
              if (FreeMem < Len)
                BERAppendMemory(Coder, Len - FreeMem + 1);
              *(Coder->ER.DataCurr - 2) = (unsigned char)(Length >> 16);
            }
          else
          if (FreeMem < Len)
            BERAppendMemory(Coder, Len - FreeMem + 1);
          *(Coder->ER.DataCurr - 1) = (unsigned char)(Length >> 8);
        }
      else
      if (FreeMem < Len)
        BERAppendMemory(Coder, Len - FreeMem + 1);
      *(Coder->ER.DataCurr) = (unsigned char)Length;
      *(Coder->ER.DataCurr - Len) = (unsigned char)(0x80 | Len);
    }
  else
    {
      if (Coder->ER.DataCurr < Coder->ER.DataEnd)
        BERAppendMemory(Coder, Coder->ER.DataEnd - Coder->ER.DataCurr + 1);
      *(Coder->ER.DataCurr) = (unsigned char)Length;          
    }
  Coder->ER.DataCurr -= Len + 1;
}

/**************************************************
 * NAME: BERDecodeDefiniteLength
 *       
 *
 */

tVMSULong
BERDecodeDefiniteLength(tCoder* Coder, tVMSULong* Length)
{
  tVMSULong DecLength = 1;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeDefiniteLength\n");
#endif

  if (Coder->ER.DataEnd == Coder->ER.DataCurr)
    BERAppendData(Coder, 1);

  *Length = *(Coder->ER.DataCurr);
  if (*Length > 0x80)
    {
      DecLength += *Length - 0x80;
      if (Coder->ER.DataEnd - Coder->ER.DataCurr < (long)DecLength)
        BERAppendData(Coder, DecLength - (Coder->ER.DataEnd - Coder->ER.DataCurr));

      if (DecLength == 2)
        *Length = *(Coder->ER.DataCurr + 1);
      else
      if (DecLength == 3)
        *Length = ((*(Coder->ER.DataCurr + 1) << 8) | *(Coder->ER.DataCurr + 2));
      else
      if (DecLength == 4)
        *Length = ((*(Coder->ER.DataCurr + 1) << 16) | (*(Coder->ER.DataCurr + 2) << 8) | *(Coder->ER.DataCurr + 3));
      else
      if (DecLength == 5)
        *Length = ((*(Coder->ER.DataCurr + 1) << 24) | (*(Coder->ER.DataCurr + 2) << 16) | (*(Coder->ER.DataCurr + 3) << 8) | *(Coder->ER.DataCurr + 4));
      else
        {
          DECODING_ERROR_HANDLER(Coder, ec_DEC_WrongLength, NO_ARGS);
        }
    }

  Coder->ER.DataCurr += DecLength;
  return DecLength;
}
#endif /* !CODER_REMOVE_BER */
