/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef __ber_base_h
#define __ber_base_h

#include "cucf.h"

#ifndef CODER_REMOVE_BER

/**************************************************************/
/******************* Buffers operations ***********************/
/**************************************************************/

void BERAppendMemory(tCoder* Coder, tVMSULong Length);
void BERAppendData(tCoder* Coder, tVMSULong Length);

/************************************/
/************** Bytes ***************/
/************************************/

#define BERPutByte(Coder, iByte) \
{ \
  if (Coder->ER.DataCurr < Coder->ER.DataEnd) \
    BERAppendMemory(Coder, Coder->ER.DataEnd - Coder->ER.DataCurr); \
  *(Coder->ER.DataCurr) = iByte; \
  Coder->ER.DataCurr--; \
}

/************************************/

#define BERGetByte(Coder, oByte) \
{ \
  if (Coder->ER.DataEnd == Coder->ER.DataCurr) \
    BERAppendData(Coder, 1); \
  oByte = *(Coder->ER.DataCurr); \
  Coder->ER.DataCurr++; \
}

/************************************/
/************** Segment *************/
/************************************/

#define BERSkipSeg(Coder, Len) \
{ \
  if (Len > 0) \
    { \
      if ((long)(Coder->ER.DataEnd - Coder->ER.DataCurr) < (long)Len) \
        BERAppendData(Coder, Len - (Coder->ER.DataEnd - Coder->ER.DataCurr)); \
      Coder->ER.DataCurr += Len; \
    } \
}

/**************************************************************/
/********************* Encoding Form **************************/
/**************************************************************/

enum
{
  bef_Primitive,
  bef_Constructed = (1 << 5)
};


enum
{
  tk_Explicit = 0,
  tk_Implicit = 0x80
}; 

typedef unsigned char tASN1TagKind;

/**************************************************************/
/******************** Identifier Octet ************************/
/**************************************************************/

typedef struct
{
  tASN1TagClass         Class;
  tASN1TagClassNumber   Number;
} tBERTag;


void BEREncodeIdentifierOctet(tCoder* Coder, unsigned char EncForm, tASN1Tag* Tag);
void BERPeekIdentifierOctet(tCoder* Coder, unsigned char* EncForm, tBERTag* Tag);
void BERDecodeIdentifierOctet(tCoder* Coder, unsigned char* EncForm, tBERTag* Tag);

/**************************************************************/
/********************* Definite Length ************************/
/**************************************************************/

void      BEREncodeDefiniteLength(tCoder* Coder, tVMSULong Length);
tVMSULong BERDecodeDefiniteLength(tCoder* Coder, tVMSULong* Length);

/**************************************************************/
/******************** Indefinite Length ***********************/
/**************************************************************/

#define BEREncodeEOC(Coder) \
{ \
  if (Coder->ER.DataCurr - Coder->ER.DataEnd < 1) \
    BERAppendMemory(Coder, 1 - (Coder->ER.DataCurr - Coder->ER.DataEnd)); \
  *(Coder->ER.DataCurr) = 0; \
  *(Coder->ER.DataCurr - 1) = 0; \
  Coder->ER.DataCurr -= 2; \
}

char BERIsEOC(tCoder* Coder);

#define BERDecodeEOC(Coder) \
  if (Coder->ER.DataEnd - Coder->ER.DataCurr < 2) BERAppendData(Coder, 2 - (Coder->ER.DataEnd - Coder->ER.DataCurr)); \
  Coder->ER.DataCurr += 2

/**************************************************************/
/************************ String Value ************************/
/**************************************************************/

typedef void (*tBEREncodePrimStringFunc)(tCoder* Coder, tVMSULong Length, tVMSString_Value Val);
typedef void (*tBERDecodePrimStringFunc)(tCoder* Coder, tVMSULong Length, tVMSString* Val);

typedef const struct
{
  tBEREncodePrimStringFunc EncPrim;
  tBERDecodePrimStringFunc DecPrim;
  tCUCFTypeClass           TypeClass;
} tBERStringInfo;

/**************************************************************/
/**************************************************************/
/**************************************************************/

#ifndef CODER_NOUSE_OPEN

#define BERPutOpenId(Coder, Type, Val, List) CUCFPutOpenId(Coder, Type, Val, List)
#define BERPutOpenBody(Coder, Type, Val, List, OTInfo) CUCFPutOpenBody(Coder, Type, Val, List, OTInfo)

/**************************************************************/

#define BERGetOpenTypeObject(Coder, Type, Val, Index) CUCFGetOpenTypeObject(Coder, Type, Val, Index)

#endif /* CODER_NOUSE_OPEN */

/**************************************************************/
/**************************************************************/
/**************************************************************/
#endif /* !CODER_REMOVE_BER */

#endif /* __ber_base_h */
