/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#include "cucf.h"
#include "er/ber/ber_content.h"

#ifndef CODER_REMOVE_BER

/*************************************************/
/******************* DECODE **********************/
/*************************************************/

/**************************************************
 * NAME: BERDecode
 *       
 *
 */

int
BERDecode(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  int retCode;
  void* DecVal;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecode\n");
#endif

  if ((retCode = BufGetErrorCode(Coder)) != ec_SUCCESS)
    return retCode;

  CUCFSetErrorCatcher(Coder, retCode);
  if (retCode == 0)
    {
      tVMSULong Length;
      unsigned char* DataCurr;

      EPInit(Coder, Type);
      VMSInit(Coder, Type, Val);
      Coder->ER.MemStart = BufGetMemory(Coder, &Length);
      Coder->ER.MemEnd   = Coder->ER.MemStart + Length;
      Coder->ER.DataEnd  = BufGetDataEnd(Coder, &Coder->ER.BitEnd);
      Coder->ER.DataCurr = BufGetDataCurr(Coder, &Coder->ER.BitCurr);
      DataCurr           = Coder->ER.DataCurr;
      INTERNAL_ERROR_HANDLER_EXP(Coder->ER.BitCurr != 7,
                                 Coder, ec_INT_InternalError,
                                 ERR_ARG(__FILE__) ERR_ARG(__LINE__));
      if (!(Coder->ER.Rule & er_BER))
        Coder->ER.Rule = (er_BER | CUCF_BER_LENGTH);
      VMSGetValue(Coder, Val, Type, DecVal);

      BERDecVal(Coder, Type, DecVal, tk_Explicit ER_OLIST(NULL));
      BufSetDataCurr(Coder, Coder->ER.DataCurr - DataCurr, 7);
      Coder->ER.ValueBitLength = (Coder->ER.DataCurr - DataCurr) << 3;
	  
	  VMSSetValue(Coder, Val, Type, DecVal);
    }

  Coder->EMS.IsAssigned = 0;
  return Coder->EMS.ErrorCode;
}

#endif /* !CODER_REMOVE_BER */
