/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#include "er/per/per_base.h"

#ifndef CODER_REMOVE_PER

/**************************************************/
/**************************************************/
/**************************************************/

/**************************************************
 * NAME: PERAppendMemory
 *       
 *
 */

void
PERAppendMemory(tCoder* Coder, tVMSULong Len)
{
  tVMSULong DataEnd = Coder->ER.DataEnd - Coder->ER.MemStart;
  tVMSULong DataCurr = Coder->ER.DataCurr - Coder->ER.MemStart;
  tVMSULong MemEnd = Coder->ER.MemEnd - Coder->ER.MemStart;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERAppendMemory\n");
#endif

  Coder->ER.MemStart = BufAppendMemory(Coder, Len);
  Coder->ER.MemEnd = Coder->ER.MemStart + MemEnd + Len;
  Coder->ER.DataEnd = Coder->ER.MemStart + DataEnd;
  Coder->ER.DataCurr = Coder->ER.MemStart + DataCurr;
}

/**************************************************
 * NAME: PERAppendData
 *       
 *
 */

void 
PERAppendData(tCoder* Coder, tVMSULong Length)
{
  unsigned char* DataEnd = Coder->ER.DataEnd;
  tBufAppendBufFunc AppendFunc = BufGetAppendBufFunc(Coder);

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERAppendData\n");
#endif

  if (AppendFunc)
    {
      AppendFunc(Coder, Length);
      Coder->ER.DataEnd = BufGetDataEnd(Coder, &Coder->ER.BitEnd);
    }
  DECODING_ERROR_HANDLER_EXP(Coder->ER.DataEnd - DataEnd < (long)Length,
                             Coder, ec_DEC_NoMoreDataForRead, NO_ARGS);
}

/**************************************************
 * NAME: PERPutBit
 *       
 *
 */

void
PERPutBit(tCoder* Coder, unsigned char Bit)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERPutBit\n");
#endif

  if (Coder->ER.DataCurr == Coder->ER.MemEnd)
    PERAppendMemory(Coder, 1);
  if (Coder->ER.BitCurr == 7)
    {
      *(Coder->ER.DataCurr) = (unsigned char)(Bit << Coder->ER.BitCurr);
      Coder->ER.BitCurr--;
    }
  else
    {
      *(Coder->ER.DataCurr) |= (unsigned char)(Bit << Coder->ER.BitCurr);
      if (Coder->ER.BitCurr == 0)
        {
          Coder->ER.DataCurr++;
          Coder->ER.BitCurr = 7;
        }
      else
        Coder->ER.BitCurr--;
    }
}

/**************************************************
 * NAME: PERGetBit
 *       
 *
 */

unsigned char
PERGetBit(tCoder* Coder)
{
  unsigned char Bit;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERGetBit\n");
#endif
  
  if (Coder->ER.DataCurr == Coder->ER.DataEnd)
    PERAppendData(Coder, 1);
  Bit = (unsigned char)((*(Coder->ER.DataCurr) >> Coder->ER.BitCurr) & 0x1);
  if (Coder->ER.BitCurr == 0)
    {
      Coder->ER.DataCurr++;
      Coder->ER.BitCurr = 7;
    }
  else
    Coder->ER.BitCurr--;
  return Bit;
}

/**************************************************
 * NAME: PERPutBits
 *       
 *
 */

void
PERPutBits(tCoder* Coder, unsigned long Bits, unsigned char Num)
{
  unsigned char NOB = (unsigned char)(Num + (7 - Coder->ER.BitCurr));
  unsigned char RB = (unsigned char)(NOB & 0x7);
  unsigned char *CurrByte;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERPutBits\n");
#endif

  if (Num == 0) return;
  INTERNAL_ERROR_HANDLER_EXP(Num > 32,
                             Coder, ec_INT_InternalError,
                             ERR_ARG(__FILE__) ERR_ARG(__LINE__));
  NOB >>= 3;
  if (Coder->ER.DataCurr + NOB + (RB > 0 ? 1 : 0) > Coder->ER.MemEnd)
    PERAppendMemory(Coder, NOB + (RB > 0 ? 1 : 0) - (Coder->ER.MemEnd - Coder->ER.DataCurr));
  if (Coder->ER.BitCurr == 7)
    *(Coder->ER.DataCurr) = 0;
  Coder->ER.BitCurr = (unsigned char)(7 - RB);
  if (NOB > 0)
    {
      Coder->ER.DataCurr += NOB;
      if (RB)
        {
          *(Coder->ER.DataCurr) = (unsigned char)(Bits << (Coder->ER.BitCurr + 1));
          Bits >>= RB;
        }
      for (CurrByte = Coder->ER.DataCurr - 1; NOB > 1; NOB--, CurrByte--, Bits >>= 8)
        *CurrByte = (unsigned char)Bits;
      *CurrByte |= (unsigned char)Bits;
    }
  else
    *(Coder->ER.DataCurr) |= (unsigned char)(Bits << (Coder->ER.BitCurr + 1));
}

/**************************************************
 * NAME: PERGetBits
 *       
 *
 */

unsigned long
PERGetBits(tCoder* Coder, unsigned char Num)
{
  unsigned long Bits = 0;
  unsigned long Length;

#ifdef CODER_DEBUG_BMS
  fprintf(stdout, "PERGetBits\n");
#endif

  if (Num == 0) return 0;
  INTERNAL_ERROR_HANDLER_EXP(Num > 32,
                             Coder, ec_INT_InternalError,
                             ERR_ARG(__FILE__) ERR_ARG(__LINE__));
  Length = ((Coder->ER.DataEnd - Coder->ER.DataCurr) << 3) + (Coder->ER.BitCurr - Coder->ER.BitEnd);
  if (Length < Num)
    PERAppendData(Coder, ((Num - Length) >> 3) + (((Num - Length) & 0x7) ? 1 : 0));
  if (Coder->ER.BitCurr != 7)
    {
      Bits = (unsigned char)(*(Coder->ER.DataCurr) << (7 - Coder->ER.BitCurr));
      if (Num <= Coder->ER.BitCurr + 1)
        {
          Bits >>= (8 - Num);
          if (Coder->ER.BitCurr + 1 == Num)
            {
              Coder->ER.BitCurr = 7;
              Coder->ER.DataCurr++;
            }
          else
            Coder->ER.BitCurr = (unsigned char)(Coder->ER.BitCurr - Num);
          return Bits;
        }
      Bits >>= (7 - Coder->ER.BitCurr);
      Num = (unsigned char)(Num - Coder->ER.BitCurr - 1);
      Coder->ER.DataCurr++;
    }
  for (; Num > 7; Num = (unsigned char)(Num - 8), Coder->ER.DataCurr++)
    {
      Bits <<= 8;
      Bits |= *(Coder->ER.DataCurr);
    }
  if (Num > 0)
    {
      Bits <<= Num;
      Coder->ER.BitCurr = (unsigned char)(7 - Num);
      Bits |= (*(Coder->ER.DataCurr) >> (8 - Num));
    }
  else
    Coder->ER.BitCurr = 7;
  return Bits;
}

/**************************************************
 * NAME: PERPutByte
 *       
 *
 */

void
PERPutByte(tCoder* Coder, unsigned char Byte)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERPutByte\n");
#endif

  if (Coder->ER.BitCurr != 7)
    {
      if (Coder->ER.DataCurr + 1 == Coder->ER.MemEnd)
        PERAppendMemory(Coder, 1);
      *(Coder->ER.DataCurr) |= (unsigned char)(Byte >> (7 - Coder->ER.BitCurr));
      Coder->ER.DataCurr++;
      *(Coder->ER.DataCurr) = (unsigned char)(Byte << (Coder->ER.BitCurr + 1));
    }
  else
    {
      if (Coder->ER.DataCurr == Coder->ER.MemEnd)
        PERAppendMemory(Coder, 1);
      *(Coder->ER.DataCurr) = Byte;
      Coder->ER.DataCurr++;
    }
}


/**************************************************
 * NAME: PERGetByte
 *       
 *
 */

unsigned char
PERGetByte(tCoder* Coder)
{
  unsigned char Byte;
  
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERGetByte\n");
#endif
  
  if (Coder->ER.BitCurr != 7)
    {
      if (Coder->ER.DataEnd - Coder->ER.DataCurr < 2)
        PERAppendData(Coder, 2 - (Coder->ER.DataEnd - Coder->ER.DataCurr));
      Byte = (unsigned char)((*(Coder->ER.DataCurr) << (7 - Coder->ER.BitCurr)));
      Coder->ER.DataCurr++;
      Byte |= (unsigned char)(*(Coder->ER.DataCurr) >> (Coder->ER.BitCurr + 1));
    }
  else
    {
      if (Coder->ER.DataCurr == Coder->ER.DataEnd)
        PERAppendData(Coder, 1);
      Byte = *(Coder->ER.DataCurr);
      Coder->ER.DataCurr++;
    }
  return Byte;
}

/**************************************************
 *
 * NAME: PERSkipBytes
 *
 *
 */

void
PERSkipBytes(tCoder* Coder, tVMSULong NumOfBytes)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERSkipBytes\n");
#endif


  if (Coder->ER.BitCurr != 7)
    {
      if (Coder->ER.DataCurr + NumOfBytes >= Coder->ER.MemEnd)
        PERAppendMemory(Coder, NumOfBytes + 1 - (Coder->ER.MemEnd - Coder->ER.DataCurr));

      *(Coder->ER.DataCurr) &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
      memset(Coder->ER.DataCurr + 1, 0, NumOfBytes);
    }
  else
    {
      if (Coder->ER.DataCurr + NumOfBytes > Coder->ER.MemEnd)
        PERAppendMemory(Coder, NumOfBytes - (Coder->ER.MemEnd - Coder->ER.DataCurr));

      memset(Coder->ER.DataCurr, 0, NumOfBytes);
    }

  Coder->ER.DataCurr += NumOfBytes;
}

/**************************************************
 *
 * NAME: PERPutSeg
 *
 *
 */

void
PERPutSeg(tCoder* Coder, unsigned char* Seg, unsigned long Len)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERPutSeg\n");
#endif

  if (Len == 0) return;
  if (Coder->ER.BitCurr != 7)
    {
      tVMSULong i;
      unsigned char* Byte;

      if (Coder->ER.DataCurr + Len + 1 > Coder->ER.MemEnd)
        PERAppendMemory(Coder, Len + 1 - (Coder->ER.MemEnd - Coder->ER.DataCurr));
      for (i = 0, Byte = Seg; i < Len; i++, Byte++)
        {
          *(Coder->ER.DataCurr) |= (unsigned char)(*Byte >> (7 - Coder->ER.BitCurr));
          Coder->ER.DataCurr++;
          *(Coder->ER.DataCurr) = (unsigned char)(*Byte << (Coder->ER.BitCurr + 1));
        }      
    }
  else
    {
      if (Coder->ER.DataCurr + Len > Coder->ER.MemEnd)
        PERAppendMemory(Coder, Len - (Coder->ER.MemEnd - Coder->ER.DataCurr));
      memcpy(Coder->ER.DataCurr, Seg, Len);
      Coder->ER.DataCurr += Len;
    }
}

/**************************************************/
/**************************************************/
/**************************************************/

/**************************************************
 * NAME: PEROctetsFragmentation
 *       
 *
 */

void 
PEROctetsFragmentation(tCoder* Coder, tVMSULong Length)
{
  unsigned char* From;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEROctetsFragmentation\n");
#endif

  if (Length < 0x4000)
    {
      PERSkipBytes(Coder, 1);
      From = Coder->ER.DataCurr - (Length + 1);
      memmove(From + 1, From, Length);
      Length |= 0x8000;
      *From = (unsigned char)Length;
      *(From - 1) = (unsigned char)(Length >> 8);
    }
  else
    {
      unsigned short Bytes = 0, MvLength = 0, N64K = 0; 

      while (Length >= 0x10000)
        {
          Length -= 0x10000;
          N64K++;
          Bytes++;
        }
      if (Length >= 0xC000)
        {
          MvLength = 0xC000;
          Bytes++;
        }
      else
      if (Length >= 0x8000)
        {
          MvLength = 0x8000;
          Bytes++;
        }
      else
      if (Length >= 0x4000)
        {
          MvLength = 0x4000;
          Bytes++;
        }
      Length -= MvLength;
      
      if (Length > 0x7F)
        {            
          PERSkipBytes(Coder, Bytes + 1);
          From = Coder->ER.DataCurr - (Length + Bytes + 1);
          memmove(From + Bytes + 1, From, Length);
          Length |= 0x8000;
          *(From + Bytes) = (unsigned char)Length;
          *(From + Bytes - 1) = (unsigned char)(Length >> 8);
        }
      else
        {
          PERSkipBytes(Coder, Bytes);
          From = Coder->ER.DataCurr - (Length + Bytes);
          memmove(From + Bytes, From, Length);
          *(From + Bytes - 1) = (unsigned char)Length;
        }

      if (MvLength != 0)
        {
          Bytes--;
          From -= MvLength;
          if (Bytes != 0)
            memmove(From + Bytes, From, MvLength);
          *(From + Bytes - 1) = (unsigned char)(0xC0 | (unsigned char)(MvLength >> 14));
        }

      if (N64K != 0)
        {
          while (N64K > 1)
            {
              Bytes--;
              From -= 0x10000;
              memmove(From + Bytes, From, 0x10000);
              *(From + Bytes - 1) = 0xC4;
              N64K--;
            }
          From -= 0x10001;
          *From = 0xC4;
        }
    }
}

/**************************************************
 * NAME: PEROctetsDefragmentation
 *       
 *
 */

tVMSULong
PEROctetsDefragmentation(tCoder* Coder)
{
  unsigned char* CurrByte = Coder->ER.DataCurr, *To, Byte;
  tVMSULong Length = 0;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEROctetsDefragmentation\n");
#endif
   
  Byte = PERGetByte(Coder);
  switch (Byte)
    {
    case 0xC4:
      Length += 0x10000;
      Coder->ER.DataCurr += 0x10000;
      break;
    case 0xC3:
      Length += 0xC000;
      Coder->ER.DataCurr += 0xC000;
      break;
    case 0xC2:
      Length += 0x8000;
      Coder->ER.DataCurr += 0x8000;
      break;
    case 0xC1:
      Length += 0x4000;
      Coder->ER.DataCurr += 0x4000;
      break;
    default:
      DECODING_ERROR_HANDLER(Coder, ec_DEC_WrongConstructedLengthPrefix, NO_ARGS);
    }
  if (Coder->ER.DataCurr >= Coder->ER.DataEnd)
    PERAppendData(Coder, Coder->ER.DataCurr - Coder->ER.DataEnd);
  To = Coder->ER.DataCurr;
  Byte = PERGetByte(Coder);
  while (Byte == 0xC4)
    {
      Length += 0x10000;
      if (Coder->ER.DataEnd - Coder->ER.DataCurr < 0x10000)
        PERAppendData(Coder, 0x10000 - (Coder->ER.DataEnd - Coder->ER.DataCurr));
      memmove(To, Coder->ER.DataCurr, 0x10000);
      To += 0x10000;
      Coder->ER.DataCurr += 0x10000;
      Byte = PERGetByte(Coder);
    }

  if (Byte >= 0xC1)
    {
      unsigned short MvLength = (unsigned short)(Byte << 14);
      Length += MvLength;
      if (Coder->ER.DataEnd - Coder->ER.DataCurr < MvLength)
        PERAppendData(Coder, MvLength - (Coder->ER.DataEnd - Coder->ER.DataCurr));
      memmove(To, Coder->ER.DataCurr, MvLength);
      To += MvLength;
      Coder->ER.DataCurr += MvLength;
      Byte = PERGetByte(Coder);
    }
 
  if ((Byte & 0xC0) == 0x80)
    {
      tVMSULong TmpLength = (((Byte & 0x7F) << 8) | PERGetByte(Coder));

      Length += TmpLength;
      if (Coder->ER.DataEnd - Coder->ER.DataCurr < (long)TmpLength)
        PERAppendData(Coder, TmpLength - (Coder->ER.DataEnd - Coder->ER.DataCurr));
      memmove(To, Coder->ER.DataCurr, TmpLength);
    }
  else
  if((Byte & 0x80) == 0x00)
    {
      Length += (Byte & 0x7F);

      if (Coder->ER.DataEnd - Coder->ER.DataCurr < (Byte & 0x7F))
        PERAppendData(Coder, (Byte & 0x7F) - (Coder->ER.DataEnd - Coder->ER.DataCurr));
      memmove(To, Coder->ER.DataCurr, (Byte & 0x7F));
    }
  else
    {
      DECODING_ERROR_HANDLER(Coder, ec_DEC_WrongConstructedLengthPrefix, NO_ARGS);
    }
  Coder->ER.DataCurr = CurrByte + 1;
  return Length;
}

/**************************************************
 * NAME: PEROctetsFragmentationWithOffset
 *       
 *
 */

void 
PEROctetsFragmentationWithOffset(tCoder* Coder, tVMSULong Length)
{
  unsigned char* From;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEROctetsFragmentationWithOffset\n");
#endif

  if (Length < 0x4000)
    {
      PERSkipBytes(Coder, 1);
      From = Coder->ER.DataCurr - (Length + 1);
      memmove(From + 1, From, Length + 1);
      Length |= 0x8000;     
      *(From - 1) &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
      *(From - 1) |= (unsigned char)(Length >> (15 - Coder->ER.BitCurr));
      *From = (unsigned char)(Length >> (7 - Coder->ER.BitCurr));
      *(From + 1) &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
      *(From + 1) |= (unsigned char)(Length << (Coder->ER.BitCurr + 1));
    }
  else
    {
      tVMSULong LengthCpy = Length;
      unsigned short Bytes = 0, MvLength = 0, N64K = 0;
      
      while (Length >= 0x10000)
        {
          Length -= 0x10000;
          N64K++;
          Bytes++;
        }
      if (Length >= 0xC000)
        {
          MvLength = 0xC000;
          Bytes++;
        }
      else
      if (Length >= 0x8000)
        {
          MvLength = 0x8000;
          Bytes++;
        }
      else
      if (Length >= 0x4000)
        {
          MvLength = 0x4000;
          Bytes++;
        }
      Length -= MvLength;

      if (Length > 0x7F)
        {
          PERSkipBytes(Coder, Bytes + 1);
                    
          From = Coder->ER.DataCurr - (Length + Bytes + 1);
          memmove(From + Bytes + 1, From, Length + 1);
        }
      else
        {
          PERSkipBytes(Coder, Bytes);

          From = Coder->ER.DataCurr - (Length + Bytes);
          memmove(From + Bytes, From, Length + 1);
        }

      if (MvLength != 0)
        {
          Bytes--;
          From -= MvLength;
          if (Bytes != 0)
            memmove(From + Bytes, From, MvLength + 1);
          else
            From--;
        }

      if (N64K != 0)
        {
          while (N64K > 1)
            {
              Bytes--;
              From -= 0x10000;
              memmove(From + Bytes, From, 0x10001);
              N64K--;
            }
          From -= 0x10001;
        }

      while (LengthCpy >= 0x10000)
        {
          *From &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
          *From |= (unsigned char)(0xC4 >> (7 - Coder->ER.BitCurr));
          *(From + 1) &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
          *(From + 1) |= (unsigned char)(0xC4 << (Coder->ER.BitCurr + 1));      
          LengthCpy -= 0x10000;
          From += 0x10001;
        }
      
      if (LengthCpy >= 0xC000)
        {
          *From &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
          *From |= (unsigned char)(0xC3 >> (7 - Coder->ER.BitCurr));
          *(From + 1) &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
          *(From + 1) |= (unsigned char)(0xC3 << (Coder->ER.BitCurr + 1));      
          LengthCpy -= 0xC000;
          From += 0xC001;
        }
      else
      if (LengthCpy >= 0x8000)
        {
          *From &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
          *From |= (unsigned char)(0xC2 >> (7 - Coder->ER.BitCurr));
          *(From + 1) &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
          *(From + 1) |= (unsigned char)(0xC2 << (Coder->ER.BitCurr + 1));      
          LengthCpy -= 0x8000;
          From += 0x8001;
        }
      else
      if (LengthCpy >= 0x4000)
        {
          *From &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
          *From |= (unsigned char)(0xC1 >> (7 - Coder->ER.BitCurr));
          *(From + 1) &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
          *(From + 1) |= (unsigned char)(0xC1 << (Coder->ER.BitCurr + 1));      
          LengthCpy -= 0x4000;
          From += 0x4001;
        }

      if (LengthCpy > 0x7F)
        {
          LengthCpy |= 0x8000;
          *From &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
          *From |= (unsigned char)(LengthCpy >> (15 - Coder->ER.BitCurr));
          *(From + 1) = (unsigned char)(LengthCpy >> (7 - Coder->ER.BitCurr));
          *(From + 2) &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
          *(From + 2) |= (unsigned char)(LengthCpy << (Coder->ER.BitCurr + 1));
        }
      else
        {
          *From &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
          *From |= (unsigned char)(LengthCpy >> (7 - Coder->ER.BitCurr));
          *(From + 1) &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
          *(From + 1) |= (unsigned char)(LengthCpy << (Coder->ER.BitCurr + 1));
        }
    }
}

/**************************************************
 * NAME: PEROctetsDefragmentationWithOffset
 *       
 *
 */

tVMSULong
PEROctetsDefragmentationWithOffset(tCoder* Coder)
{
  unsigned char* CurrByte = Coder->ER.DataCurr, *To, Byte;
  tVMSULong Length = 0;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEROctetsDefragmentationWithOffset\n");
#endif
  
  Byte = PERGetByte(Coder);
  switch (Byte)
    {
    case 0xC4:
      Length += 0x10000;
      Coder->ER.DataCurr += 0x10000;
      break;
    case 0xC3:
      Length += 0xC000;
      Coder->ER.DataCurr += 0xC000;
      break;
    case 0xC2:
      Length += 0x8000;
      Coder->ER.DataCurr += 0x8000;
      break;
    case 0xC1:
      Length += 0x4000;
      Coder->ER.DataCurr += 0x4000;
      break;
    default:
      DECODING_ERROR_HANDLER(Coder, ec_DEC_WrongConstructedLengthPrefix, NO_ARGS);
    }
  if (Coder->ER.DataCurr >= Coder->ER.DataEnd)
    PERAppendData(Coder, Coder->ER.DataCurr -  Coder->ER.DataEnd);
  To = Coder->ER.DataCurr;

  Byte = PERGetByte(Coder);
  while (Byte == 0xC4)
    {
      Length += 0x10000;
      if (Coder->ER.DataEnd - Coder->ER.DataCurr < 0x10001)
        PERAppendData(Coder, 0x10001 - (Coder->ER.DataEnd - Coder->ER.DataCurr));
      *To &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
      *(Coder->ER.DataCurr) &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
      *To |= *(Coder->ER.DataCurr);
      memmove(To + 1, Coder->ER.DataCurr + 1, 0x10000);
      To += 0x10000;
      Coder->ER.DataCurr += 0x10000;
      Byte = PERGetByte(Coder);
    }

  if (Byte >= 0xC1)
    {
      unsigned short MvLength = (unsigned short)(Byte << 14);
      Length += MvLength;
      if (Coder->ER.DataEnd - Coder->ER.DataCurr < MvLength + 1)
        PERAppendData(Coder, MvLength + 1 - (Coder->ER.DataEnd - Coder->ER.DataCurr));
      *To &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
      *(Coder->ER.DataCurr) &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
      *To |= *(Coder->ER.DataCurr);
      memmove(To + 1, Coder->ER.DataCurr + 1, MvLength);
      To += MvLength;
      Coder->ER.DataCurr += MvLength;
      Byte = PERGetByte(Coder);
    }

  if ((Byte & 0xC0) == 0x80)
    {
      tVMSULong TmpLength = (((Byte & 0x7F) << 8) | PERGetByte(Coder));
      Length += TmpLength;
      if (Coder->ER.DataEnd - Coder->ER.DataCurr < (long)TmpLength)
        PERAppendData(Coder, TmpLength - (Coder->ER.DataEnd - Coder->ER.DataCurr));
      *To &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
      *(Coder->ER.DataCurr) &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
      *To |= *(Coder->ER.DataCurr);
      memmove(To + 1, Coder->ER.DataCurr + 1, TmpLength);
    }
  else
  if((Byte & 0x80) == 0x00)
    {
      Length += (Byte & 0x7F);
      if (Coder->ER.DataEnd - Coder->ER.DataCurr < (Byte & 0x7F))
        PERAppendData(Coder, (Byte & 0x7F) - (Coder->ER.DataEnd - Coder->ER.DataCurr));
      *To &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
      *(Coder->ER.DataCurr) &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
      *To |= *(Coder->ER.DataCurr);
      memmove(To + 1, Coder->ER.DataCurr + 1, (Byte & 0x7F));
    }
  else
    {
      DECODING_ERROR_HANDLER(Coder, ec_DEC_WrongConstructedLengthPrefix, NO_ARGS);
    }
  Coder->ER.DataCurr = CurrByte + 1;

  return Length;
}

/**************************************************/
/**************************************************/
/**************************************************/

/**************************************************
 * NAME: PERConstructedEncode
 *       
 *
 */

void
PERConstructedEncode(tCoder* Coder, tPERConstructedInfo* Info)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERConstructedEncode\n");
#endif

  if (Info->Length >= 0x4000)
    {
      while (Info->Length >= 0x10000)
        {
          if (Coder->ER.Rule & er_Aligned)
            PERAlign(Coder);

          /* 8 bits: 11000100 */
          PERPutByte(Coder, 0xC4);
          Info->PrimOp(Coder, 0x10000, Info);
        }
      if (Info->Length >= 0xC000)
        {
          if (Coder->ER.Rule & er_Aligned)
            PERAlign(Coder);

          /* 8 bits: 11000011 */
          PERPutByte(Coder, 0xC3);
          Info->PrimOp(Coder, 0xC000, Info);
        }
      if (Info->Length >= 0x8000)
        {
          if (Coder->ER.Rule & er_Aligned)
            PERAlign(Coder);

          /* 8 bits: 11000010 */
          PERPutByte(Coder, 0xC2);
          Info->PrimOp(Coder, 0x8000, Info);
        }
      if (Info->Length >= 0x4000)
        {
          if (Coder->ER.Rule & er_Aligned)
            PERAlign(Coder);

          /* 8 bits: 11000001 */
          PERPutByte(Coder, 0xC1);
          Info->PrimOp(Coder, 0x4000, Info);
        }
    }
  if (Coder->ER.Rule & er_Aligned)
    PERAlign(Coder);
  if (Info->Length <= 0x7F)
    /* 1 bit: 0, 6 bits: number */
    PERPutByte(Coder, (unsigned char)(Info->Length));
  else
    /* 2 bits: 10, 14 bits: number */
    PERPutBits(Coder, (Info->Length | 0x8000), 16);
  Info->PrimOp(Coder, Info->Length, Info);
}

/**************************************************
 * NAME: PERConstructedDecode
 *       
 *
 */

void
PERConstructedDecode(tCoder* Coder, tPERConstructedInfo* Info)
{
  unsigned char Byte;
  tVMSULong DecLen = 0;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERConstructedDecode\n");
#endif

  do
    {
      if (Coder->ER.Rule & er_Aligned)
        PERAlign(Coder);
      Byte = PERGetByte(Coder);
      if (Byte == 0xC4)
        DecLen = 0x10000;
      else
      if (Byte == 0xC3)
        DecLen = 0xC000;
      else
      if (Byte == 0xC2)
        DecLen = 0x8000;
      else
      if (Byte == 0xC1)
        DecLen = 0x4000;
      else
      if((Byte & 0xC0) == 0x80)
        DecLen = (((Byte & 0x7F) << 8) | PERGetByte(Coder));
      else
      if((Byte & 0x80) == 0x00)
        DecLen = (Byte & 0x7F);
      else
        {
          DECODING_ERROR_HANDLER(Coder, ec_DEC_WrongConstructedLengthPrefix, NO_ARGS);
        }
      Info->PrimOp(Coder, DecLen, Info);
    }
  while(DecLen >= 0x4000);
}

/**************************************************/
/**************************************************/
/**************************************************/

#ifndef CODER_NOUSE_BIG_INTEGER
/**************************************************
 * NAME: PERGetBigInterval
 *       
 *
 */
void
PERGetBigInterval(tCoder* Coder, tVMSInteger* Value, tVMSBigInteger* Interval)
{
  tASN1TypeInfo* Type = Coder->VMS.Type;
  tVMSUInteger LBound, UBound;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERGetBigInterval\n");
#endif

  switch (Type->TypeClass)
    {
    case type_ASN1_CINTEGER:
      if (((tASN1CInteger*)Type)->IntegerConstraint.LBound < 0)
        {
          LBound.Sign = 1;
          LBound.Number = (unsigned int)(-(((tASN1CInteger*)Type)->IntegerConstraint.LBound));
        }
      else
        {
          LBound.Sign = 0;
          LBound.Number = (unsigned int)((tASN1CInteger*)Type)->IntegerConstraint.LBound;
        }
      if (Value == NULL)
        {
          if (((tASN1CInteger*)Type)->IntegerConstraint.UBound < 0)
            {
              UBound.Sign = 1;
              UBound.Number = (unsigned int)(-(((tASN1CInteger*)Type)->IntegerConstraint.UBound));
            }
          else
            {
              UBound.Sign = 0;
              UBound.Number = (unsigned int)((tASN1CInteger*)Type)->IntegerConstraint.UBound;
            }
        }
      break;
    case type_ASN1_BINTEGER:
      LBound.Sign = ((tASN1BInteger*)Type)->IntegerConstraint.ConstraintMask & 0x10 ? 1 : 0;
      LBound.Number = ((tASN1BInteger*)Type)->IntegerConstraint.LBound;
      if (Value == NULL)
        {
          UBound.Sign = ((tASN1BInteger*)Type)->IntegerConstraint.ConstraintMask & 0x04 ? 1 : 0;
          UBound.Number = ((tASN1BInteger*)Type)->IntegerConstraint.UBound;
        }
      break;
    case type_ASN1_CBIT_STRING:
    case type_ASN1_COCTET_STRING:
      LBound.Sign = 0;
      LBound.Number = (unsigned int)(((tASN1CString*)Type)->SizeConstraint.LBound);
      if (Value == NULL)
        {
          UBound.Sign = 0;
          UBound.Number = ((tASN1CString*)Type)->SizeConstraint.UBound;
        }
      break;
    case type_ASN1_BBIT_STRING:
    case type_ASN1_BOCTET_STRING:
      LBound.Sign = 0;
      LBound.Number = ((tASN1BString*)Type)->SizeConstraint.LBound;
      if (Value == NULL)
        {
          UBound.Sign = 0;
          UBound.Number = ((tASN1BString*)Type)->SizeConstraint.UBound;
        }
      break;
    case type_ASN1_ENUMERATED:
    case type_ASN1_BENUMERATED:
      LBound.Sign = 0;
      LBound.Number = 0;
      if (Value == NULL)
        {
          UBound.Sign = 0;
          if (((tASN1Enumerated*)Type)->ExtMarker != -1)
            UBound.Number = ((tASN1Enumerated*)Type)->ExtMarker - 1;
          else
            UBound.Number = ((tASN1Enumerated*)Type)->NumOfItems - 1;
        }
      break;
    case type_ASN1_CHOICE:
      LBound.Sign = 0;
      LBound.Number = 0;
      if (Value == NULL)
        {
          UBound.Sign = 0;
          if (((tASN1Choice*)Type)->ExtMarker != -1)
            UBound.Number = ((tASN1Choice*)Type)->ExtMarker - 1;
          else
            UBound.Number = ((tASN1Choice*)Type)->NumOfAlts - 1;
        }
      break;
    case type_ASN1_CSEQUENCE_OF:
    case type_ASN1_CSET_OF:
      LBound.Sign = 0;
      LBound.Number = ((tASN1CStructOf*)Type)->SizeConstraint.LBound;
      if (Value == NULL)
        {
          UBound.Sign = 0;
          UBound.Number = ((tASN1CStructOf*)Type)->SizeConstraint.UBound;
        }
      break;
    case type_ASN1_BSEQUENCE_OF:
    case type_ASN1_BSET_OF:
      LBound.Sign = 0;
      LBound.Number = ((tASN1BStructOf*)Type)->SizeConstraint.LBound;
      if (Value == NULL)
        {
          UBound.Sign = 0;
          UBound.Number = ((tASN1BStructOf*)Type)->SizeConstraint.UBound;
        }
      break;
    default:
      if (Type->TypeClass & 0x40)
        {
          LBound.Sign = 0;
          LBound.Number = ((tASN1CCharString*)Type)->SizeConstraint.LBound;
          if (Value == NULL)
            {
              UBound.Sign = 0;
              UBound.Number = ((tASN1CCharString*)Type)->SizeConstraint.UBound;
            }
        }
      else
      if (Type->TypeClass & 0x80)
        {
          LBound.Sign = 0;
          LBound.Number = ((tASN1BCharString*)Type)->SizeConstraint.LBound;
          if (Value == NULL)
            {
              UBound.Sign = 0;
              UBound.Number = ((tASN1BCharString*)Type)->SizeConstraint.UBound;
            }
        }
      break;
    }

  if (Value != NULL)
    {
      UBound.Sign = Value->Sign;
      UBound.Number = Value->Number;
    }
  
  Interval->HBytes = 0;
  if (UBound.Sign)
    Interval->LBytes = LBound.Number - UBound.Number;
  else
  if (LBound.Sign)
    {
      if (UBound.Number != 0)
        {
          unsigned int Tmp = (0xFFFFFFFF - LBound.Number);
          if (Tmp < UBound.Number - 1)
            {
              Interval->HBytes = 1;
              UBound.Number -= Tmp;
              UBound.Number--;
              Interval->LBytes = UBound.Number;
            }
          else
            Interval->LBytes = UBound.Number + LBound.Number;
        }
      else
        Interval->LBytes = LBound.Number;
    }
  else
    Interval->LBytes = UBound.Number - LBound.Number;
}

/**************************************************
 * NAME: PERSetDecValue
 *       
 *
 */
void
PERSetBigDecodedValue(tCoder* Coder, tVMSBigInteger* Interval, tVMSInteger* Value)
{
  tASN1TypeInfo* Type = Coder->VMS.Type;
  tVMSInteger LBound;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERSetDecodedValue\n");
#endif

  switch (Type->TypeClass)
    {
    case type_ASN1_CINTEGER:
      if (((tASN1CInteger*)Type)->IntegerConstraint.LBound < 0)
        {
          LBound.Sign = 1;
          LBound.Number = (unsigned int)(-(((tASN1CInteger*)Type)->IntegerConstraint.LBound));
        }
      else
        {
          LBound.Sign = 0;
          LBound.Number = (unsigned int)((tASN1CInteger*)Type)->IntegerConstraint.LBound;
        }
      break;
    case type_ASN1_BINTEGER:
      LBound.Sign = ((tASN1BInteger*)Type)->IntegerConstraint.ConstraintMask & 0x10 ? 1 : 0;
      LBound.Number = ((tASN1BInteger*)Type)->IntegerConstraint.LBound;
      break;
    case type_ASN1_CBIT_STRING:
    case type_ASN1_COCTET_STRING:
      LBound.Sign = 0;
      LBound.Number = (unsigned int)(((tASN1CString*)Type)->SizeConstraint.LBound);
      break;
    case type_ASN1_BBIT_STRING:
    case type_ASN1_BOCTET_STRING:
      LBound.Sign = 0;
      LBound.Number = ((tASN1BString*)Type)->SizeConstraint.LBound;
      break;
    case type_ASN1_ENUMERATED:
    case type_ASN1_BENUMERATED:
    case type_ASN1_CHOICE:
      LBound.Sign = 0;
      LBound.Number = 0;
      break;
    case type_ASN1_CSEQUENCE_OF:
    case type_ASN1_CSET_OF:
      LBound.Sign = 0;
      LBound.Number = ((tASN1CStructOf*)Type)->SizeConstraint.LBound;
      break;
    case type_ASN1_BSEQUENCE_OF:
    case type_ASN1_BSET_OF:
      LBound.Sign = 0;
      LBound.Number = ((tASN1BStructOf*)Type)->SizeConstraint.LBound;
      break;
    default:
      LBound.Sign = 0;
      if (Type->TypeClass & 0x40)
        LBound.Number = ((tASN1CCharString*)Type)->SizeConstraint.LBound;
      else
      if (Type->TypeClass & 0x80)
        LBound.Number = ((tASN1BCharString*)Type)->SizeConstraint.LBound;
      break;
    }

  INTERNAL_ERROR_HANDLER_EXP(Interval->HBytes > 1, Coder, ec_INT_UnsupportedIntegerValue, NO_ARGS);

  Value->Sign = 0;
  if (Interval->HBytes)
    {
      if (LBound.Sign && (Interval->LBytes < LBound.Number))
        {
          LBound.Number -= Interval->LBytes + 1;
          Value->Number = 0xFFFFFFFF - LBound.Number;
        }
      else
        {
          INTERNAL_ERROR_HANDLER(Coder, ec_INT_UnsupportedIntegerValue, NO_ARGS);
        }
    }
  else
    {
      if (LBound.Sign)
        {
          if (LBound.Number > Interval->LBytes)
            {
              Value->Sign = 1;
              Value->Number = LBound.Number - Interval->LBytes;
            }
          else
            Value->Number = Interval->LBytes - LBound.Number;
        }
      else
        {
          if ((0xFFFFFFFF - Interval->LBytes) >= LBound.Number)
            Value->Number = Interval->LBytes + LBound.Number;
          else
            {
              INTERNAL_ERROR_HANDLER(Coder, ec_INT_UnsupportedIntegerValue, NO_ARGS);
            }
        }
    }
}

#endif /* CODER_NOUSE_BIG_INTEGER */

#endif /* !CODER_REMOVE_PER */
