/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22510 at Mon Nov 21 03:16:40 PM MET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef __per_base_h
#define __per_base_h

#include "cucf.h"

#ifndef CODER_REMOVE_PER

/***********************************************/
/************* Buffers operations **************/
/***********************************************/

void PERAppendMemory(tCoder* Coder, tVMSULong Len);
void PERAppendData(tCoder* Coder, tVMSULong Length);

/***********************************************/

void          PERPutBit(tCoder* Coder, unsigned char Bit);
unsigned char PERGetBit(tCoder* Coder);

void          PERPutBits(tCoder* Coder, unsigned long Bits, unsigned char Num);
unsigned long PERGetBits(tCoder* Coder, unsigned char Num);

/***********************************************/

void          PERPutByte(tCoder* Coder, unsigned char Byte);
unsigned char PERGetByte(tCoder* Coder);
void          PERSkipBytes(tCoder* Coder, tVMSULong NumOfBytes);

/***********************************************/

void          PERPutSeg(tCoder* Coder, unsigned char* Seg, unsigned long Len);

/***********************************************/

#define PERAlign(Coder) \
  if (Coder->ER.BitCurr != 7) \
    { \
      *(Coder->ER.DataCurr) &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1)); \
      Coder->ER.DataCurr++; \
      Coder->ER.BitCurr = 7; \
    }

/***********************************************/
/***********************************************/
/***********************************************/

void      PEROctetsFragmentation(tCoder* Coder, tVMSULong Length);
void      PEROctetsFragmentationWithOffset(tCoder* Coder, tVMSULong Length);
tVMSULong PEROctetsDefragmentation(tCoder* Coder);
tVMSULong PEROctetsDefragmentationWithOffset(tCoder* Coder);

/***********************************************/
/***********************************************/
/***********************************************/

#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET)

typedef struct
{
  tVMSULong     CByte;
  unsigned char CBit;
} tPERCurrPos;

typedef struct
{
  tVMSULong     CByte;
  unsigned char CBit;
  tVMSULong     CLength;
} tPEREncBitField;

typedef struct
{
  unsigned char* CByte;
  unsigned char  CBit;
  unsigned char  Constructed;
  tVMSULong      CLength;
} tPERDecBitField;

#endif /* !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET) */

/***********************************************/
/***********************************************/
/***********************************************/

struct sPERConstructedInfo;
typedef struct sPERConstructedInfo tPERConstructedInfo;

typedef void (*tPERPrimFunc)(tCoder* Coder, tVMSULong Length, tPERConstructedInfo* Info);

/* BASE */
struct sPERConstructedInfo
{
  unsigned char* Value;      /* Pointer to value */
  tVMSULong      Length;     /* Length of value */
  tPERPrimFunc   PrimOp;     /* Pointer to Encode/Decode function */
};

void PERConstructedEncode(tCoder* Coder, tPERConstructedInfo* Val);
void PERConstructedDecode(tCoder* Coder, tPERConstructedInfo* Val);

typedef struct
{
  unsigned char* Value;       /* Pointer to value */
  tVMSULong      Length;      /* Length of value */
  tPERPrimFunc   PrimOp;      /* Pointer to Encode/Decode function */

  unsigned char  BitsLength;  /* Length in bits */
  unsigned char  ValMask;     /* Code or number */
  unsigned char* Alphabet;    /* Alphabet */
  tVMSULong      AlphabetLen; /* Alphabet length */
} tPERCharStringInfo;

/***********************************************/
/*************** STRUCT OF *********************/
/***********************************************/

struct sPERStructOfInfo;
typedef struct sPERStructOfInfo tPERStructOfInfo;

typedef void (*tPERStructOfFunc)(tCoder* Coder, tVMSULong Length, tPERStructOfInfo* Info);

struct sPERStructOfInfo
{
  void*             Value;      /* Pointer to value */
  tVMSULong         Length;     /* Length of value */
  tPERStructOfFunc  PrimOp;     /* Pointer to Encode/Decode function */

  tVMSULong         CurrElem;   /* Current element */
  tASN1StructOf*    Type;       /* StructOf type */
#ifndef CODER_NOUSE_OPEN
  tVMSOpenTypeList* List;       /* Open type list */
#endif
};

/***********************************************/
/***************** SHARED **********************/
/***********************************************/

#ifndef CODER_NOUSE_BIG_INTEGER

void PERGetBigInterval(tCoder* Coder, tVMSInteger* Value, tVMSBigInteger* Interval);
void PERSetBigDecodedValue(tCoder* Coder,  tVMSBigInteger* Interval, tVMSInteger* Value);

#define PERGetEncNumber(Coder, LValue, UValue, Interval) \
  PERGetBigInterval(Coder, &UValue, &Interval);

#define PERGetMaxEncNumber(Coder, LValue, UValue, Interval) \
  PERGetBigInterval(Coder, NULL, &Interval);

#define PERSetDecValue(Type, LValue, Interval, UValue) \
  PERSetBigDecodedValue(Coder, &Interval, &UValue);

#else /* CODER_NOUSE_BIG_INTEGER */

#define PERGetEncNumber(Coder, LValue, UValue, Interval) \
  Interval.LBytes = (unsigned int)((UValue) - (LValue));

#define PERGetMaxEncNumber(Coder, LValue, UValue, Interval) \
PERGetEncNumber(Coder, LValue, UValue, Interval)

#define PERSetDecValue(Coder, LValue, Interval, UValue) \
  (UValue) = ((LValue) + Interval.LBytes);

#endif

/***********************************************/
/***********************************************/
/***********************************************/

/***********************************************/
/***************** OPEN ************************/
/***********************************************/
#ifndef CODER_NOUSE_OPEN

#define PERPutOpenId(Coder, Type, Val, List) CUCFPutOpenId(Coder, Type, Val, List)
#define PERPutOpenBody(Coder, Type, Val, List, OTInfo) CUCFPutOpenBody(Coder, Type, Val, List, OTInfo)

/***********************************************/

#define PERGetOpenTypeObject(Coder, Type, Val, ObjIndex) CUCFGetOpenTypeObject(Coder, Type, Val, ObjIndex)

#endif /* CODER_NOUSE_OPEN  */ 
/***********************************************/


#endif /* !CODER_REMOVE_PER */

#endif /* __per_base_h */
